Type: Package
Package: rtweet
Title: Collecting Twitter Data
Version: 2.0.0
Authors@R: c(
    person("Michael W.", "Kearney", , "kearneymw@missouri.edu", role = "aut",
           comment = c(ORCID = "0000-0002-0730-4694")),
    person("Lluís", "Revilla Sancho", , "lluis.revilla@gmail.com", role = c("aut", "cre"),
           comment = c(ORCID = "0000-0001-9747-2570")),
    person("Hadley", "Wickham", role = "aut",
           comment = c(ORCID = "0000-0003-4757-117X")),
    person("Andrew", "Heiss", role = "rev",
           comment = c(ORCID = "0000-0002-3948-3914")),
    person("Francois", "Briatte", role = "rev"),
    person("Jonathan", "Sidi", , "yonicd@gmail.com", role = "ctb",
           comment = c(ORCID = "0000-0002-4222-1819"))
  )
Description: An implementation of calls designed to collect and organize
    Twitter data via Twitter's REST and stream Application Program
    Interfaces (API), which can be found at the following URL:
    <https://developer.twitter.com/en/docs>.
License: MIT + file LICENSE
URL: https://docs.ropensci.org/rtweet/,
        https://github.com/ropensci/rtweet/
BugReports: https://github.com/ropensci/rtweet/issues
Depends: R (>= 4.0.0)
Imports: bit64 (>= 4.0.5), curl (>= 4.3.2), httr (>= 1.3.0), httr2 (>=
        1.0.0), jsonlite (>= 0.9.22), lifecycle (>= 1.0.0), methods,
        progress (>= 1.2.2), rlang (>= 0.4.10), tibble (>= 1.3.4),
        tools, utils, withr (>= 2.5.0)
Suggests: askpass (>= 1.1), covr (>= 3.5.1), dplyr (>= 1.0.9), ggplot2
        (>= 3.3.5), httpuv (>= 1.6.5), igraph (>= 1.3.2), knitr (>=
        1.39), magick (>= 2.7.3), maps (>= 3.4.0), openssl (>= 2.0.2),
        rmarkdown (>= 2.14), spelling (>= 2.2.1), testthat (>= 3.1.0),
        vcr (>= 0.6.0), webshot (>= 0.5.3)
VignetteBuilder: knitr
Config/testthat/edition: 3
Encoding: UTF-8
RoxygenNote: 7.3.0
Language: en-US
NeedsCompilation: no
Packaged: 2024-02-24 15:10:58 UTC; lluis
Author: Michael W. Kearney [aut] (<https://orcid.org/0000-0002-0730-4694>),
  Lluís Revilla Sancho [aut, cre]
    (<https://orcid.org/0000-0001-9747-2570>),
  Hadley Wickham [aut] (<https://orcid.org/0000-0003-4757-117X>),
  Andrew Heiss [rev] (<https://orcid.org/0000-0002-3948-3914>),
  Francois Briatte [rev],
  Jonathan Sidi [ctb] (<https://orcid.org/0000-0002-4222-1819>)
Maintainer: Lluís Revilla Sancho <lluis.revilla@gmail.com>
Repository: CRAN
Date/Publication: 2024-02-24 16:20:02 UTC

<!-- README.md is generated from README.Rmd. Please edit that file -->

# rtweet <img src="man/figures/logo.png" width="160px" align="right" />

<!-- badges: start -->

[![R-CMD-check](https://github.com/ropensci/rtweet/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/ropensci/rtweet/actions/workflows/R-CMD-check.yaml)
[![CRAN
status](https://www.r-pkg.org/badges/version/rtweet)](https://cran.r-project.org/package=rtweet)
[![Coverage
Status](https://codecov.io/gh/ropensci/rtweet/branch/master/graph/badge.svg)](https://app.codecov.io/gh/ropensci/rtweet?branch=master)
![Downloads](https://cranlogs.r-pkg.org/badges/rtweet)
[![ZENODO](https://zenodo.org/badge/64161359.svg)](https://zenodo.org/badge/latestdoi/64161359)
[![rOpenSci](https://badges.ropensci.org/302_status.svg)](https://github.com/ropensci/software-review/issues/302)
[![JOSS](https://joss.theoj.org/papers/10.21105/joss.01829/status.svg)](https://doi.org/10.21105/joss.01829)
[![“Buy Me A
Coffee”](https://www.buymeacoffee.com/assets/img/custom_images/orange_img.png)](https://www.buymeacoffee.com/llrs)

<!-- badges: end -->

Use twitter from R. Get started by reading `vignette("rtweet")`.

## Installation

To get the current released version from CRAN:

``` r
install.packages("rtweet")
```

You can install the development version of rtweet from GitHub with:

``` r
install.packages("rtweet", repos = 'https://ropensci.r-universe.dev')
```

## Usage

All users must be authenticated to interact with Twitter’s APIs. See
`vignette("auth", package = "rtweet")` for details.

``` r
library(rtweet)
```

rtweet should be used in strict accordance with Twitter’s [developer
terms](https://developer.twitter.com/en/developer-terms/more-on-restricted-use-cases).

## Usage

Depending on if you are a paid user or not you can do more or less
things.

# Free

You can post (`tweet_post()`) and retrieve information about yourself
(`user_self()`).

# Paid

You can do all the other things: search tweets
(`tweet_search_recent()`), retrieve your own bookmarks
(`user_bookmarks()`), check who follows who, (`user_following()`, or
`user_followers()`), ….

## Contact

Communicating with Twitter’s APIs relies on an internet connection,
which can sometimes be inconsistent.

If you have questions, or needs an example or want to share a [use
case](https://ropensci.org/usecases/), you can post them on [rOpenSci’s
discuss](https://discuss.ropensci.org/). Were you can [browse uses of
rtweet](https://discuss.ropensci.org/tags/c/usecases/10/rtweet) too.

With that said, if you encounter an obvious bug for which there is not
already an active [issue](https://github.com/ropensci/rtweet/issues),
please [create a new
issue](https://github.com/ropensci/rtweet/issues/new) with all code used
(preferably a reproducible example) on Github.

# Code of Conduct

Please note that this package is released with a [Contributor Code of
Conduct](https://ropensci.org/code-of-conduct/). By contributing to this
project, you agree to abide by its terms.

---
output: github_document
---

<!-- README.md is generated from README.Rmd. Please edit that file -->

```{r, echo = FALSE}
knitr::opts_chunk$set(
  eval = TRUE,
  collapse = TRUE,
  comment = "#>",
  fig.path = "README-"
)
```

# rtweet <img src="man/figures/logo.png" width="160px" align="right" />

<!-- badges: start -->
[![R-CMD-check](https://github.com/ropensci/rtweet/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/ropensci/rtweet/actions/workflows/R-CMD-check.yaml)
[![CRAN status](https://www.r-pkg.org/badges/version/rtweet)](https://cran.r-project.org/package=rtweet)
[![Coverage Status](https://codecov.io/gh/ropensci/rtweet/branch/master/graph/badge.svg)](https://app.codecov.io/gh/ropensci/rtweet?branch=master)
![Downloads](https://cranlogs.r-pkg.org/badges/rtweet)
[![ZENODO](https://zenodo.org/badge/64161359.svg)](https://zenodo.org/badge/latestdoi/64161359)
[![rOpenSci](https://badges.ropensci.org/302_status.svg)](https://github.com/ropensci/software-review/issues/302)
[![JOSS](https://joss.theoj.org/papers/10.21105/joss.01829/status.svg)](https://doi.org/10.21105/joss.01829)
<!-- badges: end -->

Use twitter from R. Get started by reading `vignette("rtweet")`.

## Installation

To get the current released version from CRAN:

```{r, eval=FALSE}
install.packages("rtweet")
```

You can install the development version of rtweet from GitHub with:

```{r, eval = FALSE}
install.packages("rtweet", repos = 'https://ropensci.r-universe.dev')
```


## Usage

All users must be authenticated to interact with Twitter's APIs. 
See `vignette("auth", package = "rtweet")` for details.

```{r}
library(rtweet)
```

rtweet should be used in strict accordance with Twitter's [developer  terms](https://developer.twitter.com/en/developer-terms/more-on-restricted-use-cases).

```{r include=FALSE}
auth_as(rtweet:::rtweet_test())
```

## Usage

Depending on if you are a paid user or not you can do more or less things.

# Free

You can post (`tweet_post()`) and retrieve information about yourself (`user_self()`). 

# Paid

You can do all the other things: search tweets (`tweet_search_recent()`), retrieve your own bookmarks (`user_bookmarks()`), check who follows who, (`user_following()`, or `user_followers()`), ....

## Contact

Communicating with Twitter's APIs relies on an internet connection, which can sometimes be inconsistent. 

If you have questions, or needs an example or want to share a [use case](https://ropensci.org/usecases/), you can post them on [rOpenSci's discuss](https://discuss.ropensci.org/). 
Were you can [browse uses of rtweet](https://discuss.ropensci.org/tags/c/usecases/10/rtweet) too.

With that said, if you encounter an obvious bug for which there is not already an active [issue](https://github.com/ropensci/rtweet/issues), please [create a new issue](https://github.com/ropensci/rtweet/issues/new) with all code used (preferably a reproducible example) on Github.


# Code of Conduct

Please note that this package is released with a [Contributor
Code of Conduct](https://ropensci.org/code-of-conduct/). 
By contributing to this project, you agree to abide by its terms.

#' Count tweets
#'
#' @inheritParams tweet_search_recent
#' @returns The number of tweets for a given granularity
#' @references <https://developer.twitter.com/en/docs/twitter-api/tweets/counts/api-reference/get-tweets-counts-all>
#' @references <https://developer.twitter.com/en/docs/twitter-api/tweets/counts/api-reference/get-tweets-counts-recent>
#' @export
#' @examples
#' if (FALSE) {
#'   tcr <- tweet_counts_recent(query = "#rtweet", parse = FALSE)
#'   tca <- tweet_counts_all(query = "#rtweet", parse = FALSE)
#' }
tweet_counts_recent <- function(query, ..., token = NULL, parse = TRUE,
                                verbose = FALSE) {
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, NULL, NULL)
  data <- list(...)
  if (!is.null(data$granularity)) {
    data$granularity <- match.arg(data$granularity, c("minute", "hour", "day"))
  }
  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- c(query = query, data)
  # Rates from the website app and user limits
  req_archive <- endpoint_v2("tweets/counts/recent", 300/(15*60), set_scopes())
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, Inf, Inf, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, NULL, NULL)
}

#' @export
#' @rdname tweet_counts_recent
tweet_counts_all <- function(query, ..., token = NULL, parse = TRUE,
                             verbose = FALSE) {
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, NULL, NULL)
  data <- list(...)
  if (!is.null(data$granularity)) {
    data$granularity <- match.arg(data$granularity, c("minute", "hour", "day"))
  }
  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- c(query = query, data)
  # Rates from the website app and user limits
  req_archive <- endpoint_v2("tweets/counts/all", 300/(15*60), set_scopes())
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, Inf, Inf, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, NULL, NULL)
}

#' Set up default authentication
#'
#' You'll need to run this function once per computer so that rtweet can use
#' your personal Twitter account. See [rtweet_app()]/[rtweet_bot] and
#' [auth_save()] for other authentication options.
#'
#' It will use the current logged in account on the default browser to detect
#' the credentials needed for rtweet and save them as "default".
#' If a default is found it will use it instead.
#' @return
#' `auth_setup_default()`: Invisibly returns the previous authentication mechanism.
#' `auth_has_default()`: A logical value `TRUE` if there is a default authentication.
#' @export
#' @family authentication
#' @examples
#' \dontrun{
#' if (!auth_has_default() && interactive()) {
#'    auth_setup_default()
#' }
#' }
auth_setup_default <- function() {
  if (auth_has_default()) {
    inform("Using default authentication available.")
  } else {
    auth <- rtweet_user()
    auth_save(auth, "default")
  }
  auth_as("default")
}

#' Authentication options
#'
#' Authenticate methods to use the Twitter API.
#' See the instructions in `vignette("auth", package = "rtweet")`.
#'
#' There are four ways that you can authenticate with the Twitter API:
#'
#' * `rtweet_user()` interactively authenticates an existing Twitter user.
#'   This form is most appropriate if you want rtweet to control your
#'   Twitter account.
#'
#' * `rtweet_app()` authenticates as a Twitter application. An application can't
#'    perform actions (i.e. it can't tweet) but otherwise has generally higher
#'    rate limits (i.e. you can do more searches). See details
#'    at <https://developer.twitter.com/en/docs/twitter-api/v1/rate-limits>.
#'    This form is most appropriate if you are collecting data.
#'
#' * `rtweet_bot()` authenticates as bot that takes actions on behalf of an app.
#'    This form is most appropriate if you want to create a Twitter account that
#'    is run by a computer, rather than a human.
#'
#' * `rtweet_oauth2()` authenticates as a user using a client.
#'    This authentication is required in some endpoints.
#'
#' To use `rtweet_app()`, `rtweet_bot()`  or `rtweet_oauth2()` you will need to
#' create your own Twitter app following the instructions in
#' `vignette("auth", package = "rtweet")`.
#' `rtweet_user()` _can be_ used with your own app, but generally there is
#' no need to because it uses the Twitter app provided by rtweet.
#'
#' Use [auth_as()] to set the default auth mechanism for the current session,
#' and [auth_save()] to save an auth mechanism for use in future sessions.
#'
#' # Security
#'
#' All of the arguments to these functions are roughly equivalent to
#' passwords so should generally not be typed into the console (where they
#' the will be recorded in `.Rhistory`) or recorded in a script (which is
#' easy to accidentally share). Instead, call these functions without arguments
#' since the default behaviour is to use ask_pass that if possible uses
#' [askpass::askpass()] to interactively safely prompt you for the values.
#'
#' @param client_id,client_secret Application OAuth client ID and client Secret.
#' These are generally not required for `rtweet_user()` since the defaults will use
#' the built-in rtweet app.
#' @param access_token,access_secret Access token and secret.
#' @param api_key,api_secret API key and secret. Deprecated in favor of `client_*` arguments.
#' @param bearer_token App bearer token.
#' @param app Name of the application you are building.
#' @return If the validation is successful the OAuth token.
#' For `rtweet_app()` a `rtweet_bearer`.
#' @family authentication
#' @seealso [rtweet_client()]
#' @export
#' @examples
#' \dontrun{
#' rtweet_app()
#' }
rtweet_user <- function(client_id = NULL, client_secret = NULL,
                        api_key = client_id, api_secret = client_secret) {
  check_installed("httpuv")
  if (is.null(client_id) && is.null(client_secret)) {
    # See https://github.com/ropensci/rtweet/issues/756#issuecomment-1497464678
    # https://github.com/ropensci/rtweet/issues/761#issuecomment-1497468605
    abort(c("The default authentication was suspended.",
            i = "Please provide your own authentication see: `vignette('auth', 'rtweet')`"))
    client <- default_cached_client()
    api_key <- client$id
    api_secret <- client$secret
  } else {
    stopifnot(is_string(client_id), is_string(client_secret))
  }
  # From oauth_app help page
  # key: consumer key or client ID
  # secret: consumer secret, or client secret
  app <- httr::oauth_app("rtweet", key = api_key, secret = api_secret)
  TwitterToken1.0$new(
    app = app,
    endpoint = httr::oauth_endpoints("twitter"),
    params = list(as_header = TRUE),
    cache_path = FALSE
  )
}

#' @export
#' @rdname rtweet_user
rtweet_bot <- function(api_key, api_secret, access_token, access_secret,
                       app = "rtweet") {

  if (missing(api_key)) {
    api_key <- ask_pass("API key")
  }
  if (missing(api_secret)) {
    api_secret <- ask_pass("API secret")
  }
  if (missing(access_token)) {
    access_token <- ask_pass("access token")
  }
  if (missing(access_secret)) {
    access_secret <- ask_pass("access secret")
  }


  stopifnot(is_string(api_key), is_string(api_secret))
  stopifnot(is_string(access_token), is_string(access_secret))

  app <- httr::oauth_app(app, key = api_key, secret = api_secret)
  credentials <- list(
    oauth_token = access_token,
    oauth_token_secret = access_secret
  )
  httr::Token1.0$new(
    app = app,
    endpoint = httr::oauth_endpoints("twitter"),
    params = list(as_header = TRUE),
    credentials = credentials,
    cache_path = FALSE
  )
}

#' @export
#' @rdname rtweet_user
rtweet_app <- function(bearer_token) {
  if (missing(bearer_token)) {
    bearer_token <- ask_pass("bearer token")
  }
  structure(
    list(token = bearer_token),
    class = "rtweet_bearer"
  )
}

ask_pass <- function(type) {
  check_installed("askpass", call = current_call())

  message <- paste0("Please enter your ", type, ": ")
  val <- askpass::askpass(message)
  if (is.null(val)) {
    abort("Cancelled by user", call = current_call())
  }
  val
}

#' @export
#' @rdname rtweet_user
rtweet_bearer <- function(client = NULL, scopes  = NULL) {

  client <- client %||% client_get()
  if (!is_client(client)) {
    abort(c("Client not valid",
            i = "Check out the `vignette('auth', 'rtweet')`."),
          call = current_call())
  }

  if (!is.null(scopes) && check_scopes(scopes)) {
    scopes <- scopes
  } else if (is.null(scopes)) {
    scopes <- set_scopes(tweet_moderate = FALSE)
  } else {
    abort("Scopes is not in the right format.", call = current_call())
  }

  token <- httr2::oauth_flow_client_credentials(client,
                                       scope = scopes,
                                       token_params = list(client_secret = client$secret,
                                                           client_type = "third_party_app",
                                                           grant_type = "refresh_token"))
  attr(token, "app") <- client
  token
}

# @seealso [invalidate_bearer()]
rtweet_invalidate <- function(api_key, api_secret, token = NULL) {
  # To store the token at the right place: see ?httr2::oauth_cache_path
  withr::local_envvar(HTTR2_OAUTH_CACHE = auth_path())
  if (missing(api_key)) {
    api_key <- ask_pass("API key")
  }
  if (missing(api_secret)) {
    api_secret <- ask_pass("API secret")
  }

  token <- check_token_v2(token, mechanism = "bearer")
  if (!is.null(token$token)) {
    abort("Not possible to invalidate bearer token generated with OAuth 1.0",
        call = caller_call())
  }
  httr2::request("https://api.twitter.com/oauth2/invalidate_token") |>
    httr2::req_method("POST") |>
    httr2::req_auth_basic(api_key, api_secret) |>
    httr2::req_body_form(access_token = token$access_token) |>
    httr2::req_perform()
}

is_auth <- function(x) {
  inherits(x, "Token") || inherits(x, "rtweet_bearer") || inherits(x, "httr2_token") || inherits(x, "httr2_oauth_client")
}

#' @export
print.rtweet_bearer <- function(x, ...) {
  # Make it hard to accidentally reveal token
  cat("<Twitter bearer token>\n")
  invisible(x)
}

# Get default auth --------------------------------------------------------

#' Get the current authentication mechanism
#'
#' If no authentication has been set up for this session, `auth_get()` will
#' call [auth_as()] to set it up.
#' @return  The current token used.
#' @export
#' @family authentication
#' @examples
#' \dontrun{
#' auth_get()
#' }
auth_get <- function() {
  if (is.null(.state$auth)) {
    auth_as()
  }
  .state$auth
}

# Save authentication across sessions -------------------------------------

#' Save an authentication mechanism for use in a future session
#'
#' Use `auth_save()` with [auth_as()] to avoid repeatedly entering app
#' credentials, making it easier to share auth between projects.
#' Use `auth_list()` to list all saved credentials.
#'
#' The tokens are saved on `tools::R_user_dir("rtweet", "config")`.
#'
#' @param auth One of [rtweet_app()], [rtweet_bot()], or [rtweet_user()].
#' @param name Name of the file to use.
#' @return Invisible the path where the authentication is saved.
#' @family authentication
#' @seealso [auth_sitrep()] to help finding and managing authentications.
#' @export
#' @examples
#' \dontrun{
#' # save app auth for use in other sessions
#' auth <- rtweet_app()
#' auth_save(auth, "my-app")
#'
#' # later, in a different session...
#' auth_as("my-app")
#' # Show all authentications stored
#' auth_list()
#' }
auth_save <- function(auth, name) {
  stopifnot(is_auth(auth), is_string(name))

  path <- auth_path(paste0(name, ".rds"))
  inform(paste0("Saving auth to '", path, "'"))

  dir.create(auth_path(), showWarnings = FALSE, recursive = TRUE)
  saveRDS(auth, path)
  invisible(path)
}

#' @export
#' @rdname auth_save
auth_list <- function() {
  paths <- dir(auth_path(), pattern = "\\.rds$")
  tools::file_path_sans_ext(paths)
}

# Set default auth -------------------------------------------------------------

#' Set default authentication for the current session
#'
#' `auth_as()` sets up the default authentication mechanism used by all
#' rtweet API calls. See [rtweet_user()] to learn more about the three
#' available authentication options.
#'
#' @param auth One of the following options:
#'   * `NULL`, the default, will look for rtweet's "default" authentication
#'      which uses your personal Twitter account. If it's not found, it will
#'      call [auth_setup_default()] to set it up.
#'   * A string giving the name of a saved auth file made by [auth_save()].
#'   * An auth object created by [rtweet_app()], [rtweet_bot()], or
#'     [rtweet_user()].
#' @return Invisibly returns the previous authentication mechanism.
#' @seealso [auth_sitrep()] to help finding and managing authentications.
#' @family authentication
#' @export
#' @examples
#' \dontrun{
#' # Use app auth for the remainder of this session:
#' my_app <- rtweet_app()
#' auth_as(my_app)
#'
#' # Switch back to the default user based auth
#' auth_as()
#'
#' # Load auth saved by auth_save()
#' auth_as("my-saved-app")
#' }
auth_as <- function(auth = NULL) {
  old <- .state$auth
  .state$auth <- find_auth(auth)
  invisible(old)
}

find_auth <- function(auth = NULL) {
  if (is.null(auth)) {
    if (is_developing()) {
      rtweet_test() %||% no_token()
    } else{
      default_cached_auth()
    }
  } else if (is_auth(auth)) {
    auth
  } else if (is_string(auth)) {
    load_token(auth)
  } else {
    abort("Unrecognised input to `auth`",
          call = current_call())
  }
}

load_token <- function(auth_name) {
  if (file.exists(auth_name)) {
    path <- auth_name
    name <- tools::file_path_sans_ext(basename(auth_name))
  } else {
    path <- auth_path(paste0(auth_name, ".rds"))
    name <- auth_name
  }
  if (!file.exists(path)) {
    abort(paste0("Can't find saved auth with name '", auth_name, "'"),
          call = current_call())
  }
  if (!is_developing()) {
    inform(paste0("Reading auth from '", path, "'"))
  }
  token <- readRDS(path)
  # Store the name of the token as an attribute
  attr(token, "name") <- name
  token
}

default_cached_auth <- function() {
  default <- auth_path("default.rds")

  if (file.exists(default)) {
    return(readRDS(default))
  }

  names <- auth_list()
  if (length(names) == 0) {
    abort("No default authentication found. Please call `auth_setup_default()`",
          call = caller_call())
  } else {
    abort(c(
      "No default authentication found. Pick existing auth with:",
      paste0("auth_as('", names, "')")
    ), call = caller_call())
  }
}

#' @rdname auth_setup_default
#' @export
auth_has_default <- function() {
  file.exists(auth_path("default.rds"))
}

no_token <- function() {
  if (is_testing()) {
    testthat::skip("Auth not available")
  } else {
    abort("Could not authenticate", call = current_call())
  }
}
# Internal function to generate the bot used for testing
# Do not forget to later us auth_as()
rtweet_test <- function() {
  access_token <- Sys.getenv("RTWEET_ACCESS_TOKEN")
  access_secret <- Sys.getenv("RTWEET_ACCESS_SECRET")

  if (identical(access_token, "") || identical(access_secret, "")) {
    return()
  }

  rtweet_bot(
    "7rX1CfEYOjrtZenmBhjljPzO3",
    "rM3HOLDqmjWzr9UN4cvscchlkFprPNNg99zJJU5R8iYtpC0P0q",
    access_token,
    access_secret,
    app = "rtweet_hadley"
  )
}

# Twitter Token -----------------------------------------------------------

# Twitter requires a callback url that uses 127.0.0.1 rather than localhost
# so we temporarily override HTTR_SERVER during initialization.
# <https://developer.twitter.com/en/docs/apps/callback-urls>

TwitterToken1.0 <- R6::R6Class("TwitterToken1.0", inherit = httr::Token1.0, list(
  init_credentials = function(force = FALSE) {
    self$credentials <- twitter_init_oauth1.0(
      self$endpoint,
      self$app,
      permission = self$params$permission,
      private_key = self$private_key
    )
  }
))

twitter_init_oauth1.0 <- function(endpoint, app, permission = NULL,
                                  is_interactive = interactive(),
                                  private_key = NULL) {
  # Twitter requirements only allow numbers
  # local environment for httr::oauth_callback to find the localhost IP.
  # Which is also modified to `http://127.0.0.1:1410/`
  withr::local_envvar("HTTR_SERVER" = "127.0.0.1")
  httr::init_oauth1.0(
    endpoint,
    app,
    permission = permission,
    is_interactive = is_interactive,
    private_key = private_key
  )
}

auth_path <- function(...) {
  # Use private option to make testing easier
  path <- getOption("rtweet:::config_dir", tools::R_user_dir("rtweet", "config"))
  full_path <- file.path(path, ...)
  full_path
}

#' Some endpoints require OAuth 2.0 with specific permissions in order to work.
#' In order to work, the developer must configure the app with  callback url:
#' `http://127.0.0.1:1410/`
#' @param client Which client app will be used, see [rtweet_client()] for details.
#' @param scopes The permissions of the app, see [set_scopes()] for details.
#' By default it uses the client's scopes. Provided here in case you want to modify them.
#' @references <https://developer.twitter.com/en/docs/authentication/oauth-2-0/authorization-code>
#' @export
#' @rdname rtweet_user
rtweet_oauth2 <- function(client = NULL, scopes = NULL) {
  lifecycle::deprecate_stop("2.0.0", what = "rtweet_oatuh2()",
                            details = c("No longer needed, httr2 handles it automatically",
                                        i = "Register your client with `client_as('my_client')` and make your requests"))
  client <- client %||% client_get()
  if (!is_client(client)) {
    abort(c("Client not valid",
          i = "Check out the `vignette('auth', 'rtweet')`."),
          call = current_call())
  }
  if (is.null(scopes)) {
    scopes <- client_scopes(client)
  } else if (!check_scopes(scopes)) {
    abort("Scopes is not in the right format.",
          call = current_call())
  }

  # Guide to all urls for OAuth 2
  # https://developer.twitter.com/en/docs/authentication/api-reference
  # Guide of which endpoints require KPCE authentication
  # https://developer.twitter.com/en/docs/authentication/guides/v2-authentication-mapping
  # Useful questions: https://twittercommunity.com/t/unable-to-obtain-new-access-token-by-using-refresh-token/164123/14
  # Tutorial confirming the urls: https://developer.twitter.com/en/docs/tutorials/tweet-to-super-followers-with-postman--oauth-2-0-and-manage-twee
  token <- httr2::oauth_flow_auth_code(client,
                       auth_url = "https://twitter.com/i/oauth2/authorize",
                       pkce = TRUE,
                       scope = paste(scopes, collapse = " "),
                       redirect_uri = "http://127.0.0.1:1410"
                       # redirect_uri = "http://localhost:1410"
                       )
  # Example of valid url for authorization (created via client_as("academic_dev");rtweet_oauth2() )
  # https://twitter.com/i/oauth2/authorize?response_type=code&client_id=Tm5FWFA3OGFUVUMxTjhUREwzZzQ6MTpjaQ&redirect_uri=http%3A%2F%2F127.0.0.1%3A1410%2F&scope=tweet.read%20tweet.write%20tweet.moderate.write%20users.read%20follows.read%20follows.write%20offline.access%20space.read%20mute.read%20mute.write%20like.read%20like.write%20list.read%20list.write%20block.read%20block.write%20bookmark.read%20bookmark.write&state=PVgWK3MviQ5MBsfj0Iy5D89HBFR4mPwTl0yumjSPlWo&code_challenge=FNcGvupIzNIbWOL8rdJOrxsVS_b2R01vIbynF_iQIMQ&code_challenge_method=S256
  # # Note that the client_id should match in the url
  attr(token, "app") <- attr(client, "app")
  token
}

# Renew token if needed
# Makes the assumption that the right app is still in the user computer
auth_renew <- function() {
  withr::local_envvar(HTTR2_OAUTH_CACHE = auth_path())

  client <- client_get()
  token <- httr2::oauth_token_cached(
    client = client,
    flow = httr2::oauth_flow_refresh,
    flow_params = list(
      scope = paste(client_scopes(client), collapse = " "),
      token_params = list(client_id = client$id)
    ),
    cache_disk = TRUE
  )
  token_file <- list.files(pattern = client$name, path = auth_path(),
                           full.names = TRUE, include.dirs = FALSE)
  token <- readRDS(token_file)
  # Somehow the time doesn't look fine
  loc <- Sys.setlocale("LC_TIME", locale = "C")
  expires <- .POSIXct(token$expires_at) >= Sys.time()
  Sys.setlocale("LC_TIME", locale = loc)



  if (expires && !interactive()) {
    if (is_testing()) {
      testthat::skip(paste0("Not possible to refresh the token automatically",
                            " and not in interactive environment."))
    }
    warn("Automatic refresh of the token was not possible.",
          call = caller_call())
  } else {
    return(NULL)
  }



  token <- httr2::oauth_flow_refresh(client,
                             refresh_token = token$refresh_token,
                             scope = token$scope,
                             token_params = list(client_id = client$id))
  saveRDS(token, token_file)
  message("Automatic refereshing of token")
}

decrypt <- function(x) {
  check_installed("openssl") # Suggested!
  rawToChar(openssl::rsa_decrypt(x[[2]], x[[1]]))
}

token_name <- function(x){
  attr(x, "name", TRUE)
}

resave_token <- function(token) {
  name <- token_name(token)
  if (is.null(name)) {
    inform(c("!" = "It was not possible to save your token",
             "i" = "Saving your new oauth2 token with: `auth_save(auth_get(), 'renewed_token')`"))
    auth_save(auth_get(), 'renewed_token')
  }

  path <- auth_path(paste0(name, ".rds"))
  # Protects in case the folder gets deleted while the token is loaded
  dir.create(auth_path(), showWarnings = FALSE, recursive = TRUE)
  saveRDS(token, path)
}

test_that("bearer token doesn't accidentally expose secrets", {
  expect_snapshot(
    rtweet_app("abc")
  )
})

test_that("can set and reset auth", {

  auth <- auth_get()
  old <- auth_as(rtweet_app("abc"))
  expect_equal(old, auth)
  auth_as(auth)
})

test_that("can save and reload auth", {
  withr::local_options("rtweet:::config_dir" = tempfile())

  auth1 <- rtweet_app("abc")
  suppressMessages({
    auth_save(auth1, "test")
    auth2 <- find_auth("test")
  })
  expect_equal(auth1, auth2, ignore_attr = TRUE)
})

test_that("find auth errors politely", {
  withr::local_options("rtweet:::config_dir" = tempfile())
  expect_snapshot(error = TRUE, {
    find_auth(1:10)
    find_auth("not-present")
  })
})

test_that("default_cached_auth() handles 0, 1, and n saved", {
  withr::local_options("rtweet:::config_dir" = tempfile())
  auth <- rtweet_app("abc")

  # Error if no default auth set up
  expect_snapshot(default_cached_auth(), error = TRUE)

  # Listing options if available
  suppressMessages(auth_save(auth, "test1"))
  suppressMessages(auth_save(auth, "test2"))
  expect_snapshot(default_cached_auth(), error = TRUE)

  # Uses default if present
  suppressMessages(auth_save(auth, "default"))
  expect_equal(default_cached_auth(), auth)
})

test_that("is_developing works", {
  expect_true(is_developing())
})

test_that("rtweet_user works", {
  skip("requires manual testing")
  # Avoid saving it but check that it is redirected in the browser.
  withr::local_options("rtweet:::config_dir" = tempfile())
  expect_error(rtweet_user())
})

test_that("rtweet_bot works", {
  skip("requires manual testing")
  withr::local_options("rtweet:::config_dir" = tempfile())
  expect_error(rtweet_bot(), NA)
})

test_that("rtweet_oauth2 works", {
  skip("requires manual testing")
  # Avoid saving it but check that it is redirected in the browser.
  withr::local_options("rtweet:::config_dir" = tempfile())
  expect_error(b <- rtweet_client(app = "academic_dev"))
  client_as(b)
  expect_error(rtweet_oauth2(), NA)
})

lists_params <- function(list_id = NULL, slug = NULL, owner_user = NULL, ...) {
  params <- list(...)

  if (is.null(list_id) && !is.null(slug) && !is.null(owner_user)) {
    params$slug <- slug
    params[[paste0("owner_", user_type(owner_user, "owner_user"))]] <- owner_user
  } else {
    params$list_id <- list_id
  }
  params
}

#' Get tweets from users, or users from tweets
#'
#' Twitter API endpoints that return tweets also return data about the users who
#' tweeted, and most endpoints that return users also return their last tweet.
#' Showing these additional columns would clutter the default display, so
#' rtweet instead stores in special attributes and allows you to show them
#' with the `user_data()` and `tweets_data()` helpers.
#'
#' @return `user_data()` returns a data frame of users; `tweets_data()`
#'   returns a data frame of tweets.
#' @param tweets A data frame of tweets.
#' @export
users_data <- function(tweets) {
  users <- attr(tweets, "users", exact = TRUE)
  if (is.null(users)) {
    abort("`tweets` does not have a `users` attribute", call = current_call())
  }
  users
}

#' @param users A data frame of users.
#' @rdname users_data
#' @export
tweets_data <- function(users) {
  tweets <- attr(users, "tweets", exact = TRUE)
  if (is.null(tweets)) {
    abort("`users` does not have a `tweets` attribute", call = current_call())
  }
  tweets
}

test_that("can retrieve multiple users", {
  
  users <- c("hadleywickham", "jennybryan")
  vcr::use_cassette("get_favorites1", {
    out <- get_favorites(users, n = 20)
  })
  expect_s3_class(out, "data.frame")
  expect_s3_class(out$created_at, "POSIXct")
  expect_equal(unique(out$favorited_by), users)
})

test_that("get_favorites returns tweets data", {
  
  n <- 100
  vcr::use_cassette("get_favorites2", {
    x <- get_favorites("kearneymw", n = n)
  })
  
  expect_equal(is.data.frame(x), TRUE)
  expect_named(x)
  expect_true("id" %in% names(x))
  expect_gt(nrow(x), 10)
  expect_gt(ncol(x), 15)
  expect_true(is.data.frame(users_data(x)))
  #expect_gt(nrow(users_data(x)), 0)
  #expect_gt(ncol(users_data(x)), 15)
  #expect_named(users_data(x))
})

vcr::use_cassette("get_favorites3", {
  test_that("favorites warns on a locked user", {
    
    expect_warning(gtf <- get_favorites("515880511"),
                   "Skipping unauthorized account: 515880511")
  })
})
# unauthorized 

vcr::use_cassette("get_favorites4", {
  test_that("favorites warns on a banned user", {
    
    expect_warning(gtf <- get_favorites("realdonaldtrump"),
                   "Skipping unauthorized account: realdonaldtrump")
  })
})

vcr::use_cassette("get_favorites5", {
  test_that("favorites warns on a locked user but continues", {
    
    expect_warning(gtf <- get_favorites(c("515880511" = "bhs928",
                                          "no_idea" = "Lluis_Revilla")),
                   "Skipping unauthorized account: bhs928")
  expect_gt(nrow(gtf), 2)
  expect_true(all(gtf$favorited_by == "Lluis_Revilla"))
  })
})

test_that("mentions returns tweets data", {
  
  vcr::use_cassette("mentions", {
    suppressMessages(x <- get_mentions())
  })

  expect_s3_class(x, "data.frame")
  expect_gt(nrow(x), 0)
})

vcr::use_cassette("mentions2", {
  test_that("mentions returns tweets format", {
    
    tw <- get_mentions()
    
    expect_s3_class(tw, "data.frame")
    expect_gt(nrow(tw), 0)
    expect_s3_class(users_data(tw), "data.frame")
    expect_true("id" %in% colnames(tw))
    
    expect_error(get_mentions(since_id = tw), NA)
  })
})

test_that("tweets_data works", {
  
  vcr::use_cassette("tweet_data1", {
    jack <- lookup_users("jack")
  })

  ## get data on most recent tweet from user(s)
  tweets <- tweets_data(jack)
  expect_s3_class(tweets, "data.frame")
  expect_true("id_str" %in% names(tweets))
})

test_that("users_data works", {
  
  vcr::use_cassette("tweet_data2", {
    tweets <- search_tweets("r")
  })
  users <- users_data(tweets)
  expect_s3_class(users, "data.frame")
})

coln <- c("created_at", "id", "id_str", "full_text", "truncated", "display_text_range",
          "entities", "source", "in_reply_to_status_id", "in_reply_to_status_id_str",
          "in_reply_to_user_id", "in_reply_to_user_id_str", "in_reply_to_screen_name",
          "geo", "coordinates", "place", "contributors", "retweeted_status",
          "is_quote_status", "quoted_status_id", "quoted_status_id_str",
          "quoted_status_permalink", "retweet_count", "favorite_count",
          "favorited", "retweeted", "lang", "possibly_sensitive", "quoted_status",
          "text")

test_that("lookup_statuses returns users data", {

  ids <- c("558115838503690243", "760182486005583872", "776053079540166657")
  vcr::use_cassette("ids1", {
    x <- lookup_tweets(ids)
  })
  expect_true(all(coln %in% colnames(x)))

  expect_s3_class(x, "data.frame")
  expect_equal(nrow(x), 2) # 558115838503690243 was deleted
})


test_that("lookup status no retweet, no reply no quote", {

  vcr::use_cassette("ids2", {
    status <- lookup_tweets("1333789433288540160")
  })
  expect_true(all(coln %in% colnames(status)))
})

test_that("lookup on reply, no quote no retweet", {

  vcr::use_cassette("ids3", {
    reply <- lookup_tweets("1333789435482161153")
  })
  expect_true(all(coln %in% colnames(reply)))
})

test_that("lookup on retweet quotting", {

  vcr::use_cassette("ids4", {
    retweet_quoted <- lookup_tweets("1390610121743556609")
  })
  expect_true(all(coln %in% colnames(retweet_quoted)))
})


test_that("lookup on retweet", {

  vcr::use_cassette("ids5", {
    retweet <- lookup_tweets("1390785143615467524")
  })
  expect_true(all(coln %in% colnames(retweet)))
})

test_that("lookup on users without tweets, #574", {

  vcr::use_cassette("ids6", {
    lu <- lookup_users("994659707766833153")
  })
  td <- tweets_data(lu)
  expect_equal(nrow(td), 1)
})

test_that("lookup on users with scopes, #615", {

  vcr::use_cassette("ids7", {
    lu <- lookup_tweets("1400810492843630598")
  })
  expect_equal(nrow(lu), 1)
})

test_that("Check coordinates on different autoformatting from jsonlite", {

  vcr::use_cassette("ids8", {
    lu <- lookup_tweets(c("368194158915506176"))
  })
  expect_true(is.list(lu$coordinates) && is.data.frame(lu$coordinates[[1]]))
  expect_equal(nrow(lu), 1)
})


test_that("Check that geo works well,  #648", {

  vcr::use_cassette("ids9", {
    lu <- lookup_tweets(c("1488182699202383875", "1373362476839022592", "1481348667307180033",
                          "930475046530936834", "914607458169081858"))
  })
  expect_true(is.list(lu$geo) && !is.data.frame(lu$geo))
})

test_that("Check lookup returns appropiate format,  #657", {

  vcr::use_cassette("ids10", {
    lu <- lookup_tweets("1488182699202383875")
  })
  expect_s3_class(lu$created_at, "POSIXct")
})

test_that("Lookup_tweets return same order on output #697", {
  thread <- c("1256278643224965120", "1256278643883442176", "1256278644508377088",
              "1256278645255008256", "1256278645905055745", "1256278646605504512",
              "1256278647226265600", "1256278647914156033", "1256278648690262018",
              "1256278649600225280")
  vcr::use_cassette("ids11", {
    out <- lookup_tweets(thread)
  })
  expect_equal(out$id_str, thread)
})

test_that(" Check output is in the same order #740", {

  vcr::use_cassette("ids12", {
    ## Empty dataframe
    names0a <- names(lookup_tweets("X"))

    ## Group 1 with same variables
    names1a <- names(lookup_tweets("1580002144631279616"))

    ## Group 2 with same variables
    names2a <- names(lookup_tweets("1578824308260237312"))

    ## Group 3 with same variables
    names3a <- names(lookup_tweets("1580186891151777792"))

    ## Group 4 with same variables
    names4a <- names(lookup_tweets("1580212580249133056"))

    ## Group 5 with same variables
    names5a <- names(lookup_tweets("1580172355699023872"))

    ## Group 6 with same variables
    names6a <- names(lookup_tweets("1579969347942219776"))

    names7a <- names(get_favorites("KFC"))
  })

  a <- tibble::tibble(names0a, names1a, names2a, names3a, names4a, names5a, names6a, names7a)
  b <- apply(a, 1, function(x){length(unique(x))})
  expect_true(all(b == 1))
})

test_that("lookup_users returns users data", {
  vcr::use_cassette("lookup_users1", {
    x <- lookup_users(c("cnn", "potus", "twitter", "kearneymw"))
  })
  expect_s3_class(x, "data.frame")
  expect_equal(nrow(x), 4)
})

test_that("lookup_users works", {

  users <- c(
    "potus", "hillaryclinton", "realdonaldtrump",
    "fivethirtyeight", "cnn", "espn", "twitter"
  )
  vcr::use_cassette("lookup_users2", {
    usr_df <- lookup_users(users)
  })
  expect_s3_class(usr_df, "data.frame")
  expect_equal(nrow(usr_df), 6)
  expect_equal(ncol(usr_df), 23)
})


test_that("users with same information, #654", {

  vcr::use_cassette("lookup_users3", {
    a <- lookup_users("alexpghayes")
  })
  vcr::use_cassette("lookup_users4", {
    d <- lookup_users("Corey_Yanofsky")
  })

  expect_length(setdiff(colnames(a), colnames(d)), 0)
})

test_that("Users with date formatting, #653", {

  vcr::use_cassette("lookup_users5", {
    x <- lookup_users("alexpghayes")
  })
  expect_s3_class(x$created_at, "POSIXct")
})

test_that("lookup_users only works with ids", {
  vcr::use_cassette("lookup_users1", {
    x <- lookup_users(c("cnn", "potus", "twitter", "kearneymw"))
  })

  twd <- tweets_data(x)
  skip_if_offline()
  expect_error(b <- lookup_tweets(twd), NA)
  expect_s3_class(b, "tweets")

})

test_that("do_call_rbind works", {
  ## lapply through three different search queries
  vcr::use_cassette("do_call_rbind", {
    lrt <- lapply( c("rstats OR tidyverse", "data science"), search_tweets, n = 10)
  })

  rt <- do_call_rbind(lrt)
  nrows <- vapply(lrt, nrow, numeric(1L))
  expect_s3_class(rt, "tweets")
  expect_equal(nrow(rt), sum(nrows))
  expect_equal(nrow(users_data(rt)), sum(nrows))
})

test_that("rbind works", {
  ## lapply through three different search queries
  vcr::use_cassette("rbind", {
    lrt <- lapply( c("rstats OR tidyverse", "data science"), search_tweets, n = 10)
  })

  nrows <- vapply(lrt, nrow, numeric(1L))
  rt <- rbind(lrt[[1]], lrt[[2]])

  expect_s3_class(rt, "tweets")
  expect_equal(nrow(rt), sum(nrows))
  expect_equal(nrow(users_data(rt)), sum(nrows))
})

test_that("[.tweets works", {
  ## lapply through three different search queries
  vcr::use_cassette("[.tweets", {
    st <- search_tweets("#rstats")
  })
  nrows <- 5
  x <- expect_error(st[seq_len(nrows), ], NA)

  expect_s3_class(x, "tweets")
  expect_equal(nrow(x), nrows)
  expect_equal(nrow(users_data(x)), nrows)

  # Not subsetting columns in the users data
  y <- expect_error(st[seq_len(nrows), 1:3], NA)
  expect_equal(ncol(y), 3)
  expect_equal(ncol(users_data(y)), 23)

  y <- st[c(1, 2), "full_text", drop = TRUE]
  expect_true(is.character(y))
  expect_length(y, 2)
  expect_true(is.null(attr(y, "users")))
  y <- st[c(1, 2), "full_text"]
  expect_s3_class(y, "data.frame")
  expect_length(y, 1)
  expect_true(!is.null(attr(y, "users")))
})

test_that("[.users works", {
  ## lapply through three different search queries
  vcr::use_cassette("[.users", {
    st <- search_users("#rstats")
  })
  nrows <- 5
  x <- expect_error(st[seq_len(nrows), ], NA)

  expect_s3_class(x, "users")
  expect_equal(nrow(x), nrows)
  expect_equal(nrow(tweets_data(x)), nrows)

  y <- expect_error(st[seq_len(nrows), 1:3], NA)
  expect_equal(ncol(y), 3)
  expect_equal(ncol(tweets_data(y)), ncol(tweet(NULL)) - 1)

  y <- st[c(1, 2), "name", drop = TRUE]
  expect_true(is.character(y))
  expect_length(y, 2)
  expect_true(is.null(attr(y, "tweets")))
  y <- st[c(1, 2), "name"]
  expect_s3_class(y, "data.frame")
  expect_length(y, 1)
  expect_true(!is.null(attr(y, "tweets")))
})

#' Extract cursor (for cursor based pagination)
#'
#' This internal helper extracts the cursor from the object passed to the
#' `cursor` argument of the functions that use [TWIT_paginate_cursor()].
#'
#' @keywords internal
#' @export
next_cursor <- function(x) {
  if (is_string(x) || is_null(x)) {
    x
  } else if (is.data.frame(x)) {
    cursor <- attr(x, "rtweet_cursor")
    if (is.null(cursor)) {
      abort("`cursor` must have a `rtweet_cursor` attribute")
    }
    cursor
    # Premium APIs 1.1 with environment use next
  } else if (is.list(x)) {
    x[["next"]]
  }  else {
    abort("`cursor` must be a string or data frame")
  }
}

copy_cursor <- function(to, from) {
  attr(to, "rtweet_cursor") <- attr(from, "rtweet_cursor")
  to
}

#' Previous cursor
#'
#' @description
#' `r lifecycle::badge("deprecated")`
#' Reverse pagination is no longer supported.
#'
#' @keywords internal
#' @export
previous_cursor <- function(x) {
  lifecycle::deprecate_stop("1.0.0", "previous_cursor()")
}

#' Extract min/max id (for id based pagination)
#'
#' These internal helpers extract the ids passed on to the `max_id`
#' and `since_id` arguments to functions that use [TWIT_paginate_max_id()].
#'
#' @keywords internal
#' @param x Either a data frame of tweets or a character vector of status ids.
#' @export
max_id <- function(x) {
  id <- find_id(x, "max_id")
  as.character(min(bit64::as.integer64(id)) - 1L)
}

#' @rdname next_cursor
#' @export
since_id <- function(x) {
  id <- find_id(x, "since_id")
  as.character(max(bit64::as.integer64(id)))
}

find_id <- function(x, arg_name) {
  if (is.character(x)) {
    x
  } else if (is.data.frame(x)) {
    if (!has_name(x, "id"))  {
      abort(paste0("`", arg_name, "` must contain a `id` column"))
    }
    y <- x$id
    if (is.factor(y)) {
      y <- as.numeric(levels(y))[y]
    }
    y
  } else {
    abort(paste0("`", arg_name, "` must be a character vector or data frame"))
  }
}

# cursor ------------------------------------------------------------------

test_that("next_cursor works with character and data frames", {
  expect_equal(next_cursor("abc"), "abc")
  
  df <- data.frame(x = 1:2)
  attr(df, "rtweet_cursor") <- "def"
  expect_equal(next_cursor(df), "def")
})

test_that("next_cursor generates informative errors", {
  expect_snapshot(error = TRUE, {
    next_cursor(letters)
    next_cursor(mtcars)
  })
})


# id ----------------------------------------------------------------------

test_that("max_id and since_id work in bit64", {
  expect_equal(max_id("0"), "-1")
  expect_equal(max_id(c("50", "100")), "49")
  
  expect_equal(since_id(c("50", "100")), "100")
})

test_that("max_id and since_id work with data frames", {
  df <- data.frame(id = "123", stringsAsFactors = FALSE)
  expect_equal(max_id(df), "122")
  expect_equal(since_id(df), "123")
})

test_that("max_id and since_id work with data frames and factors", {
  df <- data.frame(id = "123")
  expect_equal(max_id(df), "122")
  expect_equal(since_id(df), "123")
})

test_that("max_id and since_id generate informative erorrs", {
  expect_snapshot(error = TRUE, {
    max_id(10)
    max_id(mtcars)
    
    since_id(10)
    since_id(mtcars)
  })
})

test_that("get_followers returns expected data", {
  
  vcr::use_cassette("get_followers", {
    users <- get_followers("KFC")
  })
  
  # expect_s3_class(users, "data.frame")
  expect_named(users, c("from_id", "to_id"))
  expect_equal(nrow(users), 5000)
  
  expect_type(next_cursor(users), "character")
})


vcr::use_cassette("get_followers2", {
  test_that("n = Inf works", {
    expect_error(get_followers("_R_Foundation", n = Inf, 
                                      retryonratelimit = FALSE), NA)
  })
})

# Contains functions to parse the objects described here: 
# https://developer.twitter.com/en/docs/twitter-api/v1/data-dictionary/object-model/geo

bounding_box <- function(x) {
  empty <- data.frame(long = NA, lat = NA, type = NA)
  if (is.null(x) || (identical(x, NA))) {
    return(empty)
  }
  if (is.data.frame(x)) {
    coord <- x$coordinates[[1]][1, , ]
    if (is.null(coord)) {
      return(empty)
    }
    return(data.frame(long = coord[, 1], lat = coord[, 2], type = x$type))
  }
  m <- x$coordinates[1, , ]
  colnames(m) <- c("long", "lat")
  df <- as.data.frame(m)
  df$type <- x$type
  df
}

# <https://developer.twitter.com/en/docs/twitter-api/v1/data-dictionary/object-model/geo#coordinates>
coordinates <- function(x) {
  if (is.null(x) || length(x) == 1 && is.na(x)) {
    return(data.frame(long = NA, lat = NA, type = NA))
  }
  if (has_name_children(x, "coordinates", "coordinates")) {
    return(data.frame(long = x$coordinates[[1]], lat = x$coordinates[[2]], type = x$type))
  }
  if (is.logical(x)) {
    nas <- rep(NA, length(x))
    return(data.frame(long = nas, lat = nas, type = nas))
  }
  if (is.data.frame(x)) {
    pos_coord <- function(y, pos){
      if (is.null(y)) {
        NA_real_
      } else {
        y[pos]
      }
    }
    long <- vapply(x$coordinates, pos_coord, numeric(1L), pos = 1)
    lat <- vapply(x$coordinates, pos_coord, numeric(1L), pos = 2)
    
    return(data.frame(long = long, lat = lat, type = x$type))
  }

  data.frame(long = x$coordinates[[1]], lat = x$coordinates[[2]], type = x$type)
}

# <https://developer.twitter.com/en/docs/twitter-api/v1/data-dictionary/object-model/geo#place>
place <- function(x) {
  if (is.null(x) || length(x) == 1 && is.na(x)) {
    df <- data.frame(geo = I(list(coordinates(NA))), 
                     coordinates = I(list(coordinates(NA))),
                             place = I(list(NA)))
    return(df)
  }

  if (is.data.frame(x)) {
    l <- simplify2array(x[!colnames(x) %in% c("geo", "coordinates", "bounding_box")])
  } else if (is.list(x)) {
    l <- simplify2array(x[!names(x) %in% c("geo", "coordinates", "bounding_box")])
    if (nrow(l) != 1) {
      l <- t(l)
    }
  }
  place <- as.data.frame(l)
  place$bounding_box <- list(bounding_box(x$bounding_box))
  
  data.frame(geo = I(coordinates(x$geo)),
            coordinates = I(coordinates(x$coordinates)),
            place = I(place))
}

test_that("bounding_box works", {
  bb <- jsonlite::fromJSON('{
  "bounding_box": {
    "coordinates": [
      [
        [
          -74.026675,
          40.683935
        ],
        [
          -74.026675,
          40.877483
        ],
        [
          -73.910408,
          40.877483
        ],
        [
          -73.910408,
          40.3935
        ]
      ]
    ],
    "type": "Polygon"
  }
}')
  out <- bounding_box(bb$bounding_box)
  expect_s3_class(out, "data.frame")
  expect_named(out, c("long", "lat", "type"))
  expect_equal(ncol(out), 3)
  expect_equal(nrow(out), 4)
})


test_that("place works", {
  exact_location <- jsonlite::fromJSON('{
  "geo": {
    "type": "Point",
    "coordinates": [
      40.74118764,
      -73.9998279
    ]
  },
  "coordinates": {
    "type": "Point",
    "coordinates": [
      -73.9998279,
      40.74118764
    ]
  },
  "place": {
    "id": "01a9a39529b27f36",
    "url": "https://api.twitter.com/1.1/geo/id/01a9a39529b27f36.json",
    "place_type": "city",
    "name": "Manhattan",
    "full_name": "Manhattan, NY",
    "country_code": "US",
    "country": "United States",
    "bounding_box": {
      "type": "Polygon",
      "coordinates": [
        [
          [
            -74.026675,
            40.683935
          ],
          [
            -74.026675,
            40.877483
          ],
          [
            -73.910408,
            40.877483
          ],
          [
            -73.910408,
            40.683935
          ]
        ]
      ]
    },
    "attributes": {

    }
  }
}')
  out <- place(exact_location)
  expect_s3_class(out, "data.frame")

})


vcr::use_cassette("geo_objects1", {
  test_that("coordinates work", {

    minimal_coord <- structure(
      list(type = "Point",
           coordinates = list(c(-85.6445217, 42.9360473))),
      row.names = 45L, class = "data.frame")

    expect_error(out <- coordinates(minimal_coord), NA)
    expect_equal(nrow(out), 1)
    expect_equal(ncol(out), 3)
    expect_equal(out$type[1], "Point")
  })
})

#' Liking users
#'
#' Looks up who have liked a given tweet.
#' @inheritParams filtered_stream
#' @param ... Other arguments passed to the API.
#' @param n Number of tweets to query.
#' @param verbose A logical value to provide more information about paginated queries.
#' @param id A tweet id string.
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/tweets/likes/api-reference/get-tweets-id-liking_users>
#' @examples
#' if (FALSE) {
#'   tlu <- tweet_liking_users("567053242429734913", n = Inf, verbose = TRUE)
#' }
tweet_liking_users <- function(id, n = 100, expansions = NULL, fields = NULL, ...,
                               token = NULL, parse = TRUE, verbose = FALSE) {

  expansions <- check_expansions(arg_def(expansions, "pinned_tweet_id"),
                                 "pinned_tweet_id")
  fields <- check_fields(arg_def(fields, set_fields()),
                         metrics = NULL,
                         place = NULL,
                         media = NULL,
                         poll = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  stopifnot(is_n(n))
  if (length(id) != 1 || !is_id(id)) {
    abort("Please introduce a single valid id")
  }
  data <- c(list(expansions = expansions), fields, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  url <- paste0("tweets/", id, "/liking_users")

  max_results <- check_interval(n, 1, formals()$n)
  n_pages <- ceiling(n / max_results)
  data <- c(max_results = max_results, data)

  # Rates from the website app and user limits
  token <- check_token_v2(token, c("bearer", "pkce"))
  check_scopes_token(token, c("tweet.read", "users.read", "like.read"))
  rate <- check_rate(token, 75/(60*15), 75/(60*15))
  req_archive <- endpoint_v2(token, url, rate)
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, n_pages, n, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

all_scopes <- c("tweet.read", "users.read", "follows.read", "space.read",
                "mute.read", "like.read", "block.read", "bookmark.read",
                "list.read",
                "tweet.write", "tweet.moderate.write", "follows.write", "offline.access", "mute.write", "like.write",
                "list.write",  "block.write",  "bookmark.write"
)

endpoints <- c("tweet", "users", "follows", "space", "mute", "like", "list", "block", "bookmark")

#' Scopes of the OAuth2 token
#'
#' Permissions given to a token of a Twitter account.
#' By default it allows everything.
#' @export
#' @param read Allow to read.
#' @param write Allow to write/manage?
#' @param tweet_moderate Allow to hide or show replies to your Tweets.
#' @param regenerate Allow to use the token for more than 2 hours.
#' @returns A character with all the possible scopes or those allowed.
#' @references <https://developer.twitter.com/en/docs/authentication/oauth-2-0/authorization-code>
#' @examples
#' set_scopes()
set_scopes <- function(read = TRUE, write = TRUE, tweet_moderate = TRUE, regenerate = TRUE) {
  scopes <- c()
  if (isTRUE(read) && isTRUE(write)) {
    scopes <- c(scopes, all_scopes)
  }
  if (isTRUE(read) && is.null(endpoints)) {
    scopes <- all_scopes[endsWith(all_scopes, ".read")]
  }
  if (isTRUE(write) && is.null(endpoints)) {
    scopes <- all_scopes[endsWith(all_scopes, ".write")]
  } else if (isTRUE(write)) {

  }
  if (isTRUE(tweet_moderate)) {
    scopes <- c(scopes, "tweet.moderate")
  }
  # To allow to regenerate the token we need to provide the offline.access:
  if (isTRUE(regenerate)) {
    scopes <- c(scopes, "offline.access")
  }
  scopes
}

get_scopes <- function(token) {
  token <- check_token_v2(token, "pkce")
  strsplit(token$scope, " ")[[1]]
}

check_scopes <- function(scopes, required = NULL) {
  if (is.null(required)) {
    diff <- setdiff(scopes, all_scopes)
    if (length(diff) != 0) {
      msg <- paste0("Scopes required are not valid: ",
                    paste0(sQuote(diff), collapse = ", "))
      abort(msg, call = current_call())
    }
  }
  missing <- setdiff(required, scopes)
  if (length(missing) != 0) {
    msg <- c("This endpoint requires missing scopes.",
             paste0("Authenticate with scopes:", paste0(sQuote(missing), collapse = ", ")))
    abort(msg, call = current_call())
  }
  TRUE
}

check_scopes_token <- function(token, required) {
  if (!auth_is_pkce(token)) {
    return(TRUE)
  }
  check_scopes(required)
  check_scopes(get_scopes(token), required)
  TRUE
}

#' Get user IDs for accounts following target user.
#'
#' Returns a list of user IDs for the accounts following specified
#' user. `r lifecycle::badge("deprecated")`
#'
#' @inheritParams TWIT_paginate_cursor
#' @inheritParams get_timeline
#' @inheritParams stream
#' @param page `r lifecycle::badge("deprecated")` Please use `cursor` instead.
#' @seealso [`rtweet-deprecated`]
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-followers-ids>
#' @examples
#' if (FALSE) {
#'   users <- get_followers("_R_Foundation")
#' }
#' @return A tibble data frame with one column named "from_id" with the
#' followers and another one "to_id" with the user used as input.
#' @export
get_followers <- function(user, n = 5000,
                          cursor = "-1",
                          retryonratelimit = NULL,
                          parse = TRUE,
                          verbose = TRUE,
                          token = NULL,
                          page = lifecycle::deprecated()) {

  if (lifecycle::is_present(page)) {
    lifecycle::deprecate_warn("1.0.0", "get_followers(page)", "get_followers(cursor)")
    cursor <- page
  }

  stopifnot(is.atomic(user) && !is.null(user), isTRUE(length(user) == 1))

  params <- list(stringify_ids = TRUE)
  params[[user_type(user)]] <- user

  results <- TWIT_paginate_cursor(token, "/1.1/followers/ids", params,
    page_size = if (n >= 5000) 5000 else n,
    n = n,
    cursor = cursor,
    retryonratelimit = retryonratelimit,
    verbose = verbose
  )

  if (parse) {
    df <- tibble::tibble(from_id = unlist(lapply(results, function(x) x$ids)),
                         to_id = user)
    results <- copy_cursor(df, results)
    class(results) <- c("followers", class(results))
  }
  results
}

test_that("TWIT_paginte_max_id respects max_id and since_id", {

  simple_timeline <- function(...) {
    r <- TWIT_paginate_max_id(NULL, "/1.1/statuses/user_timeline",
                              list(screen_name = "JustinBieber"),
                              n = 100,
                              ...
    )
    tweets_with_users(r)[1:10]
  }
  vcr::use_cassette("http1", {
    base <- simple_timeline()
  })

  vcr::use_cassette("http2", {
    # check that we can ask for older tweets
    older <- simple_timeline(max_id = base)
  })
  expect_true(min(format_date(older$created_at)) < min(format_date(base$created_at)))

  # asking for newer tweets should give back the original data
  vcr::use_cassette("http3", {
    base2 <- simple_timeline(since_id = older)
  })
  expect_length(intersect(base$id, base2$id), nrow(base))
})

test_that("TWIT_paginte_cursor respects cursor", {

  vcr::use_cassette("http4", {
    page1 <- get_followers("JustinBieber")
  })
  vcr::use_cassette("http5", {
    page2 <- get_followers("JustinBieber", cursor = page1)
  })
  expect_length(intersect(page1$from_id, page2$from_id), 0)
})

test_that("pagination with rate limits works", {
  skip("requires manual testing")
  # One needs to wait 15 minutes...
  df_follower <- get_followers("CDU", n = 80000L, retryonratelimit = TRUE)
  expect_equal(nrow(df_follower), 80000L)
})

#' Follows target Twitter user.
#'
#' `r lifecycle::badge("deprecated")`
#' @inheritParams get_timeline
#' @param destroy Logical indicating whether to post (add) or
#'   remove (delete) target tweet as favorite.
#' @param mute Logical indicating whether to mute the intended
#'   friend (you must already be following this account prior
#'   to muting them)
#' @param notify Logical indicating whether to enable notifications
#'   for target user. Defaults to false.
#' @param retweets Logical indicating whether to enable retweets
#'   for target user. Defaults to true.
#' @aliases follow_user
#' @family post
#' @seealso [`rtweet-deprecated`]
#' @export
#' @references
#' Update: <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/post-friendships-update>
#' Create: <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/post-friendships-create>
#' Destroy: <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/post-friendships-destroy>
#' Mute: <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/mute-block-report-users/api-reference/post-mutes-users-create>
post_follow <- function(user,
                        destroy = FALSE,
                        mute = FALSE,
                        notify = FALSE,
                        retweets = TRUE,
                        token = NULL) {

  stopifnot(is.atomic(user) && !is.null(user), is_logical(notify))

  if (all(!destroy, !retweets)) {
    query <- "/1.1/friendships/update"
    params <- list(
      notify = notify,
      retweets = retweets)
  } else if (mute) {
    query <- "/1.1/mutes/users/create"
    params <- list()
  } else if (destroy) {
    query <- "/1.1/friendships/destroy"
    params <- list(
      notify = notify)
  } else {
    query <- "/1.1/friendships/create"
    params <- list(
      notify = notify
    )
  }
  params[[user_type(user)]] <- user

  TWIT_post(token, query, params)
}



#' @aliases unfollow_user
#' @rdname post_follow
#' @export
post_unfollow_user <- function(user, token = NULL) {
  post_follow(user, destroy = TRUE, token = token)
}

#' @aliases unfollow_user
#' @rdname post_follow
#' @aliases mute_user
#' @export
post_mute <- function(user, token = NULL) {
  post_follow(user, mute = TRUE, token = token)
}

#' Updates friendship notifications and retweet abilities.
#'
#' @inheritParams get_timeline
#' @param device Logical indicating whether to enable or disable
#'    device notifications from target user behaviors. Defaults
#'    to false.
#' @param retweets Logical indicating whether to enable or disable
#'    retweets from target user behaviors. Defaults to false.
#' @aliases friendship_update
#' @family post
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/post-friendships-update>
post_friendship <- function(user,
                            device = FALSE,
                            retweets = FALSE,
                            token = NULL) {

  stopifnot(is.atomic(user) && !is.null(user), is_logical(device),
            is_logical(retweets))

  params <- list(
    device = device,
    retweets = retweets
  )
  params[[user_type(user)]] <- user

  TWIT_post(token, "/1.1/friendships/update", params)
}

test_that("can follow and unfollow", {
  vcr::use_cassette("post_follow1", {
    pf <- post_follow("BarackObama")
  })
  expect_equal(httr::status_code(pf), 200L)

  vcr::use_cassette("post_follow2", {
    pf <- post_follow("BarackObama", destroy = TRUE)
  })
  expect_equal(httr::status_code(pf), 200L)
})

test_that("can follow and unfollow with notifications", {
  vcr::use_cassette("post_follow3", {
    pf <- post_follow("BarackObama", notify = TRUE)
  })
  expect_equal(httr::status_code(pf), 200L)

  vcr::use_cassette("post_follow4", {
    pf <- post_follow("BarackObama", destroy = TRUE)
  })
  expect_equal(httr::status_code(pf), 200L)
})

test_that("Muting  #467", {

  vcr::use_cassette("post_follow5", {
    pf <- post_follow("hlynur", destroy = TRUE, mute = TRUE, notify = TRUE)
  })
  expect_equal(httr::status_code(pf), 200L)
  # Unmutting without following
  vcr::use_cassette("post_follow6", {
    pf <- post_follow("hlynur", destroy = TRUE, mute = FALSE, notify = TRUE)
  })
  expect_equal(httr::status_code(pf), 200L)
})

#' Job compliance
#'
#' @param ids Ids of tweets or users to check.
#' @param name Name of the job.
#' @param type Type of ids: either 'tweets' or 'users'.
#' @param resumable A logical value if the job is resumable.
#' @param token Bearer token used.
#'
#' @references <https://developer.twitter.com/en/docs/twitter-api/compliance/batch-compliance/api-reference>
#' Submit job: <https://developer.twitter.com/en/docs/twitter-api/compliance/batch-compliance/api-reference/post-compliance-jobs>
#' Job status: <https://developer.twitter.com/en/docs/twitter-api/compliance/batch-compliance/api-reference/get-compliance-jobs-id>
#' Jobs list: <https://developer.twitter.com/en/docs/twitter-api/compliance/batch-compliance/api-reference/get-compliance-jobs>
#' @keywords internal
job_compliance <- function(ids, name, type, resumable = TRUE, token = NULL) {
  # To store the token at the right place: see ?httr2::oauth_cache_path
  withr::local_envvar(HTTR2_OAUTH_CACHE = auth_path())
  type <- match.arg(type, c("tweets", "users"))
  stopifnot(is_logical(resumable))
  stopifnot(is.character(name) && length(name) == 1)
  req_jobs <- endpoint_v2("compliance/jobs", 150/(60*15), c("tweets", "users"))
  resp <- httr2::req_perform(req_jobs)
}

# Check guide if resumable = FALSE requires different handling
upload_ids <- function(upload_url, ids) {

}

job_status <- function(job_id, token = NULL) {
  url <- paste0("compliance/jobs/", job_id)
  req_jobs <- endpoint_v2(url, 150/(60*15), c("tweets", "users"))
}

job_list <- function(type, status = "all", token = NULL) {
  type <- match.arg(type, c("tweets", "users"))
  status <- match.arg(type, c("created", "in_progress", "failed", "complete", "all"))
  req_jobs <- endpoint_v2("compliance/jobs",
                          150/(60*15), set_scopes())
  # Add expiration date of jobs (1 week after creation)
}

job_download <- function() {

}

#' Clean text of tweets
#'
#' Removes from the text, users mentions, hashtags, urls and media.
#' Some urls or other text might remain if it is not recognized as an entity by
#' the API. `r lifecycle::badge("deprecated")`
#' @param x Tweets
#' @param clean Type of elements to be removed.
#' @seealso [`rtweet-deprecated`]
#' @return A vector with the text without the entities selected
#' @export
clean_tweets <- function(x, clean = c("users", "hashtags", "urls", "media")) {
  if (is.character(x)) {
    abort("You should provide tweets with all the users and hashtags information",
          call = current_call())
  }

  tweets <- nrow(x)
  final_text <- vector(mode = "character", length = tweets)
  clean <- match.arg(clean, several.ok = TRUE)
  for (tweet_n in seq_len(tweets)) {
    text <- x$full_text[tweet_n]

    start <- vector("numeric")
    end <- vector("numeric")
    if ("users" %in% clean) {
      i <- x$entities[[tweet_n]][["user_mentions"]][["indices"]]
      if (!is.null(i)) {
        start <- c(start, i_type(i))
        end <- c(end, i_type(i, type = "end"))
      }
    }

    if ("hashtags" %in% clean) {
      hashtags <- x$entities[[tweet_n]][["hashtags"]][["indices"]]
      if (!is.null(hashtags)) {
        i <- as.data.frame(do.call(rbind, hashtags))

        start <- c(start, i_type(i))
        end <- c(end, i_type(i, type = "end"))
      }
    }

    if ("media" %in% clean) {
      media <- x$entities[[tweet_n]][["media"]][["indices"]]
      if (!is.null(media)) {
        i <- as.data.frame(do.call(rbind, media))
        start <- c(start, i_type(i))
        end <- c(end, i_type(i, type = "end"))
      }
    }

    if ("urls" %in% clean) {
      i <- x$entities[[tweet_n]][["urls"]][["indices"]]
      if (!is.null(i)) {
        start <- c(start, i_type(i))
        end <- c(end, i_type(i, type = "end"))
      }
    }
    nothing <- start != 0
    start <- start[nothing]
    end <- end[nothing]

    if (length(start) < 1) {
      final_text[tweet_n] <- text
    } else {
      # message(tweet_n)
      final_text[tweet_n] <- repaste(text, start, end)
    }
  }
  # Remove tags about retweets
  gsub("RT : ", final_text, replacement = "", fixed = TRUE)
}

i_type <- function(x, type = "start") {
  if (length(x) == 1 && is.na(x)) {
    return(0)
  }
  x[[type]]
}

repaste <- function(text, start, stop) {
  stopifnot(length(text) == 1)
  text <- strsplit(text, "")[[1]]
  remove <- vector(mode = "numeric")
  # Account for index starting at 0 in Twitter API output
  start <- start + 1
  for (s_p in seq_along(start)) {
    position_str <- seq(from = start[s_p], to = stop[s_p])
    remove <- c(remove, position_str)
  }
  paste(text[-remove], collapse = "")
}

test_that("clean_tweets works", {

  vcr::use_cassette("clean_tweets", {
    tweet1 <- lookup_tweets("1576990222075985920")
  })

  out1 <- clean_tweets(tweet1)
  expect_equal(out1,
               "Código para baixar os dados da votação presidencial, por municípios, em R ()\n\n(Produzido junto com o )\n\n \n\n")
  expect_true(is.character(out1))
})

# Helper function for testing

testing_with_authentication <- function(auth) {
  skip_if_offline()
  if (!auth %in% auth_list()) {
    skip("Requires a different authentication")
  }
  withr::defer_parent(auth_as(auth_get()))
  auth_as(auth)
}

test_that("retweeted_by works", {
  skip_if_offline()
  testing_with_authentication("bearer_testing_app")
  # Pinned tweets where deleted so there will be errors
  expect_error(tweet_retweeted_by("567053242429734913", parse = FALSE), NA)
  rb <- tweet_retweeted_by("567053242429734913", parse = TRUE)
  expect_s3_class(rb, "data.frame")

})

test_that("enlist works well", {
  # In case of a data.frame
  tweet <- list(a = structure(list(a = 1:2, b = c("a", "b")),
                              class = "data.frame", row.names = c(NA, -2L)),
                id = "1638199517878140929",
                d = 1)
  # Transforms
  expect_true(lengths(tweet["a"]) != lengths(enlist(tweet)["a"]))
  expect_true(lengths(enlist(tweet)["a"]) == 1)

  # Same but for a vector
  tweet$a <- 1:2
  expect_true(lengths(tweet["a"]) != lengths(enlist(tweet)["a"]))
  expect_true(lengths(enlist(tweet)["a"]) == 1)
})

test_that("rbinding nested structures", {
  tweet <- list(a = structure(list(a = 1:2, b = c("a", "b")),
                              class = "data.frame", row.names = c(NA, -2L)),
                id = "1638199517878140929",
                d = 1)
  b <- do.call(rbind, list(list2DF(enlist(tweet)), list2DF(enlist(tweet))))
  expect_s3_class(b, "data.frame")
  expect_equal(ncol(b), 3)
  expect_length(vapply(b, class, character(1L)), ncol(b))

  tweet$a <- c(1:2)
  b <- do.call(rbind, list(list2DF(enlist(tweet)), list2DF(enlist(tweet))))
  expect_s3_class(b, "data.frame")
  expect_equal(ncol(b), 3)
  expect_length(vapply(b, class, character(1L)), ncol(b))
})

test_that("parse with multiple edits", {
  skip_on_cran()
  testing_with_authentication("bearer_testing_app")
  out <- tweet_get("1638199517878140929")
  expect_s3_class(out, "data.frame")
  expect_true(nrow(out) == 1)
})

test_that("search_fullarchive works", {
  skip_if_offline()
  # Use app with a premium account that matches the env_names
  testing_with_authentication("bearer_testing_app")
  expect_snapshot(
    df <- search_fullarchive( q = '#covid place:UK OR place:GB OR place:"United Kindom"',
                              n = 20, env_name = 'fullArchive',
                              fromDate = "201810010000"))
  expect_equal(nrow(df), 20)
})

test_that("search_fullarchive queries bigger than page size work", {
  skip_if_offline()
  # Use app with a premium account that matches the env_names
  testing_with_authentication("bearer_testing_app")
  expect_snapshot(
    df <- search_fullarchive( q = '#covid place:UK OR place:GB OR place:"United Kindom"',
                              n = 20, env_name = 'fullArchive',
                              fromDate = "201810010000"))
  expect_equal(nrow(df), 20)
})

test_that("search_fullarchive does not return duplicate tweets", {
  skip_if_offline()
  # Use app with a premium account that matches the env_names
  testing_with_authentication("bearer_testing_app")
  expect_snapshot(
    df <- search_fullarchive(q="#halalan22", n = 450,
                                       env_name = "fullArchive",
                                       fromDate = "202202080000", toDate = "202205100000",
                                       parse = TRUE)
  )
  expect_gt(nrow(df), 450)
})

test_that("list_tweets works", {
  testing_with_authentication("bearer_testing_app")
  lt <- list_tweets("1150793074420998146")
  expect_s3_class(lt, "data.frame")
  expect_true(all(c("edit_history_tweet_ids", "id", "text") %in% colnames(lt)))
})

test_that("list_followers works", {
  testing_with_authentication("bearer_testing_app")
  lf <- list_followers("1150793074420998146")
  expect_s3_class(lf, "data.frame")
  expect_true(all(c("id", "name", "username") %in% colnames(lf)))
})

test_that("get_tweet works", {
  skip_if_offline()
  testing_with_authentication("bearer_testing_app")
  gt1 <- tweet_get("567053242429734913", parse = FALSE)
  expect_true(inherits(gt1, "list"))
  gt2 <- tweet_get(c("567053242429734913", "567053242429734913"), parse = TRUE)
  expect_s3_class(gt2, "page")
  expect_length(gt2, 3)
  gt2_parsed <- tweet_get(c("567053242429734913", "567053242429734913"),
                          parse = TRUE)
  expect_s3_class(gt2_parsed, "data.frame")
  expect_equal(dim(gt2_parsed), c(2, 3))
})

test_that("get_tweets works with expansions and fields", {
  skip_if_offline()
  testing_with_authentication("bearer_testing_app")
  # From issue #757
  expect_error(
    tweet_get("1615009611186069504",
              expansions = 'attachments.media_keys',
              fields = NA, parse = FALSE))
  expect_error(
    gt4 <- tweet_get("1615009611186069504",
                     expansions = 'attachments.media_keys',
                     fields = set_fields(media = "alt_text", NULL, NULL, NULL, NULL, NULL),
                     parse = FALSE), NA)
  expect_equal(gt4[[1]]$includes$media$alt_text, "sort 893")
  expect_error(
    tweet_get("1615009611186069504",
              fields = set_fields(media = "alt_text", NULL, NULL, NULL, NULL, NULL),
              parse = FALSE))
  expect_error(
    tweet_get("1615009611186069504",
              expansions = 'attachments.media_keys',
              parse = FALSE), NA)
})

#' Get one or more user timelines
#'
#' `get_timeline()` returns the timeline of any Twitter user (i.e. what they
#' have tweeted). `get_my_timeline()` returns the home timeline for the
#' authenticated user (i.e. the tweets you see when you log into Twitter).
#' `r lifecycle::badge("deprecated")`
#' At most up to 3,200 of a user's most recent Tweets can be retrieved.
#'
#' @inheritParams TWIT_paginate_max_id
#' @inheritParams stream
#' @param user Character vector of screen names or user ids.
#'   See [as_screenname()] for more details.
#' @param home Logical, indicating whether to return a "user" timeline
#'   (the default, what a user has tweeted/retweeted) or a "home" timeline
#'   (what the user would see if they logged into twitter).
#' @param check `r lifecycle::badge("deprecated")`
#' @param ... Further arguments passed on as parameters in API query.
#' @return A tbl data frame of tweets data with users data attribute.
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/timelines/overview>
#' @family tweets
#' @seealso [user_timeline()], [`rtweet-deprecated`]
#' @export
get_timeline <- function(user = NULL,
                         n = 100,
                         since_id = NULL,
                         max_id = NULL,
                         home = FALSE,
                         parse = TRUE,
                         check = TRUE,
                         retryonratelimit = NULL,
                         verbose = TRUE,
                         token = NULL,
                         ...) {

  if (!isFALSE(home)) {
    lifecycle::deprecate_stop("1.0.0", "get_timeline(home)")
  }

  user <- user %||% api_screen_name()

  rt <- lapply(user, get_timeline_user,
    n = n,
    since_id = since_id,
    max_id = max_id,
    home = FALSE,
    parse = parse,
    check = check,
    retryonratelimit = retryonratelimit,
    verbose = verbose,
    token = token,
    ...
  )

  if (parse) {
    rt <- do.call(rbind, rt)
    rt$created_at <- format_date(rt$created_at)
  }

  rt
}


#' @rdname get_timeline
#' @export
get_my_timeline <- function(n = 100,
                            since_id = NULL,
                            max_id = NULL,
                            parse = TRUE,
                            check = TRUE,
                            retryonratelimit = NULL,
                            verbose = TRUE,
                            token = NULL,
                            ...) {

  get_timeline_user(
    user = api_screen_name(),
    n = n,
    home = TRUE,
    since_id = since_id,
    max_id = max_id,
    parse = parse,
    retryonratelimit = retryonratelimit,
    verbose = verbose,
    token = token,
    ...
  )
}

get_timeline_user <- function(user,
                              n = 200,
                              since_id = NULL,
                              max_id = NULL,
                              home = FALSE,
                              parse = TRUE,
                              retryonratelimit = NULL,
                              verbose = TRUE,
                              token = NULL,
                              ...) {
  api <- if (home) "/1.1/statuses/home_timeline" else "/1.1/statuses/user_timeline"

  params <- list(
    # Undocumented parameter https://github.com/ropensci/rtweet/issues/575#issuecomment-829605892
    tweet_mode = "extended",
    ...
  )
  params[[user_type(user)]] <- user

  result <- TWIT_paginate_max_id(token, api, params,
    n = n,
    page_size = 200,
    since_id = since_id,
    max_id = max_id,
    retryonratelimit = retryonratelimit,
    verbose = verbose,
  )

  if (parse) {
    result <- tweets_with_users(result)
  }
  result
}

#' @export
#' @rdname get_timeline
#' @usage NULL
get_timelines <- function(user,
                          n = 100,
                          max_id = NULL,
                          home = FALSE,
                          parse = TRUE,
                          check = TRUE,
                          token = NULL,
                          ...) {

  lifecycle::deprecate_warn("1.0.0", "get_timelines()", "get_timeline()")

  get_timeline(user, n, max_id = max_id, home = home, parse = parse, token = token, ...)
}

test_that("get_timeline works", {

  vcr::use_cassette("get_timeline1", {
    x <- get_timeline(c("cnnbrk", "cnn"))
  })
  expect_s3_class(x, "data.frame")
  expect_true("id" %in% names(x))
  expect_gt(nrow(x), 20)
  expect_gt(ncol(x), 20)
})

test_that("get_my_timeline() works", {
  # Use a user account
  testing_with_authentication("default")
  # Use user identification not the bot
  vcr::use_cassette("get_timeline2", {
    gmt <- get_my_timeline()
  })
  expect_s3_class(gmt, "data.frame")
  expect_true(nrow(gmt) > 50)
})

test_that("get_timelines() is deprecated", {

  vcr::use_cassette("get_timeline3", {
    expect_snapshot(x <- get_timelines("cnn", n = 10))
  })
})

test_that("Doesn't trim at 280 characters, #575", {

  vcr::use_cassette("get_timeline4", {
    timeline_users <- get_timeline(user = "mvabercron", n = 20)
  })
  text <- timeline_users$text[!is.na(timeline_users$text)]
  expect_true(any(nchar(text) > 280)|| all(!endsWith(text, "...")))
})

test_that("get_timeline provides users data from multiple accounts, #723", {

  vcr::use_cassette("get_timeline5", {
    timelines <- get_timeline(c("rOpenSci", "Bioconductor"), n = 20)
  })

  users_timelines <- users_data(timelines)
  expect_length(unique(users_timelines$screen_name), 2)
})

#' Get list subscriptions of a given user but does not include the user's own
#' lists.
#'
#' @inheritParams TWIT_paginate_cursor
#' @inheritParams get_timeline
#' @family lists
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/get-lists-subscriptions>
#' @export
lists_subscriptions <- function(user,
                                n = 20,
                                cursor = "-1",
                                parse = TRUE,
                                retryonratelimit = NULL,
                                verbose = TRUE,
                                token = NULL) {

  params <- list(
    count = n,
    cursor = cursor
  )
  params[[user_type(user)]] <- user

  r <- TWIT_paginate_cursor(token, "/1.1/lists/subscriptions", params,
    cursor = cursor,
    retryonratelimit = retryonratelimit,
    verbose = verbose,
    page_size = if (n >= 1000) 1000 else n,
    get_id = function(x) x$user_id
  )

  if (parse) {
    out <- parse_lists_list(r)
  }
  out
}

test_that("lists_subscriptions returns lists data frame", {
  
  vcr::use_cassette("lists_subscriptions1", {
    x <- lists_subscriptions("kearneymw")
  })

  expect_true(is.data.frame(x))
  expect_true("list_id" %in% names(x))
  expect_true(nrow(x) >= 1)
})

#' Tweets from a user
#'
#' Looks up tweets posted by a user.
#' @inheritParams filtered_stream
#' @param ... Other arguments passed to the API.
#' @param verbose A logical value to provide more information about paginated queries.
#' @returns
#' A data.frame with the id, name and username of the authenticated user.
#' Other information depends on the `expansions` and `fields` requested.
#' Accepted values are:
#' - Expansions: `set_expansions(tweet = NULL, list = NULL)`.
#' - Fields: `set_fields(media = NULL, poll = NULL, place = NULL)`
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/users/lookup/api-reference/get-users-me>
#' @examples
#' if (FALSE) {
#'   me <- user_self()
#' }
user_self <- function(expansions = NULL, fields = NULL, ...,
                        token = NULL, parse = TRUE, verbose = FALSE) {

  expansions <- check_expansions(arg_def(expansions, "pinned_tweet_id"),
                                 "pinned_tweet_id")
  fields <- check_fields(arg_def(fields,
                                 set_fields(media = NULL,
                                            poll = NULL,
                                            place = NULL)),
                         metrics = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  data <- c(list(expansions = expansions), fields, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  url <- paste0("users/me")

  # Rates from the website app and user limits
  # token <- check_token_v2(token, "pkce")
  # check_scopes_token(token, c("tweet.read", "users.read"))
  req_archive <- endpoint_v2(url, 75/(60*15), c("tweet.read", "users.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, 1, 1, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

#' Expansions
#'
#' Twitter parameters to add more fields on the returned values.
#'
#' The `set_expansions` can be used to prepare the arguments for other rtweet functions.
#'
#' @param attachments Add attachments values? Default yes.
#' @param referenced_tweets Add referenced_tweets values? Default yes.
#' @param tweet,user,list [tweet_expansions()], [user_expansions()] and [tweet_expansions()].
#' @return A character with the characters of valid expansions.
#' @references <https://developer.twitter.com/en/docs/twitter-api/expansions>
#' @seealso [Fields], [set_fields()]
#' @name Expansions
#' @aliases expansions
#' @examples
#' tweet_expansions()
#' user_expansions()
#' set_expansions()
#' @export
set_expansions <- function(tweet = tweet_expansions(),
                           user = user_expansions(),
                           list = list_expansions()) {

  if (is.numeric(tweet)) {
    abort("Invalid tweet expansions.", call = current_call())
  }
  if (is.numeric(user)) {
    abort("Invalid user expansions.", call = current_call())
  }

  expansions <- c(tweet, user, list)

  check_expansions(expansions)
}

#' @export
#' @name Expansions
tweet_expansions <- function(attachments = TRUE, referenced_tweets = TRUE) {
  expansions <- c("author_id", "in_reply_to_user_id", "geo.place_id",
                  "entities.mentions.username",  "edit_history_tweet_ids")
  if (attachments) {
    expansions <- c(expansions, "attachments.media_keys",
                    "attachments.poll_ids")
  }
  if (referenced_tweets) {
    expansions <- c(expansions, "referenced_tweets.id", "referenced_tweets.id.author_id")
  }
  expansions
}

#' @export
#' @name Expansions
user_expansions <- function() {
  "pinned_tweet_id"
}
#' @export
#' @name Expansions
list_expansions <- function() {
  "owner_id"
}

check_expansions <- function(passed,
                             allowed = c(tweet_expansions(), user_expansions(), list_expansions())) {
  # Empty list or NA return NULL to disable the expansions
  empty_list <- is.list(passed) && length(passed) == 0
  na <- length(passed) == 1L && is.na(passed)
  if (is.null(passed) || empty_list || na) {
    return(NULL)
  }

  within <- !passed %in% allowed
  if (any(within)) {
    extensions <- passed[within]
    abort(paste0("These extensions are not allowed: ",
         paste(extensions, collapse = ", ")), call = current_call())
  }
  passed
}

# According to https://developer.twitter.com/en/docs/twitter-api/tweets/lookup/api-reference/get-tweets
# attachments.media_keys is required for any media.fields (go to includes)
# geo.place_id is required for any place.fields (go to includes)
# attachments.poll_ids is required by any poll.fields (go to includes)
# referenced_tweets.id is required by any tweet.fields (go to includes)
# author_id, entities.mentions.username, in_reply_to_user_id, referenced_tweets.id.author_id is required by any user.fields (go to includes)
expansions_for_fields <- function(expansion, fields) {
  # Empty fields but might be expansions: no problem
  if (is.null(fields)) {
    return(TRUE)
  }
  msg <- c("Missing expansions for the fields provided.",
           "i" = "Add to expansions:")
  msg2 <- c_f_e(expansion, "attachments.media_keys", fields, "media.fields")
  msg3 <- c_f_e(expansion, "geo.place_id", fields, "place.fields")
  msg4 <- c_f_e(expansion, "attachments.poll_ids", fields, "poll.fields")
  # if (!is.null(fields[["tweet.fields"]]) && "referenced_tweets.id" %in% expansion) {
  #   problem <- TRUE
  # }
  a <- c("author_id", "entities.mentions.username", "in_reply_to_user_id",
         "referenced_tweets.id.author_id", "owner_id")
  if (!is.null(fields[["user.fields"]]) && !any(a %in% expansion)) {
    msg5 <- c("*" = paste0("Add at least one of: ",
                           paste0(sQuote(a, "'"), collapse = ", ")))
  } else {
    msg5 <- NULL
  }
  if (length(c(msg2, msg3, msg4, msg5)) >= 1) {
    abort(c(msg, msg2, msg3, msg4, msg5), call = current_call())
  }
  TRUE
}

# Check fields and expansions
c_f_e <- function(expansions, e, fields, f) {
  if (is.null(fields[[f]])) {
    return(NULL)
  }
  if (!all(e %in% expansions) || is.null(expansions)) {
    f <- gsub("\\.fields", "", f, fixed = TRUE)
    return(c("*" = sQuote(e, "'")))
  }
  return(NULL)
}

test_that("check_expansions works", {
  # Not equal
  expect_error(check_expansions("a", "b"))
  # Two not present
  expect_error(check_expansions(c("a", "c"), "b"))
  # Present and not present
  expect_error(check_expansions(c("a", "b"), "b"))
  # Present
  expect_equal(check_expansions("a", "a"), "a")

  # NULL returns NULL
  expect_equal(check_expansions(NULL, "a"), NULL)
  # Empty vector returns NULL
  expect_equal(check_expansions(c(), "a"), NULL)
  # Empty list returns NULL
  expect_equal(check_expansions(list(), "a"), NULL)
  expect_equal(check_expansions(NA, "a"), NULL)
})

test_that("set_expansions works", {
  expect_error(set_expansions(), NA)
  expect_error(set_expansions(NULL), NA)
  expect_null(set_expansions(NULL, NULL, NULL))
  expect_null(set_expansions(NULL, NULL, c()))
  expect_error(set_expansions("a"),
               "These extensions are not allowed: a",
               fixed = TRUE)
  expect_error(set_expansions(user = "a"),
               "These extensions are not allowed: a",
               fixed = TRUE)
})

test_that("expansions and fields work together", {
  expect_error(expansions_for_fields(NULL, fields = set_fields()),
               "Missing expansions for the fields provided.")
  expect_true(expansions_for_fields(NULL,
                                    fields = set_fields(poll = NULL,
                                                        tweet = NULL,
                                                        media = NULL,
                                                        place = NULL,
                                                        user = NULL)))
  expect_error(expansions_for_fields(NULL,
                                    fields = set_fields(poll = NULL,
                                                        tweet = NULL,
                                                        place = NULL,
                                                        user = NULL)),
               "attachments.media_keys", fixed = TRUE)
  expect_error(expansions_for_fields(NULL,
                                    fields = set_fields(poll = NULL,
                                                        tweet = NULL,
                                                        media = NULL,
                                                        user = NULL)),
               "geo.place_id", fixed = TRUE)
  expect_error(expansions_for_fields(NULL,
                                    fields = set_fields(tweet = NULL,
                                                        place = NULL,
                                                        media = NULL,
                                                        user = NULL)),
               "attachments.poll_ids", fixed = TRUE)
  expect_error(expansions_for_fields(NULL,
                                    fields = set_fields(poll = NULL,
                                                        tweet = NULL,
                                                        place = NULL,
                                                        media = NULL)),
               "Add at least one of", fixed = TRUE)
  expect_error(
    expansions_for_fields(
      expansion = 'attachments.media_keys',
      fields = set_fields(media = "alt_text", NULL, NULL, NULL, NULL)),
    NA)
})

#' Collect statuses contained in a thread
#'
#' Return all statuses that are part of a thread (Replies from a user to their
#' own tweets). By default the function traverses first backwards from the
#' origin status_id of the thread up to the root, then checks if there are any
#' child statuses that were posted after the origin status.
#'  `r lifecycle::badge("deprecated")`
#'
#' The backwards method looks up the tweet which is replying to, so it works if
#' starting from the last tweet of the thread.
#'
#' The forwards method looks for newer replies to the tweet provided. If the tweet doesn't have a reply it won't be able to find anything.
#' The forwards method is limited by the timeline API (See [get_timeline()]).
#' @param tw [lookup_tweets()] output containing
#'  at least the last status in the thread or an id of a tweet.
#' @param traverse character, direction to traverse from origin status in `tw`.
#' It is not recommended to change the default if you don't know at which point of a thread you are starting.
#' @param verbose logical, output to console status of traverse.
#' @return Tweets in a structure like [lookup_tweets()].
#' @seealso [`rtweet-deprecated`], [lookup_tweets()]
#' @export
tweet_threading <- function(tw, traverse = c("backwards", "forwards"), verbose = FALSE) {

  # Accept tweets ids
  if (is.character(tw)) {
    tw <- lookup_tweets(tw[1])
  }
  stopifnot(is_logical(verbose))

  # Prevent a forwards, backwards order
  if (length(unique(traverse)) == 2 && all(c("backwards", "forwards") %in% traverse)) {
    traverse <- c("backwards", "forwards")
  }
  for (i in traverse) {
    direction <- switch(i,
      backwards = tweet_threading_backwards,
      forwards = tweet_threading_forwards,
      abort("`traverse` must contain only 'backwards' or 'forwards")
    )

    tw <- direction(tw, verbose)
    if (verbose) cat("\n")
  }

  tw[order(tw$created_at), ]
}

tweet_threading_backwards <- function(tw, verbose = FALSE) {
  last_found <- FALSE

  if (verbose) {
    message("Initializing Backwards Traverse")
  }
  # Not a thread:
  if (nrow(tw) == 0) {
    return(tw)
  }
  counter <- 0L
  ud <- unique(users_data(tw))
  if (nrow(ud) >= 2) {
    stop("Data must be from a single user.", call. = FALSE)
  }
  user_data_tw <- ud
  while (!last_found) {
    nr <- nrow(tw)

    if (!is.na(tw$in_reply_to_status_id[nr])) {
      tw_head <- lookup_tweets(tw$in_reply_to_status_id_str[nr])
      user_data <- users_data(tw_head)

      if (user_data$id_str != unique(ud$id_str)) {
        stop("Reply to a different user.", call. = FALSE)
      }

      last_found <- is.na(tw_head$in_reply_to_status_id[1])
      # Bind replies with the latest reply below
      tw <- rbind(tw, tw_head)
      user_data_tw <- rbind(user_data, user_data_tw)
      counter <- counter + 1L
    } else {
      if (verbose) {
        cat("Initial tweet of thread found.")
      }
      break
    }
  }
  structure(tw, "users" = user_data_tw)
}

tweet_threading_forwards <- function(tw, verbose = FALSE) {
  if (verbose) {
    message(sprintf("Retrieving last statuses from @%s's timeline", tw$screen_name[1]))
  }
  ud <- users_data(tw)

  timeline <- get_timeline(ud$id_str[1], since_id = tw$id_str,
                           verbose = verbose, n = Inf)

  if (verbose) {
    message("Initializing Forwards Traverse")
  }

  while (any(timeline$in_reply_to_status_id_str %in% tw$id_str)) {
    idx <- which(timeline$in_reply_to_status_id_str %in% tw$id_str)
    tw <- rbind(tw, timeline[idx, ])
    timeline <- timeline[-idx, ]
  }

  if (verbose) {
    message("No more tweets found on the thread.")
    message("Either it is before the last 3200 tweets or the thread is finished.")
  }

  ud <- ud[rep(1, nrow(tw)), ]
  rownames(ud) <- NULL
  structure(tw, "users" = ud)
}

write_thread <- function() {
  pt1 <- suppressMessages(post_tweet(status = paste0("first in a thread", Sys.time())))
  pt2 <- suppressMessages(post_tweet(paste0("second in the thread", Sys.time()),
                                     in_reply_to_status_id = ids(pt1)))
  pt3 <- suppressMessages(post_tweet(paste0("3rd in the thread", Sys.time()),
                                     in_reply_to_status_id = ids(pt2)))
  pt4 <- suppressMessages(post_tweet(paste0("4th in the thread", Sys.time()),
                                     in_reply_to_status_id = ids(pt3)))
  pt5 <- suppressMessages(post_tweet(paste0("5th in the thread", Sys.time()),
                                     in_reply_to_status_id = ids(pt4)))
  pt6 <- suppressMessages(post_tweet(paste0("6th in the thread", Sys.time()),
                                     in_reply_to_status_id = ids(pt5)))
  pt7 <- suppressMessages(post_tweet(paste0("7th in the thread", Sys.time()),
                                     in_reply_to_status_id = ids(pt6)))
  pt8 <- suppressMessages(post_tweet(paste0("8th in the thread", Sys.time()),
                                     in_reply_to_status_id = ids(pt7)))
  pt9 <- suppressMessages(post_tweet(paste0("9th in the thread", Sys.time()),
                                     in_reply_to_status_id = ids(pt8)))
  pt10 <- suppressMessages(post_tweet(paste0("10th in the thread", Sys.time()),
                                      in_reply_to_status_id = ids(pt9)))
  c(ids(pt1), ids(pt2), ids(pt3), ids(pt4), ids(pt5),
    ids(pt6), ids(pt7), ids(pt8), ids(pt9), ids(pt10))
}

delete_thread <- function(ids) {
  for (id in ids) {
    suppressMessages(post_destroy(id))
  }
}

test_that("tweet_threading works", {
  skip_if_offline()

  tryCatch(thread <- write_thread(), error = function(x){
    skip("Not able to post.")
  })
  tw <- lookup_tweets(thread[1])
  tw_thread <- tweet_threading(tw)
  expect_s3_class(tw_thread, "data.frame")

  tw <- lookup_tweets(thread)
  tw_thread1 <- tweet_threading(tw[1, ])
  expect_s3_class(tw_thread1, "data.frame")
  tw_thread2 <- tweet_threading(tw[2, ])
  expect_s3_class(tw_thread2, "data.frame")
  tw_thread3 <- tweet_threading(tw[3, ])
  expect_s3_class(tw_thread3, "data.frame")
  tw_thread4 <- tweet_threading(tw[4, ])
  expect_s3_class(tw_thread4, "data.frame")
  expect_equal(order(tw_thread1$created_at)[1:4], 1:4)
  expect_equal(order(tw_thread4$created_at)[1:4], 1:4)

  tw <- tw[match(thread, tw$id_str), ]

  th1_id <- tweet_threading(thread[1], traverse = "backwards")
  th1_tw <- tweet_threading(tw[1, ], traverse = "backwards")
  expect_equal(nrow(th1_id), nrow(th1_tw))
  th10_id <- tweet_threading(thread[10], traverse = "backwards")
  th10_tw <- tweet_threading(tw[10, ], traverse = "backwards")
  expect_equal(nrow(th10_id), nrow(th10_tw))

  tw <- tw[match(thread, tw$id_str), ]
  th1_id <- tweet_threading(thread[1], traverse = "forwards")
  expect_equal(nrow(th1_id), 10)
  th1_tw <- tweet_threading(tw[1, ], traverse = "forwards")
  expect_equal(nrow(th1_id), nrow(th1_tw))

  th10_id <- tweet_threading(thread[10], traverse = "forwards")
  expect_equal(nrow(th10_id), 1)
  th10_tw <- tweet_threading(tw[10, ], traverse = "forwards")
  expect_equal(nrow(th10_id), nrow(th10_tw))

  t1f <- tweet_threading(thread[1], traverse = "forwards")
  expect_equal(nrow(t1f), 10)
  t1b <- tweet_threading(thread[1], traverse = "backwards")
  expect_equal(nrow(t1b), 1)
  t10f <- tweet_threading(thread[10], traverse = "forwards")
  expect_equal(nrow(t10f), 1)
  t10b <- tweet_threading(thread[10], traverse = "backwards")
  expect_equal(nrow(t10b), 10)
  delete_thread(thread)
})

#' Search in the Twitter archive
#'
#' @inheritParams tweet_retweeted_by
#' @inheritParams tweet_get
#' @param query One query for matching Tweets.
#' @note OAuth2.0 requires tweet.read and users.read permissions.
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/tweets/search/api-reference/get-tweets-search-all>
#' @examples
#' if (FALSE) {
#'   sa <- tweet_search_all("#rtweet", parse = FALSE)
#' }
tweet_search_all <- function(query, n = 500, expansions = NULL, fields = NULL,
                           ..., token = NULL, parse = TRUE, verbose = FALSE) {

  expansions <- check_expansions(arg_def(expansions, set_expansions(list = NULL)))
  fields <- check_fields(arg_def(fields, set_fields()), metrics = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  stopifnot(is_n(n))
  max_results <- check_interval(n, 10, formals()$n)
  n_pages <- ceiling(n / max_results)
  data <- c(list(expansions = expansions), fields, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- c(query = query, max_results = max_results, data)
  data <- data[data != ""]
  # Rates from the website app and user limits
  req_archive <- endpoint_v2("tweets/search/all", 1, set_scopes())
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, n_pages, n, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

#' Search recent tweets
#'
#' Look up tweets from the last seven days that match a search query.
#' @inheritParams tweet_retweeted_by
#' @inheritParams tweet_get
#' @param query One query for matching Tweets.
#' @export
#' @note OAuth2.0 requires tweet.read and users.read permissions.
#' @references <https://developer.twitter.com/en/docs/twitter-api/tweets/search/api-reference/get-tweets-search-recent>
#' @examples
#' if (FALSE) {
#'   sr <- tweet_search_recent("#rtweet", sort_order = "relevancy", parse = FALSE)
#' }
tweet_search_recent <- function(query, n = 100, expansions = NULL, fields = NULL,
                          ..., token = NULL, parse = TRUE, verbose = FALSE) {
  expansions <- check_expansions(arg_def(expansions, set_expansions(list = NULL)))
  fields <- check_fields(arg_def(fields, set_fields()), metrics = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  stopifnot(is_n(n))
  max_results <- check_interval(n, 10, formals()$n)
  n_pages <- ceiling(n / max_results)
  data <- c(list(expansions = expansions), fields, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- c(query = query, max_results = max_results, data)
  data <- data[data != ""]
  # Rates from the website app and user limits
  req_archive <- endpoint_v2("tweets/search/recent", 180/(15*60),
                             c("tweet.read", "users.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, n_pages, n, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

test_that("search_archive works", {
  skip_on_cran()
  testing_with_authentication("bearer_academic_dev")
  sa <- expect_error(tweet_search_all("#rtweet", parse = FALSE, n = 10), NA)
  expect_gte(length(sa[[1]]$data), 1) # No garantee it returns at least 10 values
  expect_named(sa[[1]], c("data", "meta"))
})

test_that("search_recent works", {
  skip_on_cran()
  testing_with_authentication("bearer_testing_app")
  expect_error(sa <- tweet_search_recent("#rtweet", parse = FALSE, n = 10), NA)
  expect_gte(length(sa[[1]]$data), 1)
  expect_named(sa[[1]], c("data", "meta"))
})

#' Collect a live stream of Twitter data
#'
#' `r lifecycle::badge("deprecated")`
#' @description
#' Streams public statuses to a file via one of the following four methods:
#'
#' 1. Sampling a small random sample of all publicly available tweets
#' 2. Filtering via a search-like query (up to 400 keywords)
#' 3. Tracking via vector of user ids (up to 5000 user_ids)
#' 4. Location via geo coordinates (1-360 degree location boxes)
#'
#' Learn more in `vignette("stream", package = "rtweet")`
#'
#' @inheritParams lookup_users
#' @param q Query used to select and customize streaming collection
#'   method.  There are four possible methods:
#'
#'   1. The default, `q = ""`, returns a small random sample of all
#'      publicly available Twitter statuses.
#'   2. To filter by keyword, provide a comma separated character string with
#'      the desired phrase(s) and keyword(s).
#'   3. Track users by providing a comma separated list of user IDs or
#'      screen names.
#'   4. Use four latitude/longitude bounding box points to stream by geo
#'      location. This must be provided via a vector of length 4, e.g.,
#'      `c(-125, 26, -65, 49)`.
#' @param timeout Integer specifying number of seconds to stream tweets for.
#'   Stream indefinitely with `timeout = Inf`.
#'
#'   The stream can be interrupted at any time, and `file_name` will still be
#'   valid file.
#' @param file_name Character with name of file. If not specified,
#'   will write to a temporary file `stream_tweets*.json`.
#' @param append If `TRUE`, will append to the end of `file_name`; if
#'   `FALSE`, will overwrite.
#' @param verbose If `TRUE`, display a progress bar.
#' @param parse Use `FALSE` to opt-out of parsing the tweets.
#' @param ... Other arguments passed in to query parameters.
#' @seealso [filtered_stream()], [`rtweet-deprecated`]
#' @references
#' They were removed from the website.
#' @return A tibble with one row per tweet
#' @export
#' @references
#' The webpages describing how it used to work were removed.
stream_tweets <- function(q = "",
                          timeout = 30,
                          parse = TRUE,
                          token = NULL,
                          file_name = NULL,
                          verbose = TRUE,
                          append = TRUE,
                          ...) {
  lifecycle::deprecate_stop("1.1.0", "stream_tweets()", "filtered_stream()",
                            details = "The streaming endpoint it used does no longer work.")
  if (is.null(file_name)) {
    file_name <- tempfile(pattern = "stream_tweets", fileext = ".json")
    inform(paste0("Writing to '", file_name, "'"))
  }
  output <- file(file_name)

  prep <- stream_prep(token, q, ...)
  stream <- curl::curl(prep$url, handle = prep$handle)

  quiet_interrupt(download_from_stream(stream, output,
    timeout = timeout,
    verbose = verbose
  ))

  if (parse) {
    return(parse_stream(file(file_name)))
  } else {
    return(invisible(NULL))
  }
}

download_from_stream <- function(stream, output, append = TRUE, timeout = 10, verbose = TRUE) {
  if (!timeout) {
    timeout <- Inf
  }
  stopifnot(is.numeric(timeout), timeout > 0)
  stop_time <- Sys.time() + timeout

  n_seen <- 0
  if (verbose) {
    pb <- progress::progress_bar$new(
      total = NA,
      show_after = 0,
      format = "Streaming tweets: :n tweets written / :bytes / :rate / :elapsedfull"
    )
  }

  open(stream, "rb")
  withr::defer(close(stream), current_env(), priority = "first")

  open(output, if (append) "ab" else "b")
  withr::defer(close(output), current_env(), priority = "last")

  lines <- list(lines = character(), fragment = "")
  while (isIncomplete(stream) && Sys.time() < stop_time) {
    buf <- readBin(stream, raw(), 64 * 1024)
    if (length(buf) == 0) {
      if (verbose()) {
        pb$tick()
      }
      Sys.sleep(0.25)
      next
    }

    text <- rawToChar(buf)
    lines <- whole_lines(text, lines$fragment)

    # only keep tweets
    # TODO: process more messages from
    # https://developer.twitter.com/en/docs/twitter-api/v1/tweets/filter-realtime/overview
    json <- lapply(lines$lines, jsonlite::fromJSON)
    is_tweet <- vapply(json, function(x) has_name(x, "created_at"), logical(1))

    n_seen <- n_seen + sum(is_tweet)
    if (verbose) {
      pb$tick(length(buf), tokens = list(n = n_seen))
    }

    writeLines(lines$lines[is_tweet], output, useBytes = TRUE)
  }

  if (verbose) {
    cat("\n")
  }

  invisible()
}

quiet_interrupt <- function(code) {
  tryCatch(code, interrupt = function(e) NULL)
}

whole_lines <- function(text, fragment = "") {
  lines <- strsplit(text, "\r\n")[[1]]
  lines[[1]] <- paste0(fragment, lines[[1]])

  n <- length(lines)
  complete <- grepl("\r\n$", text)
  if (!complete) {
    fragment <- lines[[n]]
    lines <- lines[-n]
  } else {
    fragment <- ""
  }

  # Drop empty keep-alive lines
  lines <- lines[lines != ""]

  list(lines = lines, fragment = fragment)
}

stream_prep <- function(token, q = "", ..., filter_level = "none") {
  token <- check_token(token)
  stopifnot(is.atomic(q) && !is.null(q) || inherits(q, "coords"))

  if (identical(q, "")) {
    path <- "1.1/statuses/sample.json"
    params <- NULL
  } else {
    path <- "1.1/statuses/filter.json"
    params <- stream_params(q, ..., filter_level = filter_level)
  }
  # Detect if q is too long in character size (using double of premium limit)
  # https://developer.twitter.com/en/docs/twitter-api/tweets/filtered-stream/introduction
  if (any(nchar(params) > 2048)) {
    warning("Detected a long parameter, this query will probably fail.", call. = FALSE)
  }

  url <- httr::modify_url("https://stream.twitter.com",
    path = path,
    query = params
  )

  handle <- curl::new_handle()
  curl::handle_setheaders(handle, .list = token$sign("GET", url)$headers)

  list(url = url, handle = handle)
}

stream_params <- function(stream, ...) {
  if (inherits(stream, "coords")) {
    params <- list(locations = paste(stream$box, collapse = ","))
  } else if ((length(stream) %% 4 == 0) && is.numeric(stream)) {
    params <- list(locations = paste(stream, collapse = ","))
  } else if (is_user_id(stream)) {
    params <- list(follow = stream, ...)
  } else {
    params <- list(track = stream, ...)
  }

  params
}


#' Parser of stream
#'
#' Converts Twitter stream data (JSON file) into parsed data frame.
#'  `r lifecycle::badge("deprecated")`
#' @param path Character, name of JSON file with data collected by
#'   [stream_tweets()].
#' @param ... Unused, keeping it for back compatibility.
#' @export
#' @seealso [stream_tweets()], [`rtweet-deprecated`]
#' @examples
#' \dontrun{
#' stream_tweets(timeout = 1, file_name = "stream.json", parse = FALSE)
#' parse_stream("stream.json")
#' }
parse_stream <- function(path, ...) {
  if (...length() > 0) {
    lifecycle::deprecate_soft("1.0.0", "parse_steam(...)",
                              details = c("Parameters ignored"))
  }

  if (!is(path, "file")) {
    path <- file(path)
  }

  tweets <- jsonlite::stream_in(path, pagesize = 1, verbose = FALSE)
  tweets <- tweet(tweets)
  tweets$created_at <- format_date(tweets$created_at)

  tweets0 <- tweet(NULL)[0, ]
  if (length(tweets) != 0) {
    tweets <- tweets[, colnames(tweets0)]
  }


  users <- user(NULL)[0, ]
  if (has_name_(tweets, "user") && length(tweets$user) != 0 && all(lengths(tweets$user) != 0)) {
    users <- do.call(rbind, tweets[["user"]])[, order(colnames(users))]
  }

  tweets <- tweets[!colnames(tweets) %in% "user"]
  users <- tibble::as_tibble(users)
  tweets <- tibble::as_tibble(tweets)

  out <- structure(tweets, users = users)
  class(out) <- c("tweets", class(out))
  out
}


# Deprecated -----------------------------------------------------------------
#' A more robust version of stream_tweets
#'
#' @description
#' `r lifecycle::badge("deprecated")`
#' Please use [stream_tweets()] instead.
#'
#' @param dir Name of directory in which json files should be written.
#'   The default, NULL, will create a timestamped "stream" folder in the
#'   current working directory. If a dir name is provided that does not
#'   already exist, one will be created.
#' @param append Logical indicating whether to append or overwrite
#'   file_name if the file already exists. Defaults to FALSE, meaning
#'   this function will overwrite the preexisting file_name (in other
#'   words, it will delete any old file with the same name as
#'   file_name) meaning the data will be added as new lines to file if
#'   pre-existing.
#' @return Returns data as expected using original search_tweets
#'   function.
#' @export
#' @keywords internal
#' @seealso [`rtweet-deprecated`]
stream_tweets2 <- function(..., dir = NULL, append = FALSE) {
  lifecycle::deprecate_stop("1.0.0", "stream_tweets2()","stream_tweets()")
}

#' Binds list of data frames while preserving attribute (tweets or users) data.
#'
#' Row bind lists of tweets/users data whilst also preserving and binding
#' users/tweets attribute data. `r lifecycle::badge("deprecated")`
#'
#' @param x List of parsed tweets data or users data, each of which
#'   presumably contains an attribute of the other (i.e., users data
#'   contains tweets attribute; tweets data contains users attribute).
#' @return A single merged (by row) data frame (tbl) of tweets or
#'   users data that also contains as an attribute a merged (by row)
#'   data frame (tbl) of its counterpart, making it accessible via the
#'   [users_data()] or [tweets_data()] extractor
#'   functions.
#' @family parsing
#' @seealso [`rtweet-deprecated`]
#' @export
do_call_rbind <- function(x) {
  do.call(rbind, x)
}

#' Get a timeline of tweets authored by members of a specified list.
#'
#' @param list_id required The numerical id of the list.
#' @param slug required You can identify a list by its slug instead of
#'   its numerical id. If you decide to do so, note that you'll also have
#'   to specify the list owner using the owner_id or owner_screen_name
#'   parameters.
#' @param owner_user optional The screen name or user ID of the user
#'   who owns the list being requested by a slug.
#' @param include_rts optional When set to either true, t or 1,
#'   the list timeline will contain native retweets (if they exist) in
#'   addition to the standard stream of tweets. The output format of
#'   retweeted tweets is identical to the representation you see in
#'   home_timeline.
#' @inheritParams TWIT_paginate_max_id
#' @inheritParams stream
#' @family lists
#' @family tweets
#' @return data
#' @export
lists_statuses <- function(list_id = NULL,
                           slug = NULL,
                           owner_user = NULL,
                           since_id = NULL,
                           max_id = NULL,
                           n = 200,
                           include_rts = TRUE,
                           parse = TRUE,
                           retryonratelimit = NULL,
                           verbose = TRUE,
                           token = NULL) {
  params <- lists_params(
    list_id = list_id,
    slug = slug,
    owner_user = owner_user,
    count = n,
    include_rts = include_rts,
    # Undocumented parameter https://github.com/ropensci/rtweet/issues/575#issuecomment-829605892
    tweet_mode = "extended"
  )

  results <- TWIT_paginate_max_id(token, "/1.1/lists/statuses", params,
    page_size = 200,
    max_id = max_id,
    since_id = since_id,
    n = n,
    retryonratelimit = retryonratelimit,
    verbose = verbose
  )

  if (parse) {
    results <- tweets_with_users(results)
    results$created_at <- format_date(results$created_at)
  }
  results
}

test_that("list_statuses() works with either id or slug + owner_user", {

  vcr::use_cassette("lists_statuses1", {
    x <- lists_statuses("105140588", n = 5)
  })
  expect_s3_class(x, "data.frame")

  vcr::use_cassette("lists_statuses2", {
    x <- lists_statuses(slug = "senators", owner_user = "cspan", n = 5)
  })
  expect_s3_class(x, "data.frame")
})

# This is almost a copy of auth.R file but for clients
# Only wto tweaks:
# - the default client is provided by rtweet and stored as rtweet.
# - the path to save clients is under a directory clients

#' Set default client for the current session
#'
#' `client_as()` sets up the default client used by rtweet API calls with PKCE. See [rtweet_user()] to learn more about the three
#' available authentication options.
#'
#' @param client One of the following options:
#'   * `NULL`, the default, will look for rtweet's "default" authentication
#'      which uses your personal default Twitter client. If it's not found, it will
#'      call [client_setup_default()] to set it up.
#'   * A string giving the name of a saved auth file made by [client_save()].
#'   * A client object created by [rtweet_client()].
#' @return Invisibly returns the previous authentication mechanism.
#' @family client
#' @export
#' @examples
#' \dontrun{
#' # Use app auth for the remainder of this session:
#' my_app <- rtweet_app()
#' auth_as(my_app)
#'
#' # Switch back to the default user based auth
#' client_as()
#' client_list()
#' }
client_as <- function(client = NULL) {
  old <- .state$client
  .state$client <- find_client(client)
  invisible(old)
}

#' @rdname client_setup_default
#' @export
client_has_default <- function() {
  file.exists(client_path("rtweet.rds"))
}

client_path <- function(...) {
  # Use private option to make testing easier
  path <- getOption("rtweet:::config_dir", tools::R_user_dir("rtweet", "config"))
  file.path(path, "clients", ...)
}

#' Get the current client
#'
#' If no client has been set up for this session, `client_get()` will
#' call [client_as()] to set it up.
#' @return  The current client used.
#' @export
#' @family client
#' @examples
#' \dontrun{
#' client_get()
#' }
client_get <- function() {
  if (is.null(.state$client)) {
    client_as()
  }
  .state$client
}

is_client <- function(client) {
  inherits(client, "httr2_oauth_client")
}

default_client <- function(client_id = NULL, client_secret = NULL) {
  if (is.null(client_id) && is.null(client_secret)) {
    # The sysdat file is in #./R and loaded automagically
    abort(c("The default rtweet client is no longer authorized.",
            i = "You'll need to register as developer in order to use the Twitter API."),
          call = caller_env())
    client_id <- decrypt(sysdat$e914c55d2f)
    client_secret <- decrypt(sysdat$d5571d4003)
  } else {
    stopifnot(is_string(client_id), is_string(client_secret))
  }
  return(c(id = client_id, secret = client_secret))
}

default_cached_client <- function() {
  if (client_has_default()) {
    return(readRDS(client_path("rtweet.rds")))
  }
  client_str <- default_client()
  rtweet_client(client_str["id"], client_str["secret"], "rtweet")
}

#' Save an authentication mechanism for use in a future session
#'
#' Use `client_save()` with [client_as()] to avoid repeatedly entering app
#' credentials, making it easier to share auth between projects.
#' Use `client_list()` to list all saved credentials.
#'
#' The tokens are saved on the clients folder in `tools::R_user_dir("rtweet", "config")`.
#'
#' @param client A client [rtweet_client()].
#' @return Invisible the path where the client is saved.
#' @family client
#' @seealso [auth_sitrep()] to help finding and managing authentications.
#' @export
#' @examples
#' \dontrun{
#' # save app client for use in other sessions
#' client <- rtweet_client()
#' client_save(client)
#'
#' # later, in a different session...
#' client_as("my-app")
#' # Show all authentications stored
#' client_list()
#' }
client_save <- function(client) {
  stopifnot(is_client(client))
  name <- paste0(attr(client, "app"), ".rds")
  path <- client_path(name)
  inform(paste0("Saving client to '", path, "'"))
  dir.create(client_path(), showWarnings = FALSE, recursive = TRUE)
  saveRDS(client, path)
  invisible(path)
}

#' @export
#' @rdname client_save
client_list <- function() {
  paths <- dir(client_path(), pattern = "\\.rds$")
  tools::file_path_sans_ext(paths)
}

find_client <- function(client = NULL) {
  if (is.null(client)) {
    no_client()
  } else if (is_client(client)) {
    client <- client
  } else if (is_string(client)) {
    client <- load_client(client)
  } else {
    abort("Unrecognised input to `client`", call = current_call())
  }
  inform(paste("Using client", client$name))
  client
}


load_client <- function(client_name) {

  if (file.exists(client_name) && !dir.exists(client_name)) {
    path <- client_name
  } else {
    path <- client_path(paste0(client_name, ".rds"))
  }
  if (!file.exists(path) && !is_developing()) {
    abort(paste0("Can't find saved client with name '", client_name, "'"),
          call = current_call())
  } else if (!file.exists(path)) {
    return(NULL)
  }

  if (!is_developing()) {
    inform(paste0("Reading client from '", path, "'"))
  }
  readRDS(path)
}

no_client <- function(call = caller_env()) {
  if (is_testing()) {
    testthat::skip("Client not available")
  } else {
    abort(c("Could not find client", i = "Find which you have with `client_list()`"), call = sys.call(1))
  }
}

#' Client
#'
#' Set up your client mechanism for the Twitter API.
#' @inheritParams rtweet_user
#' @param scopes Default scopes allowed for users using this client.
#' Leave `NULL` to allow everything or choose yours with `set_scopes()`.
#' @param app Name of the client, it helps if you make it match with the name of your app.
#' On the Twitter app the Callback URI must be `http://127.0.0.1:1410/`
#' (the trailing / must be included).
#' @seealso scopes
#' @export
#' @examples
#' \donttest{
#' if (interactive()) {
#'   rtweet_client()
#' }
#' }
rtweet_client <- function(client_id, client_secret,
                          app, scopes = NULL) {
  # The default rtweet client no longer works
  # if (missing(client_id) && missing(client_secret) ) {
  #   dc <- default_client()
  #   client_id <- dc[1]
  #   client_secret <- dc[2]
  #   app <- "rtweet"
  # }

  if (missing(client_id) && interactive()) {
    client_id <- ask_pass("client ID key")
  }
  if (missing(client_secret) && interactive()) {
    client_secret <- ask_pass("client secret")
  }

  stopifnot(is_string(client_id), is_string(client_secret))

  if (is.null(scopes)) {
    scopes <- all_scopes
  } else {
    scopes <- check_scopes(scopes)
  }

  client <- httr2::oauth_client(
    id = client_id,
    secret = client_secret,
    token_url = "https://api.twitter.com/2/oauth2/token",
    auth = "header",
    name = app)
  attr(client, "scopes") <- scopes
  client
}



#' Set up default client
#'
#' You'll need to run this function once per computer so that rtweet can use
#' your client.
#'
#' It will use the current default account for rtweet and save them as "rtweet".
#' If a default is found it will use it instead.
#' @return
#' `client_setup_default()`: Invisibly returns the previous authentication mechanism.
#' `client_has_default()`: A logical value `TRUE` if there is a default authentication.
#' @export
#' @family client
#' @examples
#' \dontrun{
#' if (!client_has_default()) {
#'    client_setup_default()
#' }
#' }
client_setup_default <- function() {
  if (client_has_default()) {
    inform("Using default client available.")
  } else {
    abort(c("The default rtweet client is no longer authorized.",
            i = "You'll need to register as developer in order to use the Twitter API."),
          call = current_call())
    client <- rtweet_client(decrypt(sysdat$DYKcJfBkgMnGveI),
                            decrypt(sysdat$MRsnZtaKXqGYHju),
                            app = "rtweet")
    client_save(client)
  }
  client_as("rtweet")
  invisible(client_get())
}


client_scopes <- function(client) {
  if (!is_client(client)) {
    abort(c("Missing client.",
            ">" = "Check the vignette('auth', 'rtweet')",
            "i" = "Get one with `rtweet_client()`"), call = call)
  }
  attr(client, "scopes", exact = TRUE)
}

client_app <- function(client) {
  stopifnot(is_client(client))
  attr(client, "app", exact = TRUE)
}

#' Clean clients
#'
#' Removes the rtweet clients directory.
#' @returns Either TRUE if folder could be deleted or FALSE.
#' @export
#' @examples
#' client_clean()
client_clean <- function() {
  out <- unlink(client_path(), recursive = TRUE, force = TRUE)
  invisible(out == 0L)
}

#' Search users
#'
#' Looks up users.
#' @inheritParams filtered_stream
#' @param ... Other arguments passed to the API.
#' @param verbose A logical value to provide more information about paginated queries.
#' @param ids A user id string or up to 100.
#' @returns
#' A data.frame with the id, name and username of the accounts.
#' Other information depends on the `expansions` and `fields` requested.
#' Accepted values are:
#' - Expansions: `set_expansions(tweet = NULL, list = NULL)`.
#' - Fields: `set_fields(media = NULL, poll = NULL, place = NULL)`.
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/users/lookup/api-reference/get-users-id>
#' <https://developer.twitter.com/en/docs/twitter-api/users/lookup/api-reference/get-users>
#' @seealso [user_by_username()]
#' @examples
#' if (FALSE) {
#'   us <- user_search(c("1599030512919650304", "2244994945"), verbose = TRUE)
#' }
user_search <- function(ids, expansions = NULL, fields = NULL, ...,
                          token = NULL, parse = TRUE, verbose = FALSE) {

  expansions <- check_expansions(arg_def(expansions, "pinned_tweet_id"),
                                 "pinned_tweet_id")
  fields <- check_fields(arg_def(fields, set_fields(media = NULL,
                                                    poll = NULL,
                                                    place = NULL)),
                         metrics = NULL, place = NULL, poll = NULL, media = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  if (!length(ids) > 1 || !is_user_id(ids)) {
    abort("Please introduce at least a valid user id.")
  }
  if (length(ids) > 100) {
    abort("Too many ids provided.")
  }
  if (length(ids) > 1) {
    data <- c(list(ids = ids, expansions = expansions), fields, ...)
    url <- "users"
  } else {
    data <- c(list(expansions = expansions), fields, ...)
    url <- paste0("users/", ids)
  }

  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- data[data != ""]

  # Rates from the website app and user limits
  req_archive <- endpoint_v2(url, 900/(60*15), c("tweet.read", "users.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, 1, 1, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

# Use conditionally testthat
tests_are_doable <- requireNamespace("rtweet", quietly = TRUE) &&
  requireNamespace("testthat", quietly = TRUE) &&
  requireNamespace("vcr", quietly = TRUE)

if (tests_are_doable) {
  library(testthat)
  library(rtweet)

  test_check("rtweet")

}

#' Extract the streaming rules
#'
#' Provides the information about the rules
#' @param x An object returned by `stream_*_rule`
#' @param ... Other arguments currently ignored.
#' @seealso `stream_add_rule()` and `stream_rm_rule()`.
#' @export
rules <- function(x, ...) {
  UseMethod("rules")
}

#' @export
rules.rules <- function(x, ...) {
  attr(x, "rules")
}

#' @export
print.post_tweet <- function(x, ...) {
  if (httr::status_code(x) != 200L) {
    cat("Your message has not been posted!", call. = FALSE)
  }
  ct <- httr::content(x)
  cat("Tweet", ct$id_str, "posted from", ct$user$screen_name,  "\nText:", ct$text)
}

#' @export
print.tweet_deleted <- function(x, ...) {
  if (httr::status_code(x) != 200L) {
    cat("Your message has not been deleted!", call. = FALSE)
  }
  ct <- httr::content(x)
  created <- format_date(ct$created_at)
  cat("Tweet", ct$id_str, "deleted from", ct$user$screen_name,
      "\nCreated at", as.character(created), ":", ct$text)
}

#' @export
print.tweets <- function(x, ...) {
  NextMethod(x)
  rlang::inform(c("i" = "Users data at users_data()\n"))
}

#' @export
print.users <- function(x, ...) {
  NextMethod(x)
  rlang::inform(c("i" = "Tweets data at tweets_data()"))
}

#' Get Twitter list memberships (lists containing a given user)
#'
#' Due to deleted or removed lists, the returned number of memberships
#' is often less than the provided n value. This is a reflection of the API and
#' not a unique quirk of rtweet.
#'
#' @inheritParams TWIT_paginate_cursor
#' @inheritParams get_timeline
#' @param filter_to_owned_lists When `TRUE`, will return only lists that
#'   authenticating user owns.
#' @param previous_cursor `r lifecycle::badge("deprecated")` Please use
#'   `cursor` instead.
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/get-lists-memberships>
#' @export
#' @seealso [`rtweet-deprecated`]
lists_memberships <- function(user = NULL,
                              n = 200,
                              cursor = "-1",
                              filter_to_owned_lists = FALSE,
                              token = NULL,
                              parse = TRUE,
                              retryonratelimit = NULL,
                              verbose = TRUE,
                              previous_cursor = NULL) {
  params <- list()
  if (!is.null(user)) {
    params[[user_type(user)]] <- user
  }
  if (isTRUE(filter_to_owned_lists)) {
    params$filter_to_owned_lists <- TRUE
  }

  r <- TWIT_paginate_cursor(token, "/1.1/lists/memberships", params,
    n = n,
    cursor = cursor,
    retryonratelimit = retryonratelimit,
    verbose = verbose,
    page_size = if (n >= 1000) 1000 else n,
    get_id = function(x) x$lists$id_str
  )

  if (parse) {
    r <- parse_lists_list(r)
  }

  r
}

parse_lists_list <- function(x) {
  lists <- lapply(x, function(x) x$lists)
  dfs <- lapply(lists, wrangle_into_clean_data, type = "list")
  dfs <- lapply(dfs, tibble::as_tibble)
  df <- do.call(rbind, dfs)

  copy_cursor(df, x)
}

test_that("lists_memberships returns data frame with nrow > 1", {
  
  vcr::use_cassette("lists_memberships", {
    df <- lists_memberships("kearneymw", filter_to_owned_lists = TRUE)
  })
  expect_s3_class(df, "data.frame")
  expect_equal(df$name, "test-memberships")
})

#' Fields
#'
#' Arguments of expansion that select which values are returned.
#' Fields are possible for:
#'  - [Tweets](https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/tweet)
#'  - [Users](https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/user)
#'  - [Media](https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/media)
#'  - [Polls](https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/poll)
#'  - [Places](https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/place)
#'  - [Lists](https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/lists)
#' @references <https://developer.twitter.com/en/docs/twitter-api/fields>
#' @seealso [Expansions], [set_fields()]
#' @name Fields
#' @aliases fields
#' @examples
#' media_fields
#' place_fields
#' poll_fields
#' tweet_fields
#' user_fields
NULL

#' @export
#' @name Fields
media_fields <- c("duration_ms", "height", "media_key", "preview_image_url",
                  "type", "url",
    "width", "public_metrics", "non_public_metrics", "organic_metrics",
    "promoted_metrics", "alt_text", "variants")
#' @export
#' @name Fields
place_fields <- c("contained_within", "country", "country_code",
                  "full_name", "geo", "id", "name", "place_type")
#' @export
#' @name Fields
poll_fields <- c("duration_minutes", "end_datetime", "id", "options",
                 "voting_status")

#' @export
#' @name Fields
list_fields <- c("created_at", "follower_count", "member_count",
                 "private", "description", "owner_id")

#' @export
#' @name Fields
tweet_fields <- c(
  "attachments", "author_id", "context_annotations",
  "conversation_id", "created_at", "entities", "edit_controls",
  "geo", "id", "in_reply_to_user_id", "lang", "public_metrics",
  "possibly_sensitive", "referenced_tweets", "reply_settings",
  "source", "text", "withheld"
  # Even with academic permissions this doesn't work (organic metrics might need my own tweets)
  # "non_public_metrics",
  # "promoted_metrics",
  # "organic_metrics" #needs user context authentication.
)

#' @export
#' @name Fields
user_fields <- c("created_at", "description", "entities", "id", "location",
                 "verified_type", "name", "pinned_tweet_id", "profile_image_url",
                 "protected", "public_metrics", "url", "username", "verified",
                 "withheld")

#' @export
#' @name Fields
metrics_fields <- c("public_metrics", "non_public_metrics", "organic_metrics", "promoted_metrics")

#' Create fields
#'
#' Choose which fields are used, by default all are returned. Usually all
#' the first 3 are accepted together and the last two too.
#'
#' @param media The fields you want from `media_fields`.
#' @param poll The fields you want from `poll_fields`.
#' @param tweet The fields you want from `tweet_fields`.
#' @param place The fields you want from `place_fields`.
#' @param user The fields you want from `user_fields`.
#' @param list The fields you want from `list_fields`.
#' @return A list with the fields requested ready to be used in your requests to
#' the API.
#' @seealso Fields
#' @export
#' @examples
#' set_fields()
#' set_fields(media = NULL)
#' set_fields(place = NULL, user = NULL)
set_fields <- function(media = media_fields,
                       poll = poll_fields,
                       tweet = tweet_fields,
                       place = place_fields,
                       user = user_fields,
                       list = list_fields) {

  if (length(media)  == 1 && is.na(media)) {
    media <- NULL
  }
  if (length(place)  == 1 && is.na(place)) {
    place <- NULL
  }
  if (length(poll)  == 1 && is.na(poll)) {
    poll <- NULL
  }
  if (length(tweet)  == 1 && is.na(tweet)) {
    tweet <- NULL
  }
  if (length(user)  == 1 && is.na(user)) {
    user <- NULL
  }


  fields <- list("media.fields" = media, "place.fields" = place,
                 "poll.fields" = poll, "tweet.fields" = tweet,
                 "user.fields" = user, "list.fields" = list)
  if (sum(lengths(fields) > 0) == 0) {
    return(NULL)
  }
  fields <- fields[lengths(fields) > 0]

  fields_c <- vapply(fields, is.character, logical(1L))
  if (any(!fields_c)) {
    abort("There is a field without characters.", call = current_call())
  }

  error <- c(
    check_field_helper(fields, media_fields, "media.fields"),
    check_field_helper(fields, place_fields, "place.fields"),
    check_field_helper(fields, poll_fields, "poll.fields"),
    check_field_helper(fields, tweet_fields, "tweet.fields"),
    check_field_helper(fields, user_fields, "user.fields"),
    check_field_helper(fields, list_fields, "list.fields")
  )
  if (!is.null(error)) {
    abort(error)
  }

  fields
}


# To disable a field use NULL
check_fields <- function(fields,
                         media = media_fields,
                         place = place_fields,
                         poll = poll_fields,
                         tweet = tweet_fields,
                         user = user_fields,
                         list = list_fields,
                         metrics = metrics_fields) {

  # If null, empty list or NA return NULL to disable the fields
  empty_list <- is.list(fields) && length(fields) == 0
  na <- length(fields) == 1L && is.na(fields)
  if ( is.null(fields) || empty_list || na) {
    return(NULL)
  }

  # Check the fields on each one:
  n_fields <- names(fields)
  valid_fields <- c("media", "place", "poll", "tweet", "user", "list", "metrics")
  valid_fields <- paste0(valid_fields, ".fields")

  if (length(setdiff(n_fields, valid_fields)) >= 1) {
    warn("Invalid fields provided, they are omitted")
  }

  error <- c(
    check_field_helper(fields, media, "media.fields"),
    check_field_helper(fields, place, "place.fields"),
    check_field_helper(fields, poll, "poll.fields"),
    check_field_helper(fields, tweet, "tweet.fields"),
    check_field_helper(fields, user, "user.fields"),
    check_field_helper(fields, metrics, "metrics.fields")
  )
  if (!is.null(error)) {
    abort(error, call = current_call())
  }

  fields <- fields[intersect(n_fields, valid_fields)]
  fields
}


check_field_helper <- function(passed, allowed, name) {
  y <- passed[[name]]
  if (is.null(allowed) && !is.null(y)) {
    return(c("x" = paste0("Invalid ", name, ".\n")))
  }
  wrong <- setdiff(y, allowed)
  if (length(wrong) >= 1) {
    c("x" = paste0("Invalid fields in ", name,": ",
                   paste(wrong, collapse = ", "), ".\n"))
  } else {
    return(NULL)
  }

}

test_that("set_fields works", {
  expect_null(set_fields(NULL, NULL, NULL, NULL, NULL, NULL))
  expect_error(set_fields(NULL, NULL, NULL, NULL, NULL, list = "a"))
  expect_error(set_fields(NULL, NULL, NULL, NULL, "created_at", list = "a"),
               "Invalid")
  expect_equal(set_fields(NULL, NULL, NULL, NULL, "created_at",
                          list = list_fields),
               list(user.fields = "created_at",
                    list.fields = list_fields))
  expect_type(set_fields(NULL, NULL, NULL, NULL), "list")
  expect_error(set_fields(NULL, NULL, NULL, NULL, 1), "characters")
  expect_error(set_fields(NULL, NULL, NULL, NULL, "a"), "Invalid")
})

test_that("check_field_helper works", {
  expect_length(check_field_helper(list(media = "a"), "b", "media"), 1L)
  expect_length(check_field_helper(list(media = "a"), c("b", "c"), "media"), 1L)
  expect_length(check_field_helper(list(media = "b"), c("b", "c"), "media"), 0L)
  expect_length(check_field_helper(list(media = c("b", "c")), c("b", "c"), "media"), 0L)
  expect_length(check_field_helper(list(media = c("b", "c")), c("b", "c"), "test"), 0L)
  expect_length(check_field_helper(list(media = c("b", "c")), NULL, "media"), 1L)
  expect_equal(check_field_helper(list(media = c("b", "c")), NULL, "media"),
               c(x = "Invalid media.\n"))

  # NULL returns the allowed fields
  expect_equal(check_field_helper(NULL, "a", "media"), NULL)
  # Empty vector returns allowed
  expect_equal(check_field_helper(c(),  "a", "media"), NULL)
  # Empty list returns empty expansions
  expect_equal(check_field_helper(list(), "a", "media"), NULL)
})

test_that("check_fields works", {
  # If null allow all the fields
  out_null <- check_fields(NULL,
    media = c(
      "duration_ms", "height", "media_key",
      "preview_image_url", "type", "url", "width",
      "public_metrics", "alt_text", "variants"
    ),
    place = c("contained_within", "country", "country_code", "full_name", "geo", "id", "name", "place_type"),
    poll = c("duration_minutes", "end_datetime", "id", "options", "voting_status"),
    tweet = c("attachments", "author_id", "context_annotations", "conversation_id", "created_at", "edit_controls", "entities", "geo", "id", "in_reply_to_user_id", "lang", "public_metrics", "possibly_sensitive", "referenced_tweets", "reply_settings", "source", "text", "withheld"),
    user = c("created_at", "description", "entities", "id", "location", "name", "pinned_tweet_id", "profile_image_url", "protected", "public_metrics", "url", "username", "verified", "withheld"),
    metrics = NULL
  )
  expect_null(out_null)

  # If already provided just check
  out <- check_fields(set_fields())
  expect_equal(out, set_fields())

  out_3 <- check_fields(list(), media = "a", place = "b", poll = "c",
                        tweet = "d", user = "e", metrics = "f")
  expect_equal(out_3, NULL)
  out_3 <- check_fields(NA, media = "a", place = "b", poll = "c", tweet = "d",
                        user = "e", metrics = "f")
  expect_equal(out_3, NULL)
  out_4 <- check_fields(c(), media = "a", place = "b", poll = "c", tweet = "d",
                        user = "e", metrics = "f")
  expect_equal(out_4, NULL)

  out_5 <- check_fields(list(media.fields  = "a"), media = "a", place = "b",
                        poll = "c", tweet = "d", user = "e", metrics = "f")
  expect_equal(out_5, list(media.fields  = "a"))
})

#' Collections API
#'
#' @description
#' `r lifecycle::badge("deprecated")`
#'
#' `get_collections()` and `lookup_collections()` have been deprecated
#' since the underlying Twitter API has been deprecated.
#'
#' @keywords internal
#' @export
lookup_collections <- function(id, n = 200,
                               parse = TRUE,
                               token = NULL,
                               ...) {
  lifecycle::deprecate_stop("1.0.0", function_call())
}

#' @export
#' @rdname lookup_collections
get_collections <- function(user = NULL,
                            status_id = NULL,
                            n = 200,
                            cursor = NULL,
                            parse = TRUE,
                            token = NULL) {

  lifecycle::deprecate_stop("1.0.0", function_call())
}

#' Save Twitter data as a comma separated value file.
#'
#' Saves as flattened CSV file of Twitter data.
#'
#' @param x Data frame returned by an rtweet function.
#' @param file_name Desired name to save file as. If `file_name` does not
#'   include the extension ".csv" it will be added automatically.
#' @param prepend_ids Logical indicating whether to prepend an "x"
#'   before all Twitter IDs (for users, statuses, lists, etc.). It's
#'   recommended when saving to CSV as these values otherwise get
#'   treated as numeric and as a result the values are often less
#'   precise due to rounding or other class-related quirks. Defaults
#'   to true.
#' @param na Value to be used for missing (NA)s. Defaults to empty
#'   character, "".
#' @param fileEncoding Encoding to be used when saving to
#'   CSV. defaults to "UTF-8".
#' @return Saved CSV files in current working directory.
#' @family datafiles
#' @export
write_as_csv <- function(x, file_name,
                         prepend_ids = TRUE,
                         na = "",
                         fileEncoding = "UTF-8") {
  lifecycle::deprecate_stop("1.0.0", "write_as_csv()",
                            details = c(i = "Only works on  rtweet data before 1.0.0 version"))
  ## to minimize rounding
  op <- options()
  on.exit(options(op))
  options(scipen = 14, digits = 22)

  ## validate inputs
  stopifnot(is.data.frame(x), is.character(file_name), length(file_name) == 1L)
  if (!grepl("\\.csv$", file_name)) {
    file_name <- paste0(file_name, ".csv")
  }
  ## flatten data
  x <- flatten(x)
  if (prepend_ids) {
    x <- prepend_ids(x)
  }
  utils::write.csv(x, file_name, row.names = FALSE, na = na,
    fileEncoding = fileEncoding)
}

#' @export
#' @rdname write_as_csv
#' @family datafiles
save_as_csv <- function(x, file_name,
                        prepend_ids = TRUE,
                        na = "",
                        fileEncoding = "UTF-8") {
  lifecycle::deprecate_stop("1.0.0", "save_as_csv()",
                            details = c(i = "Only works on  rtweet data before 1.0.0 version"))
  write_as_csv(x, file_name, prepend_ids, na, fileEncoding)
}

#' flatten/unflatten data frame
#'
#' Converts list columns that containing all atomic elements into
#' character vectors and vice versa (for appropriate named variables
#' according to the rtweet package)
#'
#' @param x Data frame with list columns or converted-to-character (flattened)
#'   columns.
#' @return If flattened, then data frame where non-recursive list
#'   columns---that is, list columns that contain only atomic, or non-list,
#'   elements---have been converted to character vectors. If unflattened,
#'   this function splits on spaces columns originally returned as lists
#'   by functions in rtweet package. See details for more information.
#'
#' @details If recursive list columns are contained within the data frame,
#'   relevant columns will still be converted to atomic types but output
#'   will also be accompanied with a warning message.
#'
#' `flatten` flattens list columns by pasting them into a single string for
#'   each observations. For example, a tweet that mentions four other users,
#'   for the mentions_user_id variable, it will include the four user IDs
#'   separated by a space.
#'
#' `unflatten`` splits on spaces to convert into list columns any
#'   columns with the following names: hashtags, symbols, urls_url,
#'   urls_t.co, urls_expanded_url, media_url, media_t.co,
#'   media_expanded_url, media_type, ext_media_url, ext_media_t.co,
#'   ext_media_expanded_url, mentions_user_id, mentions_screen_name,
#'   geo_coords, coords_coords, bbox_coords, mentions_screen_name
#' @export
#' @rdname flatten
#' @family datafiles
flatten <- function(x) {
  lifecycle::deprecate_stop("1.0.0", "flatten()",
                            details = c(i = "Only works on  rtweet data before 1.0.0 version"))
  stopifnot(is.data.frame(x))
  lst <- which(vapply(x, is.list,
    FUN.VALUE = logical(1), USE.NAMES = FALSE))
  atom <- which(vapply(x[lst], function(.) all(
    vapply(., is.atomic, FUN.VALUE = logical(1), USE.NAMES = FALSE)
  ), FUN.VALUE = logical(1), USE.NAMES = FALSE))
  la <- lst[atom]
  x[la] <- lapply(x[la], function(a)
    vapply(a, function(b)
      ifelse(length(b) == 0 | (length(b) == 1 && is.na(b)), "",
        paste(b, collapse = " ")),
      FUN.VALUE = character(1), USE.NAMES = FALSE))
  x[la] <- lapply(x[la], function(.) ifelse(. == "", NA, .))
  if (any(vapply(x, is.recursive,
    FUN.VALUE = logical(1), USE.NAMES = FALSE))) {
    warning("data frame still contains recursive columns!")
  }
  x
}

#' @export
#' @rdname flatten
#' @family datafiles
unflatten <- function(x) {
  lifecycle::deprecate_stop("1.0.0", "unflatten()",
                            details = c(i = "Only works on  rtweet data before 1.0.0 version"))
  yes_coords <- c("geo_coords", "coords_coords", "bbox_coords")
  rec_cols <- c("hashtags", "symbols",
    "urls_url", "urls_t.co", "urls_expanded_url", "media_url",
    "media_t.co", "media_expanded_url", "media_type",
    "ext_media_url", "ext_media_t.co", "ext_media_expanded_url",
    "mentions_user_id", "mentions_screen_name", "mentions_screen_name",
    yes_coords)
  rc <- names(x) %in% rec_cols
  lg <- vapply(x[rc], is.logical, FUN.VALUE = logical(1))
  if (any(lg)) {
    kp <- names(x[rc])
    rc <- kp[!lg]
  }
  x[rc] <- lapply(x[rc], strsplit, " ")
  rc <- names(x) %in% rec_cols[!rec_cols %in% yes_coords]
  x[rc] <- lapply(x[rc], function(.) {
    .[lengths(.) == 0] <- NA_character_
    .})
  rc <- names(x) %in% yes_coords
  x[rc] <- lapply(x[rc], function(.) {
    . <- lapply(., function(y) suppressWarnings(as.numeric(y)))
    .[lengths(.) == 0] <- NA_real_
    .})
  x
}

prepend_ids <- function(x) {
  ids <- grepl("\\_id$", names(x))
  x[ids] <- lapply(x[ids], x_ids)
  x
}


x_ids <- function(x) {
  if (is.recursive(x)) {
    x <- lapply(x, function(.)
      ifelse(length(.) == 0 || (length(.) == 1 && is.na(.)),
        list(NA_character_), list(paste0("x", .))))
    x <- lapply(x, unlist, recursive = FALSE)
  } else {
    x[x == ""] <- NA_character_
    x[!is.na(x)] <- paste0("x", x[!is.na(x)])
    x[!is.na(x)] <- gsub(" ", " x", x[!is.na(x)])
  }
  x
}

unprepend_ids <- function(x) {
  ids <- grepl("\\_id$", names(x))
  x[ids] <- lapply(x[ids], unx_ids)
  x
}

unx_ids <- function(x) {
  if (is.recursive(x)) {
    x <- lapply(x, function(.)
      ifelse(length(.) == 0 || (length(.) == 1 && is.na(.)),
        list(NA_character_), list(gsub("x", "", .))))
    x <- lapply(x, unlist, recursive = FALSE)
  } else {
    x <- gsub("x", "", x)
  }
  x
}

#' Read comma separated value Twitter data.
#'
#' Reads Twitter data that was previously saved as a CSV file.
#' `r lifecycle::badge("deprecated")`
#' @param file Name of CSV file.
#' @param unflatten Logical indicating whether to unflatten (separate hasthags
#'   and mentions columns on space, converting characters to lists), defaults
#'   to FALSE.
#' @return A tbl data frame of Twitter data
#' @family datafiles
#' @seealso [`rtweet-deprecated`]
#' @export
read_twitter_csv <- function(file, unflatten = FALSE) {
  lifecycle::deprecate_stop("1.0.0", "read_twitter_csv()",
                            details = c(i = "Works on rtweet data saved before 1.0.0 version."))
  x <- utils::read.csv(
    file = file,
    na.strings = "",
    stringsAsFactors = FALSE,
    strip.white = TRUE,
    encoding = "UTF-8",
    numerals = "no.loss"
  )
  x <- unprepend_ids(x)
  if (unflatten) {
    x <- unflatten(x)
  }
  tibble::as_tibble(x)
}

test_that("save_as_csv saves tweets data", {
  skip("Without old data")
  x <- search_tweets(q = "obama")
  write_as_csv(x, "csv_data.csv", prepend_ids = FALSE)
  expect_gt(ncol(utils::read.csv("csv_data.csv")), 15)
  save_as_csv(x, "csv_data.csv")
  expect_gt(nrow(utils::read.csv("csv_data.csv")), 60)
  unf <- read_twitter_csv("csv_data.csv")
  expect_gt(ncol(unf), 15)
  expect_true(all(vapply(unf, is.atomic, FUN.VALUE = logical(1))))
  unf <- read_twitter_csv("csv_data.csv", unflatten = TRUE)
  expect_gt(ncol(unf), 15)
  expect_true(any(vapply(unf, is.recursive, FUN.VALUE = logical(1))))
  unlink("csv_data.csv")
})

#' Get tweets liked/favorited by one or more users
#'
#' Returns up to 3,000 tweets liked/favorited for each `user`.
#' `r lifecycle::badge("deprecated")`
#'
#' @inheritParams TWIT_paginate_max_id
#' @inheritParams get_timeline
#' @inheritParams stream
#' @return A tibble with one row for each tweet.
#' @examples
#' if (FALSE) {
#'   get_favorites("KFC")
#' }
#' @family tweets
#' @seealso [`rtweet-deprecated`]
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/get-favorites-list>
#' @export
get_favorites <- function(user,
                          n = 200,
                          since_id = NULL,
                          max_id = NULL,
                          parse = TRUE,
                          retryonratelimit = NULL,
                          verbose = TRUE,
                          token = NULL) {
  rt <- lapply(user, get_favorites_user,
    n = n,
    since_id = since_id,
    max_id = max_id,
    parse = parse,
    retryonratelimit = retryonratelimit,
    verbose = verbose,
    token = token
  )

  if (parse) {
    rt <- do_call_rbind(rt)
  }
  rt
}

get_favorites_user <- function(user, ..., parse = TRUE, token = NULL) {
  stopifnot(length(user) == 1)
  params <- list(
    # Undocumented parameter https://github.com/ropensci/rtweet/issues/575#issuecomment-829605892
    tweet_mode = "extended"
  )
  params[[user_type(user)]] <- user

  results <- TWIT_paginate_max_id(token, "/1.1/favorites/list", params,
    page_size = 200,
    ...
  )

  if (parse) {
    results <- tweets_with_users(results)
    results$created_at <- format_date(results$created_at)
    results$favorited_by <- rep(user, nrow(results))
  }

  results
}

test_that("methods work", {
  vcr::use_cassette("methods1", {
    R_foundation_favs <- get_favorites("_R_Foundation", n = 10)
  })

  expect_error(entity(R_foundation_favs, "urls"), NA)
  expect_error(entity(R_foundation_favs, "hashtags"), NA)
  expect_error(entity(R_foundation_favs, "symbols"), NA)
  expect_error(entity(R_foundation_favs, "user_mentions"), NA)
  expect_error(entity(R_foundation_favs, "media"), NA)
})

#' Premium Twitter searches
#'
#' Search 30day or fullarchive premium products. There is a limit of 5000 tweets
#'  and 25000 for the fullarchive and 30day endpoints respectively. In addition,
#'  there are some limits in the number of requests that are possible on a
#'  certain amount of time, this have already been taken into account.
#'  See the info provided by Twitter and the "Developer Account" section.
#'
#' Note: The `env_name` must match the ones you set up for the token you are using.
#' `r lifecycle::badge("deprecated")`
#'
#' @inheritParams TWIT_paginate_max_id
#' @inheritParams stream
#' @param q Search query on which to match/filter tweets. See details for
#'   information about available search operators.
#' @param continue A character string with the next results of a query. You
#' must make the exact same query as the original, including `q`, `toDate`,
#' and `fromDate`.
#' @param premium A logical value if the environment is paid (TRUE) or
#' sandboxed, the default (FALSE). It limits the number of results retrieved so the number
#' of API queries needed to retrieve `n` results.
#' @param fromDate Oldest date-time (YYYYMMDDHHMM) from which tweets should be
#'   searched for.
#' @param toDate Newest date-time (YYYYMMDDHHMM) from which tweets should be
#'   searched for.
#' @param env_name Name/label of developer environment to use for the search.
#' @param safedir Name of directory to which each response object should be
#'   saved. If the directory doesn't exist, it will be created. If NULL (the
#'   default) then a dir will be created in the current working directory. To
#'   override/deactivate safedir set this to FALSE.
#'
#' @section Developer Account:
#' Users must have an approved developer account and an active/labeled
#' environment to access Twitter's premium APIs. For more information, to check
#' your current Subscriptions and Dev Environments, or to apply for a developer
#' account visit <https://developer.twitter.com>.
#'
#' @section Search operators:
#' *Note: Bolded operators ending with a colon should be immediately
#' followed by a word or quoted phrase (if appropriate)–e.g.,* `lang:en`
#'
#' @section Keyword:
#' \itemize{
#'   \item **""**           ~~ match exact phrase
#'   \item **#**               ~~ hashtag
#'   \item **@@**               ~~ at mentions)
#'   \item **url:**            ~~ found in URL
#'   \item **lang:**           ~~ language of tweet
#' }
#'
#' @section Accounts of interest:
#' \itemize{
#'   \item **from:**           ~~ authored by
#'   \item **to:**             ~~ sent to
#'   \item **retweets_of:**    ~~ retweet author
#' }
#'
#' @section Tweet attributes:
#' \itemize{
#'   \item **is:retweet**      ~~ only retweets
#'   \item **has:mentions**    ~~ uses mention(s)
#'   \item **has:hashtags**    ~~ uses hashtags(s)
#'   \item **has:media**       ~~ includes media(s)
#'   \item **has:videos**      ~~ includes video(s)
#'   \item **has:images**      ~~ includes image(s)
#'   \item **has:links**       ~~ includes URL(s)
#'   \item **is:verified**     ~~ from verified accounts
#' }
#'
#' @section Geospatial:
#' \itemize{
#'   \item **bounding_box:\[west_long south_lat east_long north_lat\]** ~~ lat/long coordinates box
#'   \item **point_radius:\[lon lat radius\]** ~~ center of search radius
#'   \item **has:geo**           ~~ uses geotagging
#'   \item **place:**            ~~ by place
#'   \item **place_country:**    ~~ by country
#'   \item **has:profile_geo**   ~~ geo associated with profile
#'   \item **profile_country:**  ~~ country associated with profile
#'   \item **profile_region:**   ~~ region associated with profile
#'   \item **profile_locality:** ~~ locality associated with profile
#' }
#'
#' @return A tibble data frame of Twitter data.
#' @family premium endpoints
#' @seealso [tweet_search_recent()], [tweet_search_all()], [`rtweet-deprecated`]
#' @export
search_fullarchive <- function(q, n = 100, fromDate = NULL, toDate = NULL,
                               continue = NULL,
                               env_name = NULL, premium = FALSE,
                               safedir = NULL, parse = TRUE, token = NULL) {

  search_premium("fullarchive",
    q = q,
    n = n,
    fromDate = fromDate,
    toDate = toDate,
    env_name = env_name,
    continue = continue,
    premium = premium,
    safedir = safedir,
    parse = parse,
    token = token
  )

}

#' @rdname search_fullarchive
#' @export
search_30day <- function(q, n = 100, fromDate = NULL, toDate = NULL,
                         env_name = NULL,
                         continue = NULL,  premium = FALSE,
                         safedir = NULL,
                         parse = TRUE,
                         token = NULL) {

  search_premium("30day",
    q = q,
    n = n,
    fromDate = fromDate,
    toDate = toDate,
    env_name = env_name,
    continue = continue,
    premium = premium,
    safedir = safedir,
    parse = parse,
    token = token
  )
}


search_premium <- function(product, q, n = NULL, fromDate = NULL, toDate = NULL,
                          env_name = NULL, continue = NULL, premium = FALSE, safedir = NULL,
                          parse = TRUE,
                          token = NULL) {

  if (is.null(env_name)) {
    stop("Must provide dev environment name")
  }
  if (!is.null(safedir)) {
    stop("`safedir` temporarily not supported")
  }

  if (!is_logical(premium)) {
    stop("premium must be either TRUE or FALSE.", call. = FALSE)
  }

  params <- list(query = q,
    maxResults = n,
    fromDate = format_from_to_date(fromDate),
    # tag = ?? Not sure how to support tags or how they are used.
    toDate = format_from_to_date(toDate)
  )

  api <- paste0("/1.1/tweets/search/", product, "/", env_name)
  result <- TWIT_paginate_premium(token, api, params, n = n, cursor = continue,
                                  page_size = if (premium) 500 else 100)

  if (parse) {
    cursor <- attr(result, "next")
    result <- tweets_with_users(result)
    result$created_at <- format_date(result$created_at)
    attr(result, "next") <- cursor
  }
  result
}

format_from_to_date <- function(x = NULL) {
  if (is.null(x)) {
    return(NULL)
  }
  if (length(x) > 1L) {
    stop("Can only provide one value to fromDate/toDate", call. = FALSE)
  }
  if (is.character(x) && grepl("-", x) && nchar(x) > 11) {
    x <- as.POSIXct(x)
  }
  if (is.character(x) && grepl("-", x)) {
    x <- as.Date(x)
  }
  if (inherits(x, "Date")) {
    x <- as.POSIXct(x)
  }
  if (inherits(x, "POSIXct")) {
    x <- format(x, "%Y%m%d%H%M")
  }
  x
}

#' Twitter Tokens sitrep
#'
#' Get a situation report of your current tokens; useful for upgrading from
#' rtweet 0.7.0 to 1.0.0 and diagnosing problems with tokens.
#'
#' Prints rtweet tokens on the old folder (rtweet < 0.7.0) and on the
#' new (rtweet > 1.0.0) default location.
#' For each folder it reports apps and then users and bots authentications.
#' For users authentications it reports the user_id, so that you can check who is that user.
#'
#' Users should follow its advise, if there is no advise but there are still
#' some problems authenticating regenerate the authentications.
#' @note It is safe to use in public, as instead of the tokens or keys it reports a letter.
#' @return Invisibly, TRUE if some problems were found and FALSE otherwise
#' @export
#' @seealso [auth_as()]
#' @examples
#' auth_sitrep()
auth_sitrep <- function() {
  old_tokens <- find_old_tokens()
  tools_tokens <- find_tools_tokens()
  all_tokens_files <- c(old_tokens, tools_tokens)
  if (is.null(all_tokens_files)) {
    inform("No tokens were found! See ?auth_as for more details.")
    return(NULL)
  }
  change <- FALSE
  change_old <- FALSE
  change_rappdirs <- FALSE
  change_tools <- FALSE

  if (length(old_tokens) != 0) {
    inform(paste0("Tokens from rtweet version < 1.0.0 found on ",
           unique(dirname(old_tokens)), ":"))

    change_old <- auth_check(read_tokens(old_tokens))
  }

  if (length(tools_tokens) != 0) {
    inform(paste0("Tokens found on ", unique(dirname(tools_tokens)), ":"))
    change_tools <- auth_check(read_tokens(tools_tokens))
  }

  if (change_old || change_rappdirs || change_tools) {
    change <- TRUE
  }
  if (change_old) {
    inform(paste0("All tokens should be moved to ", auth_path()))
  }

  invisible(change)
}

find_old_tokens <- function() {
  twitter_pat <- Sys.getenv("TWITTER_PAT")

  home_path <- normalizePath(file.path("~"), mustWork = TRUE)

  many_paths <- c(twitter_pat, home_path, dirname(twitter_pat))
  old_tokens <- lapply(many_paths, list.files, pattern = ".rtweet_token.*rds",
                       full.names = TRUE, all.files = TRUE)
  unique(unlist(old_tokens, TRUE, FALSE))
}

find_tools_tokens <- function() {
  list.files(auth_path(), pattern = "*.rds",
             all.files = TRUE, full.names = TRUE)
}

bearer_auth <- function(bearer) {
  oauth2 <- vapply(bearer, has_name_, name = "access_token", logical(1L))

  tok <- c(vapply(bearer[!oauth2], function(x){x$token}, character(1L)),
           vapply(bearer[oauth2], function(x){x$access_token}, character(1L)))
  tok <- as.factor(tok)
  levels(tok) <- LETTERS[seq_along(unique(tok))]
  df <- data.frame(token = tok)
  rownames(df) <- names(bearer)
  df
}

token_auth <- function(tokens) {
  tokens <- lapply(tokens, raw_auth)
  n <- length(tokens)
  df <- data.frame(app = character(n),
                   user_id = character(n),
                   key = character(n))
  df <- as.data.frame(t(list2DF(tokens)))
  rownames(df) <- names(tokens)
  if (ncol(df) < 3L) {
    x <- seq_len(ncol(df))
  } else {
    x <- 1L:3L
  }
  colnames(df) <- c("app", "user_id", "key")[x]
  uk <- unique(df$key)
  length_levels <- length(uk) - sum(any(uk == ""))
  df$key <- factor(df$key, labels = LETTERS[seq_len(length_levels)], exclude = "")
  df
}

#' @importFrom methods is
type_auth <- function(tokens) {

  class_tokens <- vapply(tokens, function(x){is(x)[1]}, character(1L))
  class_tokens2 <- character(length(class_tokens))
  class_tokens2[class_tokens %in% c("Token1.0", "TwitterToken1.0")] <- "token"
  class_tokens2[class_tokens == "rtweet_bearer"] <- "bearer"
  class_tokens2[class_tokens == "httr2_token"] <- "httr2_token"
  if (any(!nzchar(class_tokens2))) {
    warn("Detected some file which doesn't seems created by rtweet.", parent = current_call())
  }
  class_tokens2
}

move_tokens <- function(tokens, folder) {
  file_names <- basename(tokens)
  # Replace old tokens names to an easy to read name and findable by auth_as
  file_names <- gsub("\\.([0-9]*)rds", "\\1.rds",
                     file_names, ignore.case = TRUE)
  file_names <- gsub("^\\.", "", file_names)
  new_names <- file.path(folder, file_names)
  moving_files <- tokens != new_names
  file_existed <- file.exists(new_names[moving_files])
  file.rename(from = tokens[moving_files][!file_existed],
              to = new_names[moving_files][!file_existed])
  if (any(moving_files)) {
    inform(c("Moving and renaming:",
             paste0("from ", tokens[moving_files][!file_existed], " to ",
                    new_names[moving_files][!file_existed])))
  }
  if (any(file_existed)) {
    inform(paste0("Auth ", tokens[moving_files][file_existed], " not moved",
                  " but should be on ", folder))
  }
  for (p in unique(dirname(tokens[moving_files]))) {
    if (length(list.files(p, all.files = TRUE, no.. = TRUE)) == 0) {
      unlink(p, recursive = TRUE)
    }
  }
  tokens[moving_files][!file_existed] <- new_names[moving_files][!file_existed]
  tokens
}

raw_auth <- function(auth) {
  c("app" = auth$app$appname, "user_id" = auth$credentials$user_id, key = auth$app$key)
}


handle_bearer <- function(bearers) {
  action_bearer <- FALSE
  bearers_f <- bearer_auth(bearers)
  rownames(bearers_f) <- basename(names(bearers))
  if (anyDuplicated(bearers$token) != 0) {
    inform("Multiple authentications with the same token found")
    action_bearer <- TRUE
  }

  if (action_bearer) {
    inform("Choose which is the best path of action for the bearer tokens:")
  }
  rownames(bearers_f) <- tools::file_path_sans_ext(rownames(bearers_f))
  print(bearers_f)
  action_bearer
}


handle_token <- function(tokens) {
  action_tokens <- FALSE
  token <- token_auth(tokens)
  rownames(token) <- basename(rownames(token))

  if (any(is.na(token$key))) {
    action_tokens <- TRUE
    inform("Empty tokens were found.")
  }
  if (anyDuplicated(token$key)) {
    action_tokens <- TRUE
    inform("Multiple authentications with the same key found!")
  }

  if (anyDuplicated(token$app) != 0) {
    action_tokens <- TRUE
    inform("Multiple authentications with the same app found!")
  }
  if (action_tokens) {
    inform("Choose which is the best path of action for the tokens:")
  }
  rownames(token) <- tools::file_path_sans_ext(rownames(token))
  print(token)
  action_tokens
}

auth_check <- function(tokens) {
  type_auth <- type_auth(tokens)

  action <- FALSE
  bearer_action <- FALSE
  token_action <- FALSE

  if (any(type_auth == "bearer")){
    bearer_action <- handle_bearer(tokens[type_auth == "bearer"])
  }
  if (any(type_auth == "token")){
    token_action <- handle_token(tokens[type_auth == "token"])
  }
  if (bearer_action || token_action){
    action <- TRUE
  }
  action
}

#' Help managing rtweet tokens
#'
#' Moves old tokens to new path, if keys are on two tokens only one of them is kept.
#' At the end it runs auth_sitrep to show if any other action is needed.
#' @return TRUE if manual actions are needed from the user, FALSE otherwise.
#' @seealso [auth_sitrep()]
#' @examples
#' auth_helper
#' @noRd
auth_helper <- function() {

  old_tokens <- find_old_tokens()
  tools_tokens <- find_tools_tokens()
  all_tokens_files <- c(old_tokens, tools_tokens)

  final_path <- auth_path()
  all_tokens_files <- move_tokens(all_tokens_files, final_path)

  tokens <- read_tokens(all_tokens_files)
  type_auth <- type_auth(tokens)

  if (any(type_auth == "bearer")) {
    bearer_summary <- bearer_auth(tokens[type_auth == "bearer"])
    # Delete any duplicated bearer
    unlink(rownames(bearer_summary)[duplicated(bearer_summary)])
  }
  if (any(type_auth == "token")) {
    token_summary <- token_auth(tokens[type_auth == "token"])

    # Delete any "token" without key
    unlink(rownames(token_summary)[is.na(token_summary$key)])
    # Delete any "token" without user_id
    unlink(rownames(token_summary)[is.na(token_summary$user_id)])

    if (anyDuplicated(token_summary$key) != 0) {
      for (key in token_summary$key) {
        unlink(rownames(token_summary)[token_summary$key == key][-1])
      }
    }
  }
  auth_sitrep()
}

read_tokens <- function(tokens_files) {
  all_tokens <- lapply(tokens_files, readRDS)
  names(all_tokens) <- tokens_files
  all_tokens
}

# format_date ####

format_date <- function(x, format = "%a %b %d %T %z %Y") {
  locale <- Sys.getlocale("LC_TIME")
  on.exit(Sys.setlocale("LC_TIME", locale), add = TRUE)
  Sys.setlocale("LC_TIME", "C")
  as.POSIXct(x, format = format)
}

format_date_precison <- function(x) {
  strptime(x, tz = "UTC", format = "%FT%H:%M:%OS")
}

convert_tz <- function(x, tz) {
  as.POSIXct(as.POSIXlt(x, tz = tz))
}

format_iso_date <- function(x) {
  # YYYY-MM-DDTHH:mm:ssZ (ISO 8601/RFC 3339)
  # %F        T%T      Z
  format_date(x, "%FT%TZ")
}

# check data ####

has_name_ <- function(x, name) isTRUE(name %in% names(x))

has_name_children <- function(x, name, children) {
  has_name_(x, name) && has_name_(x[[name]], children)
}

is_n <- function(n) {
  if (!is.numeric(n)) {
    n <- suppressWarnings(as.numeric(n))
  }
  length(n) == 1L && !is.na(n) && n > 0L && (is.infinite(n) || n %% 1 == 0)
}

maybe_n <- function(n) {
  if (is.character(n)) {
    n <- suppressWarnings(as.numeric(n))
  }
  length(n) == 1L && is.numeric(n) && !is.na(n)
}

is_logical <- function(x) {
  isFALSE(x) || isTRUE(x)
}

check_interval <- function(value, min, max) {
  if (value < min) {
    return(min)
  }
  if (value > max) {
    return(max)
  }
  value
}


is_id <- function(x) {
  is.character(x) && all(nchar(x) >= 18) && all(grepl("[0-9]{18,}", x)) || is.numeric(x)
}

is_user_id <- function(x) {
    is.character(x) && all(nchar(x) >= 8) && all(grepl("[0-9]{8,}", x)) || is.numeric(x)
}

is_list_id <- function(x) {
    is.character(x) && all(nchar(x) >= 17) && all(grepl("[0-9]{17,}", x)) || is.numeric(x)
}

# check environment ####

is_testing <- function() {
  identical(Sys.getenv("TESTTHAT"), "true") && requireNamespace("testthat", quietly = TRUE)
}
is_dev_mode <- function() {
  exists(".__DEVTOOLS__", .getNamespace("rtweet"))
}

is_rcmd_check <- function() {
  identical(Sys.getenv("RTESTS"), "true")
}

is_developing <- function() {
  is_testing() || (is_dev_mode() %||% is_rcmd_check())
}

release_bullets <- function() {
  c("Run vignette/precompute.R",
    "Check spelling with: `spelling::spell_check_package()`",
    "Run manual tests.")
}


function_call <- function() {
  paste0(as.character(sys.call(sys.parent(1)))[1L], "()")
}

function_caller <- function() {
  paste0(as.character(sys.call(1))[1L], "()")
}

#' Extract the ids
#'
#' Extract the ids of the rtweet data if present.
#' Depending on the object type it returns either users ids,  tweet ids or rules ids.
#' @param x An object of the rtweet package.
#' @param ... Other arguments currently unused.
#' @export
ids <- function(x, ...) {
  UseMethod("ids")
}

#' @export
ids.default <- function(x, ...) {
  out <- x[["id_str"]]
  if (is.null(out)) {
    stop("Ids are not present. Are you sure this is a rtweet object?",
         call = caller_call())
  }
  out
}


#' @export
ids.rules <- function(x, ...) {
  rules(x)$id
}

#' @export
ids.users <- function(x, ...) {
  x$id_str
}

#' @export
ids.tweets <- function(x, ...) {
  x$id_str
}

#' @export
ids.followers <- function(x, ...) {
  x$from_id
}

#' @export
ids.friends <- function(x, ...) {
  x$to_id
}

#' @export
ids.page <- function(x, ...) {
  x$id
}

#' @export
ids.post_tweet <- function(x, ...) {
  if (httr::status_code(x) != 200L) {
    abort("Your message has not been posted!", call = caller_call())
  }
  cpt <- httr::content(x)
  cpt$id_str
}

# rbind ####
#' @export
rbind.tweets <- function(..., deparse.level = 1) {
  if (...length() == 1) return(..1)
  rt <- list(...)

  ud <- lapply(rt, users_data)
  udm <- do.call(rbind, ud)
  rt <- do.call(rbind.data.frame, rt)
  rt <- tibble::as_tibble(rt)
  attr(rt, "users") <- tibble::as_tibble(udm)
  class(rt) <- c("tweets", class(rt))
  rt
}

#' @export
rbind.users <- function(..., deparse.level = 1) {
  if (...length() == 1) return(..1)
  rt <- list(...)

  td <- lapply(rt, tweets_data)
  tdm <- do.call(rbind, td)
  rt <- do.call(rbind.data.frame, rt)
  rt <- tibble::as_tibble(rt)
  attr(rt, "tweets") <- tibble::as_tibble(tdm)
  class(rt) <- c("users", class(rt))
  rt
}
#' @export
rbind.page <- function(..., deparse.level = 1) {
  if (...length() == 1) return(..1)
  rt <- list(...)

  tdm <- do.call(rbind.data.frame, rt)

  m <- lapply(rt, attr, which = "meta", exact  = TRUE)
  coln <- lapply(m, colnames)
  coln <- unique(unlist(coln, FALSE, FALSE))
  mm <- matrix(nrow = length(m), ncol = length(coln))
  colnames(mm) <- coln
  mm <- as.data.frame(mm)
  for (i in seq_along(m)) {
    mm[i, colnames(m[[i]])] <- m[[i]][1, ]
  }
  attr(tdm, "meta") <- as.data.frame(mm)

  m <- lapply(rt, attr, which = "summary", exact  = TRUE)
  coln <- lapply(m, colnames)
  coln <- unique(unlist(coln, FALSE, FALSE))
  mm <- matrix(nrow = length(m), ncol = length(coln))
  colnames(mm) <- coln
  mm <- as.data.frame(mm)
  for (i in seq_along(m)) {
    mm[i, colnames(m[[i]])] <- m[[i]][1, ]
  }
  attr(tdm, "summary") <- as.data.frame(mm)

  class(tdm) <- c("result", class(tdm))
  return(tdm)
}

# subset ####
#' @export
`[.tweets` <- function(x, i, j, ..., drop) {
  tweets <- NextMethod()
  keep_users <- missing(drop) || !drop
  if (keep_users) {
    attr(tweets, "users") <- users_data(x)[i, ]
  }
  tweets
}

#' @export
`[.users` <- function(x, i, j, ..., drop) {
  users <- NextMethod()
  keep_tweets <- missing(drop) || !drop
  if (keep_tweets) {
    attr(users, "tweets") <- tweets_data(x)[i, ]
  }
  users
}

#' Get mentions for the authenticating user.
#'
#' Returns data on up to 200 of the most recent mentions (Tweets
#' containing a users' screen_name) of the authenticating user.
#' The timeline returned is the equivalent of the one seen when you view
#' your mentions on twitter.com. `r lifecycle::badge("deprecated")`
#'
#' @inheritParams TWIT_paginate_max_id
#' @inheritParams stream
#' @param ... Other arguments passed as parameters in composed API
#'   query.
#' @return Tibble of mentions data.
#' @family tweets
#' @seealso [`rtweet-deprecated`]
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/timelines/overview>
#' @export
get_mentions <- function(n = 200,
                         since_id = NULL,
                         max_id = NULL,
                         parse = TRUE,
                         retryonratelimit = NULL,
                         verbose = TRUE,
                         token = NULL,
                         ...) {

  params <- list(...)
  r <- TWIT_paginate_max_id(token, "/1.1/statuses/mentions_timeline", params,
    n = n,
    since_id = since_id,
    max_id = max_id,
    retryonratelimit = retryonratelimit,
    verbose = verbose
  )

  if (parse) {
    r <- tweets_with_users(r)
    r$created_at <- format_date(r$created_at)
  }
  r
}

#' Search users by username
#'
#' Looks up users by their username.
#' @inheritParams filtered_stream
#' @param ... Other arguments passed to the API.
#' @param verbose A logical value to provide more information about paginated queries.
#' @param username A user name string or up to 100.
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/users/lookup/api-reference/get-users-by-username-username>
#' <https://developer.twitter.com/en/docs/twitter-api/users/lookup/api-reference/get-users-by>
#' @seealso [user_search()]
#' @examples
#' if (FALSE) {
#'   user_by_username("rOpenSci")
#'   user_by_username(c("Bioconductor", "R_Contributors"))
#' }
user_by_username <- function(username, expansions = NULL, fields = NULL, ...,
                        token = NULL, parse = TRUE, verbose = FALSE) {

  expansions <- check_expansions(arg_def(expansions, "pinned_tweet_id"),
                                 "pinned_tweet_id")
  fields <- check_fields(arg_def(fields, set_fields(media = NULL,
                                                    poll = NULL,
                                                    place = NULL)),
                         metrics = NULL, place = NULL, poll = NULL, media = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  if (length(username) > 100 || !is_user_id(username) && length(username) == 0) {
    abort("Please introduce less than 100 valid user ids.")
  }
  if (length(username) > 1) {
    data <- c(list(usernames = username, expansions = expansions), fields, ...)
    url <- "users/by"
  } else {
    data <- c(list(expansions = expansions), fields, ...)
    url <- paste0("users/by/username/", username)
  }
  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- data[data != ""]

  # Rates from the website app and user limits
  req_archive <- endpoint_v2(url, 900/(60*15), c("tweet.read", "users.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, 1, 1, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

handle_errors <- function(response) {
  if (!httr::status_code(response)) {
    return(response)
  }

  obj <- httr::content(response)
  if (has_name_(obj, "errors")) {
    l <- lapply(obj$errors, list2DF)
    errors <- do.call(rbind, l)
    return(errors)
  }
  obj
}

#' Get user IDs of accounts followed by target user(s).
#'
#' Returns a list of user IDs for the accounts following BY one or
#' more specified users. `r lifecycle::badge("deprecated")`
#'
#' Generally, you should not need to set `n` to more than 5,000 since Twitter
#' limits the number of people that you can follow (i.e. to follow more than
#' 5,000 people at least 5,000 people need to follow you).
#'
#' @note If a user is protected the API will omit all requests so you'll need
#' to find which user is protected. rtweet will warn you and the output will be `NA`.
#'
#' @inheritParams TWIT_paginate_cursor
#' @inheritParams get_followers
#' @inheritParams stream
#' @param users Screen name or user ID of target user from which the
#'   user IDs of friends (accounts followed BY target user) will be
#'   retrieved.
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-friends-ids>
#' @seealso [`rtweet-deprecated`]
#' @examples
#' if (FALSE) {
#'   get_friends("ropensci")
#' }
#' @return A tibble data frame with two columns, "from_id" for name or ID of target
#'   user and "to_id" for accounts ID they follow.
#' @export
get_friends <- function(users,
                        n = 5000,
                        retryonratelimit = NULL,
                        cursor = "-1",
                        parse = TRUE,
                        verbose = TRUE,
                        token = NULL,
                        page = lifecycle::deprecated()) {

  if (lifecycle::is_present(page)) {
    lifecycle::deprecate_warn("1.0.0", "get_friends(page)", "get_friends(cursor)")
    cursor <- page
  }

  results <- lapply(users, get_friends_user,
    n = n,
    retryonratelimit = retryonratelimit,
    cursor = cursor,
    parse = parse,
    verbose = verbose,
    token = token
  )

  if (parse) {
    # Can only paginate with cursor if requesting info for single user.
    # Fortunately, few people follower >5000 users so this should rarely
    # come up in practice.
    df <- do.call(rbind, results)

    if (length(results) == 1) {
      results <- copy_cursor(df, results[[1]])
    } else {
      results <- df
    }
  }
  results
}

get_friends_user <- function(user, token, ..., parse = TRUE) {
  params <- list(stringify_ids = TRUE)
  params[[user_type(user)]] <- user

  results <- TWIT_paginate_cursor(token, "/1.1/friends/ids", params,
    page_size = 5000,
    ...
  )

  if (parse) {
    df <- tibble::tibble(
      from_id = user,
      to_id = unlist(lapply(results, function(x) x$ids),
                     recursive = FALSE, use.names = FALSE)
    )
    if (ncol(df) == 1) {
      df$to_id <- NA
    }
    results <- copy_cursor(df, results)
    class(results) <- c("friends", class(results))
  }
  results
}


#' Lookup friendship information between users.
#'
#' Gets information on friendship between authenticated user and up
#' to 100 other users.
#'
#' @inheritParams get_timeline
#' @family friends
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-friendships-lookup>
my_friendships <- function(user,
                           parse = FALSE,
                           token = NULL) {

  if (!isFALSE(parse)) {
    abort("`my_friendships()` can only return unparsed data", call = current_call())
  }

  params <- list()
  params[[user_type(user)]] <- paste0(user, collapse = ",")
  TWIT_get(token, "/1.1/friendships/lookup", params)
}

#' Lookup friendship information between two specified users.
#'
#' Gets information on friendship between two Twitter users.
#'
#' @inheritParams lookup_users
#' @inheritParams stream
#' @param source Screen name or user id of source user.
#' @param target Screen name or user id of target user.
#' @family friends
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-friendships-show>
lookup_friendships <- function(source, target, parse = TRUE, token = NULL) {
  if (length(source) > 1L && length(target) > 1L) {
    stopifnot(length(source) == length(target))
  }

  fds <- Map(
    "lookup_friendships_", source, target,
    MoreArgs = list(parse = parse, token = token)
  )
  if (parse) {
    fds <- do.call(rbind, fds)
    row.names(fds) <- NULL
  }
  fds
}

lookup_friendships_ <- function(source,
                                target,
                                parse = TRUE,
                                token = NULL) {
  stopifnot(is.atomic(source) && !is.null(source),
            is.atomic(target) && !is.null(target))

  params <- list()
  params[[paste0("source_", user_type(source, "source"))]] <- source
  params[[paste0("target_", user_type(target, "target"))]] <- target

  f <- TWIT_get(token, "/1.1/friendships/show", params)
  if (parse) {
    f <- parse_showfriendships(f, source, target)
  }
  f
}

parse_showfriendships <- function(x, source_user, target_user) {
  if (has_name_(x, "relationship")) {
    x <- x$relationship
  }
  if (has_name_(x, "source")) {
    src <- unlist(x$source)
    src <- tibble::tibble(
      relationship = "source",
      user = target_user,
      variable = names(src),
      value = src
    )
  } else {
    src <- data.frame()
  }
  if (has_name_(x, "target")) {
    trg <- unlist(x$target)
    trg <- tibble::tibble(
      relationship = "target",
      user = source_user,
      variable = names(trg),
      value = trg
    )
  } else {
    trg <- data.frame()
  }
  rbind(src, trg)
}

test_that("get_friends returns data frame with ids", {

  vcr::use_cassette("friends1", {
    f <- get_friends("kearneymw")
  })
  expect_true(is.data.frame(f))
  ##expect_true(is.character(f[["ids"]]))
  expect_gt(nrow(f), 200)
})

test_that("friendships returns data", {

  vcr::use_cassette("friends2", {
    x <- my_friendships("kearneymw")
  })
  expect_equal(is.data.frame(x), TRUE)
  expect_named(x)
  expect_true("screen_name" %in% names(x))
  vcr::use_cassette("friends3", {
    x <- lookup_friendships("kearneymw", c("realdonaldtrump", "cstonehoops"))
  })
  expect_equal(is.data.frame(x), TRUE)
  expect_named(x)
  expect_true("relationship" %in% names(x))
})

test_that("get_friends works", {

  vcr::use_cassette("friends4", {
    djt <- get_friends("ropensci")
  })
  expect_s3_class(djt, "data.frame")
  expect_gt(nrow(djt), 50)
})

test_that("lookup_friendships works", {

  vcr::use_cassette("friends5", {
    lf <- lookup_friendships("hadley", "Lluis_Revilla")
  })
  expect_s3_class(lf, "data.frame")
})

test_that("my_friendships works", {

  vcr::use_cassette("friends6", {
    mf <- my_friendships("hadley")
  })
  expect_s3_class(mf, "data.frame")
})

test_that("n = Inf works", {

  vcr::use_cassette("friends7", {
    mf <- get_friends("SmallBuStudio", n = Inf)
  })
  expect_s3_class(mf, "data.frame")
})

vcr::use_cassette("friends8", {
  test_that("n = Inf works", {
      expect_warning(
        gf <- rtweet::get_friends(c("fdrennan", "Lluis_Revilla"), n = 5),
        "Skipping unauthorized account: fdrennan")
    expect_s3_class(gf, "data.frame")
    expect_true(ncol(gf) == 2)
    # Keep the unauthorized account as NA.
    expect_true(sum(is.na(gf$to_id)) == 1)
  })
})

#' Posts status update to user's Twitter account
#'
#' `r lifecycle::badge("deprecated")`
#' @inheritParams lookup_users
#' @param status Character, tweet status. Must be 280 characters or less.
#' @param media Length 1 character vector with a file path to video media **OR**
#'     up-to length 4 character vector with file paths to static images to be included in tweet.
#'     **The caller is responsible for managing this.**
#' @param in_reply_to_status_id Status ID of tweet to which you'd like to reply.
#'   Note: in line with the Twitter API, this parameter is ignored unless the
#'   author of the tweet this parameter references is mentioned within the
#'   status text.
#' @param destroy_id To delete a status, supply the single status ID here. If a
#'   character string is supplied, overriding the default (NULL), then a destroy
#'   request is made (and the status text and media attachments) are irrelevant.
#' @param retweet_id To retweet a status, supply the single status ID here. If a
#'   character string is supplied, overriding the default (NULL), then a retweet
#'   request is made (and the status text and media attachments) are irrelevant.
#' @param auto_populate_reply_metadata If set to TRUE and used with
#'   in_reply_to_status_id, leading @mentions will be looked up from the
#'   original Tweet, and added to the new Tweet from there. Defaults to FALSE.
#' @param media_alt_text attach additional [alt text](https://en.wikipedia.org/wiki/Alt_attribute)
#'        metadata to the `media` you are uploading. Should be same length as
#'        `media` (i.e. as many alt text entries as there are `media` entries). See
#'        [the official API documentation](https://developer.twitter.com/en/docs/twitter-api/v1/media/upload-media/api-reference/post-media-metadata-create)
#'        for more information.
#' @param lat A numeric value representing the latitude of the location the
#'   tweet refers to. Range should be between -90 and 90 (north). Note that you
#'   should enable the "Precise location" option in your account via *Settings
#'   and privacy > Privacy and Safety > Location*. See
#'   [the official Help Center section](https://help.twitter.com/en/safety-and-security/x-location-services-for-mobile).
#' @param long A numeric value representing the longitude of the location the
#'   tweet refers to. Range should be between -180 and 180 (west). See
#'   `lat` parameter.
#' @param display_coordinates Put a pin on the exact coordinates a tweet has
#'   been sent from. Value should be TRUE or FALSE. This parameter would apply
#'   only if you have provided a valid `lat/long` pair of valid values.
#' @family post
#' @aliases post_status
#' @seealso [tweet_post()], [`rtweet-deprecated`]
#' @export
#' @references
#' Tweet: <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/post-statuses-update>
#' Retweet: <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/post-statuses-retweet-id>
#' Media: <https://developer.twitter.com/en/docs/twitter-api/v1/media/upload-media/api-reference/post-media-metadata-create>
#' Alt-text: <https://developer.twitter.com/en/docs/twitter-api/v1/media/upload-media/api-reference/post-media-metadata-create>
post_tweet <- function(status = "my first rtweet #rstats",
                       media = NULL,
                       token = NULL,
                       in_reply_to_status_id = NULL,
                       destroy_id = NULL,
                       retweet_id = NULL,
                       auto_populate_reply_metadata = FALSE,
                       media_alt_text = NULL,
                       lat = NULL,
                       long = NULL,
                       display_coordinates = FALSE) {

  ## if delete
  if (!is.null(destroy_id)) {
    lifecycle::deprecate_warn("1.0.0", "post_tweet(destroy_id)", "post_destroy()")
    return(post_destroy(destroy_id, token=token))
  }

  ## if retweet
  if (!is.null(retweet_id)) {
    stopifnot(is.character(retweet_id) && length(retweet_id) == 1)

    query <- sprintf("/1.1/statuses/retweet/%s", retweet_id)
    r <- TWIT_post(token, query)
    message("the tweet has been retweeted!")
    return(invisible(r))
  }

  stopifnot(is.character(status), length(status) == 1)
  ## media if provided
  if (!is.null(media)) {
    check_media(media, media_alt_text)
    media_id_string <- character(length(media))
    for (i in seq_along(media)) {
      media_id_string[[i]] <- upload_media_to_twitter(media[[i]], token, media_alt_text[[i]])
    }
    media_id_string <- paste(media_id_string, collapse = ",")
    params <- list(
      status = status,
      media_ids = media_id_string
    )
  } else {
    params <- list(
      status = status
    )
  }

  ## geotag if provided
  if (!is.null(lat) && !is.null(long)) {
    # Validate inputs
    if (!is.numeric(lat)) stop("`lat` must be numeric.")
    if (!is.numeric(long)) stop("`long` must be numeric.")

    if (!is_logical(display_coordinates)) {
      stop("`display_coordinates` must be TRUE/FALSE.")
    }

    if (abs(lat) > 90) stop("`lat` must be between -90 and 90 degrees.")
    if (abs(long) > 180) stop("`long` must be between -180 and 180 degrees.")

    params[["lat"]] <- as.double(lat)
    params[["long"]] <- as.double(long)

    if (display_coordinates) {
      params[["display_coordinates"]] <- "true"
    } else {
      params[["display_coordinates"]] <- "false"
    }
  }

  if (!is.null(in_reply_to_status_id)) {
    params[["in_reply_to_status_id"]] <- in_reply_to_status_id
  }
  if (auto_populate_reply_metadata) {
    params[["auto_populate_reply_metadata"]] <- "true"
  }

  r <- TWIT_post(token, "/1.1/statuses/update", params)
  message("Your tweet has been posted!")
  class(r) <- c("post_tweet", class(r))
  invisible(r)
}

#' Uploads media using chunked media endpoint
#'
#' @param media Path to media file (image or movie) to upload.
#' @inheritParams lookup_users
#' @noRd
upload_media_to_twitter <- function(media,
                                    token = NULL,
                                    alt_text = NULL,
                                    chunk_size = 5 * 1024 * 1024) {
  media_type <- switch(tools::file_ext(media),
    jpg = ,
    jpeg = "image/jpeg",
    png = "image/png",
    gif = "image/gif",
    mp4 = "video/mp4",
    stop("Unsupported file extension", call. = FALSE)
  )

  file_size <- file.size(media)

  if (file_size <= chunk_size && media_type != "video/mp4") {
    resp <- TWIT_upload(token, "/1.1/media/upload", list(
      media = httr::upload_file(media)
    ))
    media_id <- from_js(resp)$media_id_string
  } else {
    # https://developer.twitter.com/en/docs/twitter-api/v1/media/upload-media/uploading-media/chunked-media-upload

    # Initialize upload
    resp <- TWIT_upload(token, "/1.1/media/upload", list(
      command = "INIT",
      media_type = media_type,
      total_bytes = file_size
    ))
    media_id <- from_js(resp)$media_id_string

    # Send chunks
    bytes_sent <- 0
    videofile <- file(media, open = "rb")
    withr::defer(close(videofile))

    segment_id <- 0
    while (bytes_sent < file_size) {
      chunk <- readBin(videofile, chunk_size, what = "raw")
      resp <- TWIT_upload(token, "/1.1/media/upload", list(
        command = "APPEND",
        media_id = media_id,
        segment_index = segment_id,
        media = chunk
      ))

      segment_id <- segment_id + 1
      bytes_sent <- bytes_sent + chunk_size
    }

    # Finalize
    resp <- TWIT_upload(token, "/1.1/media/upload", list(
      command = "FINALIZE",
      media_id = media_id
    ))
    wait_for_chunked_media(resp, media_id, token)
  }

  if (!is.null(alt_text)) {
    # https://developer.twitter.com/en/docs/twitter-api/v1/media/upload-media/api-reference/post-media-metadata-create
    TWIT_upload(token, "/1.1/media/metadata/create",
      list(
        media_id = media_id,
        alt_text = list(text = substr(as.character(alt_text), 1, 1000))
      ),
      encode = "json"
    )
  }

  media_id
}

TWIT_upload <- function(token, api, body, ...) {
  TWIT_post(token, api, body = body, ..., host = "upload.twitter.com")
}

wait_for_chunked_media <- function(resp, media_id, token = NULL) {
  json <- from_js(resp)
  if (is.null(json$process_info)) {
    return()
  }

  params <- list(
    command = "STATUS",
    media_id = media_id
  )

  while (!json$processing_info$state %in% c("pending", "in_progress")) {
    Sys.sleep(json$processing_info$check_after_secs)

    json <- TWIT_get(token, "/1.1/media/upload",
      params = params,
      host = "upload.twitter.com"
    )
  }

  invisible()
}

check_media <- function(media, alt_text) {
  if (!is.character(media) || !is.character(alt_text)) {
    stop("Media and alt_text must be character vectors.", call. = FALSE)
  }
  media_type <- tools::file_ext(media)
  if (length(media) > 4) {
    stop("At most 4 images per plot can be uploaded.", call. = FALSE)
  }

  if (all(media_type %in% c("gif", "mp4")) && length(media) > 1) {
    stop("Cannot upload more than one gif or video per tweet.", call. = TRUE)
  }

  if (!is.null(alt_text) && length(alt_text) != length(media)) {
    stop("Alt text for media isn't provided for each image.", call. = TRUE)
  }
  if (!any(media_type %in% c("jpg", "jpeg", "png", "gif", "mp4"))) {
    stop("Media type format not recognized.", call. = TRUE)
  }

  if (any(nchar(alt_text) > 1000)) {
    stop("Alt text cannot be longer than 1000 characters.", call. = TRUE)
  }
}

vcr::use_cassette("post_favorite", {
  test_that("can favourite and unfavourite a tweet", {
    
    tw <- suppressMessages(post_tweet(paste0("test favourite ", Sys.time())))
    json <- httr::content(tw)
    
    expect_error(post_favorite(json$id_str), NA)
    expect_error(post_favorite(json$id_str, destroy = TRUE), NA)
    expect_message(expect_error(post_destroy(json$id_str), NA), 
                   "Your tweet has been deleted!")
  })
})

test_that("upload_media_to_twitter() can handle small file", {

  # gif - unchunk 1MB
  vcr::use_cassette("upload_media_to_twitter1", {
    id <- upload_media_to_twitter(test_path("tweet.gif"), chunk_size = 1024 * 1024)
  })
  expect_type(id, "character")

  # doesn't appear to be any way to get info about a media object
  # after it's been uploaded

  # gif - chunk 5KB
  vcr::use_cassette("upload_media_to_twitter2", {
    id <- upload_media_to_twitter(test_path("tweet.gif"), chunk_size = 5 * 1024)
  })
  expect_type(id, "character")

  # mp4 - test forced chunk / small file w/ high chunk sizes
  vcr::use_cassette("upload_media_to_twitter3", {
    id <- upload_media_to_twitter(test_path("tweet.mp4"), chunk_size = 1024 * 1024)
  })
  expect_type(id, "character")
})

test_that("check_media handles well multiple files", {
  media <- c("image.png", "image.png")
  expect_error(check_media(media, letters[1:2]), NA)
  files <- c(test_path("testing_plot.png"), test_path("testing_plot.jpg"))
  vcr::use_cassette("upload_multiple_media_to_twitter", {
    id <- post_tweet("Testing multiple media", media = files,
                     media_alt_text = c("mp4 for testing", "gif for testing"))
  })

})

test_that("can set alt text", {

  vcr::use_cassette("upload_media_to_twitter4", {
    id <- upload_media_to_twitter(test_path("tweet.gif"), alt_text = "A bird tweeting")
  })
  expect_type(id, "character")
})

test_that("post_tweet works", {
  skip_if_offline() # destroy id changes on each test
  msg <- paste("test", Sys.time()) # To avoid having duplicated status

  expect_message(pt <- post_tweet(msg), "Your tweet has been posted!")
  #pt = post tweet
  cpt <- httr::content(pt)
  expect_equal(httr::status_code(pt), 200L)
  expect_message(dt <- post_destroy(cpt$id_str), "Your tweet has been deleted!")
  # dt = destroy tweet
  expect_equal(httr::status_code(dt), 200L)
})

test_that("post_tweet geolocated works", {
  skip_if_offline() # destroy id changes on each test

  # Test geolocated tweet
  msg <- paste("test geolocated", Sys.time()) # To avoid having duplicated status
  expect_message(pt <- post_tweet(msg, lat = -36.811784, long = 174.792657),
                 "Your tweet has been posted!")
  cpt <- httr::content(pt)
  expect_message(dt <- post_destroy(cpt$id_str), "Your tweet has been deleted!")
  expect_equal(httr::status_code(dt), 200L)

  # Test display_coordinates param
  msg <- paste("test geolocated", Sys.time()) # To avoid having duplicated status
  expect_message(pt <- post_tweet(msg, lat = -36.811784, long = 174.792657,
                                  display_coordinates = TRUE),
                 "Your tweet has been posted!")
  cpt <- httr::content(pt)

  expect_message(dt <- post_destroy(cpt$id_str), "Your tweet has been deleted!")
  expect_equal(httr::status_code(dt), 200L)
})

test_that("Check geo-related inputs for post_tweet", {
  # All these post_tweets fail
  expect_snapshot(error = TRUE, {
    msg <- paste("test geolocated error", Sys.time()) # To avoid having duplicated status
    post_tweet(msg, lat = "x", long = 0)
    post_tweet(msg, lat = 0, long = "x")
    post_tweet(msg, lat = 91, long = 0)
    post_tweet(msg, lat = 0, long = 181)
    post_tweet(msg, lat = 0, long = 0, display_coordinates = "error")
  })
})

#' Get subscribers of a specified list.
#'
#' @inheritParams TWIT_paginate_cursor
#' @inheritParams stream
#' @param list_id required The numerical id of the list.
#' @param slug,owner_user The list name (slug) and owner.
#' @family lists
#' @family users
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/get-lists-subscribers>
lists_subscribers <- function(list_id = NULL,
                              slug = NULL,
                              owner_user = NULL,
                              n = 5000,
                              cursor = "-1",
                              parse = TRUE,
                              retryonratelimit = NULL,
                              verbose = TRUE,
                              token = NULL) {

  params <- lists_params(
    list_id = list_id,
    slug = slug,
    owner_user = owner_user
  )

  r <- TWIT_paginate_cursor(token, "/1.1/lists/subscribers", params,
    n = n,
    cursor = cursor,
    retryonratelimit = retryonratelimit,
    verbose = verbose,
    page_size = if (n >= 5000) 5000 else n,
    get_id = function(x) x$users$id_str
  )

  if (parse) {
    r <- parse_lists_users(r)
  }
  r
}

parse_lists_users <- function(x) {
  users <- lapply(x, function(x) x$users)
  dfs <- lapply(users, wrangle_into_clean_data, type = "user")
  dfs <- lapply(dfs, tibble::as_tibble)
  df <- do.call(rbind, dfs)

  copy_cursor(df, x)
}

test_that("lists_subscribers returns users data frame", {
  
  vcr::use_cassette("lists_subscribers", {
    x <- lists_subscribers(
      slug = "new-york-times-politics",
      owner_user = "nytpolitics",
      n = 20
    )
  })
  expect_true(is.data.frame(x))
  expect_true("description" %in% names(x))
  expect_gt(nrow(x), 10)
})

#' Deprecated functions in rtweet
#'
#' These functions might not work due to the drop of API v1 in favor of API v2.
#' \itemize{
#'  \item `clean_tweets()`: No replacement.
#'  \item `collections()`: No replacement (It hasn't worked for a while).
#'  \item `direct_messages()`: No replacement.
#'  \item `do_call_rbind()`: No replacement (if any it will be a method).
#'  \item `get_favorites()`: Use `tweet_liking_users()`.
#'  \item `get_followers()`: Use `user_following()`.
#'  \item `get_friends()`: Use `user_followers()`.
#'  \item `network_data()` and `network_graph()`: No replacement.
#'  \item `list_memberships()`: Use `list_users()`.
#'  \item `get_mentions()`: Use `user_mentions()`
#'  \item `user_block()`: No replacement.
#'  \item `post_favorite()`: No replacement.
#'  \item `post_list()`: `lists_subscribers()`, `list_subscriptions()`, `list_members()`, `lists_users()`
#'  \item `post_tweet()`: Use `tweet_post()`.
#'  \item `post_follow()`: No replacement.
#'  \item `post_destroy()`: Use `tweet_delete()`.
#'  \item `search_fullarchive()`: Use `tweet_search_all()`.
#'  \item `search_30d()`: Use `tweet_search_recent()`.
#'  \item `rate_limit()`: No replacement (already implemented inside the calls).
#'  \item `save_as_csv()`: No replacement.
#'  \item `search_tweets()`: Use `tweet_search_recent()`.
#'  \item `search_tweets2()`: Use `tweet_search_recent()`.
#'  \item `search_users()`: Use `user_search()`.
#'  \item `lookup_tweets()`: Use `tweet_get()`, `tweet_retweeted_by()`.
#'  \item `stream_tweets()`: Use `filtered_stream()`, `stream_add_rule()`, `stream_rm_rule()` and `sample_stream()`.
#'  \item `get_timeline()`: Use `user_timeline()`.
#'  \item `get_my_timeline()`: Use `user_timeline()`.
#'  \item `get_token()`: Use `auth_get()`.
#'  \item `get_tokens()`: Use `auth_get()`.
#'  \item `get_trends()`: No replacement.
#'  \item `trends_available()` and `trends_closest()`: No replacement.
#'  \item `ts_data()` and `ts_plot()`: No replacement.
#'  \item `tweet_shot()`: No replacement.
#'  \item `tweet_threading()`: Use `tweet_get()` with conversation ID.
#' }
#'
#' @name rtweet-deprecated
NULL

#' Manage Twitter lists
#'
#' Create, add users, and destroy Twitter lists. `r lifecycle::badge("deprecated")`
#'
#' @inheritParams lookup_users
#' @param users Character vectors of users to be added to list.
#' @param name Name of new list to create.
#' @param description Optional, description of list (single character string).
#' @param private Logical indicating whether created list should be private.
#'   Defaults to false, meaning the list would be public. Not applicable if list
#'   already exists.
#' @param destroy Logical indicating whether to delete a list. Either `list_id` or
#'   `slug` must be provided if `destroy = TRUE`.
#' @param list_id Optional, numeric ID of list.
#' @param slug Optional, list slug.
#' @return Response object from HTTP request.
#' @seealso [`rtweet-deprecated`]
#' @references
#' Create: <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-create>
#' Destroy: <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-destroy>
#' Add users: <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-members-create>,
#' <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-members-create_all>
#' Remove users: <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-members-destroy>,
#' <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-members-destroy_all>
post_list <- function(users = NULL,
                      name = NULL,
                      description = NULL,
                      private = FALSE,
                      destroy = FALSE,
                      list_id = NULL,
                      slug = NULL,
                      token = NULL) {
  ## destroy list
  if (destroy && is.null(users)) {
    return(post_list_destroy(list_id, slug, token))
  }

  ## drop users from list
  if (destroy) {
    return(post_list_destroy_all(users, list_id, slug, token))
  }

  ## create list
  if (is.null(list_id) && is.null(slug)) {
    r <- post_list_create(name, description, private, token)
    tl <- from_js(r)
    list_id <- tl$id_str
  }

  ## add users to list one at a time
  #post_list_create_all(users, list_id, slug, token)
  r <- list()
  for (i in seq_along(users)) {
    r[[length(r) + 1]] <- post_list_add_one(users[i], list_id = list_id, slug = slug, token = token)
  }

  invisible(r)
}

post_list_create <- function(name,
                             description = NULL,
                             private = FALSE,
                             token = NULL) {

  stopifnot(is.atomic(name) && !is.null(name), length(name) == 1,
            is_logical(private))

  if (private) {
    mode <- "private"
  } else {
    mode <- "public"
  }

  params <- list(
    name = name,
    mode = mode,
    description = description
  )
  TWIT_post(token, "/1.1/lists/create", params)
}



post_list_add_one <- function(user,
                              list_id = NULL,
                              slug = NULL,
                              token = NULL) {

  ## check and reformat users
  stopifnot(is.character(user))
  if (length(user) > 1) {
    warning("Can only add 1 users at a time via this method. Adding user[]...",
      call. = FALSE)
    user <- user[1]
  }

  params <- my_list_params(token,
    users = user,
    list_id = list_id,
    slug = slug
  )
  TWIT_post(token, "/1.1/lists/members/create", params)
}


post_list_destroy <- function(list_id = NULL,
                              slug = NULL,
                              token = NULL) {

  params <- my_list_params(token,
    list_id = list_id,
    slug = slug
  )
  TWIT_post(token, "/1.1/lists/destroy", params)
}

post_list_create_all <- function(users,
                                 list_id = NULL,
                                 slug = NULL,
                                 token = NULL) {
  stopifnot(is.character(users))
  if (length(users) > 100) {
    warning("Can only add 100 users at a time. Adding users[1:100]...",
      call. = FALSE)
    users <- users[1:100]
  }

  params <- my_list_params(token,
    users = users,
    list_id = list_id,
    slug = slug
  )
  TWIT_post(token, "/1.1/lists/members/create_all", params)
}

post_list_destroy_all <- function(users,
                                  list_id = NULL,
                                  slug = NULL,
                                  token = NULL) {

  stopifnot(is.character(users))
  if (length(users) > 100) {
    warning("Can only drop 100 users at a time. Dropping users[1:100]...",
      call. = FALSE)
    users <- users[1:100]
  }

  params <- my_list_params(token,
    users = users,
    list_id = list_id,
    slug = slug
  )
  TWIT_post(token, "/1.1/lists/members/destroy_all", params = params)
}

my_list_params <- function(token, slug = NULL, list_id = NULL, ..., users = NULL) {
  params <- list(...)

  if (!is.null(list_id) && !is.null(slug)) {
    stopifnot(is.atomic(list_id), length(list_id) == 1)

    params$list_id <- list_id
  } else if (is.null(slug) && !is.null(list_id)) {
    stopifnot(is.atomic(slug), length(slug) == 1)

    params$slug <- slug
    params$owner_screen_name = api_screen_name(token)
  } else {
    abort("Must supply exactly one of `list_id` or `slug` to identify a list")
  }

  if (!is.null(users)) {
    params[[user_type(users, "users")]] <- paste0(users, collapse = ",")
  }
  params
}

#' Search for users
#'
#' Search for Twitter users. The Twitter API limits the results to at most
#' 1,000 users.  `r lifecycle::badge("deprecated")`
#'
#' @inheritParams TWIT_paginate_max_id
#' @inheritParams stream
#' @param q As string providing the search query. Try searching by interest,
#'   full name, company name, or location. Exact match searches are not
#'   supported.
#' @return Data frame with one row for each matching user.
#' @family users
#' @seealso [user_search()], [`rtweet-deprecated`]
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-users-search>
search_users <- function(q, n = 100,
                         parse = TRUE,
                         token = NULL,
                         verbose = TRUE) {

  stopifnot(is_n(n), is.atomic(q) && !is.null(q))
  if (n > 1000) {
    abort("`n` must be <= 1,000 (the maximum allowed by Twitter)")
  }

  pages <- ceiling(n / 20)
  results <- vector("list", pages)

  if (verbose) {
    pb <- progress::progress_bar$new(
      format = "Searching for users :bar",
      total = pages
    )
    withr::defer(pb$terminate())
  }

  params <- list(q = q, count = 20)
  for (i in seq_len(pages)) {
    if (verbose) {
      pb$tick()
    }
    params$page <- i
    results[[i]] <- TWIT_get(token, "/1.1/users/search", params)
  }

  if (parse) {
    results <- users_with_tweets(results)
    results$created_at <- format_date(results$created_at)
  }

  results
}

test_that("search_users returns users data", {
  
  vcr::use_cassette("search_users", {
    x <- search_users("twitter", n = 20, verbose = FALSE)
  })
  expect_s3_class(x, "data.frame")
  expect_equal(nrow(x), 20)
})

#' Mark a user id as a screen name
#'
#' @description
#' There are two ways to identify a Twitter user: a screen name (e.g.
#' "justinbieber") or a user identifier (e.g. "27260086"). User identifiers
#' look like regular numbers, but are actually 64-bit integers which can't be
#' stored in R's numeric vectors. For this reason, rtweet always returns ids as
#' strings.
#'
#' Unfortunately this introduces an ambiguity, because user names can
#' also consist solely of numbers (e.g. "123456") so it's not obvious whether
#' a string consisting only of numbers is a screen name or a user id. By
#' default, rtweet will assume its a user id, so if you have a screen name
#' that consists only of numbers, you'll need to use `as_screenname()` to
#' tell rtweet that it's actually a screen name.
#'
#' Note that in general, you are best off using user ids; screen names are
#' not static and may change over longer periods of time.
#'
#' @param x A character vector of Twitter screen names.
#' @family users
#' @rdname as_screenname
#' @export
as_screenname <- function(x) {
  stopifnot(is.character(x))
  structure(x, class = "rtweet_screen_name")
}

#' @export
`[.rtweet_screen_name` <- function(x, i) {
  as_screenname(NextMethod())
}

#' @export
print.rtweet_screen_name <- function(x, ...) {
  cat("<rwteet_screen_name>\n")
  class(x) <- NULL
  print(x, ...)
  invisible(x)
}

#' @rdname as_screenname
#' @export
#' @usage NULL
as_userid <- function(x) {
  lifecycle::deprecate_warn("1.0.0", "as_userid()")
  x
}

user_type <- function(x, arg_name = "user") {
  if (is.numeric(x)) {
    "user_id"
  } else if (is.character(x)) {
    if (inherits(x, "rtweet_screen_name")) {
      # needed for purely numeric screen names
      "screen_name"
    } else if (all(grepl("^[0-9]+$", x))) {
      "user_id"
    } else {
      "screen_name"
    }
  } else {
    abort(paste0("`", arg_name, "` must be a screen name or user id"),
          call = caller_call())
  }
}

is_int64 <- function(x) {
  all(!is.na(bit64::as.integer64(x)))
}

api_screen_name <- function(token = NULL) {
  params <- list(
    include_entities = FALSE,
    skip_status = TRUE,
    include_email = FALSE
  )
  r <- TWIT_get(token, "/1.1/account/verify_credentials", params)
  r$screen_name
}

test_that("screen_name has print and [ methods", {
  x <- as_screenname("123456")
  expect_s3_class(x[1], "rtweet_screen_name")
  expect_snapshot(x)
})

test_that("user_type handles simple cases", {
  expect_equal(user_type("hadleywickham"), "screen_name")

  expect_equal(user_type(123), "user_id")
  expect_equal(user_type(bit64::as.integer64(123)), "user_id")
  expect_equal(user_type("123"), "user_id")
  expect_equal(user_type(as_screenname("123")), "screen_name")

  expect_error(user_type(TRUE),
               "`user` must be a screen name or user id")
})

parse <- function(x, expansions, fields) {

  if (is.null(fields) && is.null(expansions)) {
    pages <- lapply(x, parse_page, expansions = expansions, fields = fields)
    if (length(pages) == 1) {
      return(pages[[1]])
    }
    return(do.call(rbind, pages))
  }

  abort(c("Not yet implemented!",
          i = "Stay tuned for further updates or use `parse = FALSE`"))
}

enlist <- function(x) {
  # Going through lapply and converting it to a list
  # This works for matrices or data.frames
  if (!is.data.frame(x)) {
    x[lengths(x) > 1] <- lapply(x[lengths(x) > 1], function(x){list(x)})
  }
  x
}

parse_page <- function(page, expansions, fields) {
  if (is.null(fields) && is.null(expansions)) {
    if (is.null(page$data)) {
      dcr <- list2DF(page)
    } else if (!is.null(names(page$data))) {
      dcr <- list2DF(enlist(page$data))
    } else {
      ldf <- lapply(page$data, function(x){list2DF(enlist(x))})
      dcr <- do.call(rbind, ldf)
    }
    # User search do not return meta
    if (!is.null(page$meta)) {
      attr(dcr, "meta") <- page$meta
    }
    class(dcr) <- c("page", class(dcr))
    return(dcr)
  }

  abort("Not yet implemented")
}

#' Fetch Twitter OAuth token
#'
#' @description
#' `r lifecycle::badge("deprecated")`
#' Please use [auth_get()] instead.
#'
#' @family tokens
#' @export
get_token <- function() {
  lifecycle::deprecate_warn("1.0.0", "get_token()", "auth_get()")
  auth_get()
}

#' @export
#' @rdname get_token
get_tokens <- function() {
  lifecycle::deprecate_warn("1.0.0", "get_tokens()", "auth_get()")
  auth_get()
}

#' Create custom Twitter OAuth token
#'
#' @description
#' `r lifecycle::badge("deprecated")`
#' By default, `create_token()` does three things: it creates an authentication
#' "token", sets it as the default token for the current session, and save it
#' to disk to make it the default for future sessions.
#'
#' These three components have now been split up into three separate pieces:
#' use [rtweet_user()]/[rtweet_app()]/[rtweet_bot()] to create the token,
#' [auth_as()] to make it the default for this session, and [auth_save()] to
#' use it in future sessions. See `vignette("auth", package = "rtweet")` for full details.
#'
#' @param app Name of user created Twitter application
#' @param consumer_key,consumer_secret App API key and secret.
#' @param access_token,access_secret Access token and secret.
#' @param set_renv Should the token be cached?
#' @return Twitter OAuth token(s) (Token1.0).
#' @keywords internal
#' @family tokens
#' @export
create_token <- function(app = "mytwitterapp",
                         consumer_key = NULL,
                         consumer_secret = NULL,
                         access_token = NULL,
                         access_secret = NULL,
                         set_renv = TRUE) {

  lifecycle::deprecate_warn(
    when = "1.0.0",
    what = "create_token()",
    details = "See vignette('auth', package = 'rtweet') for details"
  )

  if (!is.null(access_token) && !is.null(access_secret)) {
    token <- rtweet_bot(consumer_key, consumer_secret, access_token, access_secret)
  } else {
    token <- rtweet_user(consumer_key, consumer_secret)
  }

  if (set_renv) {
    auth_save(token, "create_token")
  }
  auth_as(token)

  invisible(token)
}

test_that("get_token() and get_tokens() are deprecated", {
  expect_snapshot({
    . <- get_token()
    . <- get_tokens()
  })
})

test_that("create_token is deprecated", {

  path <- tempfile()
  withr::local_options("rtweet:::config_dir" = path)
  expect_snapshot(token <- suppressMessages(create_token("my-app", "x", "x", "y", "y")))

  # still sets as default
  expect_equal(auth_get(), token)

  # and saves in config dir
  expect_equal(dir(path), "create_token.rds")
})

#' Streaming
#'
#' Open a streaming connection with Twitter and stores tweets for as long as you
#'  wish.
#'
#' The connection can be left open as long as you wish, the data is appended to
#' the file provided. Be aware that the stream might have incomplete records
#' (you won't be able to read directly from the json file).
#' One tweet might belong to multiple rules.
#'
#' @param file Path to a file where the raw streaming should be stored.
#' @param token These endpoints only accept a bearer token (can be created via
#' [rtweet_app()]). In most cases you
#' are better of changing the default for all calls via [auth_as()].
#' @param parse If `TRUE`, the default, returns a tidy data frame. Use `FALSE`
#' to return the "raw" list corresponding to the JSON returned from the
#' Twitter API.
#' @param timeout time, in seconds, of the recording stream.
#' @param expansions Set `NULL` to not use any expansion, set `NA` to get all
#' expansions, or provide a vector with the expansions you want (create it with
#' [set_expansions()]).
#' @param fields Set `NULL` to not use any field, get all allowed fields with `NA`,
#' provide a list with the fields you want (create it with [set_fields()]).
#' @param append Append streaming to the file? Default does but it is
#' recommended to have a new file for each call.
#' @param query If `NULL` returns the current rules, else depending:
#'  - In stream_add_rule it should be a list of value and tag.
#'  - In stream_rm_rule it should be a vector of ids of rules to be removed
#' @param dry Check if the addition or removal of the rule works.
#' @param ... Other parameters passed to the body of the request.
#'
#' @return The records in the streaming.
#' @seealso
#' Rules for filtered stream: <https://developer.twitter.com/en/docs/twitter-api/tweets/filtered-stream/integrate/build-a-rule>
#'
#' Sampled stream: <https://developer.twitter.com/en/docs/twitter-api/tweets/volume-streams/api-reference/get-tweets-sample-stream>
#'
#' Filtered stream: <https://developer.twitter.com/en/docs/twitter-api/tweets/filtered-stream/api-reference/get-tweets-search-stream>
#'
#' [ids()]
#' @rdname stream
#' @name stream
#' @examples
#' # Requires a bearer token
#' if (FALSE) {
#'   # How many rules do we have
#'   stream_add_rule(NULL)
#'   # Add new rule
#'   new_rule <- stream_add_rule(list(value = "#rstats", tag = "rstats"))
#'   new_rule
#'   # Open filtered streaming connection for 30s
#'   filtered_stream(file = tempfile(), timeout = 30, parse = FALSE)
#'   # Remove rule
#'   stream_rm_rule(ids(new_rule))
#'   # Open random streaming connection
#'   sample_stream(file = tempfile(), timeout = 3, parse = FALSE)
#' }
NULL

#' @export
#' @describeIn stream Start a filtered stream according to the rules.
filtered_stream <- function(timeout, file = tempfile(),
                            expansions = NULL, fields = NULL,
                            ...,  token = NULL, append = TRUE, parse = TRUE) {
  parsing(parse, expansions, fields)
  expansions <- check_expansions(arg_def(expansions, set_expansions(list = NULL)))
  fields <- check_fields(arg_def(fields, set_fields()), metrics = NULL)
  expansions_for_fields(expansions, fields)
  req_stream <- endpoint_v2("tweets/search/stream", 50 / (60*15), set_scopes())
  data <- c(list(expansions = expansions), fields, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  req_stream <- httr2::req_url_query(req_stream, !!!data)
  if (file.exists(file) && isFALSE(append)) {
    abort("File already exists and append = FALSE",  call = caller_call())
  }
  out <- stream(req_stream, file, timeout = timeout)
  if (!parse) {
    return(out)
  }
  parse(out, expansions, fields)
}

stream <- function(req, file, timeout) {
  file_tmp <- tempfile(pattern = "rtweet_raw_stream")
  callback <- function(x) {
    chr <- rawToChar(x)
    if (!isTRUE(chr)) {
      cat(chr, file = file_tmp, appends = TRUE)
    }
    TRUE
  }

  httr2::req_stream(req, callback, timeout_sec = timeout)

  if (!file.exists(file_tmp)) {
    warning("No matching tweets with streaming rules were found in the time provided.",
            call. = FALSE)
    return(NULL)
  }

  # Create a json file but each line is a datapoint in the ndjson format
  # This makes it appendable to other times.
  text_json <- readLines(file_tmp, warn = FALSE)
  # Skip the first and last lines as most probably they are faulty:
  # httr2 doesn't wait for a line to close the connection.
  good_json <- text_json[c(-1, -length(text_json))]
  if (is.null(good_json) || length(good_json) == 0) {
    warning("No matching tweets with streaming rules were found in the time provided.",
            call. = FALSE)
    return(NULL)
  }
  cat(good_json, file = file, append = TRUE, sep = "\n")
  readable_json <- paste(good_json, collapse = "\n")
  text_c <- textConnection(readable_json)
  out <- jsonlite::stream_in(text_c, simplifyVector = FALSE, flatten = FALSE)
  close.connection(text_c)
  out
}

#' @describeIn stream Add rules for the filtered streaming.
#' @export
stream_add_rule <- function(query, dry = FALSE, token = NULL) {
  # To store the token at the right place: see ?httr2::oauth_cache_path
  withr::local_envvar(HTTR2_OAUTH_CACHE = auth_path())
  if (!is.null(query)) {
    query <- list(add = check_stream_add(query))
  }
  streaming <- stream_rules(query, token, auto_unbox = TRUE, pretty = FALSE)
  if (isTRUE(dry)) {
    streaming <- httr2::req_url_query(streaming, dry_run = dry)
  }
  out <- httr2::req_perform(streaming)
  out <- resp(out)
  handle_rules_resp(out)
}

#' @describeIn stream Remove rules from the filtered streaming
#' @export
stream_rm_rule <- function(query, dry = FALSE, token = NULL) {
  # To store the token at the right place: see ?httr2::oauth_cache_path
  withr::local_envvar(HTTR2_OAUTH_CACHE = auth_path())
  if (!is.null(query)) {
    query <- check_stream_remove(query)
  }
  rm_rule <- stream_rules(query, token, pretty = FALSE, auto_unbox = TRUE)
  if (isTRUE(dry)) {
    rm_rule <- httr2::req_url_query(rm_rule, dry_run = dry)
  }
  out <- httr2::req_perform(rm_rule)
  out <- resp(out)
  handle_rules_resp(out)
}

handle_rules_resp <- function(x) {
  if (!is.null(x$meta$summary)) {
    df <- cbind.data.frame(sent = x$meta$sent, x$meta$summary)
  } else {
    df <- x$meta
  }
  rules <- x$data

    # Ensure that the same order is always used
  if (!is.null(rules)) {
    rules <- rules[, c("id", "value", "tag")]
  }
  attr(df, "rules") <- rules
  class(df) <- c("rules", class(df))
  df
}

stream_rules <- function(query = NULL, token = NULL, ...) {
  req <- endpoint_v2("tweets/search/stream/rules", 450 / (15 * 60), set_scopes())

  if (!is.null(query)) {
    req <- httr2::req_body_json(req, data = query, ...)
  }
  req
}

is_rule <- function(q) {
  if (!has_name(q, "value")) {
    abort("Please add value for filtering and a tag", call = current_call())
  }
  nc <- nchar(q[["value"]])
  if (any(nc > 1024)) {
    abort("Value cannot be longer than 1024 characters", call = current_call())
  } else if (any(nc > 512)) {
    warn("Requires academic research access.")
  }

  if (length(nc) > 1000) {
    abort("Impossible to have more than 1000 rules", call = current_call())
  } else if (length(nc) > 5) {
    warn("Requires elevated or academic research access")
  }

  if (is.null(q[["tag"]]) || any(nchar(q[["tag"]]) == 0)) {
    abort("Add tags for the rules for better handling of the streaming output",
          call = current_call())
  }
  q
}

check_stream_add <- function(q) {
  if (any(lengths(q) == 1)) {
    out <- list(is_rule(q))
  } else {
    out <- lapply(q, is_rule)
  }
  out

}

check_stream_remove <- function(q) {
  if (is.numeric(q)) {
    q <- as.character(q)
  }

  if (!any(grepl("^[0-9]{19}$", q))) {
    abort("Streaming ids should be 19 numbers long", call = caller_call())
  }
  if (length(q) == 1) {
    list(delete = list(ids = list(q)))
  } else {
    list(delete = list(ids = q))
  }
}


split_stream <- function(file, path) {
  rL <- readLines(file)
  # For each tag write the line to that file
  # Omit last line as an incomplete record (easiest solution to parse it correctly)
  lines <- rL[-length(rL)]
  cat(paste0(lines, "\n"), file = file, fill = FALSE)
  # Fix stream
  lines <- lines[nzchar(lines)]
  tags <- character(length(lines))
  for (i  in seq_along(tags)) {
    tag <- substring(lines[i], regexpr("\",\"tag\":\"(.+)\"", lines[i]) + 9)
    tag <- substring(tag, first = 1, last = regexpr("\"", tag) - 1)
    tag <- gsub("\\s+", "_", tag)
    tags[i] <- tag
  }
  tweets <- split(lines, tags)
  for (tag in names(tweets)) {
    file <- normalizePath(file.path(path, paste0(tag, ".json")), mustWork = FALSE)
    cat(tweets[[tag]], file = file, append = TRUE, fill = TRUE)
  }
  TRUE
}

#
# gov_url <- "https://api.dummy.gov/destiny/v1/placeholder"
#
# req <- request(gov_url) %>%
#   req_body_json(data = list(
#     param1  = "10",
#     api_key = "abcdefg",
#     param2  = "xyz",
#     param3  = "09/10/2022")
#   )
#
# resp <- req_perform(req)
#
# # Slower
# a <- stream_in(con = file("~/Downloads/rtweet_data/streaming_valid.json"), pagesize = 1)
# # Faster
# b <- stream_in(con = file("~/Downloads/rtweet_data/streaming_valid.json"), pagesize = 344)
# # But they both miss some records (there are 344 lines but just 341 records)


#' @describeIn stream Retrieve a sample of the tweets posted.
#' @export
sample_stream <- function(timeout, file = tempfile(),
                          expansions = NULL, fields = NULL, ...,
                          token = NULL, parse = TRUE, append = TRUE) {

  expansions <- check_expansions(arg_def(expansions, set_expansions(list = NULL)))
  fields <- check_fields(arg_def(fields, set_fields()), metrics = NULL)
  expansions_for_fields(expansions, fields)
  parsing(parse, expansions, fields)
  req_stream <- endpoint_v2("tweets/sample/stream", 50 / (60*15), set_scopes())

  data <- c(list(expansions = expansions), fields, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  req_stream <- httr2::req_url_query(req_stream, !!!data)
  if (file.exists(file) && isFALSE(append)) {
    abort("File already exists and append = FALSE", call = caller_call())
  }
  out <- stream(req_stream, file, timeout = timeout)
  if (!parse) {
    return(out)
  }
  parse(out, expansions, fields)
}

test_that("Stream for 10 seconds", {
  skip_if_offline()
  testing_with_authentication("bearer_testing_app")
  new_rule <- stream_add_rule(list(value = "#rstats", tag = "rstats"))
  # Open filtered streaming connection for 20s
  tmp <- tempfile()
  expect_error({
    f <- filtered_stream(file = tmp, timeout = 10, parse = FALSE)
    f2 <- filtered_stream(file = tmp, timeout = 10, parse = FALSE)
  }, NA)
  # Remove rule
  stream_rm_rule(ids(new_rule))
  # Open random streaming connection
  expect_error(sample_stream(file = tempfile(), timeout = 10, parse = FALSE), NA)
})

test_that("Request all current rule ", {
  skip_if_offline()
  testing_with_authentication("bearer_testing_app")
  rt <- expect_error(stream_add_rule(NULL), NA)
  expect_gte(rt$result_count, 0)
})

test_that("Add a streaming rule ", {
  skip_if_offline()
  testing_with_authentication("bearer_testing_app")
  stream_rm_rule(ids(stream_add_rule(NULL)))
  expect_error(rt0 <- stream_add_rule(list(value = "testing rules", tag = "ts")), NA)
  expect_equal(rt0$created, 1)
  expect_equal(rt0$valid, 1)

  # Clean up
  stream_rm_rule(attr(rt0, "rules")$id)
})

test_that("Handle adding duplicate streaming rules ", {
  skip_if_offline()
  testing_with_authentication("bearer_testing_app")
  stream_rm_rule(ids(stream_add_rule(NULL)))
  rt0 <- stream_add_rule(list(value = "testing rules", tag = "ts"))
  expect_error(stream_add_rule(list(value = "testing rules", tag = "ts2")),
               "DuplicateRule")

  # Clean up
  expect_equal(stream_rm_rule(ids(rt0))$deleted, 1)
})


test_that("Handle multiple streaming rules ", {
  skip_if_offline()
  testing_with_authentication("bearer_testing_app")
  stream_rm_rule(ids(stream_add_rule(NULL)))
  tags2 <- stream_add_rule(list(
    list(value = "testing rules rtweet1", tag = "tsrt"),
    list(value = "testing rules rtweet2", tag = "tsrt2"))
  )
  expect_equal(tags2$created, 2)
  # Clean up
  expect_equal(stream_rm_rule(ids(tags2))$deleted, 2)
})

#' Get all lists a specified user subscribes to, including their own.
#'
#' @inheritParams get_timeline
#' @param reverse optional Set this to true if you would like owned lists
#'   to be returned first. See description above for information on
#'   how this parameter works.
#' @return data
#' @family lists
#' @export
lists_users <- function(user = NULL, reverse = FALSE, token = NULL, parse = TRUE) {
  params <- list(
    reverse = reverse
  )
  params[[user_type(user)]] <- user

  r <- TWIT_get(token, "/1.1/lists/list", params)
  if (parse) {
    r <- as_lists_users(r)
    r <- as.data.frame(r)
  }
  r
}

#' Clean up character vector (tweets) to more of a plain text.
#' 
#' Removes links, linebreaks, fancy spaces and apostrophes and convert everything to ASCII text.
#' Deprecated to be defunct for next release as there are better text processing tools.
#' @param x The desired character vector or data frame/list with named column/element
#'   "text" to be cleaned and processed.
#' @return Data reformatted with ascii encoding and normal ampersands and
#'   without URL links, line breaks, fancy spaces/tabs, fancy apostrophes,
#' @export
plain_tweets <- function(x) {
  lifecycle::deprecate_warn("1.0.0", "plain_tweets()")
  if (is.data.frame(x)) {
    if (has_name_(x, "text")) {
      x$text <- plain_tweets_(x$text)
    } else {
      stop("Couldn't find \"text\" variable.", call. = FALSE)
    }
  } else if (is.list(x)) {
    if (has_name_(x, "text")) {
      x$text <- plain_tweets_(x$text)
    } else {
      stop("Couldn't find \"text\" variable.", call. = FALSE)
    }
  } else {
    x <- plain_tweets_(x)
  }
  x
}

plain_tweets_ <- function(x) {
  if (is.factor(x)) {
    x <- as.character(x)
  }
  stopifnot(is.character(x))
  x <- rm_links(x)
  x <- rm_linebreaks(x)
  x <- rm_fancy_spaces(x)
  x <- rm_fancy_apostrophes(x)
  x <- rm_amp(x)
  x <- enc2ascii(x)
  trim_ws(x)
}


##----------------------------------------------------------------------------##
##                  remove/replace tricky chars and URL links                 ##
##----------------------------------------------------------------------------##

rm_fancy_apostrophes <- function(x) gsub(intToUtf8(8217), "'", x)

rm_fancy_spaces <- function(x) {
  gsub("\\t", " ", gsub(intToUtf8(65039), " ", x))
}

rm_links <- function(x) {
  x <- gsub("\\s?https?[[:graph:]]", "", x)
  gsub("\\s?\\b[[:graph:]]+(\\.com|\\.net|\\.gov|\\.io|\\.org)\\b", "", x)
}

rm_linebreaks <- function(x, y = " ") {
  gsub("\\n", y, x)
}

enc2ascii <- function(x, y = "") {
  iconv(x, to = "ascii", sub = y)
}

rm_amp <- function(x, y = "&") {
  if (is.null(y)) {
    y <- ""
  }
  gsub("&amp;", y, x)
}

trim_ws <- function(x) {
  x <- gsub("[ ]{2,}", " ", x)
  gsub("^[ ]+|[ ]+$", "", x)
}

#' Get direct messages sent to and received by the authenticating user from the
#' past 30 days
#'
#' Returns all Direct Message events (both sent and received) within the last 30
#' days. Sorted in reverse-chronological order. Includes detailed information
#' about the sender and recipient. `r lifecycle::badge("deprecated")`
#'
#' @inheritParams TWIT_paginate_cursor
#' @inheritParams stream
#' @param next_cursor `r lifecycle::badge("deprecated")` Use `cursor` instead.
#' @return A list with one element for each page of results.
#' @examples
#' \dontrun{
#'
#' ## get my direct messages
#' direct_messages()
#'
#' }
#' @export
#' @seealso [`rtweet-deprecated`]
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/direct-messages/sending-and-receiving/api-reference/list-events>
direct_messages <- function(n = 50,
                            cursor = NULL,
                            next_cursor = NULL,
                            parse = TRUE,
                            token = NULL,
                            retryonratelimit = NULL,
                            verbose = TRUE) {

  if (!is.null(next_cursor)) {
    lifecycle::deprecate_warn("1.0.0",
      "direct_messages(next_cursor)",
      "direct_messages(cursor)"
    )
    cursor <- next_cursor
  }

  TWIT_paginate_cursor(token, "/1.1/direct_messages/events/list", list(),
    n = n,
    cursor = cursor,
    retryonratelimit = retryonratelimit,
    verbose = verbose,
    page_size = if (n >= 50) 50 else n,
    get_id = function(x) x$events$id
  )
}

#' (DEPRECATED) Get the most recent direct messages sent to the authenticating user.
#'
#' Retrieves up to 200 of the most recently received direct messages
#' by the authenticating (home) user. This function requires access
#' token with read, write, and direct messages access.
#'
#' @return Return object converted to nested list. If status code of
#'   response object is not 200, the response object is returned
#'   directly.
#' @examples
#'
#' \dontrun{
#'
#' ## get my direct messages
#' dms <- direct_messages_received()
#' ## get direct messages I've sent
#' sdms <- direct_messages_sent()
#' }
#'
#' @details Includes detailed information about the sender and
#'   recipient user. You can request up to 200 direct messages per
#'   call, and only the most recent 200 direct messages will be available using
#'   this endpoint.
#' @export
#' @keywords internal
direct_messages_received <- function(since_id = NULL,
                                     max_id = NULL,
                                     n = 200,
                                     parse = TRUE,
                                     token = NULL) {
  abort("The endpoint for `direct_messages_received()` no longer exists. ",
    "Please use `direct_messages()` instead.", call = current_call())
}

#' @export
#' @rdname direct_messages_received
direct_messages_sent <- function(since_id = NULL,
                                 max_id = NULL,
                                 n = 200,
                                 parse = TRUE,
                                 token = NULL) {
  abort("The endpoint for `direct_messages_received()` no longer exists. ",
    "Please use `direct_messages()` instead.", call = current_call())
}

test_that("direct_messages works", {

  vcr::use_cassette("direct_messages", {
    dm <- direct_messages(n = 1)[[1]]
  })
  expect_type(dm, "list")
  # Twitter is returning next_cursor and the app information in this endpoint
  expect_named(dm, c("events", "apps", "next_cursor"))

  # Usually a data.frame but if no message it can be an empty list
  expect_true(is.list(dm$events))
})

test_that("old functions give informative errors", {
  expect_error(direct_messages_received(), "no longer exists")
  expect_error(direct_messages_sent(), "no longer exists")
})

#' rtweet: Collect Twitter data from R
#'
#' @description 
#' rtweet provides users a range of functions designed to extract data
#' from Twitter's REST and streaming APIs. It has three main goals:
#'
#' * Formulate and send requests to Twitter's REST and stream APIs.
#' * Retrieve and iterate over returned data.
#' * Wrangling data into tidy structures.
#' 
#' Get started by reading `vignette("rtweet")`.
#' 
#' @keywords internal
"_PACKAGE"

#' @import rlang
NULL

# The internal environment where state of the app is stored.
.state <- new.env(parent = emptyenv())

tweet <- function(x) {
  empty <- data.frame(created_at = NA_character_, id = NA_integer_,
                      id_str = NA_character_,
                      text = NA_character_,
                      full_text = NA_character_,
                      truncated = NA,
                      entities = I(list(list())),
                      source = NA_character_,
                      in_reply_to_status_id = NA_integer_,
                      in_reply_to_status_id_str = NA_character_,
                      in_reply_to_user_id = NA_integer_,
                      in_reply_to_user_id_str = NA_character_,
                      in_reply_to_screen_name = NA_character_,
                      geo = I(list(list())),
                      coordinates = NA, place = NA,
                      contributors = NA, is_quote_status = NA,
                      retweet_count = 0, favorite_count = 0,
                      favorited = NA, favorited_by = NA,
                      retweeted = NA,
                      scopes = I(list(list())),
                      lang = NA_character_,
                      possibly_sensitive = NA,
                      display_text_width = NA,
                      display_text_range = NA,
                      retweeted_status = NA,
                      quoted_status = NA,
                      quoted_status_id = NA,
                      quoted_status_id_str = NA,
                      quoted_status_permalink = NA,
                      quote_count = NA,
                      timestamp_ms = NA,
                      reply_count = NA,
                      filter_level = NA,
                      metadata = NA,
                      query = NA,
                      user = I(list(list())),
                      withheld_scope = NA_character_,
                      withheld_copyright = NA,
                      withheld_in_countries = NA_character_,
                      possibly_sensitive_appealable = NA)
  if (NROW(x) == 0) {
    return(empty)
  }
  tb <- x
  #  Some fields seem to depend on what is needed
  # possibly_sensitive, full_text, extended_entities
  if (has_name_(x, "possibly_sensitive")) {
    tb$possibly_sensitive <- x$possibly_sensitive
  } else {
    tb$possibly_sensitive <- list(NA)
  }

  # Recursive and in a loop not good..
  if (has_name_(x, "quoted_status")) {
    tb$quoted_status <- tweet(x$quoted_status)
  } else {
    tb$quoted_status <- list(NA)
  }

  if (has_name_(x, "display_text_range")) {
    # Handle missing display_text_range
    tb$display_text_range <- display_text_range(x$display_text_range)
  }

  if (has_name_(x, "quoted_status_permalink")){
    tb$quoted_status_permalink <- split_df(x$quoted_status_permalink)
  }
  if (has_name_(x, "retweeted_status")){
    tb$retweeted_status <- split_df(x$retweeted_status)
  }
  if (has_name_(x, "quoted_status")){
    tb$quoted_status <- split_df(x$quoted_status)
  }
  if (has_name_(x, "metadata")){
    tb$metadata <- split_df(x$metadata)
  }
  if (has_name_(x, "scopes")){
    tb$scopes <- split_df(x$scopes)
  }
  if (has_name_(x, "geo")){
    tb$geo <- split_df(x$geo)
  }

  # If extended_tweet is present it also have the full_text field and extended_entities
  # Add the columns and use the columns if available
  # columns: "full_text", "display_text_range", "entities", "extended_entities"
  if (has_name_(x, "extended_tweet")) {
    x <- cbind(x, x[, "extended_tweet"])
    x[, "extended_tweet"] <- NULL
    tb$extended_tweet <- NULL
  }

  if (has_name_(x, "text")) {
    tb$text <- x$text
    tb$display_text_width <- nchar(x$text)
  } else if (has_name_(x, "full_text")) {
    tb$text <- x$full_text
  }

  user <- user(x[["user"]])
  tb$user <- split_df(user)

  if (has_name_(x, "entities") && has_name_(x, "extended_entities")) {
    ent <- parse_entities2(x$entities)
    ext_ent <- parse_entities2(x$extended_entities)
    tb$extended_entities <- NULL
    for (i in NROW(x$entities)) {
      ent[[i]][names(x$extended_entities)] <- ext_ent[[i]][names(x$extended_entities)]
    }

  } else if (has_name_(x, "entities")) {
    ent <- parse_entities2(x$entities)
  } else if (has_name_(x, "extended_entities")) {
    ent <- parse_entities2(x$extended_entities)
  }  else {
    ent <- vector("list", NROW(x$entities))
  }
  tb$entities <- ent

  tb$coordinates <- split_df(coordinates(x$coordinates))
  if (is.data.frame(x$place)) {
    l <- split_df(x$place)
    tb$place <- lapply(l, place)
  } else {
    tb$place <- lapply(x$place, place)
  }


  end <- setdiff(names(tb), colnames(empty))
  # Omit extended tweet info from stream API v1 and premium API: should be handled now
  # Omit matching_rules just from premium API v1 (not sure how it works)
  # Omit edit fields as they will be handled in API v2
  edits <- c("edit_history", "edit_controls", "editable")
  end <- setdiff(end, c(edits, "matching_rules"))
  if (is.data.frame(x) && length(end) != 0) {
    warning("Unidentified value: ", paste(end, collapse = ", "),
         ".\n\tPlease open an issue to notify the maintainer. Thanks!", call. = FALSE)
  }
  tb[setdiff(names(empty), names(tb))] <- NA
  # Skip this new fields I will
  tb[, edits] <- NULL
  rownames(tb) <- NULL
  if (!is.data.frame(tb)) {
    k <- lengths(tb) == 0
    tb[names(k)[k]] <- empty[names(k)[k]]
    tb <- list2DF(tb[names(empty)])
  }
  tb
}

parse_entities2 <- function(y) {
  if (!is.data.frame(y) && is.list(y)) {
    l <- vector("list", length(y))
  } else {
    l <- vector("list", NROW(y))
  }
  for (col in seq_along(y)) {
    # Look for the function of said object and save it.
    if (names(y)[col] != "user_mentions")  {
      fun <- match.fun(names(y)[col])
    } else {
      fun <- match.fun("user_mention")
    }
    l[[col]] <- lapply(y[[col]], fun)
  }
  # Split and join
  ll <- transpose_list(l)
  lapply(ll, `names<-`, value = colnames(y))
}

# From https://stackoverflow.com/a/54970694/2886003
# Assumes equal length for each list on the list
transpose_list <- function(l) {
  l2 <- split(do.call(cbind, l), seq_len(length(l[[1]])))
  names(l2) <- NULL
  l2
}


split_df <- function(x) {
  if (is.null(nrow(x))) {
    return(list(list()))
  }
  l <- split(x, seq_len(NROW(x)))
  names(l) <- NULL
  l
}

display_text_range <- function(x) {
  ldtr <- lengths(x)
  dtr <- rep(NA, length.out = length(x))
  dtr[ldtr != 0] <- vapply(x[ldtr != 0], `[`, numeric(1), i = 2)
  dtr
}

test_that("lat_lng works", {
  expect_error(search_tweets("lang:en", geocode = lookup_coords("usa"), n = 100))
})

test_that("lat_lng works on empty tweet", {
  expect_error(lat_lng(tweet(NULL)), NA)

})

# Contains functions to parse the objects described here:
# https://developer.twitter.com/en/docs/twitter-api/v1/data-dictionary/object-model/entities

# <https://developer.twitter.com/en/docs/twitter-api/v1/data-dictionary/object-model/entities#hashtags>
hashtags <- function(x) {
  if (NROW(x) == 0) {
    data.frame(text = NA, indices = I(list(NA)),
                      stringsAsFactors = FALSE)
  } else {
    i <- indices_vec(x$indices)
    data.frame(text = x$text, indices = I(i))
  }
}

# PowerTrack $ text
# has:symbol
# They are the same
# <https://developer.twitter.com/en/docs/twitter-api/v1/data-dictionary/object-model/entities#symbols>
# parse_entities2 uses the name of the columns to match the appropriate function to parse it.
# It needs a symbols function that is the same as hashtags
symbols <- hashtags

indices_vec <- function(x) {
  lapply(x, function(y){
    matrix(y, ncol = 2, dimnames = list(NULL, c("start", "end")))})
}

# The extended entities is really for media
# <https://developer.twitter.com/en/docs/twitter-api/v1/data-dictionary/object-model/extended-entities>
media <- function(x) {
  if (NROW(x) == 0) {
    df <- data.frame(id = NA, id_str = NA, indices = I(list(NA)),
                     media_url = NA, media_url_https = NA,
                     url = NA, display_url = NA, expanded_url = NA,
                     type = NA, sizes = I(list(NA)), ext_alt_text = NA,
                     stringsAsFactors = FALSE)
    return(df)
  }
  indices <- as.data.frame(t(simplify2array(x$indices)))
  colnames(indices) <- c("start", "end")
  x$indices <- I(list(indices))
  sizes <- rbind(x$sizes$large, x$sizes$small, x$sizes$thumb, x$sizes$medium)
  sizes$type <- c("large", "small", "thumb", "medium")
  x$sizes <- list(sizes)
  df_colnames <- c("id", "id_str", "indices", "media_url", "media_url_https",
                   "url", "display_url", "expanded_url", "type", "sizes",
                   "ext_alt_text")
  x[setdiff(df_colnames, colnames(x))] <- rep(NA, nrow(x))
  x
}

urls <- function(x) {
  if (NROW(x) == 0) {
    df <- data.frame(url = NA, expanded_url = NA, display_url = NA,
                     indices = I(list(NA)), unwound = I(list(NA)),
                     stringsAsFactors = FALSE)
    return(df)
  }
  indices <- as.data.frame(t(simplify2array(x$indices)))
  colnames(indices) <- c("start", "end")
  x$indices <- I(indices)
  x[setdiff(c("url", "expanded_url", "display_url", "indices", "unwound"),
            colnames(x))] <- rep(NA, nrow(x))
  x
}

# PowerTrack @ screen_name
# has:mentions
# <https://developer.twitter.com/en/docs/twitter-api/v1/data-dictionary/object-model/entities#mentions>
user_mention <- function(x) {
  if (NROW(x) == 0) {
    df <- data.frame(screen_name = NA, name = NA, id = NA, id_str = NA,
                     indices = I(list(NA)), stringsAsFactors = FALSE)
    return(df)
  }
  indices <- as.data.frame(t(simplify2array(x$indices)))
  colnames(indices) <- c("start", "end")
  x$indices <- indices
  df_colnames <- c("screen_name", "name", "id", "id_str", "indices")
  x[setdiff(df_colnames, colnames(x))] <- rep(NA, nrow(x))
  rownames(x) <- NULL
  x
}

# <https://developer.twitter.com/en/docs/twitter-api/v1/data-dictionary/object-model/entities#polls>
# Not testable without fullarchive access
polls <- function(x) {
  df <- data.frame(options= I(list(NA)), end_datetime = NA,
                   duration_minutes = NA, stringsAsFactors = FALSE)
  if (NROW(x) == 0) {
    return(df)
  }
  x[setdiff(colnames(df), colnames(x))] <- rep(NA, nrow(x))
  x
}


parse_entities <- function(x) {

  if (is.null(x)) {
    return(list(description = urls(NULL), url = urls(NULL)))
  }

  if (is.null(x$description$urls) || length(x$description$urls) == 0) {
    description <- list(description = urls(NULL))
  } else {
    description <- lapply(x$description$urls, urls)

  }

  if (is.null(x$url$urls)) {
    url <- list(url = urls(NULL))
  } else {
    url <- lapply(x$url$urls, urls)
  }
  l <- Map(list, description, url)
  lapply(l, `names<-`, value = c("description", "url"))
}

test_that("hashtags works", {
  hashtags <- jsonlite::fromJSON('{
  "hashtags": [
    {
      "indices": [
        32,
        38
      ],
      "text": "nodejs"
    }
  ]
}')
  out <- hashtags(hashtags$hashtags)
  expect_s3_class(out, "data.frame")
  expect_named(out, c("text", "indices"))
  expect_length(out$indices[[1]], 2)
})




test_that("media works", {
  extended_media <- jsonlite::fromJSON('{
"extended_entities": {
    "media": [
      {
        "id": 861627472244162561,
        "id_str": "861627472244162561",
        "indices": [
          68,
          91
        ],
        "media_url": "http://pbs.twimg.com/media/C_UdnvPUwAE3Dnn.jpg",
        "media_url_https": "https://pbs.twimg.com/media/C_UdnvPUwAE3Dnn.jpg",
        "url": "https://t.co/9r69akA484",
        "display_url": "pic.twitter.com/9r69akA484",
        "expanded_url": "https://twitter.com/FloodSocial/status/861627479294746624/photo/1",
        "type": "photo",
        "sizes": {
          "medium": {
            "w": 1200,
            "h": 900,
            "resize": "fit"
          },
          "small": {
            "w": 680,
            "h": 510,
            "resize": "fit"
          },
          "thumb": {
            "w": 150,
            "h": 150,
            "resize": "crop"
          },
          "large": {
            "w": 2048,
            "h": 1536,
            "resize": "fit"
          }
        }
      },
      {
        "id": 861627472244203520,
        "id_str": "861627472244203520",
        "indices": [
          68,
          91
        ],
        "media_url": "http://pbs.twimg.com/media/C_UdnvPVYAAZbEs.jpg",
        "media_url_https": "https://pbs.twimg.com/media/C_UdnvPVYAAZbEs.jpg",
        "url": "https://t.co/9r69akA484",
        "display_url": "pic.twitter.com/9r69akA484",
        "expanded_url": "https://twitter.com/FloodSocial/status/861627479294746624/photo/1",
        "type": "photo",
        "sizes": {
          "small": {
            "w": 680,
            "h": 680,
            "resize": "fit"
          },
          "thumb": {
            "w": 150,
            "h": 150,
            "resize": "crop"
          },
          "medium": {
            "w": 1200,
            "h": 1200,
            "resize": "fit"
          },
          "large": {
            "w": 2048,
            "h": 2048,
            "resize": "fit"
          }
        }
      },
      {
        "id": 861627474144149504,
        "id_str": "861627474144149504",
        "indices": [
          68,
          91
        ],
        "media_url": "http://pbs.twimg.com/media/C_Udn2UUQAADZIS.jpg",
        "media_url_https": "https://pbs.twimg.com/media/C_Udn2UUQAADZIS.jpg",
        "url": "https://t.co/9r69akA484",
        "display_url": "pic.twitter.com/9r69akA484",
        "expanded_url": "https://twitter.com/FloodSocial/status/861627479294746624/photo/1",
        "type": "photo",
        "sizes": {
          "medium": {
            "w": 1200,
            "h": 900,
            "resize": "fit"
          },
          "small": {
            "w": 680,
            "h": 510,
            "resize": "fit"
          },
          "thumb": {
            "w": 150,
            "h": 150,
            "resize": "crop"
          },
          "large": {
            "w": 2048,
            "h": 1536,
            "resize": "fit"
          }
        }
      },
      {
        "id": 861627474760708096,
        "id_str": "861627474760708096",
        "indices": [
          68,
          91
        ],
        "media_url": "http://pbs.twimg.com/media/C_Udn4nUMAAgcIa.jpg",
        "media_url_https": "https://pbs.twimg.com/media/C_Udn4nUMAAgcIa.jpg",
        "url": "https://t.co/9r69akA484",
        "display_url": "pic.twitter.com/9r69akA484",
        "expanded_url": "https://twitter.com/FloodSocial/status/861627479294746624/photo/1",
        "type": "photo",
        "sizes": {
          "small": {
            "w": 680,
            "h": 680,
            "resize": "fit"
          },
          "thumb": {
            "w": 150,
            "h": 150,
            "resize": "crop"
          },
          "medium": {
            "w": 1200,
            "h": 1200,
            "resize": "fit"
          },
          "large": {
            "w": 2048,
            "h": 2048,
            "resize": "fit"
          }
        }
      }
    ]
  }
}')
  out <- media(extended_media$extended_entities$media)
  expect_s3_class(out, "data.frame")
  expect_named(out, c("id", "id_str", "indices", "media_url", "media_url_https", 
                      "url", "display_url", "expanded_url", "type", "sizes", 
                      "ext_alt_text"))
})

  


test_that("polls works", {
  polls_media <- jsonlite::fromJSON('{"polls": [
      {
        "options": [
          {
            "position": 1,
            "text": "I read documentation once."
          },
          {
            "position": 2,
            "text": "I read documentation twice."
          },
          {
            "position": 3,
            "text": "I read documentation over and over again."
          }
        ],
        "end_datetime": "Thu May 25 22:20:27 +0000 2017",
        "duration_minutes": 60
      }
    ]
  }')
  out <- polls(polls_media$polls)
  expect_s3_class(out, "data.frame")
  expect_named(out, c("options", "end_datetime", "duration_minutes"))
})

TWIT_get <- function(token, api, params = NULL, ..., host = "api.twitter.com") {
  resp <- TWIT_method("GET",
                      token = token,
                      api = api,
                      params = params,
                      ...,
                      host = host
  )

  from_js(resp)
}

TWIT_post <- function(token, api, params = NULL, body = NULL, ..., host = "api.twitter.com") {
  TWIT_method("POST",
              token = token,
              api = api,
              params = params,
              body = body,
              ...,
              host = host
  )
}

TWIT_method <- function(method, token, api,
                        params = NULL,
                        host = "api.twitter.com",
                        retryonratelimit = NULL,
                        verbose = TRUE,
                        ...) {
  lifecycle::deprecate_warn("2.0.0", function_caller(),
                            details = c("This function might work until your bot/app/user is blocked or fail randomly!",
                                        "!" = "The API has been deprecated and the new API v2.2 requires subscriptions for most endpoints.",
                                        i = "See updates of function and API: help('rtweet-deprecated', 'rtweet' )"
                                        ),
                            always = TRUE)
  # need scipen to ensure large IDs are not displayed in scientific notation
  # need ut8-encoding for the comma separated IDs
  withr::local_options(scipen = 14, encoding = "UTF-8")

  token <- check_token(token)
  url <- paste0("https://", host, api, ".json")

  resp <- switch(method,
                 GET = httr::GET(url, query = params, token, ...),
                 POST = httr::POST(url, query = params, token, ...),
                 stop("Unsupported method", call. = FALSE)
  )

  switch(resp_type(resp),
         ok = NULL,
         rate_limit = handle_rate_limit(
           resp, api,
           retryonratelimit = retryonratelimit,
           verbose = verbose
         ),
         error = handle_error(resp, params)
  )

  resp
}

#' Pagination
#'
#' @description
#' `r lifecycle::badge("experimental")`
#' These are internal functions used for pagination inside of rtweet.
#'
#' @keywords internal
#' @param token Use this to override authentication for
#'   a single API call. In many cases you are better off changing the
#'   default for all calls. See [auth_as()] for details.
#' @param n Desired number of results to return. Results are downloaded
#'   in pages when `n` is large; the default value will download a single
#'   page. Set `n = Inf` to download as many results as possible.
#'
#'   The Twitter API rate limits the number of requests you can perform
#'   in each 15 minute period. The easiest way to download more than that is
#'   to use `retryonratelimit = TRUE`.
#'
#'   You are not guaranteed to get exactly `n` results back. You will get
#'   fewer results when tweets have been deleted or if you hit a rate limit.
#'   You will get more results if you ask for a number of tweets that's not
#'   a multiple of page size, e.g. if you request `n = 150` and the page
#'   size is 200, you'll get 200 results back.
#' @param get_id A single argument function that returns a vector of ids given
#'   the JSON response. The defaults are chosen to cover the most common cases,
#'   but you'll need to double check whenever implementing pagination for
#'   a new endpoint.
#' @param max_id Supply a vector of ids or a data frame of previous results to
#'   find tweets **older** than `max_id`.
#' @param since_id Supply a vector of ids or a data frame of previous results to
#'   find tweets **newer** than `since_id`.
#' @param retryonratelimit If `TRUE`, and a rate limit is exhausted, will wait
#'   until it refreshes. Most Twitter rate limits refresh every 15 minutes.
#'   If `FALSE`, and the rate limit is exceeded, the function will terminate
#'   early with a warning; you'll still get back all results received up to
#'   that point. The default value, `NULL`, consults the option
#'   `rtweet.retryonratelimit` so that you can globally set it to `TRUE`,
#'   if desired.
#'
#'   If you expect a query to take hours or days to perform, you should not
#'   rely solely on `retryonratelimit` because it does not handle other common
#'   failure modes like temporarily losing your internet connection.
#' @param verbose Show progress bars and other messages indicating current
#'   progress?
#' @returns A list with the json output of the API.
TWIT_paginate_max_id <- function(token, api, params,
                                 get_id = function(x) x$id_str,
                                 n = 1000,
                                 page_size = 200,
                                 since_id = NULL,
                                 max_id = NULL,
                                 count_param = "count",
                                 retryonratelimit = NULL,
                                 verbose = TRUE) {
  if (!is.null(max_id)) {
    max_id <- rtweet::max_id(max_id)
  }
  if (!is.null(since_id)) {
    since_id <- rtweet::since_id(since_id)
  }

  params$since_id <- since_id
  params[[count_param]] <- page_size
  pages <- if (is.infinite(n)) page_size else max(c(n %/% page_size), 1)
  results <- vector("list", pages)

  if (verbose)  {
    pb <- progress::progress_bar$new(
      format = "Downloading multiple pages :bar",
      total = pages
    )
    withr::defer(pb$terminate())
  }

  i <- 0
  while (i < pages) {
    i <- i + 1
    params$max_id <- max_id
    if (i == pages) {
      params[[count_param]] <- n - (pages - 1) * page_size
    }

    json <- catch_rate_limit(
      TWIT_get(
        token, api, params,
        retryonratelimit = retryonratelimit,
        verbose = verbose
      )
    )
    if (is_rate_limit(json)) {
      warn_early_term(json,
                      hint = paste0("Set `max_id = '", max_id, "' to continue."),
                      hint_if = !is.null(max_id)
      )
      break
    }

    id <- get_id(json)
    # no more tweets to return
    if (length(id) == 0) {
      break
    }
    if(i > length(results)) {
      # double length per https://en.wikipedia.org/wiki/Dynamic_array#Geometric_expansion_and_amortized_cost
      length(results) <- 2 * length(results)
    }

    max_id <- max_id(id)
    results[[i]] <- json

    if (verbose) {
      pb$tick()
    }
  }
  results
}

# https://developer.twitter.com/en/docs/pagination
#' @rdname TWIT_paginate_max_id
#'
#' @param cursor Which page of results to return. The default will return
#'   the first page; you can supply the result from a previous call to
#'   continue pagination from where it left off.
TWIT_paginate_cursor <- function(token, api, params,
                                 n = 5000,
                                 page_size = 5000,
                                 cursor = "-1",
                                 get_id = function(x) x$ids,
                                 retryonratelimit = NULL,
                                 verbose = TRUE) {
  params$count <- page_size
  cursor <- next_cursor(cursor)
  if (identical(cursor, "0")) {
    # Last request retrieved all available results
    return(list())
  }

  # TODO: consider if its worth using fastmap::faststack() here
  pages <- if (is.infinite(n)) page_size else max(c(n %/% page_size), 1)
  results <- vector("list", pages)
  i <- 1
  n_seen <- 0

  if (verbose) {
    pb <- progress::progress_bar$new(
      format = "Downloading multiple pages :bar",
      total = length(results)
    )
    withr::defer(pb$terminate())
  }

  repeat({
    params$cursor <- cursor
    json <- catch_rate_limit(
      TWIT_get(
        token, api, params,
        retryonratelimit = retryonratelimit,
        verbose = verbose
      )
    )

    # Rate limit hit, repeat call to continue
    error_limit <- "errors" %in% names(json)
    continue_limit <- !is.null(retryonratelimit) && retryonratelimit
    if (error_limit && continue_limit) {
      json <- catch_rate_limit(
        TWIT_get(
          token, api, params,
          retryonratelimit = retryonratelimit,
          verbose = verbose
        ))
    }

    if (is_rate_limit(json)) {
      if (!is.null(retryonratelimit)){
        warn_early_term(json,
                        hint = paste0("Set `cursor = '", cursor, "' to continue."),
                        hint_if = !identical(cursor, "-1")
        )
      }
      next
    }
    if (i > length(results)) {
      # double length per https://en.wikipedia.org/wiki/Dynamic_array#Geometric_expansion_and_amortized_cost
      length(results) <- 2 * length(results)
    }
    if (any(grepl("next_cursor", names(json)))) {
      cursor <- ifelse(!is.null(json$next_cursor_str),
                       json$next_cursor_str,
                       json$next_cursor)
    } else {
      # If next_cursor is missing there are no message within the last 30 days
      cursor <- "0"
    }
    results[[i]] <- json
    n_seen <- n_seen + length(get_id(json))
    i <- i + 1
    empty_response <- !is.null(json$events) && length(json$events) == 0
    if (identical(cursor, "0") || n_seen >= n || empty_response) {
      break
    }

    if (verbose) {
      pb$update(n_seen / n)
    }
  })

  structure(results, rtweet_cursor = cursor)
}

#' @rdname TWIT_paginate_max_id
#' @keywords internal
TWIT_paginate_chunked <- function(token, api, params_list,
                                  retryonratelimit = NULL,
                                  verbose = TRUE) {


  pages <- length(params_list)
  results <- vector("list", pages)

  if (verbose)  {
    pb <- progress::progress_bar$new(
      format = "Downloading multiple pages :bar",
      total = pages
    )
    withr::defer(pb$terminate())
  }

  for (i in seq_along(params_list)) {
    params <- params_list[[i]]
    json <- catch_rate_limit(
      TWIT_get(
        token, api, params,
        retryonratelimit = retryonratelimit,
        verbose = verbose
      )
    )
    # Rate limit hit, repeat call to continue
    error_limit <- "errors" %in% names(json)
    continue_limit <- !is.null(retryonratelimit) && retryonratelimit
    if (error_limit && continue_limit) {
      json <- catch_rate_limit(
        TWIT_get(
          token, api, params,
          retryonratelimit = retryonratelimit,
          verbose = verbose
        ))
    }
    if (is_rate_limit(json)) {
      warn_early_term(json, hint_if = FALSE)
      break
    }

    results[[i]] <- json

    if (verbose) {
      pb$tick()
    }
  }

  results
}

#' @rdname TWIT_paginate_max_id
TWIT_paginate_premium <- function(token, api, params,
                                  n = 100,
                                  page_size = 100,
                                  cursor = "next",
                                  retryonratelimit = NULL,
                                  verbose = TRUE) {
  if (identical(cursor, "next")) {
    # Last request retrieved all available results
    cursor <- NULL
  } else {
    cursor <- next_cursor(cursor)
  }
  params[["next"]] <- cursor

  # TODO: consider if its worth using fastmap::faststack() here
  pages <- if (is.infinite(n)) page_size else max(c(n %/% page_size), 1)
  results <- vector("list", pages)
  i <- 1
  n_seen <- 0

  if (length(results) > 1) {
    params[["maxResults"]] <- page_size
  }

  if (verbose) {
    pb <- progress::progress_bar$new(
      format = "Downloading multiple pages :bar",
      total = length(results))
    withr::defer(pb$terminate())
  }
  # Time to sleep avoid hitting the lowest rate limits
  min_sleep <- 0.9
  if (page_size == 500) {
    min_sleep <- min_sleep * 2
  }
  repeat({

    Sys.sleep(min_sleep)
    params[["next"]] <- cursor
    json <- catch_rate_limit(
      TWIT_get(
        token, api, params,
        retryonratelimit = retryonratelimit,
        verbose = verbose
      )
    )

    if (is_rate_limit(json)) {
      if (!is.null(retryonratelimit)){
        warn_early_term(json,
                        hint = paste0("Set `continue = '", cursor, "' to continue."),
                        hint_if = !identical(cursor, "next")
        )
      }
      break
    }

    # Rate limit hit, repeat call to continue
    error_limit <- "errors" %in% names(json)
    continue_limit <- !is.null(retryonratelimit) && retryonratelimit
    if (error_limit && continue_limit) {
      json <- catch_rate_limit(
        TWIT_get(
          token, api, params,
          retryonratelimit = retryonratelimit,
          verbose = verbose
        ))
    }

    if (i > length(results)) {
      # double length per https://en.wikipedia.org/wiki/Dynamic_array#Geometric_expansion_and_amortized_cost
      length(results) <- 2 * length(results)
    }
    results[[i]] <- json$results
    if (any(grepl("next", names(json)))) {
      cursor <- if (!is.null(json[["next"]])) json[["next"]]
    }
    n_seen <- n_seen + nrow(json$results)
    i <- i + 1
    empty_response <- !is.null(json$results) && length(json$results) == 0
    if ( length(n_seen) == 0 || n_seen >= n || empty_response) {
      break
    }

    if (verbose) {
      pb$update(n_seen / n)
    }
  })

  structure(results, "next" = cursor)
}


# helpers -----------------------------------------------------------------

from_js <- function(resp) {
  if (is.null(resp$headers[["content-type"]]) || !grepl("application/json", resp$headers[["content-type"]])) {
    stop("API did not return json", call. = FALSE)
  }
  resp <- httr::content(resp, as = "text", encoding = "UTF-8")
  jsonlite::fromJSON(resp)
}

resp_type <- function(resp) {
  status <- httr::status_code(resp)
  if (status == 429) {
    "rate_limit"
  } else if (status >= 400) {
    "error"
  } else {
    "ok"
  }
}

# Three possible exits:
# * skip, if testing
# * return, if retryonratelimit is TRUE
# * error, otherwise
handle_rate_limit <- function(x, api, retryonratelimit = NULL, verbose = TRUE) {
  if (is_testing()) {
    testthat::skip("Rate limit exceeded")
  }

  headers <- httr::headers(x)
  n <- headers$`x-rate-limit-limit`
  when <- .POSIXct(as.numeric(headers$`x-rate-limit-reset`))

  retryonratelimit <- retryonratelimit %||% getOption("rtweet.retryonratelimit", FALSE)

  if (retryonratelimit) {
    wait_until(when, api, verbose = verbose)
  } else {
    message <- c(
      paste0("Rate limit exceeded for Twitter endpoint '", api, "'"),
      paste0("Will receive ", n, " more requests at ", format(when, "%H:%M"))
    )
    abort(message, class = "rtweet_rate_limit", when = when)
  }
}

# Function for responses that might be errors
# Depending on the internal error code it is provided to the users as a warning or error
handle_codes <- function(x) {
  if ("errors" %in% names(httr::content(x))) {
    errors <- httr::content(x)$errors[[1]]
    for (e in seq_len(max(lengths(errors)))) {
      funct <- switch(as.character(errors$code[e]),
                      "89" = stop,
                      warning)
      funct(paste0(errors$message[e], " (", errors$code[e], ")"),
            call. = FALSE)

    }
  }
}

# https://developer.twitter.com/en/support/twitter-api/error-troubleshooting
handle_error <- function(x, params) {
  chk_message <- "Check error message at https://developer.twitter.com/en/support/twitter-api/error-troubleshooting"
  if (is.null(x$headers[["content-type"]])) {
    abort(paste0("Twitter API failed [", x$status_code, "]\n", chk_message),
          call = caller_call())
  }
  json <- from_js(x)
  error <- if (!is.null(json[["error"]])) json[["error"]] else json[["errors"]]
  if (x$status_code %in% c("401", "403") && is_developing()) {
    testthat::skip("API v1.1 no longer works")
    if (length(error) == 1) {
      if (any(c("screen_name", "user_id") %in% names(params))) {
        account <- params$screen_name
        if (is.null(account))
          account <- params$user_id
        warn(paste0("Skipping unauthorized account: ", account))
      } else {
        warn(paste0("Something went wrong with the authentication:\n\t", error))
      }
    } else if (length(error) == 2) {
      abort(c(paste0("Twitter API failed [", x$status_code, "]:"),
              paste0(error$message, " (", error$code, ")")),
            call. = caller_call())
    } else {
      if (is_testing()) {
        testthat::skip("Something went wrong with the requests")
      }
      warn("Something went wrong with the requests")
    }
  }
}

# I don't love this interface because it returns either a httr response object
# or a condition object, but it's easy to understand and avoids having to do
# anything exotic to break from the correct frame.
catch_rate_limit <- function(code) {
  tryCatch(code, rtweet_rate_limit = function(e) e)
}

is_rate_limit <- function(x) inherits(x, "rtweet_rate_limit")

warn_early_term <- function(cnd, hint, hint_if) {
  warn(c(
    "Terminating paginate early due to rate limit.",
    cnd$message,
    i = if (hint_if) hint,
    i = "Set `retryonratelimit = TRUE` to automatically wait for reset"
  ))
}

check_status <- function(x, api) {
  switch(resp_type(x),
         ok = NULL,
         rate_limit = ,
         error = handle_error(x)
  )
}

check_token <- function(token = NULL) {
  token <- token %||% auth_get()

  if (inherits(token, "Token1.0")) {
    token
  } else if (auth_is_bearer(token)) {
    httr::add_headers(Authorization = paste0("Bearer ", token$token))
  } else if (auth_is_pkce(token)) {
    abort(c("This OAuth 2.0 `token` is not a valid access token",
            "i" = "Please use a bearer token via `rtweet_app()`."),
          call = caller_call())
  } else {
    abort("`token` is not a valid access token", call = caller_call())
  }
}

#' Lists tweets of a specified list
#'
#' Looks up the followers of a list.
#' @inheritParams list_get
#' @export
#' @returns A data.frame with the user information of who is following the list:
#' edit_history_tweet_ids, id and text.
#' Other information depends on the `expansions` and `fields` requested.
#' Accepted values are:
#' - Expansions: `set_expansions(list = NULL)`.
#' - Fields: `set_fields(list = NULL)`.
#' @references <https://developer.twitter.com/en/docs/twitter-api/lists/list-tweets/api-reference/get-lists-id-tweets>
#' @examples
#' if (FALSE) {
#'   lt <- list_tweets("1150793074420998146")
#' }
list_tweets <- function(ids, n = 100, expansions = NULL, fields = NULL, ...,
                           token = NULL, parse = TRUE, verbose = FALSE) {

  expansions <- check_expansions(arg_def(expansions, set_expansions(list = NULL)),
                                 set_expansions(list = NULL))
  fields <- check_fields(arg_def(fields, set_fields(list = NULL)), list = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  if (length(ids) != 1 || !is_list_id(ids) && length(ids) == 0) {
    abort("Please introduce at least a valid list id")
  }

  data <- c(list(expansions = expansions), fields, ...)
  url <- paste0("lists/", ids, "/tweets")

  max_results <- check_interval(n, 1, formals()$n)
  n_pages <- ceiling(n / max_results)
  data <- c(max_results = max_results, data)

  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- data[data != ""]

  # Rates from the website app and user limits
  req_archive <- endpoint_v2(url, 900/(60*15),
                             c("tweet.read", "users.read", "list.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, n_pages, n, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

#' Search users by username
#'
#' Looks up users by their username.
#' @inheritParams filtered_stream
#' @inheritParams user_following
#' @param ids A user name string or up to 100.
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/lists/list-lookup/api-reference/get-users-id-owned_lists>
#' @examples
#' if (FALSE) {
#'   ul <- user_lists("1051050384")
#' }
user_lists <- function(ids, n = 100, expansions = NULL, fields = NULL, ...,
                       token = NULL, parse = TRUE, verbose = FALSE) {

  expansions <- check_expansions(arg_def(expansions, "owner_id"), "owner_id")
  fields <- check_fields(arg_def(fields, list_fields),
                         metrics = NULL, place = NULL, poll = NULL,
                         media = NULL, user = NULL, tweet = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  if (length(ids) != 1 || !is_user_id(ids) && length(ids) == 0) {
    abort("Please introduce at least a valid user id")
  }

  data <- c(list(expansions = expansions), fields, ...)
  url <- paste0("users/", ids, "/owned_lists")
  max_results <- check_interval(n, 1, formals()$n)
  n_pages <- ceiling(n / max_results)
  data <- c(max_results = max_results, data)

  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- data[data != ""]

  # Rates from the website app and user limits
  req_archive <- endpoint_v2(url, 15/(60*15), c("tweet.read", "users.read", "like.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, n_pages, n, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

#' Get Twitter users data for given users (user IDs or screen names).
#'
#' @inheritParams TWIT_paginate_max_id
#' @inheritParams stream
#' @param users User id or screen name of target user.
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-users-lookup>
#'
#' @examples
#'
#' if (FALSE) {
#'     users <- c("twitter", "rladiesglobal", "_R_Foundation")
#'     users <- lookup_users(users)
#' }
#'
#' @return A tibble of users data.
#' @family users
#' @export
lookup_users <- function(users, parse = TRUE, token = NULL,
                         retryonratelimit = NULL,
                         verbose = TRUE) {
  type <- user_type(users, "users")

  chunks <-  unname(split(users, (seq_along(users) - 1) %/% 100))
  params_list <- lapply(chunks, function(users) {
    params <- list()
    params[[type]] <- paste0(users, collapse = ",")
    params
  })

  results <- TWIT_paginate_chunked(token, "/1.1/users/lookup", params_list,
    retryonratelimit = retryonratelimit,
    verbose = verbose
  )

  if (parse) {
    results <- users_with_tweets(results)
    results$created_at <- format_date(results$created_at)
  }

  results
}

#' Get coordinates of specified location.
#'
#' Convenience function for looking up latitude/longitude coordinate
#' information for a given location. Returns data as a special
#' "coords" object, which is specifically designed to interact
#' smoothly with other relevant package functions. NOTE: USE OF THIS FUNCTION
#' REQUIRES A VALID GOOGLE MAPS API KEY.
#'
#' Since Google Maps implemented stricter API requirements, sending
#' requests to Google's API isn't very convenient. To enable basic uses
#' without requiring a Google Maps API key, a number of the major cities
#' throughout the word and the following two larger locations are
#' baked into this function: 'world' and 'usa'. If 'world' is supplied then
#' a bounding box of maximum latitutde/longitude values, i.e.,
#' `c(-180, -90, 180, 90)`, and a center point `c(0, 0)` are
#' returned. If 'usa' is supplied then estimates of the United States'
#' bounding box and mid-point are returned. To specify a city, provide the
#' city name followed by a space and then the US state abbreviation or
#' country name. To see a list of all included cities, enter
#' `rtweet:::citycoords` in the R console to see coordinates data.
#'
#' @param address Desired location typically in the form of place
#'   name, subregion, e.g., address = "lawrence, KS". Also accepts the
#'   name of countries, e.g., address = "usa", address = "brazil" or
#'   states, e.g., address = "missouri" or cities, e.g., address =
#'   "chicago". In most cases using only address should be sufficient.
#' @param components Unit of analysis for address e.g., components =
#'   "country:US". Potential components include postal_code, country,
#'   administrative_area, locality, route.
#' @param apikey A valid Google Maps API key. If NULL, `lookup_coords()` will
#'   look for a relevant API key stored as an environment variable (e.g.,
#'   `GOOGLE_MAPS_KEY`).
#' @param ... Additional arguments passed as parameters in the HTTP
#'   request
#' @return Object of class coords.
#' @examples
#'
#' \dontrun{
#'
#' ## get coordinates associated with the following addresses/components
#' sf <- lookup_coords("san francisco, CA", "country:US")
#' usa <- lookup_coords("usa")
#' lnd <- lookup_coords("london")
#' bz <- lookup_coords("brazil")
#'
#' }
#'
#' @family geo
#' @export
lookup_coords <- function(address, components = NULL, apikey = NULL, ...) {
  if (missing(address)) stop("must supply address", call. = FALSE)
  stopifnot(is.atomic(address) && !is.null(address))
  place <- address
  if (grepl("^us$|^usa$|^united states$|^u\\.s",
            address, ignore.case = TRUE)) {
    boxp <- c(
      sw.lng = -124.848974,
      sw.lat = 24.396308,
      ne.lng = -66.885444,
      ne.lat = 49.384358
    )
    point <- c(
      lat = 36.89,
      lng = -95.867
    )
  } else if (grepl("^world$|^all$|^globe$|^earth$",
            address, ignore.case = TRUE)) {
    boxp <- c(
      sw.lng = -180,
      sw.lat = -90,
      ne.lng = 180,
      ne.lat = 90
    )
    point <- c(
      lat = 0,
      lng = 0
    )
    # citycoords is a dataset stored in R/sysdata.rda
  } else if (gsub("\\,\\s?", " ", tolower(address)) %in% c(citycoords$city,
    sub("can$", "canada", citycoords$city),
    sub("usa$", "us", citycoords$city))) {
    address <- gsub("\\,\\s?", " ", tolower(address))
    address <- sub("canada", "can", address)
    address <- sub("usa$", "us", address)
    i <- match(address, citycoords$city)
    point <- c(
      lat = citycoords$lat[i],
      lng = citycoords$lng[i])
    boxp <- c(
      sw.lng = point[2] - .05,
      sw.lat = point[1] - .05,
      ne.lng = point[2] + .05,
      ne.lat = point[1] + .05
    )
  } else {
    ## encode address
    address <- gsub(" ", "+", gsub(",", "", address))
    ## compose query
    params <- list(address = address,
                   components = components,
                   ...)
    params <- params[!vapply(params, is.null, logical(1))]
    params <- paste0(
      mapply(function(x, y) paste0(x, "=", y),
             names(params), params),
      collapse = "&")
    ## build URL
    if (is.null(apikey)) {
      apikey <- find_google_geocode_key()
    }
    geourl <- paste0("https://maps.googleapis.com/maps/api/geocode/json?key=",
      apikey, "&", params)
    ## read and convert to list obj
    r <- jsonlite::fromJSON(geourl)
    ## extract and name box and point data frames
    boxp <- c(
      sw.lng = r$results$geometry$bounds$southwest$lng,
      sw.lat = r$results$geometry$bounds$southwest$lat,
      ne.lng = r$results$geometry$bounds$northeast$lng,
      ne.lat = r$results$geometry$bounds$northeast$lat
    )
    point <- c(
      lat = r$results$geometry$location$lat,
      lng = r$results$geometry$location$lng
    )
  }
  as.coords(place = place, box = boxp, point = point)
}

find_google_geocode_key <- function() {
  evs <- names(Sys.getenv())
  if (any(grepl("GOOGLE.*MAP", evs, ignore.case = TRUE))) {
    p <- grep("GOOGLE.*MAP", evs, ignore.case = TRUE)
    p <- p[length(p)]
    key <- Sys.getenv(evs[p])
  } else if (any(grepl("GOOGLE.*KEY", evs, ignore.case = TRUE))) {
    p <- grep("GOOGLE.*KEY", evs, ignore.case = TRUE)
    p <- p[length(p)]
    key <- Sys.getenv(evs[p])
  } else if (interactive()) {
    yn <- menuline(c("lookup_users() requires a Google Maps API key.",
                     "For instructions on how to acquire one, see: https://developers.google.com/maps/documentation/javascript/tutorial.",
                     "Do you have a Google Maps API key you'd like to use?"),
                   c("Yes", "No"))
    if (yn == 2) {
      abort("sorry, lookup_users() requires a Google Maps API key")
    }
    key <- readline("Please enter your Google Maps API key:")
    key <- gsub("\\s+|\"|'", "", key)
    Sys.setenv(GOOGLE_MAPS_KEY = key)
  } else {
    key <- ""
  }
  ## if invalid key
  if (identical(key, "")) {
    msg <- c("Invalid key. `lookup_users()` expects a non-empty string stored as ",
      "`GOOGLE_MAPS_KEY` in the \".Renviron\" file or passed via `apikey`, e.g., ",
      "`lookup_coords(\"London, UK\", apikey = \"MWIFdTiGjPqy-nPknKmvLLeOInVzETZVlRg_2mg\")`. ",
      "i" = "For instructions on obtaining a Google Maps API key, see: ",
      "https://developers.google.com/maps/documentation/javascript/tutorial")
    abort(msg)
  }
  key
}

menuline <- function(q, a) {
  message(q)
  utils::menu(a)
}


as.coords <- function(place, box, point) {
  coords <- list(place = place, box = box, point =  point)
  class(coords) <- c("coords", "list")
  coords
}

test_that("lookup_coords returns coords data", {

  kcmo <- lookup_coords("kansas city, mo")
  expect_gt(cor(kcmo$point, c(39.0997, 94.5786)), 0.9)
  tor <- lookup_coords("toronto canada")
  expect_gt(cor(tor$point, c(43.6532, 79.3832)), 0.9)

  x <- lookup_coords("usa")
  expect_equal(is.list(x), TRUE)
  expect_named(x)
  expect_true("box" %in% names(x))

  x <- lookup_coords("world")
  expect_equal(is.list(x), TRUE)
  expect_named(x)
  expect_true("box" %in% names(x))

  gmk <- Sys.getenv("GOOGLE_MAPS_KEY")
  if (!is.null(gmk) && !identical(gmk, "")) {
    vcr::use_cassette("lookup_coords5", {
      x <- lookup_coords("New York, NY")
    })
    expect_equal(is.list(x), TRUE)
    expect_named(x)
    expect_true("box" %in% names(x))
  }
  Sys.setenv(GOOGLE_KEY = gmk)
  Sys.setenv(GOOGLE_MAPS_KEY = "")
  if (!is.null(gmk) && !identical(gmk, "")) {
    vcr::use_cassette("lookup_coords6", {
      x <- lookup_coords("New York, NY")
    })
    expect_equal(is.list(x), TRUE)
    expect_named(x)
    expect_true("box" %in% names(x))
  }
  e <- names(Sys.getenv())
  g <- grep("google|gmap", e, ignore.case = TRUE, value = TRUE)
  if (length(g) > 0) {
    ng <- as.list(rep("", length(g)))
    names(ng) <- g
    do.call(Sys.setenv, ng)
  }
  expect_error(lookup_coords("London, UK"))
})

#' Get the most recent retweets/retweeters
#'
#' `get_retweets()` returns the 100 most recent retweets of a tweet;
#' `get_retweeters()` returns the 100 most recent users who retweeted them.
#'
#' @inheritParams lookup_users
#' @param status_id Tweet/status id.
#' @param n Number of results to retrieve. Must be <= 100.
#' @param ... Other arguments used as parameters in the query sent to
#'   Twitter's rest API, for example, `trim_user = TRUE`.
#' @return Tweets data of the most recent retweets/retweeters of a given status.
#' @inheritParams stream
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/get-statuses-retweets-id>
get_retweets <- function(status_id, n = 100, parse = TRUE, token = NULL, ...) {
  stopifnot(is.character(status_id), length(status_id) == 1L, is_n(n))

  query <- sprintf("/1.1/statuses/retweets/%s", status_id)
  params <- list(
    id = status_id,
    count = n,
    # Undocumented parameter https://github.com/ropensci/rtweet/issues/575#issuecomment-829605892
    tweet_mode = "extended",
    ...
  )
  r <- TWIT_get(token, query, params)

  if (parse) {
    r <- tweets_with_users(list(r))
    r$created_at <- format_date(r$created_at)
  }
  r
}

#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/get-statuses-retweeters-ids>
#' @rdname get_retweets
get_retweeters <- function(status_id, n = 100, parse = TRUE, token = NULL) {
  stopifnot(is_n(n))
  params <- list(
    id = status_id,
    count = n,
    stringify_ids = TRUE
  )
  r <- TWIT_get(token, "/1.1/statuses/retweeters/ids", params)

  if (parse) {
    r <- tibble::tibble(user_id = r$ids)
  }
  r
}

test_that("get_retweets returns tweets data", {
  
  vcr::use_cassette("get_retweets1", {
    x <- get_retweets("1363488961537130497")
  })
  expect_equal(is.data.frame(x), TRUE)
  expect_named(x)
  expect_true(all(colnames(x) %in% colnames(tweet(NULL))))
})

test_that("get_retweets returns user data", {
  
  vcr::use_cassette("get_retweets2", {
    x <- get_retweets("1363488961537130497")
  })
  expect_s3_class(users_data(x), "data.frame")
})

test_that("get_retweeters returns users", {
  
  vcr::use_cassette("get_retweets3", {
    x <- get_retweeters("1363488961537130497")
  })
  expect_equal(is.data.frame(x), TRUE)
  expect_named(x)
  expect_true("user_id" %in% names(x))
})

#' List muted users
#'
#' Looks up the muted users.
#' @inheritParams list_get
#' @export
#' @returns A data.frame with the user information of who is following the list:
#' id, name, and username.
#' Other information depends on the `expansions` and `fields` requested.
#' Accepted values are:
#' - Expansions: `set_expansions(tweet = NULL, list = NULL)`.
#' - Fields: `set_fields(media = NULL, poll = NULL, place = NULL, list = NULL)`.
#' @references <https://developer.twitter.com/en/docs/twitter-api/users/mutes/api-reference/get-users-muting>
#' @seealso [user_self()]
#' @examples
#' if (FALSE) {
#'   um <- user_muted(user_self()$id)
#' }
user_muted <- function(ids, n = 1000, expansions = NULL, fields = NULL, ...,
                           token = NULL, parse = TRUE, verbose = FALSE) {


  expansions <- check_expansions(
    arg_def(expansions,
            set_expansions(tweet = NULL, list = NULL)),
    set_expansions(tweet = NULL, list = NULL))
  fields <- check_fields(
    arg_def(fields,
            set_fields(place = NULL, poll = NULL, list = NULL)),
    metrics = NULL, place = NULL, poll = NULL, list = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  if (length(ids) != 1 || !is_list_id(ids) && length(ids) == 0) {
    abort("Please introduce at least a valid list id")
  }

  data <- c(list(expansions = expansions), fields, ...)
  url <- paste0("users/", ids, "/muting")
  max_results <- check_interval(n, 1, formals()$n)
  n_pages <- ceiling(n / max_results)
  data <- c(max_results = max_results, data)

  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- data[data != ""]

  # Rates from the website app and user limits
  req_archive <- endpoint_v2(url, 900/(60*15), c("tweet.read", "users.read", "mute.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, n_pages, n, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

#' Create the links
#'
#' create the links from the rtweet data present.
#' Depending on the object type it returns either users links,  tweet links or rules links.
#' @param x An object of the rtweet package.
#' @param ... Other arguments currently unused.
#' @export
links <- function(x, ...) {
  UseMethod("links")
}

#' @export
links.default <- function(x, ...) {
  out <- x[["id_str"]]
  if (is.null(out)) {
    stop("links are not present. Are you sure this is a rtweet object?",
         call. = FALSE)
  }
  paste0("https://twitter.com/", out)
}


#' @export
links.rules <- function(x, ...) {
  abort("rules are not provided in a website.")
}

#' @export
links.users <- function(x, ...) {
  paste0("https://twitter.com/", x$screen_name)
}

#' @export
links.tweets <- function(x, ...) {
  u <- users_data(x)
  paste0("https://twitter.com/", u$screen_name, "/status/", x$id_str)
}

#' @export
links.followers <- function(x, ...) {
  paste0("https://twitter.com/", x$to_id)
}

#' @export
links.friends <- function(x, ...) {
  paste0("https://twitter.com/", x$from_id)
}

#' Bearer token
#'
#' @description
#' `r lifecycle::badge("deprecated")`
#'
#' `bearer_token()` has been deprecated because it used a rather indirect
#' method of generating a bearer token. Instead, use [rtweet_app()], copying
#' in the bearer token directly from the
#' [Twitter developer portal](https://developer.twitter.com/en/portal/projects-and-apps).
#' See `vignette("auth", package = "rtweet")` for full details.
#' @keywords internal
#' @seealso [rtweet_bearer()], [`rtweet-deprecated`]
#' @export
bearer_token <- function(token = NULL) {
  lifecycle::deprecate_stop("1.0.0", "bearer_token()", "rtweet_app()")
}

#' Invalidate bearer token
#'
#' Invalidate the bearer token automatically if you know the API key and API secret.
#'
#' @note Not tested!
#' @inheritParams rtweet_user
#' @param token Expert use only. Use this to invalidate a specific bearer token
#' created with [rtweet_app()]. If `NULL` the default authentication mechanism is invalidated.
#' @references <https://developer.twitter.com/en/docs/authentication/api-reference/invalidate_bearer_token>
#' <https://developer.twitter.com/en/docs/authentication/api-reference/invalidate_access_token>
#' @keywords internal
#' @export
invalidate_bearer <- function(api_key, api_secret, client = NULL, token = NULL) {
  # See also rtweet_invalidate in auth.R
  # To store the token at the right place: see ?httr2::oauth_cache_path
  withr::local_envvar(HTTR2_OAUTH_CACHE = auth_path())
  if (is.null(client)) {
    client <- client_as(client)
    api_key <- client["id"]
    api_secret <- client["secret"]
  } else {
    stopifnot(is_string(api_key), is_string(api_secret))
  }
  if (is.null(client) && missing(api_key)) {
    api_key <- ask_pass("API key")
  }
  if (is.null(client) &&  missing(api_secret)) {
    api_key <- ask_pass("API secret")
  }
  token <- check_token_v2(token)
  req1 <- httr2::request("https://api.twitter.com/oauth2/invalidate_token")
  req2 <- httr2::req_url_query(req1, access_token = token)
  req3 <- httr2::req_method(req2, "POST")
  req4 <- httr2::req_auth_basic(req3, api_key, api_secret)
  resp <- httr2::req_perform(req4)
  resp
}

# Handling responses ####
parsing <- function(x, expansions, fields) {
  if (!is_logical(x)) {
    abort("parse should be either TRUE or FALSE", call = current_call())
  }
  if (isTRUE(x) && (!is.null(expansions) || !is.null(fields))) {
    abort(c("Not yet implemented!",
            i = "Stay tuned for further updates or use `parse = FALSE`"),
          call = current_call())
  }
}

list_minus <- function(l, minus) {
  keep <- setdiff(names(l), minus)
  l[keep]
}

# Pagination should be consistent across API v2
# <https://developer.twitter.com/en/docs/twitter-api/pagination>
pagination <- function(req, n_pages, count, verbose = TRUE) {
  # To store the token at the right place: see ?httr2::oauth_cache_path
  withr::local_envvar(HTTR2_OAUTH_CACHE = auth_path())
  if (is.infinite(n_pages)) {
    n_pages <- 8
  }
  # Temporary file to store data in case of troubles
  tmp <- tempfile("rtweet_tmp", fileext = ".rds")

  all_results <- vector("list", length = n_pages)
  resp <- httr2::req_perform(req, error_call = sys.call(1))
  x0 <- resp(resp)
  all_results[[1]] <- x0

  # If already got what we need stop
  next_pag_token <- x0$meta$next_token
  if (n_pages == 1 || is.null(next_pag_token)) {
    return(list(x0))
  }
  i <- 2
  # counts in the tweet/counts/* endpoints return total_tweet_count
  total <- x0$meta[[names(x0$meta)[endsWith(names(x0$meta), "_count")]]]

  if (verbose)  {
    pb <- progress::progress_bar$new(
      format = "Downloading paginated request :bar",
      total = n_pages)
    pb$message(paste0("Saving temporary data to ", tmp))
    withr::defer(pb$terminate())
  }

  while (!is.null(next_pag_token) && i <= n_pages) {
    req <- httr2::req_url_query(req, pagination_token = next_pag_token)
    resp <- httr2::req_perform(req)
    cnt <- resp(resp)
    if (i > length(all_results)) {
      # double length per https://en.wikipedia.org/wiki/Dynamic_array#Geometric_expansion_and_amortized_cost
      length(all_results) <- 2 * length(all_results)
    }
    # Save temporary data: https://github.com/ropensci/rtweet/issues/531
    all_results[[i]] <- cnt
    if (verbose) {
      pb$tick()
      # Only save the data if verbose (assuming non verbose output will be quick)
      # Also to avoid a verbose and save argument.
      saveRDS(all_results, tmp)
    }
    i <- i + 1
    total <- total + cnt$meta[[names(cnt$meta)[endsWith(names(cnt$meta), "_count")]]]
    next_pag_token <- cnt$meta$next_token
  }
  if (!is.infinite(count) && total < count) {
    warn("The API returned less results than requested and possible.")
  }
  if (verbose && !is.null(next_pag_token)) {
    inform("The API might allow you to continue the same query via the `next_token`.")
  }
  empty <- vapply(all_results, is.null, logical(1L))
  all_results[!empty]
}

# Initial conversion of data about the requests returned by the API
resp <- function(x, ...) {
  # Simplify so that a list is converted to a vector and that there are data.frames
  # Might make it harder when a tweet has some data and others don't!
  out <- httr2::resp_body_json(x, simplifyVector = TRUE, flatten = FALSE)
  class(out) <- c("Twitter_resp", class(out))

  if (has_name_(out, "errors")) {
    abort(req_errors(out), call = current_call())
  }

  if (has_name_(out, "meta")) {
    # Summary and sent are fields in some endpoints:
    # streaming endpoints, ?
    rest <- list2DF(list_minus(out$meta, c("summary", "sent")))
    # Protection in case of other fields are empty
    rest <- rest[1, seq_len(NCOL(rest)), drop = FALSE]
    rownames(rest) <- NULL
    if (has_name_(out$meta, "sent")) {
      sent <- format_date_precison(out$meta$sent)
      rest$sent <- sent
    }

    if (has_name_(out$meta, "summary")) {
      rest$summary <- list2DF(out$meta$summary)
    }

    if (nrow(rest) > 1) {
      abort("Please check", call = current_call())
    }
    out$meta <- rest
  }
  out
}

#' Expose errors of the response
#'
#' @param expr An expression that might cause an error.
#' If `NULL` it looks for the last error.
#' @examples
#' if (FALSE){
#'   new_rule <- stream_add_rule(list(value = "#rstats", tag = "rstats1"))
#'   stream_add_rule(list(value = "#rstats", tag = "rstats2")) # ERROR
#'   # See the full information provided by the API:
#'   retrieve_errors(stream_add_rule(list(value = "#rstats", tag = "rstats2")))
#'   retrieve_errors()
#' }
retrieve_errors <- function(expr = NULL) {
  if (is.null(expr)) {
    le <- rlang::last_error()
    if (is(class(le), "rtweet_API_errors")) {
      return(le$errors)
    } else {
      le
    }
  }
  # This is experimental on the rlang side!
  try_fetch(expr, error = function(cnd){cnd$errors}
  )
}

#' Retrieve user bookmarks
#'
#' Collects the 800 most recent bookmarked tweets of a user.
#' @note This endpoint requires a OAuth2.0 authentication, with tweet.read, users.read and bookmark.read permissions.
#' @param id Twitter user id: character string identifying your account.
#' @param n Number of tweets to retrieve.
#' @param ... Other arguments passed down to the API.
#' @param verbose A logical value
#' @param token This endpoint only accept a OAuth2.0 authentication (can be
#' created via [rtweet_oauth2()]).
#' @inheritParams sample_stream
#' @seealso [rtweet_oauth2()], [user_self()]
#' @export
#' @returns A data.frame with the user information of who is following the list:
#' edit_history_tweet_ids, id and text.
#' Other information depends on the `expansions` and `fields` requested.
#' Accepted values are:
#' - Expansions: `set_expansions(list = NULL)`.
#' - Fields: `set_fields(list = NULL)`.
#' @references <https://developer.twitter.com/en/docs/twitter-api/tweets/bookmarks/api-reference/get-users-id-bookmarks>
#' @examples
#' if (FALSE) {
#'    # Requires token_oa2
#'    ub <- user_bookmarks(user_self()$id, parse = FALSE, n = Inf, token = token_oa2)
#' }
user_bookmarks <- function(id, n = 100, ..., expansions = NULL, fields = NULL,
                           parse = TRUE, token = NULL, verbose = FALSE) {
  parsing(parse, expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  max_results <- check_interval(n, 1, formals()$n)
  n_pages <- ceiling(n / max_results)
  expansions <- check_expansions(arg_def(expansions, set_expansions(list = NULL)))
  fields <- check_fields(arg_def(fields, set_fields(list = NULL)), metrics = NULL)
  expansions_for_fields(expansions, fields)
  data <- c(list(expansions = expansions), fields, max_results = max_results, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  if (!is_user_id(id)) {
    abort(c("Please introduce a valid user id.",
            "i" = "Have you introduced your user name instead of your code number 123456789?"))
  }
  url <- paste0("users/", id,"/bookmarks")
  req_bookmarks <- endpoint_v2(url, 180 / (60*15),
                               c("tweet.read", "users.read", "bookmark.read"))
  req_final <- httr2::req_url_query(req_bookmarks, !!!data)
  p <- pagination(req_final, n_pages, n, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

#' Defunct: Emojis codes and descriptions data.
#'
#' This data comes from "Unicode.org":
#' <https://unicode.org/emoji/charts/full-emoji-list.html>.
#' The data are codes and descriptions of Emojis.
#'
#' @docType data
#' @name emojis
#' @format A tibble with two variables and 2,623 observations.
NULL

#' Defunct: Language codes recognized by Twitter data.
#'
#' This data comes from the Library of Congress,
#' <https://www.loc.gov/standards/iso639-2/ISO-639-2_utf-8.txt>. The data are
#' descriptions and codes associated with internationally recognized languages.
#' Variables include translations for each language represented as
#' bibliographic, terminological, alpha, English, and French.
#'
#' @docType data
#' @name langs
#' @format A tibble with five variables and 486 observations.
NULL


#' Defunct: Twitter stop words in multiple languages data.
#'
#' This data comes form a group of Twitter searches conducted at
#' several times during the calendar year of 2017. The data are
#' commonly observed words associated with 10 different languages,
#' including `c("ar", "en", "es", "fr", "in", "ja", "pt", "ru",
#' "tr", "und")`. Variables include `"word"` (potential stop
#' words), `"lang"` (two or three word code), and `"p"`
#' (probability value associated with frequency position along a
#' normal distribution with higher values meaning the word occurs more
#' frequently and lower values meaning the words occur less
#' frequently).
#'
#' @docType data
#' @name stopwordslangs
#' @format A tibble with three variables and 24,000 observations
NULL

#' Delete status of user's Twitter account `r lifecycle::badge("deprecated")`
#'
#' Deletes a status of user's profile.
#' @inheritParams post_tweet
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/post-statuses-destroy-id>
#' @seealso [tweet_delete()] [`rtweet-deprecated`]
post_destroy <- function(destroy_id, token = NULL) {
  stopifnot(is.character(destroy_id) && length(destroy_id) == 1)

  query <- sprintf("/1.1/statuses/destroy/%s", destroy_id)
  r <- TWIT_post(token, query)
  class(r) <- c("tweet_deleted", class(r))
  message("Your tweet has been deleted!")
  return(invisible(r))
}

##----------------------------------------------------------------------------##
##                          COMPUTE LAT/LNG VARIABLES                         ##
##----------------------------------------------------------------------------##

#' Adds single-point latitude and longitude variables to tweets data.
#'
#' Appends parsed Twitter data with latitude and longitude variables
#' using all available geolocation information.
#'
#' @param x Parsed Twitter data as returned by various rtweet
#'   functions. This should be a data frame with variables such as
#'   "bbox_coords", "coords_coords", and "geo_coords" (among
#'   other non-geolocation Twitter variables).
#' @param coords Names of variables containing latitude and longitude
#'   coordinates.  Priority is given to bounding box coordinates (each
#'   obs consists of eight entries) followed by the supplied order of
#'   variable names. Defaults to "bbox_coords",
#'   "coords_coords", and "geo_coords") (which are the default column
#'   names of data returned by most status-oriented rtweet functions).
#' @param prefs Preference of coordinates to use as default, must be in `coords`.
#' @details On occasion values may appear to be outliers given a
#'   previously used query filter (e.g., when searching for tweets
#'   sent from the continental US).  This is typically because those
#'   tweets returned a large bounding box that overlapped with the
#'   area of interest. This function converts boxes into their
#'   geographical midpoints, which works well in the vast majority of
#'   cases, but sometimes includes an otherwise puzzling result.
#' @return Returns updated data object with full information latitude
#'   and longitude vars.
#' @family geo
# Used by Twitmo
#' @export
lat_lng <- function(x, coords = c("coords_coords", "bbox_coords", "geo_coords"), prefs = "bbox_coords") {
  stopifnot(is.data.frame(x))
  coords <- match.arg(coords, several.ok = TRUE)
  prefs <- match.arg(prefs, choices = c("coords_coords", "bbox_coords", "geo_coords"))
  prefs <- prefs[prefs %in% coords]
  if (length(prefs) == 0) {
    abort("`prefs` is not included in `coords`")
  } else if (length(prefs) > 1) {
    abort("`prefs` must be of length 1")
  }

  lat_lang <- function(x) {

    if (is.null(x)) {
      return(list(long = NA, lat = NA))
    }

    # Protect against AsIs olClass data.frames in a list in x
    if (is.list(x) && !is.data.frame(x) && length(x) == 1) {
      x <- as.data.frame(x[[1]])
    }

    list(long = mean(range(x$long)),
         lat = mean(range(x$lat)))
  }
  l <- lapply(x$place, function(x) {
    if (length(x) == 1 && is.na(x)) {
      empty_coord <- list(long = NA, lat = NA)
      df <- data.frame(bbox_coords = I(list(empty_coord)),
                       geo_coords = I(list(empty_coord)),
                       coords_coords = I(list(empty_coord)))
      return(df)
    }

    data.frame(bbox_coords = I(list(lat_lang(x$place$bounding_box[[1]]))),
               geo_coords = I(list(lat_lang(x$geo))),
               coords_coords = I(list(lat_lang(x$coordinates))))
  })
  ll <- do.call(rbind, l)[, coords, drop = FALSE]

  lat <- vapply(ll, extract_coord, numeric(nrow(ll)), coord = "lat")
  if (!is.matrix(lat)) {
    lat <- list2DF(as.list(lat))
  }
  lat <- lat[, prefs]
  long <- vapply(ll, extract_coord, numeric(nrow(ll)), coord = "long")
  if (!is.matrix(long)) {
    long <- list2DF(as.list(long))
    }
  long <- long[, prefs]

  cbind(x, lat = lat, lng = long, ll)

}


extract_coord <- function(x, coord) {
  if (length(x) == 1) {
    return(x[[1]][[coord]])
  }

  vapply(x, function(y){
    y[[coord]]
  }, numeric(1L))
}

# Helper to explain the sydata.rda file
# This is a file with two R objects:
# citycoords: A tibble used by lookup_coords (and tested in test-coords.)
# sysdat: A list used by trends and auth clients
#  - woeid
#  - DYK, MRsn: used to set up default client with oauth 1.0:
#     - This account was created by Michael W. Kearney and it is now lost
#  - d55, e914: used to set up default client with oauth 2.0:
#     - This account was created by me:
#        - id: 1355953759982120964
#        - account username: app_rtweet
#        - name: rtweet_app
# Each client is hidden using openssl::encrypt(secret, rsa-key)
# Just in case I always use the same rsa-key as in DYK... and MRsn...
# The key is the first element of DYK, MRsn, d55, e914
# The names are a section for md5sum from something.

# Checking tokens ####
auth_is_bearer <- function(token = NULL) {

  if (is.null(token)) {
    token <- auth_get()
  }
  # if the bearer is created with rtweet_bearer the class is different
  bearer_httr2 <- inherits(token, "httr2_token") && is.null(token$refresh_token)
  inherits(token, "rtweet_bearer") || bearer_httr2
}

prepare_bearer <- function(x, y) {
  token_credentials <- paste0(x, ":", y, collapse = "")

  check_installed("openssl")
  openssl::base64_encode(token_credentials)
}

auth_is_pkce <- function(token = NULL) {
  if (is.null(token)) {
    token <- auth_get()
  }
  inherits(token, "httr2_token")
}

# Check token readiness for API v2
#
# Check if current authentication is ready for API v2 usage.
# @param token The token to check if can be used for API v2.
# @param mechanism Which flavor of authentication must be used.
#
# The authentication method required for each endpoint might change, this is a
# helper for examples.
#
# @return If no issue is found the original token, if something is amiss it raises an error.
# @export
#
# @examples
#  if (auth_has_default()) {
#     tryCatch(check_token_v2())
#  }
check_token_v2 <- function(token = NULL, mechanism = "bearer") {

  token <- token %||% auth_get()
  return(token)
  mechanism <- match.arg(mechanism, c("bearer", "pkce"), several.ok = TRUE)

  # For endpoints that accept both authentications methods
  if (length(mechanism) == 2 && (auth_is_bearer(token) || auth_is_pkce(token))) {
    return(token)
  } else if (length(mechanism) == 2) {
    # To make it easier testing interactively
    if (is_developing()) {
      return(load_token("bearer_academic_dev"))
    }

    abort(c(
      "x" = "You must use a token accepted by the endpoints v2.",
      "i" = "Check the `vignette('auth', package = 'rtweet')` about how to get them."),
      call = current_call())
  }

  if (mechanism == "bearer" && !auth_is_bearer(token)) {

    abort(c("x" = "A bearer `token` is needed for this endpoint.",
            "i" = "Get one via `rtweet_app()`"),
          call = current_call())
  }
  if (mechanism == "pkce" && !auth_is_pkce(token)) {

    client <- client_get()
    if (!is_client(client)) {
      msg <- c(">" = "Check the vignette('auth', 'rtweet')",
      "i" = "Get a client with `rtweet_client()`")
    } else {
      msg <- NULL
    }
    abort(c("x" = "An OAuth 2.0  is needed for this endpoint.",
            msg,
            "i" = "Get the authorization via `rtweet_oauth2()`"),
          call = current_call())
  }
  token
}

# Provides the required method for the token type
req_auth <- function(req, token) {
  if (auth_is_bearer(token)) {
    httr2::req_auth_bearer_token(req, token$token)
  } else if (auth_is_pkce(token)) {
    token <- auth_renew()
    token <- token$access_token
  }
}

req_is_error <- function(resp) {
  if (is(resp, "httr2_response")) {
    r <- httr2::resp_body_json(resp, simplifyVector = TRUE, flatten = FALSE)
  } else {
    r <- resp
  }
  has_name_(r, "errors") || httr2::resp_is_error(resp)
}

req_errors <- function(resp) {
  if (is(resp, "httr2_response")) {
    r <- httr2::resp_body_json(resp, simplifyVector = TRUE, flatten = FALSE)
  } else {
    r <- resp
  }

  if (any(lengths(r$errors) > 1)) {
    if (is.data.frame(r$errors[[1]])) {
      errors <- r$errors
    } else {
      errors <- do.call(rbind, lapply(r$errors, list2DF))
    }
  }  else {
    errors <- r$errors
  }

  if (has_name_(errors, "message")) {
    return(errors$message)
  }
  if (has_name_(errors, "title")) {
    return(paste0(errors$title, " with value: ", errors$value))
  }
}

# Prepare the requests ####
# General function to create the requests for Twitter API v2 with retry limits
# and error handling
req_v2 <- function(scopes) {
  client <- client_get()
  scopes_client <- client_scopes(client)
  req <- httr2::request("https://api.twitter.com/2")
  req_agent <- httr2::req_user_agent(req, "rtweet (https://docs.ropensci.org/rtweet)")
  # req_authorized <- req_auth(req_agent, token)
  check_scopes(scopes_client, scopes)
  # httr2 looks for this path.
  withr::local_envvar(HTTR2_OAUTH_CACHE = auth_path())
  req_authorized <- httr2::req_oauth_auth_code(req_agent,
                             client = client,
                             auth_url = "https://twitter.com/i/oauth2/authorize",
                             pkce = TRUE,
                             scope = paste(scopes_client, collapse = " "),
                             redirect_uri = "http://127.0.0.1:1410",
                             cache_disk = TRUE
                             # redirect_uri = "http://localhost:1410"
  )

  req_content <- httr2::req_headers(req_authorized,
                             `Content-type` = "application/json")
  req_try <- httr2::req_retry(req_content,
                              is_transient = twitter_is_transient,
                              after = twitter_after)
  req <- httr2::req_error(req_try, is_error = httr2::resp_is_error, body = req_errors)
  req
}

twitter_is_transient <- function(resp) {
  httr2::resp_status(resp) %in% c(403, 503) &&
    identical(httr2::resp_header(resp, "x-rate-limit-remaining"), "0")
}

twitter_after <- function(resp) {
  when <- as.numeric(httr2::resp_header(resp, "x-rate-limit-reset"))
  when - unclass(Sys.time())
}


endpoint_v2 <- function(path, throttle, scopes) {

  req <- httr2::req_url_path_append(req_v2(scopes), path)
  httr2::req_throttle(req, throttle, realm = path)
}

# Help with the arguments of the requests ####
prepare_params <- function(x) {
  lapply(x, paste0, collapse = ",")
}

check_rate <- function(token, rate_app, rate_user) {
  switch(is(token),
         rtweet_bearer = rate_app,
         httr2_token =  rate_user,
         NULL)
}

# Function to set fields and expansions:
#  - NA is reference (aka, all possibilities via set_*)
#  - NULL is NULL
#  - other are the ones provided via argument
arg_def <- function(argument, reference) {

  if (length(argument) >= 1 && !anyNA(argument)) {
    return(argument)
  }

  if (is.null(argument)) {
    return(NULL)
  }

  reference
}

test_that("multiplication works", {
  expect_null(arg_def(NULL, "b"))
  expect_equal(arg_def(NA, "b"), "b")
  expect_equal(arg_def(NA_character_, "b"), "b")
  expect_equal(arg_def(c("a", "b"), "b"), c("a", "b"))
  arg <- list("a" = letters[1:2], "b" = letters[2:3])
  expect_equal(arg_def(arg, "b"), arg)
})

#' Capture an image of a tweet/thread
#'
#' Provide a status id or a full Twitter link to a tweet and this function
#' will capture an image of the tweet --- or tweet + thread (if there are
#' Twitter-linked replies) --- from the mobile version of said tweet/thread.
#'  `r lifecycle::badge("deprecated")`
#'
#' For this to work, you will need to ensure the packages in `Suggests:` are
#' installed as they will be loaded upon the first invocation of this function.
#'
#' Use the `zoom` factor to get more pixels which may improve the text rendering
#' of the tweet/thread.
#'
#' @param statusid_or_url a valid Twitter status id (e.g. "`947082036019388416`") or
#'     a valid Twitter status URL (e.g. "`https://twitter.com/jhollist/status/947082036019388416`").
#' @param zoom a positive number >= 1. See the help for `[webshot::webshot()]` for more information.
#' @param scale auto-scale the image back to 1:1? Default it `TRUE`, which means `magick`
#'     will be used to return a "normal" sized tweet. Set it to `FALSE` to perform your
#'     own image manipulation.
#' @return `magick` object
#' @export
#' @seealso [`rtweet-deprecated`]
#' @examples
#' \dontrun{
#' if (auth_has_default()) {
#'     shot1 <- tweet_shot("947061504892919808")
#'     plot(shot1)
#'     shot2 <- tweet_shot("https://twitter.com/ma_salmon/status/947061504892919808")
#'     plot(shot2)
#' }
#' }
tweet_shot <- function(statusid_or_url, zoom = 3, scale = TRUE) {
  lifecycle::deprecate_warn("1.0.0", "tweet_shot()",
                            details = "The resulting image might not have a screenshot of the tweet")
  check_installed(c("magick", "webshot"))

  statusid_or_url <- statusid_or_url[1]
  zoom <- zoom[1]
  scale <- scale[1]

  if (zoom <= 1) {
    stop("zoom must be a positive number, >= 1", call. = FALSE)
  }
  if (!is_logical(scale)) {
    stop("scale must be TRUE/FALSE", call. = FALSE)
  }

  x <- statusid_or_url

  ## first test if we have a Twitter URL
  is_url <- grepl("^http[s]://", x)

  if (is_url) {

    ## should have "twitter" in it
    is_twitter <- grepl("twitter", x)
    if (!is_twitter) {
      stop("statusid_or_url must be a valid Twitter status id or URL",
        call. = FALSE)
    }

    ## shld also have "status" in it
    is_status <- grepl("status", x)
    if (!is_status) {
      stop("statusid_or_url must be a valid Twitter status id or URL",
        call. = FALSE)
    }

    ## if it's not a mobile status, make it one
    already_mobile <- grepl("://mobile\\.", x)
    if (!already_mobile) {
      x <- sub("://twi", "://mobile.twi", x)
    }

  } else {

    ## let's see if it's a status id
    x <- rtweet::lookup_tweets(x)
    if (!(nrow(x) > 0)) {
      stop("Twitter status not found", call. = FALSE)
    }

    ## make a mobile URL
    x <- sprintf("https://mobile.twitter.com/%s/status/%s",
                 users_data(x)$screen_name, x$id_str)

  }

  ## keep the filesystem clean
  tf <- tempfile(fileext = ".png")
  ## it'll clean up for us
  on.exit(unlink(tf), add = TRUE)

  ## capture the tweet
  webshot::webshot(url = x, file = tf, zoom = zoom)

  ## read the image in
  img <- magick::image_read(tf)
  ## remove the extraneous border
  img <- magick::image_trim(img)

  ## scale if we want to
  if ((zoom > 1) && (scale)) {
    img <- magick::image_scale(img, as_percent(1/zoom))
  }

  ## return img
  img
}

as_percent <- function(x) {
  paste0(round(x * 100), "%")
}

vcr::use_cassette("tweet_shot2", {
  test_that("tweet_shot", {
    skip_on_ci()
    skip_if_not(webshot::is_phantomjs_installed())
    skip_if_offline()

    expect_warning(tw <- tweet_shot("https://twitter.com/PeerCommunityIn/status/1593171041341575168"))
    expect_equal(class(tw), "magick-image")
    expect_equal(length(tw), 1L)

    expect_warning(tw2 <- tweet_shot("1593171041341575168"))
    expect_equal(class(tw2), "magick-image")
    expect_equal(length(tw2), 1L)
    expect_true(all.equal(tw, tw2))
  })
})

test_that("tweet_shot correct image", {
  skip_on_ci()
  skip_if_not(webshot::is_phantomjs_installed())

  skip("requires visual check")

  vcr::use_cassette("tweet_shot3", {
    tw <- rtweet::tweet_shot("https://twitter.com/PeerCommunityIn/status/1593171041341575168")
  })
})

#' Blocking or unblocking twitter users
#'
#' `user_block(...)` blocks or unblocks a target twitter user.
#' `user_unblock(...)` is synonymous to `user_block(..., unblock=TRUE)`.
#' `r lifecycle::badge("deprecated")`
#'
#' @inheritParams get_timeline
#' @param unblock Logical indicating whether to unblock the intended
#'   friend.
#' @aliases user_unblock
#' @seealso [`rtweet-deprecated`]
#' @export
#' @references
#' Block: <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/mute-block-report-users/api-reference/post-blocks-create>
user_block <- function(user,
                      unblock = FALSE,
                      token = NULL) {

  stopifnot(is.atomic(user) || is.null(user), is_logical(unblock))

  if (!unblock) {
    query <- "/1.1/blocks/create"
    params <- list()
  } else {
    query <- "/1.1/blocks/destroy"
    params <- list()
  }
  params[[user_type(user)]] <- user

  TWIT_post(token, query, params)
}


#' @rdname user_block
#' @export
user_unblock <- function(user, token = NULL) {
  user_block(user, unblock = TRUE, token = token)
}

test_that("blocking and unblocking users", {
  skip_if_offline()
  pf <- user_block("s_hesz")
  expect_equal(httr::status_code(pf), 200L)

  # unblocking
  pf <- user_unblock("s_hesz")
  expect_equal(httr::status_code(pf), 200L)
})

# Needs a user account
test_that("blocking works", {
  skip("requires manual testing")
  # Use other account to block the user
  b <- user_block("Lluis_Revilla")
  expect_equal(httr::status_code(b), 200L)
  a <- user_unblock("Lluis_Revilla")
  expect_equal(httr::status_code(a), 200L)
})

#' Get tweets data for given statuses (status IDs).
#'
#' `r lifecycle::badge("deprecated")`
#' @inheritParams lookup_users
#' @inheritParams stream
#' @param statuses User id or screen name of target user.
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/get-statuses-lookup>
#' @return A tibble of tweets data.
#' @family tweets
#' @seealso [tweet_search_recent()], [`rtweet-deprecated`]
#' @export
lookup_tweets <- function(statuses, parse = TRUE, token = NULL,
                          retryonratelimit = NULL, verbose = TRUE) {
  # Prevents problems if someone passes a full table.
  if (is.data.frame(statuses)) {
    statuses <- ids(statuses)
  }
  chunks <- unname(split(statuses, (seq_along(statuses) - 1) %/% 100))
  params_list <- lapply(chunks, function(id) {
    list(
      id = paste(id, collapse = ","),
      tweet_mode = "extended",
      include_ext_alt_text = "true"
    )
  })

  results <- TWIT_paginate_chunked(token, "/1.1/statuses/lookup", params_list,
    retryonratelimit = retryonratelimit,
    verbose = verbose
  )

  if (parse) {
    results <- tweets_with_users(results)
    results$created_at <- format_date(results$created_at)
    # Reorder to match input, skip NA if the status is not found.
    m <- match(statuses, results$id_str)
    m <- m[!is.na(m)]
    results <- results[m, ]
    attr(results, "users") <- users_data(results)[m, ]
  }
  results
}

#' @export
#' @rdname lookup_tweets
#' @usage NULL
lookup_statuses <- function(statuses, parse = TRUE, token = NULL) {
  lifecycle::deprecate_warn("1.0.0", "lookup_statuses()", "lookup_tweets()")

  lookup_tweets(statuses = statuses, parse = parse, token = token)
}

#' Get tweet information
#'
#' Look up tweets up to 100 at the same time.
#' @inheritParams tweet_retweeted_by
#' @inheritParams stream
#' @param token This endpoint accepts a OAuth2.0 authentication (can be
#' created via [rtweet_oauth2()]) or a bearer token (can be created via [rtweet_app()]).
#' @param id At least a tweet id.
#' @seealso [lookup_tweets()]
#' @references
#' One tweet: <https://developer.twitter.com/en/docs/twitter-api/tweets/lookup/api-reference/get-tweets-id>
#'
#' Multiple tweets: <https://developer.twitter.com/en/docs/twitter-api/tweets/lookup/api-reference/get-tweets>
#' @export
#' @examples
#' if (FALSE){
#'  tweet_get("567053242429734913", parse = FALSE)
#'  tweet_get(c("567053242429734913", "567053242429734913"), parse = FALSE)
#'  tweet_get(c("567053242429734913", "567053242429734913"), parse = TRUE)
#' }
tweet_get <- function(id, expansions = NULL, fields = NULL, ..., token = NULL,
                      parse = TRUE, verbose = FALSE) {
  expansions <- check_expansions(
    arg_def(expansions,
            set_expansions(user = NULL, list = NULL)),
    set_expansions(user = NULL, list = NULL))
  fields <- check_fields(arg_def(fields, set_fields(list = NULL)),
                         metrics = NULL, list = NULL)
  expansions_for_fields(expansions, fields)
  parsing(parse, expansions, fields)
  data <- c(list(expansions = expansions), fields, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  stopifnot("Requires valid ids." = is_id(id))
  if (length(id) == 1) {
    url <- paste0("tweets/", id)
  } else if (length(id) <= 100 ) {
    data <- c(ids = paste(id, collapse = ","), data)
    url <- "tweets"
  } else {
    abort("Only 100 tweets can be processed at once.")
  }

  # Rates from the website app and user limits
  req_archive <- endpoint_v2(url, 900 / (60 * 15), c("tweet.read", "users.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, 1, length(ids), verbose = verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}


#' Post a tweet
#'
#' This function uses the API v2 to post tweets.
#' @param text Text of the tweet.
#' @param ... Other accepted arguments.
#' @inheritParams tweet_get
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/tweets/manage-tweets/api-reference/post-tweets>
#' @examples
#' if (FALSE) {
#'  # It requires the Oauth2.0 Authentication
#'   tp_id <- tweet_post("Posting from #rtweet with the basic plan")
#'   tweet_post()
#' }
tweet_post <- function(text, ..., token = NULL) {
  # To store the token at the right place: see ?httr2::oauth_cache_path
  withr::local_envvar(HTTR2_OAUTH_CACHE = auth_path())
  options <- list(text = text, ...)

  if (sum(c("media", "quote_tweet_id", "poll") %in% names(options) ) > 1) {
    abort(c("media and quoting a tweet are excluse",
            i = "Chose one or the other."))
  }

  if ("for_super_followers_only" %in% names(options) && !is_logical(options[["for_super_followers_only"]])) {
      abort("Provide only TRUE or FALSE for 'for_super_followers_only'")
  }
  if (check_reply_settings(options)) {
    abort(c("Provide a valid reply_setting option:",
          i = "If not provided it is open to everybody, or choose from:",
          "*" = "mentionedUsers",
          "*" = "following"
          ))
  }

  # Rates from the website app and user limits
  req_archive <- endpoint_v2("tweets", 200/(60*15), c("tweet.read", "users.read", "tweet.write"))
  req_final <- httr2::req_body_json(req_archive, options)
  resp <- httr2::req_perform(req_final)
  r <- resp(resp)
  parse(r, NULL, NULL)
}

check_reply_settings <- function(options) {
  included <- "reply_settings" %in% options
  length1 <- length(options[["reply_settings"]]) > 1
  valid <- options[["reply_settings"]] %in% c("mentionedUsers")
  included && length1 && valid
}

#' Delete tweet
#'
#' Will delete a tweet
#' @inheritParams tweet_get
#' @seealso [tweet_post()], [tweet_search_recent()], [user_timeline()]
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/tweets/manage-tweets/api-reference/delete-tweets-id>
tweet_delete <- function(id, verbose = FALSE, token = NULL) {
  # To store the token at the right place: see ?httr2::oauth_cache_path
  withr::local_envvar(HTTR2_OAUTH_CACHE = auth_path())
  stopifnot("Requires valid ids." = is_id(id))
  if (length(id) == 1) {
    url <- paste0("tweets/", id)
  }  else {
    abort("Only 1 tweets can be processed at once.")
  }

  # Rates from the website app and user limits
  req_archive <- endpoint_v2(url, 50 / (60 * 15),
                             c("tweet.read", "users.read", "tweet.write"))
  req_final <- httr2::req_url_query(req_archive)

  r <- httr2::req_perform(httr2::req_method(req_final, "DELETE"))
  resp <- resp(r)
  resp$data$deleted
}



#' Get quoted tweet information
#'
#' Look up tweets quoting that tweet id.
#' @inheritParams tweet_get
#' @inheritParams tweet_search_recent
#' @param id At least a tweet id.
#' @references
#' One tweet: <https://developer.twitter.com/en/docs/twitter-api/tweets/quote-tweets/api-reference/get-tweets-id-quote_tweets>
#' @export
#' @examples
#' if (FALSE){
#'  tweet_quoted("1631945769748930561", parse = FALSE)
#' }
tweet_quoted <- function(id, n = 100, expansions = NULL, fields = NULL, ..., token = NULL,
                         parse = TRUE, verbose = FALSE) {
  expansions <- check_expansions(arg_def(expansions, set_expansions(list = NULL)))
  fields <- check_fields(arg_def(fields, set_fields()), metrics = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  stopifnot(is_n(n))
  max_results <- check_interval(n, 10, formals()$n)
  n_pages <- ceiling(n / max_results)
  data <- c(list(expansions = expansions), fields, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- c(max_results = max_results, data)
  data <- data[data != ""]

  stopifnot("Requires valid ids." = is_id(id))
  if (length(id) == 1) {
    url <- paste0("tweets/", id, "/quote_tweets")
  } else {
    abort("Only 1 tweet can be processed at once.")
  }

  # Rates from the website app and user limits
  req_archive <- endpoint_v2(url, 75 / (60 * 15), c("tweet.read", "users.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, n_pages, n, verbose = verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

test_that("tweet works with withheld_* #647", {
  
  vcr::use_cassette("lookup_tweets", {
    lu <- rtweet::lookup_tweets("1168343686863892480")
  })
  expect_true(is.data.frame(lu))
  expect_true(lu$withheld_copyright)
  expect_equal(lu$withheld_in_countries, list("XY"))
  expect_equal(lu$withheld_scope, "status")
})

#' Favorites target status id.
#'
#' `r lifecycle::badge("deprecated")`
#' @inheritParams lookup_users
#' @param status_id Status id of target tweet.
#' @param destroy Logical indicating whether to post (add) or
#'   remove (delete) target tweet as favorite.
#' @param include_entities Logical indicating whether to
#'   include entities object in return.
#' @aliases post_favourite favorite_tweet
#' @family post
#' @seealso [`rtweet-deprecated`]
#' @export
#' @references
#' Create: <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/post-favorites-create>
#' Destroy: <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/post-favorites-destroy>
post_favorite <- function(status_id,
                          destroy = FALSE,
                          include_entities = FALSE,
                          token = NULL) {

  stopifnot(is.atomic(status_id) && !is.null(status_id))

  if (destroy) {
    query <- "/1.1/favorites/destroy"
  } else {
    query <- "/1.1/favorites/create"
  }

  params <- list(id = status_id)
  TWIT_post(token, query, params)
}

#' Network data
#'
#' Retrieve data to know which users are connected to which users.
#' `r lifecycle::badge("deprecated")`
#'
#' @description
#' * `network_data()` returns a data frame that can easily be converted to
#'    various network classes.
#' * `network_graph()` returns a igraph object
#'
#' @param x Data frame returned by rtweet function
#' @param e Type of edge/link–i.e., "mention", "retweet", "quote", "reply".
#'   This must be a character vector of length one or more. This value will be
#'   split on punctuation and space (so you can include multiple types in the
#'   same string separated by a comma or space). The values "all" and
#'   "semantic" are assumed to mean all edge types, which is equivalent to the
#'   default value of `c("mention", "retweet", "reply", "quote")`
#' @return A from/to data edge data frame
#' @seealso [network_graph()] [`rtweet-deprecated`]
#' @export
network_data <- function(x, e = c("mention", "retweet", "reply", "quote")) {
  if (isTRUE(e) || (length(e) == 1 && e %in% c("semantics", "all"))) {
    e <- c("mention", "retweet", "reply", "quote")
  }

  stopifnot(is.character(e))
  y <- users_data(x)

  ids <- character()
  screen_names <- character()
  if ("mention" %in% e) {
    user_mentions <- lapply(x$entities, function(x){
      if (has_name_(x, "user_mentions")) {
        y <- x$user_mentions
        if (length(y$id_str) > 1 || !is.na(y$id_str)) {
          return(y[, c("screen_name", "id_str")])
        }
      }
    NULL
    })
    k <- vapply(user_mentions, is.null, logical(1L))
    # If no mention skip
    if (!all(k)) {


    r <- do.call(rbind, user_mentions[!k])


    ids <- c(ids, r$id_str, y[!k, "id_str", drop = TRUE])
    screen_names <- c(screen_names, r$screen_name, y[!k, "screen_name", drop = TRUE])

    mention <- data.frame(from = rep(y[!k, "id_str", drop = TRUE], times = vapply(user_mentions[!k], nrow, numeric(1L))),
                        to = r$id_str,
                        type = "mention")
    } else {
      mention <- data.frame(from = NA, to = NA, type = NA)[0, , drop = FALSE]
    }
  } else {
    mention <- data.frame(from = NA, to = NA, type = NA)[0, , drop = FALSE]
  }

  if ("retweet" %in% e) {
    retweet0 <- data.frame(from = NA, to = NA, type = NA)[0, , drop = FALSE]
    # Retweets are those that the text start with RT and a mention but are not quoted
    retweets <- startsWith(x$text, "RT @")
    if (any(retweets)) {
      r <- x[retweets, ]
      yr <- y[retweets, ]

      user_mentions <- lapply(r$entities, function(x){
        y <- x$user_mentions
        # Pick the first mention that is the one the tweet is quoting
        # Example: 1390785143615467524
        return(y[y$indices$start == 3, c("screen_name", "id_str")])
      })

      um <- do.call(rbind, user_mentions)
      ur <- yr[, c("screen_name", "id_str")]

      # remove content from deleted users
      um_r <- vapply(user_mentions, nrow, numeric(1L))
      removed_users <- which(um_r == 0)
      for (i in seq_along(ur$id_str)) {
        if (i %in% removed_users) {
          to_id <- NA_character_
          to_screen_name <- NA_character_
        } else {
          to_id <- um$id_str[i]
          to_screen_name <- um$screen_name[i]
        }

        ids <- c(ids, ur$id_str[i], to_id)
        screen_names <- c(screen_names, ur$screen_name[i], to_screen_name)

        retweet <- data.frame(from = ur$id_str[i],
                              to = to_id,
                              type = "retweet")
        retweet0 <- rbind(retweet0, retweet)
      }
    }
    retweet <- retweet0
  } else {
    retweet <- data.frame(from = NA, to = NA, type = NA)[0, , drop = FALSE]
  }

  if ("reply" %in% e && !all(is.na(x$in_reply_to_user_id_str))) {
    reply_keep <- !is.na(x$in_reply_to_user_id_str)

    ids <- c(ids, y[["id_str"]][reply_keep], x[["in_reply_to_user_id_str"]][reply_keep])
    screen_names <- c(screen_names, y[["screen_name"]][reply_keep], x[["in_reply_to_screen_name"]][reply_keep])

    reply <- data.frame(from = y[["id_str"]][reply_keep],
                        to = x[["in_reply_to_user_id_str"]][reply_keep],
                        type = "reply")

  } else {
    reply <- data.frame(from = NA, to = NA, type = NA)[0, , drop = FALSE]
  }
  if ("quote" %in% e && !all(is.na(x$is_quote_status))) {
    r <- x[x$is_quote_status, ]
    yr <- y[x$is_quote_status, c("screen_name", "id_str")]
    # Quotes are from users on entities$user_mentions whose indices start at 3

    if (is.data.frame(r$quoted_status$user)) {
      um <- r$quoted_status$user[, c("screen_name", "id_str")]
    } else {
      user_mentions <- lapply(r$quoted_status$user, function(x){
        # Pick the first mention that is the one the tweet is quoting
        # Example: 1390785143615467524
        return(x[, c("screen_name", "id_str")])
      })
      um <- do.call(rbind, user_mentions)
    }
    ums <- is.na(um[, 1])
    if (!is.null(nrow(ums))) {
      um <- um[!ums, ]
      yr <- yr[!ums, ]
      ids <- c(ids, um$id_str, yr$id_str)
      screen_names <- c(screen_names, um$screen_name, yr$screen_name)

      quote <- data.frame(from = um$id_str,
                          to = yr$id_str,
                          type = "quote")
    } else {
      quote <- data.frame(from = NA, to = NA, type = NA)[0, , drop = FALSE]
    }
  } else {
    quote <- data.frame(from = NA, to = NA, type = NA)[0, , drop = FALSE]
  }

  out <- rbind(mention, retweet, reply, quote)
  out <- out[!is.na(out$type), ]

  idsn <- data.frame(id = ids, sn = screen_names)
  idsn <- unique(idsn)
  stopifnot(all(out$from %in% idsn$id))
  stopifnot(all(out$to %in% idsn$id))
  attr(out, "idsn") <- as.list(idsn)
  out
}


#' @return An igraph object
#' @rdname network_data
#' @export
network_graph <- function(x, e = c("mention", "retweet", "reply", "quote")) {
  check_installed("igraph")
  nd <- network_data(x = x, e = e)
  idsn <- attr(nd, "idsn")
  g <- igraph::make_empty_graph(n = 0, directed = TRUE)
  g <- igraph::add_vertices(g, length(idsn$id),
    attr = list(id = idsn$id, name = idsn$sn))
  edges <- rbind(match(nd[[1]], idsn$id), match(nd[[2]], idsn$id))
  igraph::add_edges(g, edges, attr = list(type = nd[[3]]))
}

# Status (no retweet, no reply no quote)
test_that("network_data on status", {

  vcr::use_cassette("graph-network1", {
    status <- lookup_tweets("1333789433288540160")
    nd <- network_data(status, "mention")
  })
  expect_s3_class(nd, "data.frame")
})

# Reply (no quote no retweet)
test_that("network_data on reply", {

  vcr::use_cassette("graph-network2", {
    reply <- lookup_tweets("1333789435482161153")
    nd <- network_data(reply, "reply")
    })
  expect_s3_class(nd, "data.frame")
  })

# Retweet with other tweet embedded quoting
test_that("network_data on retweet quoting", {

  vcr::use_cassette("graph-network3", {
    retweet_quoted <- lookup_tweets("1390610121743556609")
  })
  nd <- network_data(retweet_quoted, "quote")
  expect_s3_class(nd, "data.frame")
})

# Retweet without adding anything new
test_that("network_data on retweet", {

  vcr::use_cassette("graph-network4", {
    retweet <- lookup_tweets("1390785143615467524")
    nd_retweet <- network_data(retweet, "retweet")
  })
  expect_s3_class(nd_retweet, "data.frame")
})


test_that("network_data on many", {

  vcr::use_cassette("graph-network5", {
    status <- lookup_tweets(c("1333789433288540160", "1333789435482161153",
                              "1390610121743556609", "1390785143615467524"))
    nd <- network_data(status)
  })
  expect_s3_class(nd, "data.frame")
})


test_that("graphing functions work", {
  skip_if_not_installed("igraph")
  vcr::use_cassette("graph-network6", {
    x <- search_tweets("twitter filter:verified")
    d <- network_data(x)
  })
  expect_true(
    is.data.frame(d)
  )
  expect_gt(nrow(d), 1)
  expect_equal(ncol(d), 3)
  g <- network_graph(x)
  expect_true(
    inherits(g, "igraph")
  )

})


# https://twitter.com/henrikbengtsson/status/1390403676057980928
test_that("network_data works", {

  vcr::use_cassette("graph-network7", {
    rstats <- search_tweets("#rstats", n = 20)
    ## create from-to data frame representing retweet/mention/reply connections
    rstats_net <- network_data(rstats, c("retweet","mention","reply"))
  })
  expect_s3_class(rstats_net, "data.frame")
  expect_equal(colnames(rstats_net), c("from", "to", "type"))
})

test_that("network_graph works", {
  skip_if_not_installed("igraph")
  vcr::use_cassette("graph-network8", {
    rstats <- search_tweets("#rstats", n = 20)

    ## create from-to data frame representing retweet/mention/reply connections
    rstats_net <- network_graph(rstats)
  })
  expect_s3_class(rstats_net, "igraph")
})

test_that("Network data works even with no retweet, #696", {

  vcr::use_cassette("graph-network9", {
    th10 <- tweet_threading("1256278649600225280", traverse = "backwards")
  })
  expect_error(nd <- network_data(th10), NA)
})

test_that("Network data works even retweet of deleted users, #730", {

  vcr::use_cassette("graph-network10", {
    tweets <- lookup_tweets(c("1423938851492536320", "1416464850742661122"))
  })
  expect_error(nd <- network_data(tweets), NA)
})

#' Find followers.
#'
#' List of users that follow the specified user ID.
#' @inheritParams filtered_stream
#' @param ... Other arguments passed to the API.
#' @param n Number of tweets to query.
#' @param verbose A logical value to provide more information about paginated queries.
#' @param id A user id string.
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/users/follows/api-reference/get-users-id-followers>
#' @examples
#' if (FALSE) {
#'   uf <- user_followers("1599030512919650304", verbose = TRUE)
#' }
user_followers <- function(id, n = 100, expansions = NULL, fields = NULL, ...,
                           token = NULL, parse = TRUE, verbose = FALSE) {

  expansions <- check_expansions(arg_def(expansions, "pinned_tweet_id"),
                                 "pinned_tweet_id")
  fields <- check_fields(arg_def(fields, set_fields(media = NULL,
                                                    poll = NULL,
                                                    place = NULL)),
                         metrics = NULL, place = NULL, poll = NULL, media = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  stopifnot(is_n(n))
  if (length(id) != 1 || !is_user_id(id)) {
    abort("Please introduce a single valid user id")
  }
  data <- c(list(expansions = expansions), fields, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  url <- paste0("users/", id, "/followers")

  max_results <- check_interval(n, 1, formals()$n)
  n_pages <- ceiling(n / max_results)
  data <- c(max_results = max_results, data)

  # Rates from the website app and user limits
  token <- check_token_v2(token, c("bearer", "pkce"))
  check_scopes_token(token,  c("tweet.read", "users.read", "follows.read"))
  req_archive <- endpoint_v2(url, 15/(60*15),  c("tweet.read", "users.read", "follows.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, n_pages, n, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

#' Extract methods
#'
#' Extract entities of the tweets linked to a tweet id.
#'
#' The position of where does this occur is not provided.
#' @param x A tweets object of the rtweet package.
#' @param entity A entity to extract data from.
#' @param ... Other possible arguments currently ignored.
#' @return Some information about those entities and the tweet id it comes from.
#' for users mentions the ids of the mentioned users are "user_id", "user_id_str"
#' (not "id_str")
#' @export
entity <- function(x, entity, ...) {
  UseMethod("entity")
}

#' @export
entity.default <- function(x, entity, ...) {
  entity <- match.arg(entity, c("urls", "hashtags", "symbols",
                                "user_mentions", "media"))
  l <- lapply(x, function(x){x[[entity]]})
  l
}


#' @export
entity.tweets <- function(x, entity, ...) {
  entity <- match.arg(entity, c("urls", "hashtags", "symbols",
                                "user_mentions", "media"))

  out <- .entity(x, entity)

  if (entity == "user_mentions") {
    colnames(out) <- c("id_str", "screen_name", "name", "user_id", "user_id_str")
  }
  out
}

.entity <- function(x, name = "urls") {
  ids <- ids(x)
  ent <- lapply(x$entities, function(x) {list_minus(x[[name]], "indices")})
  n_ent <- vapply(ent, NROW, numeric(1L))
  ids <- rep(ids, n_ent)
  ent <- do.call(rbind, ent)
  cbind.data.frame(id_str = ids, ent)
}

#' Get tweets data on statuses identified via search query.
#'
#' Returns Twitter statuses matching a user provided search
#' query. `r lifecycle::badge("deprecated")`
#'
#' @param q Query to be searched, used to filter and select tweets to
#'   return from Twitter's REST API. Must be a character string not to
#'   exceed maximum of 500 characters. Spaces behave like boolean
#'   "AND" operator. To search for tweets containing at least one of
#'   multiple possible terms, separate each search term with spaces
#'   and "OR" (in caps). For example, the search `q =
#'   "data science"` looks for tweets containing both "data" and
#'   "science" located anywhere in the tweets and in any order.
#'   When "OR" is entered between search terms, `query =
#'   "data OR science"`, Twitter's REST API should return any tweet
#'   that contains either "data" or "science." It is also possible to
#'   search for exact phrases using double quotes. To do this, either
#'   wrap single quotes around a search query using double quotes,
#'   e.g., `q = '"data science"'` or escape each internal double
#'   quote with a single backslash, e.g., `q =
#'   "\"data science\""`.
#'
#' Some other useful query tips:
#'
#' \itemize{
#'   \item Exclude retweets via `"-filter:retweets"`
#'   \item Exclude quotes via `"-filter:quote"`
#'   \item Exclude replies via `"-filter:replies"`
#'   \item Filter (return only) verified via `"filter:verified"`
#'   \item Exclude verified via `"-filter:verified"`
#'   \item Get everything (firehose for free) via `"-filter:verified OR filter:verified"`
#'   \item Filter (return only) tweets with links to news articles via `"filter:news"`
#'   \item Filter (return only) tweets with media `"filter:media"`
#' }
#'
#' @inheritParams TWIT_paginate_max_id
#' @inheritParams stream
#' @param type Character string specifying which type of search
#'   results to return from Twitter's REST API. The current default is
#'   `type = "recent"`, other valid types include `type =
#'   "mixed"` and `type = "popular"`.
#' @param geocode Geographical limiter of the template
#'   "latitude,longitude,radius" e.g., `geocode =
#'   "37.78,-122.40,1mi"`.
#' @param include_rts Logical, indicating whether to include retweets
#'   in search results. Retweets are classified as any tweet generated
#'   by Twitter's built-in "retweet" (recycle arrows) function. These
#'   are distinct from quotes (retweets with additional text provided
#'   from sender) or manual retweets (old school method of manually
#'   entering "RT" into the text of one's tweets).
#' @param ... Further arguments passed as query parameters in request
#'   sent to Twitter's REST API. To return only English language
#'   tweets, for example, use `lang = "en"`. For more options see
#'   Twitter's API documentation.
#' @details Twitter API documentation recommends limiting searches to
#'   10 keywords and operators. Complex queries may also produce API
#'   errors preventing recovery of information related to the query.
#'   It should also be noted Twitter's search API does not consist of
#'   an index of all Tweets. At the time of searching, the search API
#'   index includes between only 6-9 days of Tweets.
#' @return List object with tweets and users each returned as a
#'   data frame.
#' @family tweets
#' @seealso [tweet_search_recent()], [tweet_search_all()], [`rtweet-deprecated`]
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/search/api-reference/get-search-tweets>
search_tweets <- function(q, n = 100,
                          type = c("mixed", "recent", "popular"),
                          include_rts = TRUE,
                          geocode = NULL,
                          since_id = NULL,
                          max_id = NULL,
                          parse = TRUE,
                          token = NULL,
                          retryonratelimit = NULL,
                          verbose = TRUE,
                          ...) {
  stopifnot(is_n(n))
  params <- search_params(q,
    type = type,
    include_rts = include_rts,
    geocode = geocode,
    ...
  )

  result <- TWIT_paginate_max_id(token, "/1.1/search/tweets", params,
    get_id = function(x) x$statuses$id_str,
    page_size = 100,
    n = n,
    since_id = since_id,
    max_id = max_id,
    retryonratelimit = retryonratelimit,
    verbose = verbose
  )

  if (parse) {
    tweets <- lapply(result, "[[", "statuses")
    result <- tweets_with_users(tweets)
    result$created_at <- format_date(result$created_at)
  }
  result
}

search_params <- function(q,
                          type = c("mixed", "recent", "popular"),
                          include_rts = TRUE,
                          geocode = NULL,
                          max_id = NULL,
                          ...) {
  if (missing(q) && !is.null(geocode)) {
    q <- ""
  }
  stopifnot(is.atomic(q) && !is.null(q) && length(q) == 1L,
            is.atomic(max_id) && length(max_id) <= 1L)
  stopifnot(is.atomic(q), length(q) == 1L, is.atomic(max_id))
  type <- arg_match(type)

  ## validate query length–char count might not always be same here as with
  ## Twitter, so set this to 600 and let Twitter reject others
  if (nchar(q) > 600) {
    stop("q cannot exceed 600 characters.", call. = FALSE)
  }
  if (!include_rts) {
    q <- paste0(q, " -filter:retweets")
  }

  if (!is.null(geocode) && inherits(geocode, "coords")) {
    mls1 <- abs(geocode$box[2] - geocode$box[4]) * 69
    mls2 <- abs(geocode$box[1] - geocode$box[3]) *
      (69 - abs(.093 * geocode$point[1])^2)
    mls <- (mls1/1.8 + mls2/1.8) / 1.8
    mls <- round(mls, 3)
    geocode <- paste0(paste(geocode$point, collapse = ","), ",", mls, "mi")
  }

  list(
    q = q,
    result_type = type,
    max_id = max_id,
    tweet_mode = "extended",
    include_ext_alt_text = "true",
    geocode = geocode,
    ...
  )
}



#' Search tweets (vectorized)
#'
#' search_tweets2 Passes all arguments to search_tweets. Returns data from
#' one OR MORE search queries.
#' `r lifecycle::badge("deprecated")`
#'
#' @return A tbl data frame with additional "query" column.
#' @rdname search_tweets
#' @seealso [tweet_search_recent()], [`rtweet-deprecated`]
#' @export
search_tweets2 <- function(...) {
  dots <- match_fun(list(...), "search_tweets")
  q <- dots[["q"]]
  dots[["q"]] <- NULL
  ## is parse = TRUE?
  parse <- dots[["parse"]]
  ## search for each string in column of queries
  rt <- Map("search_tweets", q, MoreArgs = dots)
  ## if parse is false, return rt
  if (!parse) {
    return(rt)
  }
  ## deal with queries that returned zero tweets
  kp <- lengths(rt) > 0L
  if (sum(kp, na.rm = TRUE) == 0L) return(data.frame())
  rt <- rt[kp]
  q <- q[kp]
  ## add query variable to data frames
  rt <- Map("add_var", rt, query = q)
  ## merge users data into one data frame
  do_call_rbind(rt)
}

add_var <- function(x, ...) {
  dots <- list(...)
  if (!is.null(names(dots))) {
    varname <- names(dots)
  } else {
    varname <- deparse(substitute(...))
  }
  x[[varname]] <- unlist(dots, use.names = FALSE)
  x
}


match_fun <- function(dots, fun) {
  rfuns <- names(formals(fun))
  nms <- match(names(dots), rfuns)
  nms[names(dots) != ""] <- names(dots)[names(dots) != ""]
  is_na <- function(x) is.na(x) | x == "NA"
  nms[is_na(nms) & names(dots) == ""] <- names(
    formals(fun))[which(is_na(nms) & names(dots) == "")]
  names(dots) <- nms
  names(dots)[is.na(names(dots))] <- ""
  fmls <- formals(fun)
  dotsdots <- dots[!names(dots) %in% names(fmls)]
  dots <- dots[names(dots) %in% names(fmls)]
  fmls <- fmls[!names(fmls) %in% names(dots) & names(fmls) != "..."]
  c(dots, fmls, dotsdots)
}

test_that("search_tweets returns tweets data and latlng", {
  vcr::use_cassette("search_tweets", {
    df <- search_tweets("#rstats", n = 50)
  })
  expect_s3_class(df, "data.frame")
  expect_true(nrow(df) > 25) # should almost always be true

  # can extract lat_lng
  ll <- lat_lng(df)
  expect_equal(c("lat", "lng") %in% names(ll), c(TRUE, TRUE))
})

test_that("gives useful errors", {
  expect_snapshot(search_tweets(c(1:10), verbose = FALSE), error = TRUE)
  expect_snapshot(search_tweets("stats", type = "all"), error = TRUE)
})

test_that("non-existent search returns empty data frame", {

  vcr::use_cassette("search_tweets1", {
    tweets <- search_tweets("abcabcabcabcabcabcabcabcabcabcabcabcabcabcabcabc")
  })
  expect_s3_class(tweets, "data.frame")
  expect_equal(nrow(tweets), 0)
})

test_that("search_tweets2 can search for multiple queries", {

  vcr::use_cassette("search_tweets2", {
    df <- search_tweets2(c("#rstats", "open science"), n = 50)
  })
  expect_s3_class(df, "data.frame")
  expect_true(nrow(df) > 25) # should almost always be true
})

test_that("search_tweets uses POSIXct at created_at, #660", {

  vcr::use_cassette("search_tweets3", {
    df <- search_tweets2(c("#rstats", "open science"), n = 50)
  })
  expect_true(is(df$created_at, "POSIXct"))
})


test_that("search_tweets2 works", {
  vcr::use_cassette("search_tweets4", {
    st2 <- search_tweets2(c('"data science"', "rstats OR python"), n = 50)
  })
  expect_gte(nrow(st2), 100)
})

test_that("search_tweets", {
  vcr::use_cassette("search_tweets5", {
    st_lang <- search_tweets("advanced_recycling", include_rts = FALSE,
                          n = 1000, lang = "en")
  })

  expect_equal(nrow(st_lang), nrow(users_data(st_lang)))
})

#' Get Twitter trends data.
#'
#' `r lifecycle::badge("deprecated")`
#' @inheritParams lookup_users
#' @param woeid Numeric, WOEID (Yahoo! Where On Earth ID) or character
#'   string of desired town or country. Users may also supply latitude
#'   and longitude coordinates to fetch the closest available trends
#'   data given the provided location. Latitude/longitude coordinates
#'   should be provided as WOEID value consisting of 2 numeric values
#'   or via one latitude value and one longitude value (to the
#'   appropriately named parameters).  To browse all available trend
#'   places, see [trends_available()]
#' @param lat Optional alternative to WOEID. Numeric, latitude in
#'   degrees.  If two coordinates are provided for WOEID, this
#'   function will coerce the first value to latitude.
#' @param lng Optional alternative to WOEID. Numeric, longitude in
#'   degrees.  If two coordinates are provided for WOEID, this
#'   function will coerce the second value to longitude.
#' @param exclude_hashtags Logical, indicating whether or not to
#'   exclude hashtags. Defaults to FALSE--meaning, hashtags are
#'   included in returned trends.
#' @inheritParams stream
#' @return Tibble data frame of trends data for a given geographical area.
#' @family trends
#' @seealso [`rtweet-deprecated`]
#' @export
get_trends <- function(woeid = 1,
                       lat = NULL,
                       lng = NULL,
                       exclude_hashtags = FALSE,
                       token = NULL,
                       parse = TRUE) {

  if (inherits(woeid, "coords")) {
    lat <- woeid$point[1]
    lng <- woeid$point[2]
  } else if (is_latlng(woeid)) {
    lat <- woeid[1]
    lng <- woeid[2]
  }

  if (!is.null(lat) && !is.null(lng)) {
    stopifnot(maybe_n(lat), maybe_n(lng))
    woeid <- trends_closest(lat, lng, token = token)
    woeid <- as.character(woeid$woeid[1])
    if (length(woeid) == 0L || is.na(woeid)) {
      stop("could not find woe id for provided lat/lng coordinates", call. = FALSE)
    }
  } else {
    stopifnot(is.atomic(woeid) && !is.null(woeid), length(woeid) == 1)
    if (!is_n(woeid)) {
      trends <- trends_available(token = token)
      woeid <- trends$woeid[grep(woeid, trends$name, ignore.case = TRUE)[1]]
      if (length(woeid) == 0L || is.na(woeid)) {
        stop("Could not find trend data for that location", call. = FALSE)
      }
    }
    woeid <- check_woeid(woeid)
  }

  params <- list(
    id = woeid,
    exclude = if (exclude_hashtags) "hashtags"
  )

  gt <- TWIT_get(token, "/1.1/trends/place", params)
  if (parse) {
    gt <- parse_trends(gt)
  }
  gt
}


is_latlng <- function(x) {
  if (!is.numeric(x) || length(x) != 2L) return(FALSE)
  x[1] <= 90 && x[1] >= -90 && x[2] <= 180 && x[2] >= -180
}

trends_closest <- function(lat, long, token = NULL) {
  params <- list(lat = lat, long = long)
  TWIT_get(token, "/1.1/trends/closest", params)
}

parse_trends <- function(x) {
  if (!is.recursive(x) || !has_name_(x, "trends")) return(data.frame())
  locations <- x$locations[[1]]
  place <- var_or_na(locations$name)
  woeid <- var_or_na(locations$woeid)
  as_of <- format_trend_date(x$as_of)
  created_at <- format_trend_date(x$created_at)
  x <- x$trends[[1]]
  if (!is.data.frame(x)) {
    x <- as.data.frame(x, stringsAsFactors = FALSE)
  }
  names(x)[names(x) == "name"] <- "trend"
  x$place <- place
  x$woeid <- woeid
  x$as_of <- as_of
  x$created_at <- created_at
  tibble::as_tibble(x)
}

var_or_na <- function(x) {
  if (length(x) == 0L) return(NA_character_)
  x
}

format_trend_date <- function(x) {
  if (length(x) == 0L) return(as.POSIXct(NA_character_, tz = ""))
  if (all(is.na(x))) return(as.POSIXct(NA_character_, tz = ""))
  x <- as.POSIXct(x, format = "%Y-%m-%dT%H:%M:%SZ", tz = "")
  if (all(is.na(x))) return(as.POSIXct(NA_character_, tz = ""))
  x
}

#' Available Twitter trends along with associated WOEID.
#'
#' `r lifecycle::badge("deprecated")`
#' @inheritParams lookup_users
#'
#' @return Data frame with WOEID column. WOEID is a Yahoo! Where On
#'   Earth ID.
#' @family trends
#' @seealso [`rtweet-deprecated`]
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/trends/locations-with-trending-topics/api-reference/get-trends-available>
trends_available <- function(token = NULL, parse = TRUE) {
  trd <- TWIT_get(token, "/1.1/trends/available")
  if (parse) {
    trd <- parse_trends_available(trd)
  }
  trd
}

parse_trends_available <- function(x) {
  p <- cbind(data.frame(x[names(x) != "placeType"],
                        stringsAsFactors = FALSE),
             data.frame(x[["placeType"]],
                        stringsAsFactors = FALSE),
             stringsAsFactors = FALSE)
  names(p)[ncol(p)] <- "place_type"
  tibble::as_tibble(p)
}


find_woeid <- function(x) {
  if (length(x) == 0L) {
    warning(paste0(
      "unable to find matching location.",
      "Using WOEID for Worldwide trends instead."))
    x <- "1"
  } else if (length(match_woeid(x)) > 0L) {
    x <- match_woeid(x)
  } else {
    warning(paste0(
      "unable to find matching location.",
      "Using WOEID for Worldwide trends instead."))
    x <- "1"
  }
  if (length(x) == 0L) {
    warning(paste0(
      "unable to find matching location.",
      "Using WOEID for Worldwide trends instead."))
    x <- "1"
  }
  if (length(x) > 1L) {
    x <- x[1L]
  }
  x
}

check_woeid <- function(x) {
  if (is_n(x)) return(as.character(x))
  x <- find_woeid(x)
  as.character(x)
}

match_woeid <- function(x) {
  if (tolower(x) %in% c("world", "worldwide",
                        "world wide", "all")) {
    return("1")
  } else if (tolower(x) %in% c("us", "u.s.", "u s", "usa", "unitedstates")) {
    return("23424977")
  } else {
    # This function relies on data from WOEID that was last updated in 2012!
    places <- sysdat$woeid[["name"]]
    woeids <- as.character(sysdat$woeid[["woeid"]])
    woeids[tolower(places) == tolower(x)]
  }
}

test_that("get_trends returns trends data", {

  vcr::use_cassette("get_trends1", {
    x <- get_trends()
  })

  expect_true(is.data.frame(x))
  expect_named(x)
  expect_true(all(c("trend", "promoted_content") %in% names(x)))
  expect_gt(nrow(x), 10)
  expect_gt(ncol(x), 5)
  expect_equal(check_woeid("world"), "1")
  expect_equal(check_woeid("kansas"), "2347575")
  expect_equal(check_woeid("new york"), "2347591")
})

test_that("trends_available returns data frame", {

  vcr::use_cassette("get_trends2", {
    x <- trends_available()
  })

  expect_equal(is.data.frame(x), TRUE)
  expect_named(x)
  expect_true(all(c("name", "woeid") %in% names(x)))
  expect_gt(nrow(x), 5)
  expect_gt(ncol(x), 2)
  expect_equal(as.integer(subset(x, name == "Worldwide", select = "woeid")), 1)
})

test_that("get_trends_closest returns data frame with correct city name", {

  vcr::use_cassette("get_trends3", {
    x <- get_trends(lat = 40.7, lng = -74.0)
  })

  expect_true(is.data.frame(x))
  expect_named(x)
  expect_true(all(c("trend", "woeid") %in% names(x)))
  expect_gt(nrow(x), 5)
  expect_gt(ncol(x), 2)
  expect_equal(as.character(x[1,]$place), "New York")
})

# Documents <https://developer.twitter.com/en/docs/twitter-api/v1/data-dictionary/object-model/user>


user <- function(x) {
 empty <- data.frame(
   "id" = NA_integer_, "id_str" = NA_character_,
   "name" = NA_character_, "screen_name" = NA_character_,
   "location" = NA_character_, "derived" = I(list(list())),
   "url" = NA_character_, "description" = NA_character_,
   "protected" = NA, "verified" = NA, "followers_count" = NA_integer_,
   "friends_count" = NA_integer_, "listed_count" = NA_character_,
   "favourites_count" = NA_integer_, "statuses_count" = NA_integer_,
   "created_at" = NA_character_, "profile_banner_url" = NA_character_,
   "profile_image_url_https" = NA_character_,
   "default_profile" = NA, "default_profile_image" = NA,
   "withheld_in_countries" = I(list(list())),
   "entities" = I(list(list())),
   "withheld_scope" = NA, stringsAsFactors = FALSE
 )
 empty <- empty
 if (NROW(x) == 0) {
    return(empty)
 }

 if (!is.data.frame(x) && is.list(x)) {
      y <- list2DF(x[lengths(x) == 1])
 } else {
   # Ignoring status, as it holds tweets
   y <- x[ , colnames(x) %in% colnames(empty)]
 }
 # Adding missing values.
 missing <- setdiff(colnames(empty), colnames(y))

 if (length(missing) != 0 ) {
    y[ , missing] <- empty[rep(1, nrow(y)), missing]
 }

 if (has_name_(x, "entities")) {
    y$entities <- parse_entities(x$entities)
 } else {
    y$entities <- list(list())
 }


 end <- setdiff(colnames(y), colnames(empty))
 if (is.data.frame(x) && length(end) != 0) {
   warning("Unidentified value: ", paste(end, collapse = ", "),
        ".\n\tPlease open an issue to notify the maintainer. Thanks!")
 }

 y
}

# Helper function to test a tweet and learn about what is returned by each
# combination of field and expansion.
helper <- function(tweet = "1615009611186069504") {
  se <- set_expansions(user = NULL)
  sf <- set_fields()
  out <- vector("list", (sum(lengths(sf)))*(length(se)))
  out_sf <- vector("list", (length(se)))
  out_se <- vector("list", sum(lengths(sf)))
  i <- 1
  for (i_se in seq_along(se)) {
    for (i_sf in seq_along(sf)) {
      for (i_sfi in seq_along(sf[[i_sf]])) {

        sf_test <- list(sf[[i_sf]][i_sfi])
        names(sf_test) <- names(sf)[i_sf]
        out[[i]] <- tweet_get(tweet,
                              expansions = se[i_se], fields = sf_test,
                              parse = FALSE)
        out_sf[[i]] <- sf_test
        out_se[[i]] <- se[i_se]
        i <- i + 1
      }
    }
  }
  l2df <- list2DF(list(out = out, fields = out_sf, expansion = out_se))
  l2df
}

if (FALSE) {
  l2df <- helper()
  inc <- lapply(l2df$out, function(x){names(x[[1]]$includes)})
  inc[lengths(inc) == 0] <- NA
  df <- data.frame(field = unlist(out_sf, recursive = TRUE, FALSE),
                   expansion = unlist(l2df$expansion),
                   includes = unlist(inc))
  l <- lapply(l2df$out, function(x){
    names(list_minus(x[[1]]$data, c("edit_history_tweet_ids", "id", "text")))})
  df$data <- l
  df <- distinct(df)
}
# Expansions that produces "includes":
#     attachments.media_keys, author_id, edit_history_tweet_ids, geo.place_id,
#     referenced_tweets.id.author_id
# These fields create a data with its name:
#     attachments, conversation_id, created_at, entities, geo, lang,
#     public_metrics, possibly_sensitive, reply_settings, author_id
#
# attachments.media_keys is required for any media.fields (go to includes)
# geo.place_id is required for any place.fields (go to includes)
# attachments.poll_ids is required by any poll.fields (go to includes)
# referenced_tweets.id is required by any tweet.fields (go to includes)
# author_id, entities.mentions.username, in_reply_to_user_id, referenced_tweets.id.author_id is required by any user.fields (go to includes)
#

#' Remove tokens
#'
#' If there is a file with saved tokens it will delete it.
#'
#' This functions helps to comply with CRAN policy to remove files created by
#' the package.
#' @param old A logical value if you want to remove old tokens.
#' @param new A logical value if you want to remove new tokens.
#'
#' @return An invisible logical value showing the success of the operation.
#' If no tokens need to be deleted it will return FALSE too.
#' `NULL` if there is nothing to do.
#' @export
#' @examples
#' auth_clean(TRUE, TRUE)
auth_clean <- function(old = TRUE, new = FALSE) {
  stopifnot(is_logical(old))
  stopifnot(is_logical(new))

  if (isFALSE(old) && isFALSE(new)) {
    inform(c("Nothing to do",
             i = "Did you meant to set `old = TRUE`?"))
    return(invisible(NULL))
  }
  old_tokens <- find_old_tokens()
  tools_tokens <- find_tools_tokens()
  all_tokens_files <- c(old_tokens, tools_tokens)
  if (is.null(all_tokens_files)) {
    inform("No tokens were found! Nothing to do.")
    return(invisible(NULL))
  }
  ot <- FALSE
  nt <- FALSE
  if (length(old_tokens) != 0 && old) {
    ot <- unlink(old_tokens)
  }
  if (length(tools_tokens) != 0 && new) {
    nt <- unlink(tools_tokens)
  }
  out <- old && ot || new && nt
  invisible(out)
}

#' Posts direct message from user's Twitter account
#'
#' @inheritParams get_timeline
#' @param text Character, text of message.
#' @param media File path to image or video media to be
#'   included in tweet.
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/direct-messages/sending-and-receiving/api-reference/new-event>
post_message <- function(text, user, media = NULL, token = NULL) {
  ## get user id
  if (user_type(user) != "user_id") {
    user_id <- lookup_users(user, token = token)
    user_id <- user_id$id_str[1]
  } else {
    user_id <- user
  }

  stopifnot(is.character(text))
  stopifnot(length(text) == 1)

  body <- list(
    event = list(
      type = "message_create",
      message_create = list(
        target = list(recipient_id = user_id),
        message_data = list(text = text)
      )
    )
  )

  if (!is.null(media)) {
    media_id <- upload_media_to_twitter(media, token = token)
    body$event$message_create$message_data$attachment <- list(
      type = "media",
      media = list(id = media_id)
    )
  }

  r <- TWIT_post(token, "/1.1/direct_messages/events/new",
    body = body,
    encode = "json"
  )
  message("Your DM has been posted!")
  invisible(r)
}

test_that("post_message works", {
  skip("requires manual testing")
  expect_message(
    rt <- post_message(paste("Testing", Sys.time()), user = "Lluis_Revilla"),
    "Your DM has been posted!"
  )
  expect_equal(httr::status_code(rt), 200L)

})

if (requireNamespace("vcr", quietly = TRUE)) {
  library("vcr") # *Required* as vcr is set up on loading
  invisible(vcr::vcr_configure(
    dir = vcr::vcr_test_path("fixtures"),
    filter_request_headers = list(Authorization = "My oauth token is safe",
                                  GOOGLE_KEY = "My google key is safe.",
                                  GOOGLE_MAPS_KEY = "My google key is safe."),
    filter_query_parameters = c(status = "status message"),
    serialize_with = "json",
    warn_on_empty_cassette = TRUE

  ))
  vcr::check_cassette_names(allowed_duplicates = "lookup_users1")
}

#' Get Twitter list members (users on a given list).
#'
#' @inheritParams TWIT_paginate_cursor
#' @param list_id required The numerical id of the list.
#' @param slug required You can identify a list by its slug instead of
#'   its numerical id. If you decide to do so, note that you'll also
#'   have to specify the list owner using the owner_id or
#'   owner_user parameters.
#' @param owner_user optional The screen name or user ID of the user
#' @param ... Other arguments used as parameters in query composition.
#' @inheritParams stream
#' @family lists
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/get-lists-members>
lists_members <- function(list_id = NULL,
                          slug = NULL,
                          owner_user = NULL,
                          n = 5000,
                          cursor = "-1",
                          token = NULL,
                          retryonratelimit = NULL,
                          verbose = TRUE,
                          parse = TRUE,
                          ...) {
  params <- lists_params(
    list_id = list_id,
    slug = slug,
    owner_user = owner_user
  )
  r <- TWIT_paginate_cursor(token, "/1.1/lists/members", params,
    n = n,
    cursor = cursor,
    retryonratelimit = retryonratelimit,
    verbose = verbose,
    page_size = if (n >= 5000) 5000 else n,
    get_id = function(x) x$users$id_str
  )

  if (parse) {
    r <- parse_lists_users(r)
  }
  r
}

test_that("list_members() works with either id or slug + owner_user", {

  vcr::use_cassette("lists_members1", {
    x <- lists_members("105140588", n = 5)
  })
  expect_s3_class(x, "data.frame")

  vcr::use_cassette("lists_members2", {
    x <- lists_members(slug = "senators", owner_user = "cspan", n = 5)
  })
  expect_s3_class(x, "data.frame")
})

#' Create a Tweet Embed 
#' 
#' Twitter API GET call to retieve the tweet in embedded form.
#' 
#' @param screen_name character, screen name of the user
#' @param status_id character, status id
#' @param ... parameters to pass to the GET call. See
#'   <https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/get-statuses-oembed>
#'   for details.
#' @return character
#' @examples 
#' name   <- 'kearneymw'
#' status <- '1087047171306856451'
#' 
#' tweet_embed(screen_name = name, status_id = status)
#' 
#' tweet_embed(
#'  screen_name = name,
#'  status_id = status,
#'  hide_thread = TRUE, 
#'  hide_media = FALSE, 
#'  align = 'center'
#' )
#' 
#' @seealso [httr::GET()],[httr::content()]
#' @rdname tweet_embed
#' @export 
tweet_embed <- function(screen_name,status_id,...){
  # https://developer.twitter.com/en/docs/twitter-for-websites/timelines/guides/oembed-api
  
  params <- list(
    url = sprintf('https://twitter.com/%s/status/%s', screen_name, status_id),
    ...
  )
  resp <- httr::GET("https://publish.twitter.com/oembed", query = params)
  check_status(resp, "oembed")
  
  json <- from_js(resp)
  json$html
}

## utility functions
wrangle_into_clean_data <- function(x, type = NULL) {
  x <- keep_atomic(x)
  x <- only_keep_str_vars(x, type = type)
  format_created_at(x)
}

keep_atomic <- function(x) {
  x[!vapply(x, is.recursive, logical(1))]
}

only_keep_str_vars <- function(x, type = NULL) {
  strs <- grep("\\_str$", names(x), value = TRUE)
  if (length(strs) > 0L) {
    ## remove _str
    strs_names <- gsub("_str$", "", strs)
    ## drop non_str
    x <- x[!names(x) %in% strs_names]
    ## update names
    if (!is.null(type)) {
      strs_names <- paste0(type, "_", strs_names)
    }
    names(x)[grep("\\_str$", names(x))] <- strs_names
  }
  x
}

format_created_at <- function(x) {
  if (has_name_(x, "created_at")) {
    x$created_at <- format_date(x$created_at)
  }
  x
}

##----------------------------------------------------------------------------##
##                                 lists_users                                ##
##----------------------------------------------------------------------------##

as_lists_users <- function(x) {
  structure(x, class = "lists_users")
}

#' @export
as.data.frame.lists_users <- function(x, row.names, optional, ...) {
  if (!missing(row.names)) {
    warning("`row.names` argument is ignored.")
  }
  if (!missing(optional)) {
    warning("`optional` argument is ignored.")
  }
  if (has_name_(x, "lists")) {
    x <- x[["lists"]]
  }
  out <- tibble::as_tibble(
    wrangle_into_clean_data(x, "list")
  )
  if (has_name_(x, "user")) {
    users <- tibble::as_tibble(
      wrangle_into_clean_data(x$user, "user")
    )
    attr(out, "users") <- users
  }
  if (has_name_(x, "status")) {
    tweets <- tibble::as_tibble(
      wrangle_into_clean_data(x$status, "status")
    )
    attr(out, "tweets") <- tweets
  }
  out
}

#' Rate limit helpers
#'
#' `r lifecycle::badge("deprecated")`
#'
#' @description
#' * `rate_limit()` returns a tibble of info about all rate limits
#' * `rate_limit_reset()` returns the next reset for a endpoint
#' * `rate_limit_wait()` waits for the next reset for an endpoint
#'
#' You should not need to use these function in the usual operation of rtweet
#' because all paginated functions will wait on your behalf if you set
#' `retryonratelimit = TRUE`.
#'
#' @inheritParams lookup_users
#' @param resource_match An optional regular expression used to filter the
#'   resources listed in returned rate limit data.
#' @param endpoint Name of Twitter endpoint like `"lookup/users"`,
#'   `"/media/upload"`, or `"/feedback/show/:id"`.
#' @family tokens
#' @seealso [`rtweet-deprecated`]
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/v1/developer-utilities/rate-limit-status>
rate_limit <- function(resource_match = NULL, token = NULL) {
  json <- TWIT_get(token, "/1.1/application/rate_limit_status")

  resources <- unlist(unname(json$resources), recursive = FALSE)
  df <- tibble::tibble(
    resource = names(resources),
    limit = unlist(lapply(resources, "[[", "limit"), use.names = FALSE),
    remaining = unlist(lapply(resources, "[[", "remaining"), use.names = FALSE),
    reset_at = unlist(lapply(resources, "[[", "reset"), use.names = FALSE),
  )
  df$reset_at <- .POSIXct(df$reset_at)
  df$reset <- round(difftime(df$reset_at, Sys.time(), units = "mins"))

  if (!is.null(resource_match)) {
    df <- df[grepl(resource_match, df$resource), ]
  }

  df
}

#' @export
#' @rdname rate_limit
rate_limit_reset <- function(endpoint, token = NULL) {
  endpoint <- gsub("^/", "", endpoint)

  resource <- strsplit(endpoint, "/")[[1]][[1]]
  params <- list(resource = resource)
  json <- TWIT_get(token, "/1.1/application/rate_limit_status", params)

  info <- json$resources[[resource]][[paste0("/", endpoint)]]
  if (is.null(info)) {
    stop("Unrecognised endpoint '", endpoint, "'", call. = FALSE)
  }

  if (info$remaining > 0) {
    Sys.time()
  } else {
    .POSIXct(info$reset)
  }
}

#' @export
#' @rdname rate_limit
rate_limit_wait <- function(endpoint, token = NULL) {
  reset <- unclass(rate_limit_reset(endpoint, token))
  wait_until(reset, endpoint)

  invisible()
}

wait_until <- function(until, api, fps = 8, verbose = TRUE) {
  until <- unclass(until)
  seconds <- until - unclass(Sys.time())

  if (!verbose) {
    Sys.sleep(ceiling(seconds))
    return()
  }

  if (seconds < 0) {
    return(invisible())
  }

  pb <- progress::progress_bar$new(
    total = seconds * fps,
    format = paste0(
      "Rate limit exceeded for Twitter endpoint '", api, "'. ",
      "Waiting for refresh in :mins mins :spin"
    )
  )
  withr::defer(pb$terminate())

  while(Sys.time() < until) {
    Sys.sleep(1 / fps)
    mins <- round((until - unclass(Sys.time())) / 60)
    pb$tick(tokens = list(mins = mins))
  }

  invisible()
}

test_that("rate_limit works", {
  
  vcr::use_cassette("rate_limit1", {
    rl <- rate_limit()
  })
  expect_s3_class(rl, "data.frame")
})

test_that("rate_limit works", {
  
  vcr::use_cassette("rate_limit2", {
    rl <- rate_limit("application/rate_limit_status")
  })
  expect_s3_class(rl, "data.frame")
  expect_equal(nrow(rl), 1)
})

test_that("rate_limit returns rate_limit data", {
  
  vcr::use_cassette("rate_limit3", {
    x <- rate_limit()
  })
  expect_equal(is.data.frame(x), TRUE)
  expect_named(x)
  expect_true("remaining" %in% names(x))
  expect_gt(nrow(x), 2)
  expect_gt(ncol(x), 2)
})

test_that("rate_limit_reset works", {
  
  vcr::use_cassette("rate_limit4", {
    reset <- rate_limit_reset("application/rate_limit_status")
  })
  expect_s3_class(reset, "POSIXct")
})

test_that("rate_limit_wait works", {
  
  vcr::use_cassette("rate_limit5", {
    wait <- rate_limit_wait("application/rate_limit_status")
  })
  expect_null(wait)
})

#' Tweet retweeted by
#'
#' Looks up who have retweeted a given tweet.
#' @inheritParams filtered_stream
#' @param ... Other arguments passed to the API.
#' @param n Number of tweets to query.
#' @param verbose A logical value to provide more information about the
#' paginated queries (if any) and to store the data of each page.
#' @param ids A tweet id string.
#' @returns A data.frame with the user information of who retweeted it:
#' id, name, and username.
#' Other information depends on the `expansions` and `fields` requested.
#' @export
#' @references <https://developer.twitter.com/en/docs/twitter-api/tweets/retweets/api-reference/get-tweets-id-retweeted_by>
#' @examples
#' if (FALSE) {
#'   rb <- tweet_retweeted_by("567053242429734913")
#' }
tweet_retweeted_by <- function(ids, n = 100, expansions = NULL, fields = NULL, ...,
                      token = NULL, parse = TRUE, verbose = FALSE) {

  expansions <- check_expansions(arg_def(expansions, set_expansions(list = NULL)))
  fields <- check_fields(arg_def(fields, set_fields()), metrics = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  stopifnot(is_n(n))
  if (length(ids) != 1 || !is_id(ids)) {
    abort("Please introduce a single valid id")
  }
  data <- c(list(expansions = expansions), fields, ...)
  data <- unlist(prepare_params(data), recursive = FALSE)
  url <- paste0("tweets/", ids, "/retweeted_by")

  max_results <- check_interval(n, 10, formals()$n)
  n_pages <- ceiling(n / max_results)
  data <- c(max_results = max_results, data)

  # Rates from the website app and user limits
  req_archive <- endpoint_v2(url, 75/(60*15), c("tweet.read", "users.read"))
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, n_pages, n, verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

#' Parsing data into tweets/users data tibbles
#'
#' For internal use only
#'
#' @param x A list of responses, with one element for each page.
#' @return A tweets/users tibble with users/tweets attribute.
#' @export
tweets_with_users <- function(x) {
  empty_response <- vapply(x, is.null, logical(1L))
  x <- x[!empty_response]

  tweets <- tweet(NULL)[0, ]
  if (length(x) != 0) {
    tweets <- do.call(rbind, lapply(x, tweet))[, colnames(tweets)]
  }

  users <- user(NULL)[0, ]
  if (has_name_(tweets, "user") && length(tweets$user) != 0 && all(lengths(tweets$user) != 0)) {
    users <- do.call(rbind, tweets[["user"]])[, colnames(users)]
  }
  tweets <- tweets[!colnames(tweets) %in% "user"]
  users <- tibble::as_tibble(users)
  tweets <- tibble::as_tibble(tweets)

  out <- structure(tweets, users = users)
  class(out) <- c("tweets", class(out))
  out
}

#' @rdname tweets_with_users
#' @export
users_with_tweets <- function(x) {
  empty_response <- vapply(x, is.null, logical(1L))
  x <- x[!empty_response]

  users <- user(NULL)[0, ]
  if (length(x) != 0) {
    users <- do.call(rbind, lapply(x, user))[, colnames(users)]
  }

  tweets <- tweet(NULL)[0, ]
  if (length(x) != 0) {
    status <- lapply(x, `[[`, i = "status")
    tweets <- do.call(rbind, lapply(status, tweet))[, colnames(tweets)]
  }
  tweets <- tweets[!colnames(tweets) %in% "user"]
  users <- tibble::as_tibble(users)
  tweets <- tibble::as_tibble(tweets)
  out <- structure(users, tweets = tweets)
  class(out) <- c("users", class(out))
  out
}

clean_source <- function(s) {
  sub("<\\/.*", "", sub("[^>]+>", "", s))
}

#' Plots tweets data as a time series-like data object.
#'
#' Creates a ggplot2 plot of the frequency of tweets over a specified
#' interval of time. `r lifecycle::badge("deprecated")`
#'
#' @param data Data frame or grouped data frame.
#' @param by Desired interval of time expressed as numeral plus one of
#'   "secs", "mins", "hours", "days", "weeks", "months", or
#'   "years". If a numeric is provided, the value is assumed to be in
#'   seconds.
#' @param trim The number of observations to drop off the beginning
#'   and end of the time series.
#' @param tz Time zone to be used, defaults to "UTC" (Twitter default)
#' @param ... Other arguments passed to
#'   [ggplot2::geom_line()].
#' @return If
#'   [ggplot2](https://cran.r-project.org/package=ggplot2) is
#'   installed then a [ggplot2::ggplot()] plot object.
#' @family ts_data
#' @seealso [`rtweet-deprecated`]
#' @keywords internal
#' @export
ts_plot <- function(data, by = "days", trim = 0L, tz ="UTC", ...) {
  lifecycle::deprecate_stop("2.0.0", function_call())
  data <- ts_data(data, by, trim, tz)
  check_installed("ggplot2")

  p <- ggplot2::ggplot(data, ggplot2::aes(x = .data[["time"]], y = .data[["n"]]))
  if (ncol(data) == 3L) {
    # retrieve group name
    p + ggplot2::geom_line(ggplot2::aes(colour = .data[[names(data)[3]]]), ...)
  } else if (ncol(data) == 4L) {
    p + ggplot2::geom_line(ggplot2::aes(colour = .data[[names(data)[3]]],
                                        linetype = .data[[names(data)[4]]]), ...)
  } else {
     p + ggplot2::geom_line(...)
  }
}


#' Converts tweets data into time series-like data object.
#'
#' Returns data containing the frequency of tweets over a specified
#' interval of time. `r lifecycle::badge("deprecated")`
#'
#' @param data Data frame or grouped data frame.
#' @param by Desired interval of time expressed as numeral plus one of
#'   "secs", "mins", "hours", "days", "weeks", "months", or
#'   "years". If a numeric is provided, the value is assumed to be in
#'   seconds.
#' @param trim Number of observations to trim off the front and end of
#'   each time series
#' @param tz Time zone to be used, defaults to "UTC" (Twitter default)
#' @return Data frame with time, n, and grouping column if applicable.
#' @keywords internal
#' @seealso [`rtweet-deprecated`]
#' @export
ts_data <- function(data, by = "days", trim = 0L, tz ="UTC") {
  lifecycle::deprecate_stop("2.0.0", function_call())
  stopifnot(is.data.frame(data), is.atomic(by) && !is.null(by))
  if (has_name_(data, "created_at")) {
    dtvar <- "created_at"
  } else {
    dtvar <- vapply(data, inherits, "POSIXct", FUN.VALUE = logical(1))
    if (sum(dtvar) == 0L) stop("no datetime (POSIXct) var found", call. = FALSE)
    dtvar <- names(data)[which(dtvar)[1]]
  }
  ## drop NAs and sort data
  data <- data[!is.na(data[[dtvar]]), ]
  data <- data[order(data[[dtvar]]), ]
  ## reformat time var
  .unit <- parse_unit(by)
  ## adjust to desired tz
  data[[dtvar]] <- convert_tz(data[[dtvar]], tz = tz)
  data[[dtvar]] <- round_time(data[[dtvar]], by, tz)
  ## get unique values of time in series
  dtm <- unique(
    seq(data[[dtvar]][1], data[[dtvar]][length(data[[dtvar]])], .unit)
  )
  ## if grouped df (up to 2 groups)
  if (inherits(data, "grouped_df") &&
      ("groups" %in% names(attributes(data)) ||
          "labels" %in% names(attributes(data)))) {
    if (!"groups" %in% names(attributes(data)) &&
        "labels" %in% names(attributes(data))) {
      groups <- names(attr(data, "labels"))
    } else {
      groups <- names(attr(data, "groups"))
      groups <- groups[!groups %in% ".rows"]
    }
    if (length(groups) > 1L) {
      group2 <- groups[2]
    } else {
      group2 <- NULL
    }
    group1 <- groups[1]
    lv1 <- unique(data[[group1]])
    df1 <- as.POSIXct(character(), tz = tz)
    df2 <- integer()
    df3 <- list()
    if (!is.null(group2)) {
      lv2 <- unique(data[[group2]])
      df4 <- list()
      ## count expressions for each row for output time series-like data
      for (i in seq_along(dtm)) {
        for (j in seq_along(lv1)) {
          for (k in seq_along(lv2)) {
            df1[length(df1) + 1L] <- dtm[i]
            df2[length(df2) + 1L] <- sum(
              data[[dtvar]] == dtm[i] &
                data[[group1]] == lv1[j] &
                data[[group2]] == lv2[k],
              na.rm = TRUE
            )
            df3[[length(df3) + 1L]] <- lv1[j]
            df4[[length(df4) + 1L]] <- lv2[k]
          }
        }
      }
      df <- data.frame(
        time = df1,
        n = df2,
        g1 = unlist(df3),
        g2 = unlist(df4),
        stringsAsFactors = FALSE
      )
      names(df)[3:4] <- groups[1:2]
    } else {
      ## count expressions for each row for output time series-like data
      for (i in seq_along(dtm)) {
        for (j in seq_along(lv1)) {
          df1[length(df1) + 1L] <- dtm[i]
          df2[length(df2) + 1L] <- sum(
            data[[dtvar]] == dtm[i] &
              data[[group1]] == lv1[j],
              na.rm = TRUE
          )
          df3[[length(df3) + 1L]] <- lv1[j]
        }
      }
      df <- data.frame(
        time = df1,
        n = df2,
        g1 = unlist(df3),
        stringsAsFactors = FALSE
      )
      names(df)[3] <- group1
    }
  } else {
    df <- data.frame(
      time = dtm,
      n = vapply(dtm, function(x) sum(data[[dtvar]] == x), FUN.VALUE = integer(1)),
      stringsAsFactors = FALSE
    )
  }
  df <- tibble::as_tibble(df)
  if (trim > 0L) {
    df <- trim_ts(df, trim)
  }
  df
}

parse_unit <- function(by) {
  stopifnot(is.atomic(by) && !is.null(by))
  if (is.numeric(by)) {
    return(by)
  } else if (grepl("year", by)) {
    n <- 60 * 60 * 24 * 365
  } else if (grepl("month", by)) {
    n <- 60 * 60 * 24 * 30
  } else if (grepl("week", by)) {
    n <- 60 * 60 * 24 * 7
  } else if (grepl("day", by)) {
    n <- 60 * 60 * 24
  } else if (grepl("hour", by)) {
    n <- 60 * 60
  } else if (grepl("min", by)) {
    n <- 60
  } else if (grepl("sec", by)) {
    n <- 1
  } else {
    stop("must express time interval in secs, mins, hours, days, weeks, months, or years",
         call. = FALSE)
  }
  x <- as.double(gsub("[^[:digit:]|\\.]", "", by))
  if (any(is.na(x), identical(x, ""))) {
    x <- 1
  }
  n * x
}


#' A generic function for rounding date and time values
#'
#' @param x A vector of class POSIX or Date.
#' @param n Unit to round to. Defaults to mins. Numeric values treated
#'   as seconds. Otherwise this should be one of "mins", "hours", "days",
#'   "weeks", "months", "years" (plural optional).
#' @param tz Time zone to be used, defaults to "UTC" (Twitter default)
#' @return If POSIXct then POSIX. If date then Date.
#' @examples
#'
#' ## class posixct
#' round_time(Sys.time(), "12 hours")
#'
#' ## class date
#' unique(round_time(seq(Sys.Date(), Sys.Date() + 100, "1 day"), "weeks"))
#'
#' @export
round_time <- function(x, n, tz) UseMethod("round_time")

#' @export
round_time.POSIXt <- function(x, n = "mins", tz = "UTC") {
  n <- parse_to_secs(n)
  #as.POSIXct(hms::hms(as.numeric(x) %/% n * n), tz = tz)
  hms(as.numeric(x) %/% n * n, tz = tz)
}


hms <- function(secs = NULL, tz = "UTC") {
  if (is.null(secs)) {
    secs <- numeric()
  }
  structure(secs, tzone = tz,
    class = c("POSIXct", "POSIXt"))
}


#' @export
round_time.Date <- function(x, n = "months", tz = "UTC") {
  x <- as.POSIXct(format(x, tz = "UTC"), tz = tz)
  as.Date(round_time(x, n, tz = tz))
}


round_time2 <- function(x, interval = 60, center = TRUE, tz = "UTC") {
  stopifnot(inherits(x, "POSIXct"))
  ## parse interval
  interval <- parse_unit(interval)
  ## round off to lowest value
  rounded <- floor(as.numeric(x) / interval) * interval
  if (center) {
    ## center so value is interval mid-point
    rounded <- rounded + round(interval * .5, 0)
  }
  ## return to date-time
  as.POSIXct(rounded, tz = tz, origin = "1970-01-01")
}


trim_ts <- function(data, trim = 1L) {
  if (ncol(data) > 2L) {
    g <- unique(data[[3]])
    g <- lapply(g, function(x) trim_ots(data[data[[3]] == x, ], trim, trim))
    g <- do.call(rbind, g)
    if (ncol(data) == 4L) {
      g2 <- unique(data[[4]])
      g2 <- lapply(g2, function(x) trim_ots(data[data[[4]] == x, ], trim, trim))
      g2 <- do.call(rbind, g2)
      g <- rbind(g, g2)
    }
    g
  } else {
    trim_ots(data, trim, trim)
  }
}


trim_ots <- function(x, f = 1L, l = 1L) {
  x <- x[order(x[[1]]), ]
  f <- seq_len(f)
  l <- nrow(x) - seq_len(l) + 1L
  if ((length(l) + length(f)) >= nrow(x)) {
    return(x)
  }
  x[-c(f, l), ]
}


parse_to_secs <- function(x) {
  if (is.numeric(x)) {
    n <- x
  } else if (grepl("year", x)) {
    n <- 60 * 60 * 24 * 365
  } else if (grepl("month", x)) {
    n <- 60 * 60 * 24 * 30
  } else if (grepl("week", x)) {
    n <- 60 * 60 * 24 * 7
  } else if (grepl("day", x)) {
    n <- 60 * 60 * 24
  } else if (grepl("hour", x)) {
    n <- 60 * 60
  } else if (grepl("min", x)) {
    n <- 60
  } else if (grepl("sec", x)) {
    n <- 1
  } else {
    stop("must express time interval in secs, mins, hours, days, weeks, months, or years",
      call. = FALSE)
  }
  x <- as.double(gsub("[^[:digit:]|\\.]", "", x))
  if (any(is.na(x), identical(x, ""))) {
    x <- 1
  }
  n * x
}

test_that("ts_plot works", {
  vcr::use_cassette("ts_plot1", {
    rt <- search_tweets("rstats", n = 100)
  })
  expect_error(ts_plot(rt), NA)
})

test_that("ts_data works", {
  vcr::use_cassette("ts_plot2", {
    rt <- search_tweets("rstats", n = 100)
  })
  expect_error(ts_data(rt), NA)
})

test_that("ts_plot grouped works", {
  skip_if_not_installed("dplyr")
  vcr::use_cassette("ts_plot3", {
    rt <- search_tweets("rstats", n = 100)
  })
  grouped <- dplyr::group_by(rt, is_quote_status)
  expect_error(ts_plot(grouped), NA)
})

#' List information
#'
#' Looks up information about a list.
#' @inheritParams filtered_stream
#' @inheritParams user_following
#' @param ids A list id.
#' @export
#' @returns A data.frame with the user information of who is included in the list:
#' id, name, and username.
#'
#' Other information depends on the `expansions` and `fields` requested.
#' Accepted values are:
#' - Expansions: `set_expansions(tweet = NULL, user = NULL)`
#' - Fields: `set_fields(place = NULL, poll = NULL, media = NULL, tweet = NULL)`.
#' @references <https://developer.twitter.com/en/docs/twitter-api/lists/list-lookup/api-reference/get-lists-id>
#' @examples
#' if (FALSE) {
#'   lg <- list_get("1306285118877831168")
#' }
list_get <- function(ids, n = 100, expansions = NULL, fields = NULL, ...,
                       token = NULL, parse = TRUE, verbose = FALSE) {

  expansions <- check_expansions(arg_def(expansions, "owner_id"), "owner_id")
  fields <- check_fields(
    arg_def(fields,
            set_fields(place = NULL, poll = NULL, media = NULL, tweet = NULL)),
    metrics = NULL, place = NULL, poll = NULL, media = NULL, tweet = NULL)
  expansions_for_fields(expansions, fields)
  if (!is_logical(verbose)) {
    abort("`verbose` must be either `TRUE` or `FALSE`.")
  }
  parsing(parse, expansions, fields)
  if (length(ids) != 1 || !is_list_id(ids) && length(ids) == 0) {
    abort("Please introduce at least a valid list id")
  }

  data <- c(list(expansions = expansions), fields, ...)
  url <- paste0("lists/", ids)

  data <- unlist(prepare_params(data), recursive = FALSE)
  data <- data[data != ""]

  # Rates from the website app and user limits
  token <- check_token_v2(token, c("bearer", "pkce"))
  check_scopes_token(token, c("tweet.read", "users.read", "list.read"))
  rate <- check_rate(token, 75/(60*15), 75/(60*15))
  req_archive <- endpoint_v2(token, url, rate)
  req_final <- httr2::req_url_query(req_archive, !!!data)
  p <- pagination(req_final, 1, 1, verbose = verbose)
  if (!parse) {
    return(p)
  }
  parse(p, expansions, fields)
}

---
title: "Authentication with rtweet"
output:
  rmarkdown::html_vignette:
    fig_caption: true
    code_folding: show
    toc_float:
      collapsed: true
      toc_depth: 3
vignette: >
  %\VignetteIndexEntry{Authentication with rtweet}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, eval = FALSE, comment = "#>", collapse = TRUE)
```

rtweet's default authentication is shared by all user.
If it is just for a test, a workshop or a lecture it is fine.
But if you plan to use it more than a day you will benefit of authenticating yourself.

The **authentication** mechanism is using your own app authentication.
It allows you to act on behalf of your personal Twitter account, as if you were performing actions on twitter.com.

If you want to collect a lot of data or implement a bot, you should instead use one of rtweet's two other authentication mechanisms:

-   **App authentication** allows you to act as if you were a Twitter app.
    You can't perform operations that a user can (like posting a tweet or reading a DM), but you get higher rate limits on data collection operations.

-   **Bot authentication** allows you to create a fully automated Twitter bot that performs actions on its own behalf rather than on behalf of a human.

In either case, you'll need to create your own Twitter app (yes, it can be confusing), so we'll start by discussing what an app is and how to create one on the Twitter website.
Next, you'll learn how to use the `rtweet_app()` function to tell rtweet about your app config.
You'll then learn how to set the default authentication mechanism for the current R session, and how to save it so you can use it in a future session.

```{r}
library(rtweet)
```

## Creating a Twitter app

You're already familiar with using twitter, either through [the website](https://twitter.com) or an app that you installed on your phone or computer.
To use twitter from R, you'll need to learn a little more about what's going on behind the scenes.
The first important concept to grasp is that every request to the Twitter API has to go through an "app".
Normally, someone else has created the app for you, but now that you're using twitter programmatically, you can create your own app.
(It's still called an app even though you'll be using it through an R package).

To create a Twitter app, you need to first apply for a developer account by following the instructions at <https://developer.twitter.com>.
Once you have been approved (which may take several hours), navigate to the [developer portal](https://developer.twitter.com/en/portal/projects-and-apps) and click the "Create App" button at the bottom of the page.
You'll need to name your app: the name is unimportant for our purposes, but needs to be unique across all twitter apps.

After you've created your app, you'll see a screen that gives you some important information.
You'll only see this once, so make sure to record it in a secure location.

![](app-info.png){width="548"}

Don't worry if you forget to save this data: you can always regenerate new values by clicking the "regenerate" button on the "keys and tokens" page.
If you regenerate the previous values will cease to work, so do not use it to get different credentials for an authentication already in use.

## Setup

Now that you have an app registered on twitter.com, you have to tell rtweet about it.

#### OAuth2 protocol

Some new functions require a different authentication mechanism[^1].
This functions will need you to first set up a client, which requires your client id and secret.

[^1]: Called [OAuth 2](https://aaronparecki.com/oauth-2-simplified/)

You can get them in your [developer dashboard](https://developer.twitter.com/en/portal/dashboard) after selecting your app, you first need to fill the details of the "User authentication settings":

Choose one of the **App permissions**: Read, Read and write, or Read and write and Direct message  
In **Type of App** select Native app  
In **App info**  set the callback URI to: `http://127.0.0.1:1410/`

The callback URI is important as this is what rtweet will use to validate.

The clients are under "Key and tokens" tab, check the top.
At the last section of the tab, there is the section \"Auth 2.0 Client ID and Client Secret\":

![Screenshot showing what to look to get the OAuth credentials](oauth2.png){width="548"}

Use them to set up your client app:

```{r client, eval = FALSE}
client <- rtweet_client(app = "my app")
```

Once you get your client you'll need to tell rtweet to use it (that's why we use `client_as()`).
But first you'll need to authorize it via `rtweet_oauth2()`: 
It will ask your default browser to authorize the client.
You should have a Twitter session to authorize rtweet.

```{r rtweet_oauth2}
user_oauth2 <- rtweet_oauth2()
## Waiting for authentication in browser...
## Press Esc/Ctrl + C to abort
auth_as(user_oauth2)
auth_save(user_oauth2, "oauth2_authentication")
```

This authentication only last for 2 hours.
You'll be asked to renew the authorization if it is expired. 

### Apps

To use app based authentication, run this code:

```{r, eval = FALSE}
auth <- rtweet_app()
```

This will prompt you to enter the *bearer token* that you recorded earlier.

It's good practice to only provide secrets interactively, because that makes it harder to accidentally share them in either your `.Rhistory` or an `.R` file.


## Default

You can call `auth_as()` to set this as the default for the remainder of the session:

```{r, eval = FALSE}
auth_as(auth)
```

Similarly you can use by default a client.

```{r, eval = FALSE}
client_as(client)
```


## Saving and loading {#save}

`auth_as()` only lasts for a single session; if you close and re-open R, you'd need to repeat the whole process (generate the tokens and pass them to `rtweet_app()` or `rtweet_oauth2()`).
This would be annoying (!) so rtweet also provides a way to save and reload authentications across sessions:

```{r, eval = FALSE}
auth_save(auth, "some-name")
```

The second argument to `auth_save()` can be any string.
It just needs to be meaningful to you so that you remember exactly what you're loading when you use it a future session:

```{r, eval = FALSE}
auth_as("some-name")
```

You can see all the authentication options you have saved with `auth_list()`.
`auth_list()` reports all the available authentications at the default location (See `auth_save()` details).
If you use an authentication saved on a different path you can directly use it `auth_as("../authentications/rtweet.rds")`

So, after your initial setup you can start all your scripts with `auth_as("default")` to load it.

Clients work similarly, but the client will be saved with the name of the app you provided:

```{r, eval=FALSE}
client_save(client)
client_as("myapp")
```


### On continuous integration workflows

On continuous integration you need to provide the keys and tokens as secret variables.
Otherwise anyone with access to the logs of those checks might use your keys and tokens.
Check your CI documentation about how to do that, but it might be something similar to what [Github does](https://docs.github.com/en/actions/security-guides/encrypted-secrets#creating-encrypted-secrets-for-a-repository).
Where secrets are created as environmental variables.

You will need to provide a name of your variable, try to be informative (RTWEET_BEARER, RTWEET_API_KEY, RTWEET_API_SECRET, RTWEET_TOKEN, RTWEET_SECRET).

Usually you later need to load them from the environmental variables and create the token on the CI:

``` r
app <- rtweet_app(bearer_token = Sys.getenv("RTWEET_BEARER"))
auth_as(app)
```

Don't leave the arguments without values as this won't authenticate.
Also do not print RTWEET_BEARER or other secrets.

## Authentications sitrep

On the rtweet 1.0.0 version there were some changes on the default location of the tokens.

If you upgrade or want a complete check up of your authentications you can use `auth_sitrep()`.
It can help when regenerating credentials and to follow best practices when upgrading rtweet.
It will print something like these:

```{r, eval = FALSE}
auth_sitrep()
## Tokens from rtweet version < 1.0.0 found on /home/user:
## Empty tokens were found.
## Choose which is the best path of action for the tokens:
##                              user_id  key
## .rtweet_token.rds      My app         <NA>
## .rtweet_token1.rds My account            A
## Tokens found on /home/user/.config/R/rtweet:
##             token
## my-app2.rds     A
## Multiple authentications with the same app found!
## Choose which is the best path of action for the tokens:
##                       app    user_id key
## default.rds        rtweet 9951053384   A
## testing_rtweet.rds rtweet              B
## All tokens should be moved to /home/user/.config/R/rtweet
```

First looks up old authentications rtweet saved at your home directory (`~`, or `$HOME`) as it did on rtweet \< 1.0.0.
Then it reports the authentications found on the new location (rtweet \>= 1.0.0).
For each folder it reports apps and then users and bots authentications.
It is safe to use in public, as instead of the tokens or keys it reports a letter.
For users authentications it reports the user_id, so that you can check who is that user (`user_search("1251053384")`).

This makes it easier to see if there is a saved authentication with a name not matching the user_id.
It also warns you if there is the same key or token for multiple files, as this indicates a misunderstanding or a duplication of the authentication.

# bdpar

<details>

* Version: 
* GitHub: https://github.com/ropensci/rtweet
* Source code: NA
* Number of recursive dependencies: 0

</details>

## Error before installation

### Devel

```






```
### CRAN

```






```
# carbonate

<details>

* Version: 
* GitHub: https://github.com/ropensci/rtweet
* Source code: NA
* Number of recursive dependencies: 0

</details>

## Error before installation

### Devel

```






```
### CRAN

```






```
# epitweetr

<details>

* Version: 
* GitHub: https://github.com/ropensci/rtweet
* Source code: NA
* Number of recursive dependencies: 0

</details>

## Error before installation

### Devel

```






```
### CRAN

```






```
# graphTweets

<details>

* Version: 
* GitHub: https://github.com/ropensci/rtweet
* Source code: NA
* Number of recursive dependencies: 0

</details>

## Error before installation

### Devel

```






```
### CRAN

```






```
# imgrec

<details>

* Version: 
* GitHub: https://github.com/ropensci/rtweet
* Source code: NA
* Number of recursive dependencies: 0

</details>

## Error before installation

### Devel

```






```
### CRAN

```






```
# saotd

<details>

* Version: 
* GitHub: https://github.com/ropensci/rtweet
* Source code: NA
* Number of recursive dependencies: 0

</details>

## Error before installation

### Devel

```






```
### CRAN

```






```
# tidytags

<details>

* Version: 
* GitHub: https://github.com/ropensci/rtweet
* Source code: NA
* Number of recursive dependencies: 0

</details>

## Error before installation

### Devel

```






```
### CRAN

```






```
# Twitmo

<details>

* Version: 
* GitHub: https://github.com/ropensci/rtweet
* Source code: NA
* Number of recursive dependencies: 0

</details>

## Error before installation

### Devel

```






```
### CRAN

```






```
# VOSONDash

<details>

* Version: 
* GitHub: https://github.com/ropensci/rtweet
* Source code: NA
* Number of recursive dependencies: 0

</details>

## Error before installation

### Devel

```






```
### CRAN

```






```
# vosonSML

<details>

* Version: 
* GitHub: https://github.com/ropensci/rtweet
* Source code: NA
* Number of recursive dependencies: 0

</details>

## Error before installation

### Devel

```






```
### CRAN

```






```

<!-- This is an issue template for bugs and requests for R pkg rtweet -->

<!-- If you've encountered a likely bug in rtweet, please take a few seconds to 
look through existing issues for a similar issue. If you don't see a related 
issue, please complete the prompts below to make it easier to replicate and 
[hopefully] resolve your issue.  -->

<!-- If you have some question about how to use this package, please post it on
https://discuss.ropensci.org/tag/rtweet -->

### Problem

<!-- Succinctly describe the problem (be as specific as you think necessary) -->

### Expected behavior

<!-- Describe the behavior/result you expected -->

### Reproduce the problem

<!-- Describe and provide relevant code to reproduce the problem -->
<!-- If code doesn't always produce error, provide approximate code anyway -->

``` r
## insert code here

```

### rtweet version

<!-- run the code below and copy/paste the output -->

``` r
## copy/paste output
packageVersion("rtweet")
```


### Session info

<!-- run the code below and copy/paste the output -->

``` r
## copy/paste output
sessionInfo()
```

<!-- If you think the problem may be related to features/limitations of 
Twitter's API, you can find more information about Twitter's APIs here: 
https://developer.twitter.com/en/docs.html -->

<!-- Thank you for using and improving rtweet!  -->

---
title: "Live streaming tweets"
subtitle: "rtweet: Collecting Twitter Data"
output:
  rmarkdown::html_vignette:
    fig_caption: true
    code_folding: show
    toc_float:
      collapsed: true
      toc_depth: 3
vignette: >
  %\VignetteIndexEntry{Live streaming tweets}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---



## Installing and loading package

Prior to streaming, make sure to install and load rtweet.
This vignette assumes users have already setup app access tokens (see: the "auth" vignette, `vignette("auth", package = "rtweet")`).


```r
## Load rtweet
library(rtweet)
```



## Overview

In addition to accessing Twitter's REST API (e.g., `search_tweets`, `get_timeline`), rtweet makes it possible to capture live streams of Twitter data[^1]. This requires an app authentication see `vignette("auth", package = "rtweet")`.

[^1]: Till November 2022 it was possible with API v1.1, currently this is no longer possible and uses API v2.

There are two ways of having a stream:

-   [A stream collecting data from a set of rules](https://developer.twitter.com/en/docs/twitter-api/tweets/filtered-stream/api-reference/get-tweets-search-stream), which can be collected via `filtered_stream()`.

-   [A stream of a 1% of tweets published](https://developer.twitter.com/en/docs/twitter-api/tweets/volume-streams/api-reference/get-tweets-sample-stream), which can be collected via `sample_stream()`.

In either case we need to choose how long should the streaming connection hold, and in which file it should be saved to.


```r
## Stream time in seconds so for one minute set timeout = 60
## For larger chunks of time, I recommend multiplying 60 by the number
## of desired minutes. This method scales up to hours as well
## (x * 60 = x mins, x * 60 * 60 = x hours)
## Stream for 5 seconds
streamtime <- 5
## Filename to save json data (backup)
filename <- "rstats.json"
```

## Filtered stream

The filtered stream collects tweets for all rules that are currently active, not just one rule or query.

### Creating rules

Streaming rules in rtweet need a value and a tag.
The value is the query to be performed, and the tag is the name to identify tweets that match a query.
You can use multiple words and hashtags as value, please [read the official documentation](https://developer.twitter.com/en/docs/twitter-api/tweets/filtered-stream/integrate/build-a-rule).
Multiple rules can match to a single tweet.


```r
## Stream rules used to filter tweets
new_rule <- stream_add_rule(list(value = "#rstats", tag = "rstats"))
```

### Listing rules

To know current rules you can use `stream_add_rule()` to know if any rule is currently active:


```r
rules <- stream_add_rule(NULL)
rules
#>   result_count                sent
#> 1            1 2023-03-19 22:04:29
rules(rules)
#>                    id   value    tag
#> 1 1637575790693842952 #rstats rstats
```

With the help of `rules()` the id, value and tag of each rule is provided.

### Removing rules

To remove rules use `stream_rm_rule()`


```r
# Not evaluated now
stream_rm_rule(ids(new_rule))
```

Note, if the rules are not used for some time, Twitter warns you that they will be removed.
But given that `filtered_stream()` collects tweets for all rules, it is advisable to keep the rules list short and clean.

### filtered_stream()

Once these parameters are specified, initiate the stream.
Note: Barring any disconnection or disruption of the API, streaming will occupy your current instance of R until the specified time has elapsed.
It is possible to start a new instance or R ---streaming itself usually isn't very memory intensive--- but operations may drag a bit during the parsing process which takes place immediately after streaming ends.


```r
## Stream election tweets
stream_rstats <- filtered_stream(timeout = streamtime, file = filename, parse = FALSE)
#> Warning: No matching tweets with streaming rules were found in the time provided.
```

If no tweet matching the rules is detected a warning will be issued.

Parsing larger streams can take quite a bit of time (in addition to time spent streaming) due to a somewhat time-consuming simplifying process used to convert a json file into an R object.

Don't forget to clean the streaming rules:


```r
stream_rm_rule(ids(new_rule))
#>                  sent deleted not_deleted
#> 1 2023-03-19 22:04:51       1           0
```

## Sample stream

The `sample_stream()` function doesn't need rules or anything.


```r
stream_random <- sample_stream(timeout = streamtime, file = filename, parse = FALSE)
#> 
 Found 316 records...
 Imported 316 records. Simplifying...
length(stream_random)
#> [1] 316
```


## Saving files

Users may want to stream tweets into json files upfront and parse those files later on.
To do this, simply add `parse = FALSE` and make sure you provide a path (file name) to a location you can find later.

You can also use `append = TRUE` to continue recording a stream into an already existing file.

Currently parsing the streaming data file with `parse_stream()` is not functional.
However, you can read it back in with `jsonlite::stream_in(file)`.

## Returned data object

The parsed object should be the same whether a user parses up-front or from a json file in a later session.

Currently the returned object is a raw conversion of the feed into a nested list depending on the fields and extensions requested.

## revdepcheck results

We checked 13 reverse dependencies (3 from CRAN + 10 from Bioconductor), comparing R CMD check results across CRAN and dev versions of this package.

 * We saw 0 new problems
 * We failed to check 0 packages

# Contributing to rtweet

This outlines how to propose a change to rtweet. For more detailed
info about contributing to this, and other tidyverse packages, please see the
[**development contributing guide**](https://rstd.io/tidy-contrib).

### Fixing typos

Small typos or grammatical errors in documentation may be edited directly using
the GitHub web interface, so long as the changes are made in the _source_ file.

*  YES: you edit a roxygen comment in a `.R` file below `R/`.
*  NO: you edit an `.Rd` file below `man/`.

### Prerequisites

Before you make a substantial pull request, you should always file an issue and
make sure someone from the team agrees that it’s a problem. If you’ve found a
bug, create an associated issue and illustrate the bug with a minimal 
[reprex](https://www.tidyverse.org/help/#reprex).

### Pull request process

*  We recommend that you create a Git branch for each pull request (PR).  
*  Look at the Travis and AppVeyor build status before and after making changes.
The `README` should contain badges for any continuous integration services used
by the package.  
*  New code should follow the tidyverse [style guide](http://style.tidyverse.org).
You can use the [styler](https://CRAN.R-project.org/package=styler) package to
apply these styles, but please don't restyle code that has nothing to do with 
your PR.  
*  We use [roxygen2](https://cran.r-project.org/package=roxygen2), with
[Markdown syntax](https://cran.r-project.org/web/packages/roxygen2/vignettes/markdown.html), 
for documentation.  
*  We use [testthat](https://cran.r-project.org/package=testthat). Contributions
with test cases included are easier to accept.  
*  For user-facing changes, add a bullet to the top of `NEWS.md` below the
current development version header describing the changes made followed by your
GitHub username, and links to relevant issue(s)/PR(s).
*  Development for next release is in [devel branch](https://github.com/ropensci/rtweet/tree/devel) 
fixes or typos are okay in the default branch.

### Code of Conduct

Please note that the rtweet project is released with a
[Contributor Code of Conduct](CODE_OF_CONDUCT.md). By contributing to this
project you agree to abide by its terms.

See tidyverse [development contributing guide](https://www.tidyverse.org/contribute/)
for further details.

---
title: "rtweet: Collecting and analyzing Twitter data"
authors:
  - name: Michael W. Kearney
    orcid: 0000-0002-0730-4694
    affiliation: '1'
affiliations:
  - name: School of Journalism, Informatics Institute, University of Missouri
    index: '1'
date: 13 May 2019
bibliography: paper.bib
tags:
  - R
  - twitter
  - social media
  - API
---

# Statement of need

Following the [announced (2016) deprecation of the ``twitteR``
package](https://github.com/ropensci/rtweet/issues/1#issuecomment-492753003)
[@twitteR], R users seeking to interact with Twitter APIs have been encouraged
to use the ``rtweet`` package. Use of the up-to-date and actively-maintained
``rtweet`` package is especially important in light of changes to Twitter's APIs
since 2016. Most notably is the increased character limit (from 140 to 280) for
Twitter statuses [@tweetmodeextended]. In addition to providing an updated
interface with similar functionality to ``twitteR``, allowing R users to
communicate with various endpoints from Twitter's REST API, the ``rtweet``
package also provides support for communicating with Twitter's stream API.

# Summary

Interest in Twitter data continues to grow, but for many the task of actually
collecting and analyzing data via Twitter APIs remains daunting. For example, in
order to interact with Twitter's APIs users must, in addition to identifying and
digesting the relevant information from [Twitter's developer
documentation](https://developer.twitter.com), build/send/receive requests,
manage rate limits, and wrangle nested and real-time response objects into
analysis-friendly data structures. Fortunately, the ``rtweet`` R package [@rtweet]
is designed to simplify these processes, making interacting with Twitter's APIs
more accessible to a wider range of users.

The main goals of the ``rtweet`` package are two-fold. The first goal is to make
interacting with Twitter's APIs more approachable and streamlined for less
computationally-experienced users. The second goal is to assist in the analysis
of Twitter data via converting information returned by Twitter's APIs into
tabular data structures and providing several convenience functions for common
analytical techniques such as examining Twitter networks or the frequency of
tweets over time. In short, although it is certainly possible for users to write
their own Twitter API wrapper functions, the heavy-lifting done by ``rtweet`` to
(a) streamline the building, authorizing, and sending of API requests, (b)
wrangle deeply nested JSON data into tabular structures, and (c) provide
convenience functions for relevant and popular analytical techniques, make
it a valuable contribution in the area of collecting and analyzing Twitter data.

Although ``rtweet`` provides some coverage to user context-behaviors (e.g.,
posting statuses, liking tweets, following users, etc.), the primary audience
for the package to date has been researchers. Accordingly, ``rtweet`` has been
featured in numerous popular press [e.g.,
@bajak2019democrats; @machlis2019r; @riley2019twitter] and academic publications
[e.g.,
@bossetta2018simulated; @bradley2019major; @buscema2018media;
@erlandsen2018twitter; @gitto2019brand; @kearney2019analyzing;
@kearney2018analyzing; @li2019sentiment; @lutkenhaus2019tailoring;
@lutkenhaus2019mapping; @molyneux2018media; @tsoi2018can; @unsihuay2018topic;
@valls2017urban; @wu2018finding].

# References

---
title: "Authentication with rtweet"
output:
  rmarkdown::html_vignette:
    fig_caption: true
    code_folding: show
    toc_float:
      collapsed: true
      toc_depth: 3
vignette: >
  %\VignetteIndexEntry{Authentication with rtweet}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include=FALSE}
knitr::opts_chunk$set(echo = TRUE, eval = FALSE, comment = "#>", collapse = TRUE)
```

In previous versions rtweet provided a default authentication mechanism shared by all rtweet users.
This is no longer possible, if you want to use it you'll need to create your own authentication.

The **authentication** mechanism is using your own app authentication.
It allows you to act on behalf of your personal Twitter account, as if you were performing actions on twitter.com.

You will need an **app authentication**, which allows you to act as if you were a Twitter app.

Then we will see how to set the default authentication mechanism for the current R session, and how to save it so you can use it in a future session.

```{r}
library(rtweet)
```

## Creating a Twitter app

You're already familiar with using twitter, either through the website or an app that you installed on your phone or computer.
To use twitter from R, you'll need to learn a little more about what's going on behind the scenes.
The first important concept to grasp is that every request to the Twitter API has to go through an "app".
Normally, someone else has created the app for you, but now that you're using twitter programmatically, you can create your own app.
(It's still called an app even though you'll be using it through an R package).

To create a Twitter app, you need to first apply for a developer account by following the instructions at <https://developer.twitter.com>.
Once you have been approved (which may take several hours), navigate to the [developer portal](https://developer.twitter.com/en/portal/projects-and-apps) and click the "Create App" button at the bottom of the page.
You'll need to name your app: the name is unimportant for our purposes, but needs to be unique across all twitter apps.

After you've created your app, you'll see a screen that gives you some information.
You'll only see this once: 

![](app-info.png){width="548"}

You can always regenerate new values by clicking the "regenerate" button on the "keys and tokens" page.

## Setup

Now that you have an app registered on twitter.com, you have to tell rtweet about it.

New functions require a different authentication mechanism[^1].
This functions will need you to first set up a client, which requires your client id and secret.

[^1]: Called [OAuth 2](https://aaronparecki.com/oauth-2-simplified/)

After selecting your app[^2] we created in the first section, you first need to fill the details of the "User authentication settings":

[^2]: You can find your apps at the [developer dashboard](https://developer.twitter.com/en/portal/dashboard).

Choose one of the **App permissions**: Read, Read and write, or Read and write and Direct message  
In **Type of App** select Native app.
In **App info**  set the callback URI to: `http://127.0.0.1:1410/`

The callback URI is important as this is what rtweet will use to validate.

The clients are under "Key and tokens" tab, check the top.
At the last section of the tab, there is the section \"Auth 2.0 Client ID and Client Secret\":

![Screenshot showing what to look to get the OAuth credentials](oauth2.png){width="548"}

Use these client ID and client secret to set up your client app in R:

```{r client, eval = FALSE}
client <- rtweet_client(app = "my_app")
client_as(client)
```

Once you get your client you'll need to tell rtweet to use it (that's why we use `client_as()`).

This authentication only last for 2 hours, you'll be asked to renew the authorization if it is expired. 

This is all you need to do in future R sessions:

```{r client_load, eval = FALSE}
client_as("my_app")
```

The functions that use the API v2 will use this client and the related authentication mechanism to validate your request.
You might get prompted to approve the app every two hours.

## Authentications sitrep

On the rtweet 1.0.0 version there were some changes on the default location of the tokens.

If you upgrade or want a complete check up of your authentications you can use `auth_sitrep()`.
It can help when regenerating credentials and to follow best practices when upgrading rtweet.
It will print something like these:

```{r, eval = FALSE}
auth_sitrep()
## Tokens from rtweet version < 1.0.0 found on /home/user:
## Empty tokens were found.
## Choose which is the best path of action for the tokens:
##                              user_id  key
## .rtweet_token.rds      My app         <NA>
## .rtweet_token1.rds My account            A
## Tokens found on /home/user/.config/R/rtweet:
##             token
## my-app2.rds     A
## Multiple authentications with the same app found!
## Choose which is the best path of action for the tokens:
##                       app    user_id key
## default.rds        rtweet 9951053384   A
## testing_rtweet.rds rtweet              B
## All tokens should be moved to /home/user/.config/R/rtweet
```

First looks up old authentications rtweet saved at your home directory (`~`, or `$HOME`) as it did on rtweet \< 1.0.0.
Then it reports the authentications found on the new location (rtweet \>= 1.0.0).
For each folder it reports apps and then users and bots authentications.
It is safe to use in public, as instead of the tokens or keys it reports a letter.
For users authentications it reports the user_id, so that you can check who is that user (`user_search("1251053384")`).

This makes it easier to see if there is a saved authentication with a name not matching the user_id.
It also warns you if there is the same key or token for multiple files, as this indicates a misunderstanding or a duplication of the authentication.

## Old authentication process

After the API v1.1 was closed to most users this previous forms of authentication are deprecated or do not work well.

From rtweet 2.0.0 I will not maintain them, I leave these here in case someone needs them for references

### Apps

To use app based authentication, run this code:

```{r, eval = FALSE}
auth <- rtweet_app()
```

This will prompt you to enter the *bearer token* that you recorded earlier.

It's good practice to only provide secrets interactively, because that makes it harder to accidentally share them in either your `.Rhistory` or an `.R` file.


### Default

You can call `auth_as()` to set this as the default for the remainder of the session:

```{r, eval = FALSE}
auth_as(auth)
```

Similarly you can use by default a client.

```{r, eval = FALSE}
client_as(client)
```


### Saving and loading {#save}


`auth_as()` only lasts for a single session; if you close and re-open R, you'd need to repeat the whole process (generate the tokens and pass them to `rtweet_app()`).
This would be annoying (!) so rtweet also provides a way to save and reload authentications across sessions:

```{r, eval = FALSE}
auth_save(auth, "some-name")
```

The second argument to `auth_save()` can be any string.
It just needs to be meaningful to you so that you remember exactly what you're loading when you use it a future session:

```{r, eval = FALSE}
auth_as("some-name")
```

You can see all the authentication options you have saved with `auth_list()`.
`auth_list()` reports all the available authentications at the default location (See `auth_save()` details).
If you use an authentication saved on a different path you can directly use it `auth_as("../authentications/rtweet.rds")`

So, after your initial setup you can start all your scripts with `auth_as("default")` to load it.

Clients work similarly, but the client will be saved with the name of the app you provided:

```{r, eval=FALSE}
client_save(client)
client_as("myapp")
```


### On continuous integration workflows

On continuous integration you need to provide the keys and tokens as secret variables.
Otherwise anyone with access to the logs of those checks might use your keys and tokens.
Check your CI documentation about how to do that, but it might be something similar to what [Github does](https://docs.github.com/en/actions/security-guides/encrypted-secrets#creating-encrypted-secrets-for-a-repository).
Where secrets are created as environmental variables.

You will need to provide a name of your variable, try to be informative (RTWEET_BEARER, RTWEET_API_KEY, RTWEET_API_SECRET, RTWEET_TOKEN, RTWEET_SECRET).

Usually you later need to load them from the environmental variables and create the token on the CI:

``` r
app <- rtweet_app(bearer_token = Sys.getenv("RTWEET_BEARER"))
auth_as(app)
```

Don't leave the arguments without values as this won't authenticate.
Also do not print RTWEET_BEARER or other secrets.

---
title: "Live streaming tweets"
subtitle: "rtweet: Collecting Twitter Data"
output:
  rmarkdown::html_vignette:
    fig_caption: true
    code_folding: show
    toc_float:
      collapsed: true
      toc_depth: 3
vignette: >
  %\VignetteIndexEntry{Live streaming tweets}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

## Installing and loading package

Prior to streaming, make sure to install and load rtweet.
This vignette assumes users have already setup app access tokens (see: the "auth" vignette, `vignette("auth", package = "rtweet")`).

```r
## Load rtweet
library(rtweet)
client_as("my_app")
```

## Overview

rtweet makes it possible to capture live streams of Twitter data[^1]. 

[^1]: Till November 2022 it was possible with API v1.1, currently this is no longer possible and uses API v2.

There are two ways of having a stream:

-   [A stream collecting data from a set of rules](https://developer.twitter.com/en/docs/twitter-api/tweets/filtered-stream/api-reference/get-tweets-search-stream), which can be collected via `filtered_stream()`.

-   [A stream of a 1% of tweets published](https://developer.twitter.com/en/docs/twitter-api/tweets/volume-streams/api-reference/get-tweets-sample-stream), which can be collected via `sample_stream()`.

In either case we need to choose how long should the streaming connection hold, and in which file it should be saved to.


```r
## Stream time in seconds so for one minute set timeout = 60
## For larger chunks of time, I recommend multiplying 60 by the number
## of desired minutes. This method scales up to hours as well
## (x * 60 = x mins, x * 60 * 60 = x hours)
## Stream for 5 seconds
streamtime <- 5
## Filename to save json data (backup)
filename <- "rstats.json"
```

## Filtered stream

The filtered stream collects tweets for all rules that are currently active, not just one rule or query.

### Creating rules

Streaming rules in rtweet need a value and a tag.
The value is the query to be performed, and the tag is the name to identify tweets that match a query.
You can use multiple words and hashtags as value, please [read the official documentation](https://developer.twitter.com/en/docs/twitter-api/tweets/filtered-stream/integrate/build-a-rule).
Multiple rules can match to a single tweet.


```r
## Stream rules used to filter tweets
new_rule <- stream_add_rule(list(value = "#rstats", tag = "rstats"))
```

### Listing rules

To know current rules you can use `stream_add_rule()` to know if any rule is currently active:


```r
rules <- stream_add_rule(NULL)
rules
#>   result_count                sent
#> 1            1 2023-03-19 22:04:29
rules(rules)
#>                    id   value    tag
#> 1 1637575790693842952 #rstats rstats
```

With the help of `rules()` the id, value and tag of each rule is provided.

### Removing rules

To remove rules use `stream_rm_rule()`


```r
# Not evaluated now
stream_rm_rule(ids(new_rule))
```

Note, if the rules are not used for some time, Twitter warns you that they will be removed.
But given that `filtered_stream()` collects tweets for all rules, it is advisable to keep the rules list short and clean.

### filtered_stream()

Once these parameters are specified, initiate the stream.
Note: Barring any disconnection or disruption of the API, streaming will occupy your current instance of R until the specified time has elapsed.
It is possible to start a new instance or R ---streaming itself usually isn't very memory intensive--- but operations may drag a bit during the parsing process which takes place immediately after streaming ends.


```r
## Stream election tweets
stream_rstats <- filtered_stream(timeout = streamtime, file = filename, parse = FALSE)
#> Warning: No matching tweets with streaming rules were found in the time provided.
```

If no tweet matching the rules is detected a warning will be issued.

Parsing larger streams can take quite a bit of time (in addition to time spent streaming) due to a somewhat time-consuming simplifying process used to convert a json file into an R object.

Don't forget to clean the streaming rules:


```r
stream_rm_rule(ids(new_rule))
#>                  sent deleted not_deleted
#> 1 2023-03-19 22:04:51       1           0
```

## Sample stream

The `sample_stream()` function doesn't need rules or anything.


```r
stream_random <- sample_stream(timeout = streamtime, file = filename, parse = FALSE)
#> 
 Found 316 records...
 Imported 316 records. Simplifying...
length(stream_random)
#> [1] 316
```


## Saving files

Users may want to stream tweets into json files upfront and parse those files later on.
To do this, simply add `parse = FALSE` and make sure you provide a path (file name) to a location you can find later.

You can also use `append = TRUE` to continue recording a stream into an already existing file.

Currently parsing the streaming data file with `parse_stream()` is not functional.
However, you can read it back in with `jsonlite::stream_in(file)`.

## Returned data object

The parsed object should be the same whether a user parses up-front or from a json file in a later session.

Currently the returned object is a raw conversion of the feed into a nested list depending on the fields and extensions requested.

---
title: "Intro to rtweet"
output:
  rmarkdown::html_vignette:
    fig_caption: true
    code_folding: show
    toc_float:
      collapsed: true
      toc_depth: 3
vignette: >
  %\VignetteIndexEntry{Intro to rtweet}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---



This vignette provides a quick tour of the R package, describing what could be possible to do.


```r
library("rtweet")
```

## Authenticate

First you should set up your own credentials, lease read the `vignette("auth", "rtweet")`.

## Free

### Posting statuses

You can post tweets with:

```r
tweet_post(paste0("My first tweet with #rtweet #rstats at ", Sys.time()))
```

###  Your own data

```r
user_self()
```


## Paid

### Search tweets

You can search tweets:


```r
rstats <- tweet_search_recent("#rstats", n = 100)
```


```r
tweets_peace <- tweet_search_all("peace", n = 250000, retryonratelimit = TRUE)
```

### Get friends

Retrieve a list of all the accounts a **user follows**.

```r
user_following("1234565")
```

### Get followers

If you really want all the users that follow the account we can use `user_follower()`:

```r
R_foundation_flw <- user_follower("1599030512919650304")
```

### Search users

We can use `user_search()`:


```r
users <- user_search(c("1599030512919650304", "2244994945"))
```


### Get timelines

Get the most recent tweets from R Foundation.

```r
R_foundation_tline <- user_timeline("1599030512919650304")
```

### Get favorites

Get the 10 recently favorited statuses by R Foundation.


```r
R_foundation_favs <- user_liked_tweets("1599030512919650304")
```


### Muting users

You can list those users muted:


```r
um <- user_muted(user_self()$id)
```


### Blocking users

You can block users and unblock them:


```r
user_block("rtweet")
user_unblock("rtweet")
```

# search_fullarchive works

    Code
      df <- search_fullarchive(q = "#covid place:UK OR place:GB OR place:\"United Kindom\"",
        n = 20, env_name = "fullArchive", fromDate = "201810010000")

# search_fullarchive queries bigger than page size work

    Code
      df <- search_fullarchive(q = "#covid place:UK OR place:GB OR place:\"United Kindom\"",
        n = 20, env_name = "fullArchive", fromDate = "201810010000")

# search_fullarchive does not return duplicate tweets

    Code
      df <- search_fullarchive(q = "#halalan22", n = 450, env_name = "fullArchive",
        fromDate = "202202080000", toDate = "202205100000", parse = TRUE)

# get_timelines() is deprecated

    Code
      x <- get_timelines("cnn", n = 10)
    Condition
      Warning:
      `get_timelines()` was deprecated in rtweet 1.0.0.
      i Please use `get_timeline()` instead.

# Check geo-related inputs for post_tweet

    Code
      msg <- paste("test geolocated error", Sys.time())
      post_tweet(msg, lat = "x", long = 0)
    Condition
      Error in `post_tweet()`:
      ! `lat` must be numeric.
    Code
      post_tweet(msg, lat = 0, long = "x")
    Condition
      Error in `post_tweet()`:
      ! `long` must be numeric.
    Code
      post_tweet(msg, lat = 91, long = 0)
    Condition
      Error in `post_tweet()`:
      ! `lat` must be between -90 and 90 degrees.
    Code
      post_tweet(msg, lat = 0, long = 181)
    Condition
      Error in `post_tweet()`:
      ! `long` must be between -180 and 180 degrees.
    Code
      post_tweet(msg, lat = 0, long = 0, display_coordinates = "error")
    Condition
      Error in `post_tweet()`:
      ! `display_coordinates` must be TRUE/FALSE.

# get_token() and get_tokens() are deprecated

    Code
      . <- get_token()
    Condition
      Warning:
      `get_token()` was deprecated in rtweet 1.0.0.
      i Please use `auth_get()` instead.
    Code
      . <- get_tokens()
    Condition
      Warning:
      `get_tokens()` was deprecated in rtweet 1.0.0.
      i Please use `auth_get()` instead.

# create_token is deprecated

    Code
      token <- suppressMessages(create_token("my-app", "x", "x", "y", "y"))
    Condition
      Warning:
      `create_token()` was deprecated in rtweet 1.0.0.
      i See vignette('auth', package = 'rtweet') for details

# next_cursor generates informative errors

    Code
      next_cursor(letters)
    Condition
      Error in `next_cursor()`:
      ! `cursor` must be a string or data frame
    Code
      next_cursor(mtcars)
    Condition
      Error in `next_cursor()`:
      ! `cursor` must have a `rtweet_cursor` attribute

# max_id and since_id generate informative erorrs

    Code
      max_id(10)
    Condition
      Error in `find_id()`:
      ! `max_id` must be a character vector or data frame
    Code
      max_id(mtcars)
    Condition
      Error in `find_id()`:
      ! `max_id` must contain a `id` column
    Code
      since_id(10)
    Condition
      Error in `find_id()`:
      ! `since_id` must be a character vector or data frame
    Code
      since_id(mtcars)
    Condition
      Error in `find_id()`:
      ! `since_id` must contain a `id` column

# gives useful errors

    Code
      search_tweets(c(1:10), verbose = FALSE)
    Condition
      Error in `search_params()`:
      ! is.atomic(q) && !is.null(q) && length(q) == 1L is not TRUE

---

    Code
      search_tweets("stats", type = "all")
    Condition
      Error in `search_params()`:
      ! `type` must be one of "mixed", "recent", or "popular", not "all".

# bearer token doesn't accidentally expose secrets

    Code
      rtweet_app("abc")
    Output
      <Twitter bearer token>

# find auth errors politely

    Code
      find_auth(1:10)
    Condition
      Error in `find_auth()`:
      ! Unrecognised input to `auth`
    Code
      find_auth("not-present")
    Condition
      Error in `load_token()`:
      ! Can't find saved auth with name 'not-present'

# default_cached_auth() handles 0, 1, and n saved

    Code
      default_cached_auth()
    Condition
      Error:
      ! No default authentication found. Please call `auth_setup_default()`

---

    Code
      default_cached_auth()
    Condition
      Error:
      ! No default authentication found. Pick existing auth with:
      * auth_as('test1')
      * auth_as('test2')

# collections API has been deprecated

    Code
      lookup_collections("custom-539487832448843776")
    Condition
      Error:
      ! `lookup_collections()` was deprecated in rtweet 1.0.0 and is now defunct.
    Code
      get_collections(status_id = "925172982313570306")
    Condition
      Error:
      ! `get_collections()` was deprecated in rtweet 1.0.0 and is now defunct.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/post-block.R
\name{user_block}
\alias{user_block}
\alias{user_unblock}
\title{Blocking or unblocking twitter users}
\usage{
user_block(user, unblock = FALSE, token = NULL)

user_unblock(user, token = NULL)
}
\arguments{
\item{user}{Character vector of screen names or user ids.
See \code{\link[=as_screenname]{as_screenname()}} for more details.}

\item{unblock}{Logical indicating whether to unblock the intended
friend.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\description{
\code{user_block(...)} blocks or unblocks a target twitter user.
\code{user_unblock(...)} is synonymous to \code{user_block(..., unblock=TRUE)}.
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
Block: \url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/mute-block-report-users/api-reference/post-blocks-create}
}
\seealso{
\code{\link{rtweet-deprecated}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/user_lists.R
\name{user_lists}
\alias{user_lists}
\title{Search users by username}
\usage{
user_lists(
  ids,
  n = 100,
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  parse = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{ids}{A user name string or up to 100.}

\item{n}{Number of users to query.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{...}{Other parameters passed to the body of the request.}

\item{token}{These endpoints only accept a bearer token (can be created via
\code{\link[=rtweet_app]{rtweet_app()}}). In most cases you
are better of changing the default for all calls via \code{\link[=auth_as]{auth_as()}}.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{A logical value to provide more information about paginated queries.}
}
\description{
Looks up users by their username.
}
\examples{
if (FALSE) {
  ul <- user_lists("1051050384")
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/lists/list-lookup/api-reference/get-users-id-owned_lists}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/search_tweets.R
\name{search_tweets}
\alias{search_tweets}
\alias{search_tweets2}
\title{Get tweets data on statuses identified via search query.}
\usage{
search_tweets(
  q,
  n = 100,
  type = c("mixed", "recent", "popular"),
  include_rts = TRUE,
  geocode = NULL,
  since_id = NULL,
  max_id = NULL,
  parse = TRUE,
  token = NULL,
  retryonratelimit = NULL,
  verbose = TRUE,
  ...
)

search_tweets2(...)
}
\arguments{
\item{q}{Query to be searched, used to filter and select tweets to
return from Twitter's REST API. Must be a character string not to
exceed maximum of 500 characters. Spaces behave like boolean
"AND" operator. To search for tweets containing at least one of
multiple possible terms, separate each search term with spaces
and "OR" (in caps). For example, the search \code{q = "data science"} looks for tweets containing both "data" and
"science" located anywhere in the tweets and in any order.
When "OR" is entered between search terms, \code{query = "data OR science"}, Twitter's REST API should return any tweet
that contains either "data" or "science." It is also possible to
search for exact phrases using double quotes. To do this, either
wrap single quotes around a search query using double quotes,
e.g., \code{q = '"data science"'} or escape each internal double
quote with a single backslash, e.g., \verb{q = "\\"data science\\""}.

Some other useful query tips:

\itemize{
\item Exclude retweets via \code{"-filter:retweets"}
\item Exclude quotes via \code{"-filter:quote"}
\item Exclude replies via \code{"-filter:replies"}
\item Filter (return only) verified via \code{"filter:verified"}
\item Exclude verified via \code{"-filter:verified"}
\item Get everything (firehose for free) via \code{"-filter:verified OR filter:verified"}
\item Filter (return only) tweets with links to news articles via \code{"filter:news"}
\item Filter (return only) tweets with media \code{"filter:media"}
}}

\item{n}{Desired number of results to return. Results are downloaded
in pages when \code{n} is large; the default value will download a single
page. Set \code{n = Inf} to download as many results as possible.

The Twitter API rate limits the number of requests you can perform
in each 15 minute period. The easiest way to download more than that is
to use \code{retryonratelimit = TRUE}.

You are not guaranteed to get exactly \code{n} results back. You will get
fewer results when tweets have been deleted or if you hit a rate limit.
You will get more results if you ask for a number of tweets that's not
a multiple of page size, e.g. if you request \code{n = 150} and the page
size is 200, you'll get 200 results back.}

\item{type}{Character string specifying which type of search
results to return from Twitter's REST API. The current default is
\code{type = "recent"}, other valid types include \code{type = "mixed"} and \code{type = "popular"}.}

\item{include_rts}{Logical, indicating whether to include retweets
in search results. Retweets are classified as any tweet generated
by Twitter's built-in "retweet" (recycle arrows) function. These
are distinct from quotes (retweets with additional text provided
from sender) or manual retweets (old school method of manually
entering "RT" into the text of one's tweets).}

\item{geocode}{Geographical limiter of the template
"latitude,longitude,radius" e.g., \code{geocode = "37.78,-122.40,1mi"}.}

\item{since_id}{Supply a vector of ids or a data frame of previous results to
find tweets \strong{newer} than \code{since_id}.}

\item{max_id}{Supply a vector of ids or a data frame of previous results to
find tweets \strong{older} than \code{max_id}.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{retryonratelimit}{If \code{TRUE}, and a rate limit is exhausted, will wait
until it refreshes. Most Twitter rate limits refresh every 15 minutes.
If \code{FALSE}, and the rate limit is exceeded, the function will terminate
early with a warning; you'll still get back all results received up to
that point. The default value, \code{NULL}, consults the option
\code{rtweet.retryonratelimit} so that you can globally set it to \code{TRUE},
if desired.

If you expect a query to take hours or days to perform, you should not
rely solely on \code{retryonratelimit} because it does not handle other common
failure modes like temporarily losing your internet connection.}

\item{verbose}{Show progress bars and other messages indicating current
progress?}

\item{...}{Further arguments passed as query parameters in request
sent to Twitter's REST API. To return only English language
tweets, for example, use \code{lang = "en"}. For more options see
Twitter's API documentation.}
}
\value{
List object with tweets and users each returned as a
data frame.

A tbl data frame with additional "query" column.
}
\description{
Returns Twitter statuses matching a user provided search
query. \ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

search_tweets2 Passes all arguments to search_tweets. Returns data from
one OR MORE search queries.
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\details{
Twitter API documentation recommends limiting searches to
10 keywords and operators. Complex queries may also produce API
errors preventing recovery of information related to the query.
It should also be noted Twitter's search API does not consist of
an index of all Tweets. At the time of searching, the search API
index includes between only 6-9 days of Tweets.
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/search/api-reference/get-search-tweets}
}
\seealso{
\code{\link[=tweet_search_recent]{tweet_search_recent()}}, \code{\link[=tweet_search_all]{tweet_search_all()}}, \code{\link{rtweet-deprecated}}

\code{\link[=tweet_search_recent]{tweet_search_recent()}}, \code{\link{rtweet-deprecated}}

Other tweets: 
\code{\link{get_favorites}()},
\code{\link{get_mentions}()},
\code{\link{get_timeline}()},
\code{\link{lists_statuses}()},
\code{\link{lookup_tweets}()}
}
\concept{tweets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statuses.R
\name{tweet_quoted}
\alias{tweet_quoted}
\title{Get quoted tweet information}
\usage{
tweet_quoted(
  id,
  n = 100,
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  parse = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{id}{At least a tweet id.}

\item{n}{Number of tweets to query.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{...}{Other arguments passed to the API.}

\item{token}{This endpoint accepts a OAuth2.0 authentication (can be
created via \code{\link[=rtweet_oauth2]{rtweet_oauth2()}}) or a bearer token (can be created via \code{\link[=rtweet_app]{rtweet_app()}}).}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{A logical value to provide more information about the
paginated queries (if any) and to store the data of each page.}
}
\description{
Look up tweets quoting that tweet id.
}
\examples{
if (FALSE){
 tweet_quoted("1631945769748930561", parse = FALSE)
}
}
\references{
One tweet: \url{https://developer.twitter.com/en/docs/twitter-api/tweets/quote-tweets/api-reference/get-tweets-id-quote_tweets}
}
\seealso{
\code{\link[=lookup_tweets]{lookup_tweets()}} \code{\link[=tweet_get]{tweet_get()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tweet_shot.R
\name{tweet_shot}
\alias{tweet_shot}
\title{Capture an image of a tweet/thread}
\usage{
tweet_shot(statusid_or_url, zoom = 3, scale = TRUE)
}
\arguments{
\item{statusid_or_url}{a valid Twitter status id (e.g. "\code{947082036019388416}") or
a valid Twitter status URL (e.g. "\verb{https://twitter.com/jhollist/status/947082036019388416}").}

\item{zoom}{a positive number >= 1. See the help for \verb{[webshot::webshot()]} for more information.}

\item{scale}{auto-scale the image back to 1:1? Default it \code{TRUE}, which means \code{magick}
will be used to return a "normal" sized tweet. Set it to \code{FALSE} to perform your
own image manipulation.}
}
\value{
\code{magick} object
}
\description{
Provide a status id or a full Twitter link to a tweet and this function
will capture an image of the tweet --- or tweet + thread (if there are
Twitter-linked replies) --- from the mobile version of said tweet/thread.
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\details{
For this to work, you will need to ensure the packages in \verb{Suggests:} are
installed as they will be loaded upon the first invocation of this function.

Use the \code{zoom} factor to get more pixels which may improve the text rendering
of the tweet/thread.
}
\examples{
\dontrun{
if (auth_has_default()) {
    shot1 <- tweet_shot("947061504892919808")
    plot(shot1)
    shot2 <- tweet_shot("https://twitter.com/ma_salmon/status/947061504892919808")
    plot(shot2)
}
}
}
\seealso{
\code{\link{rtweet-deprecated}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rt_stream.R
\name{stream}
\alias{stream}
\alias{filtered_stream}
\alias{stream_add_rule}
\alias{stream_rm_rule}
\alias{sample_stream}
\title{Streaming}
\usage{
filtered_stream(
  timeout,
  file = tempfile(),
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  append = TRUE,
  parse = TRUE
)

stream_add_rule(query, dry = FALSE, token = NULL)

stream_rm_rule(query, dry = FALSE, token = NULL)

sample_stream(
  timeout,
  file = tempfile(),
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  parse = TRUE,
  append = TRUE
)
}
\arguments{
\item{timeout}{time, in seconds, of the recording stream.}

\item{file}{Path to a file where the raw streaming should be stored.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{...}{Other parameters passed to the body of the request.}

\item{token}{These endpoints only accept a bearer token (can be created via
\code{\link[=rtweet_app]{rtweet_app()}}). In most cases you
are better of changing the default for all calls via \code{\link[=auth_as]{auth_as()}}.}

\item{append}{Append streaming to the file? Default does but it is
recommended to have a new file for each call.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{query}{If \code{NULL} returns the current rules, else depending:
\itemize{
\item In stream_add_rule it should be a list of value and tag.
\item In stream_rm_rule it should be a vector of ids of rules to be removed
}}

\item{dry}{Check if the addition or removal of the rule works.}
}
\value{
The records in the streaming.
}
\description{
Open a streaming connection with Twitter and stores tweets for as long as you
wish.
}
\details{
The connection can be left open as long as you wish, the data is appended to
the file provided. Be aware that the stream might have incomplete records
(you won't be able to read directly from the json file).
One tweet might belong to multiple rules.
}
\section{Functions}{
\itemize{
\item \code{filtered_stream()}: Start a filtered stream according to the rules.

\item \code{stream_add_rule()}: Add rules for the filtered streaming.

\item \code{stream_rm_rule()}: Remove rules from the filtered streaming

\item \code{sample_stream()}: Retrieve a sample of the tweets posted.

}}
\examples{
# Requires a bearer token
if (FALSE) {
  # How many rules do we have
  stream_add_rule(NULL)
  # Add new rule
  new_rule <- stream_add_rule(list(value = "#rstats", tag = "rstats"))
  new_rule
  # Open filtered streaming connection for 30s
  filtered_stream(file = tempfile(), timeout = 30, parse = FALSE)
  # Remove rule
  stream_rm_rule(ids(new_rule))
  # Open random streaming connection
  sample_stream(file = tempfile(), timeout = 3, parse = FALSE)
}
}
\seealso{
Rules for filtered stream: \url{https://developer.twitter.com/en/docs/twitter-api/tweets/filtered-stream/integrate/build-a-rule}

Sampled stream: \url{https://developer.twitter.com/en/docs/twitter-api/tweets/volume-streams/api-reference/get-tweets-sample-stream}

Filtered stream: \url{https://developer.twitter.com/en/docs/twitter-api/tweets/filtered-stream/api-reference/get-tweets-search-stream}

\code{\link[=ids]{ids()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/save_as_csv.R
\name{write_as_csv}
\alias{write_as_csv}
\alias{save_as_csv}
\title{Save Twitter data as a comma separated value file.}
\usage{
write_as_csv(x, file_name, prepend_ids = TRUE, na = "", fileEncoding = "UTF-8")

save_as_csv(x, file_name, prepend_ids = TRUE, na = "", fileEncoding = "UTF-8")
}
\arguments{
\item{x}{Data frame returned by an rtweet function.}

\item{file_name}{Desired name to save file as. If \code{file_name} does not
include the extension ".csv" it will be added automatically.}

\item{prepend_ids}{Logical indicating whether to prepend an "x"
before all Twitter IDs (for users, statuses, lists, etc.). It's
recommended when saving to CSV as these values otherwise get
treated as numeric and as a result the values are often less
precise due to rounding or other class-related quirks. Defaults
to true.}

\item{na}{Value to be used for missing (NA)s. Defaults to empty
character, "".}

\item{fileEncoding}{Encoding to be used when saving to
CSV. defaults to "UTF-8".}
}
\value{
Saved CSV files in current working directory.
}
\description{
Saves as flattened CSV file of Twitter data.
}
\seealso{
Other datafiles: 
\code{\link{flatten}()},
\code{\link{read_twitter_csv}()}

Other datafiles: 
\code{\link{flatten}()},
\code{\link{read_twitter_csv}()}
}
\concept{datafiles}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tokens.R
\name{get_token}
\alias{get_token}
\alias{get_tokens}
\title{Fetch Twitter OAuth token}
\usage{
get_token()

get_tokens()
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
Please use \code{\link[=auth_get]{auth_get()}} instead.
}
\seealso{
Other tokens: 
\code{\link{create_token}()},
\code{\link{rate_limit}()}
}
\concept{tokens}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tweet_liking_users.R
\name{tweet_liking_users}
\alias{tweet_liking_users}
\title{Liking users}
\usage{
tweet_liking_users(
  id,
  n = 100,
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  parse = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{id}{A tweet id string.}

\item{n}{Number of tweets to query.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{...}{Other arguments passed to the API.}

\item{token}{These endpoints only accept a bearer token (can be created via
\code{\link[=rtweet_app]{rtweet_app()}}). In most cases you
are better of changing the default for all calls via \code{\link[=auth_as]{auth_as()}}.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{A logical value to provide more information about paginated queries.}
}
\description{
Looks up who have liked a given tweet.
}
\examples{
if (FALSE) {
  tlu <- tweet_liking_users("567053242429734913", n = Inf, verbose = TRUE)
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/tweets/likes/api-reference/get-tweets-id-liking_users}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/coords.R
\name{lookup_coords}
\alias{lookup_coords}
\title{Get coordinates of specified location.}
\usage{
lookup_coords(address, components = NULL, apikey = NULL, ...)
}
\arguments{
\item{address}{Desired location typically in the form of place
name, subregion, e.g., address = "lawrence, KS". Also accepts the
name of countries, e.g., address = "usa", address = "brazil" or
states, e.g., address = "missouri" or cities, e.g., address =
"chicago". In most cases using only address should be sufficient.}

\item{components}{Unit of analysis for address e.g., components =
"country:US". Potential components include postal_code, country,
administrative_area, locality, route.}

\item{apikey}{A valid Google Maps API key. If NULL, \code{lookup_coords()} will
look for a relevant API key stored as an environment variable (e.g.,
\code{GOOGLE_MAPS_KEY}).}

\item{...}{Additional arguments passed as parameters in the HTTP
request}
}
\value{
Object of class coords.
}
\description{
Convenience function for looking up latitude/longitude coordinate
information for a given location. Returns data as a special
"coords" object, which is specifically designed to interact
smoothly with other relevant package functions. NOTE: USE OF THIS FUNCTION
REQUIRES A VALID GOOGLE MAPS API KEY.
}
\details{
Since Google Maps implemented stricter API requirements, sending
requests to Google's API isn't very convenient. To enable basic uses
without requiring a Google Maps API key, a number of the major cities
throughout the word and the following two larger locations are
baked into this function: 'world' and 'usa'. If 'world' is supplied then
a bounding box of maximum latitutde/longitude values, i.e.,
\code{c(-180, -90, 180, 90)}, and a center point \code{c(0, 0)} are
returned. If 'usa' is supplied then estimates of the United States'
bounding box and mid-point are returned. To specify a city, provide the
city name followed by a space and then the US state abbreviation or
country name. To see a list of all included cities, enter
\code{rtweet:::citycoords} in the R console to see coordinates data.
}
\examples{

\dontrun{

## get coordinates associated with the following addresses/components
sf <- lookup_coords("san francisco, CA", "country:US")
usa <- lookup_coords("usa")
lnd <- lookup_coords("london")
bz <- lookup_coords("brazil")

}

}
\seealso{
Other geo: 
\code{\link{lat_lng}()}
}
\concept{geo}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fields.R
\name{set_fields}
\alias{set_fields}
\title{Create fields}
\usage{
set_fields(
  media = media_fields,
  poll = poll_fields,
  tweet = tweet_fields,
  place = place_fields,
  user = user_fields,
  list = list_fields
)
}
\arguments{
\item{media}{The fields you want from \code{media_fields}.}

\item{poll}{The fields you want from \code{poll_fields}.}

\item{tweet}{The fields you want from \code{tweet_fields}.}

\item{place}{The fields you want from \code{place_fields}.}

\item{user}{The fields you want from \code{user_fields}.}

\item{list}{The fields you want from \code{list_fields}.}
}
\value{
A list with the fields requested ready to be used in your requests to
the API.
}
\description{
Choose which fields are used, by default all are returned. Usually all
the first 3 are accepted together and the last two too.
}
\examples{
set_fields()
set_fields(media = NULL)
set_fields(place = NULL, user = NULL)
}
\seealso{
Fields
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bearer_token.R
\name{bearer_token}
\alias{bearer_token}
\title{Bearer token}
\usage{
bearer_token(token = NULL)
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{bearer_token()} has been deprecated because it used a rather indirect
method of generating a bearer token. Instead, use \code{\link[=rtweet_app]{rtweet_app()}}, copying
in the bearer token directly from the
\href{https://developer.twitter.com/en/portal/projects-and-apps}{Twitter developer portal}.
See \code{vignette("auth", package = "rtweet")} for full details.
}
\seealso{
\code{\link[=rtweet_bearer]{rtweet_bearer()}}, \code{\link{rtweet-deprecated}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/save_as_csv.R
\name{read_twitter_csv}
\alias{read_twitter_csv}
\title{Read comma separated value Twitter data.}
\usage{
read_twitter_csv(file, unflatten = FALSE)
}
\arguments{
\item{file}{Name of CSV file.}

\item{unflatten}{Logical indicating whether to unflatten (separate hasthags
and mentions columns on space, converting characters to lists), defaults
to FALSE.}
}
\value{
A tbl data frame of Twitter data
}
\description{
Reads Twitter data that was previously saved as a CSV file.
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\seealso{
\code{\link{rtweet-deprecated}}

Other datafiles: 
\code{\link{flatten}()},
\code{\link{write_as_csv}()}
}
\concept{datafiles}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rtweet-package.R
\docType{package}
\name{rtweet-package}
\alias{rtweet}
\alias{rtweet-package}
\title{rtweet: Collect Twitter data from R}
\description{
rtweet provides users a range of functions designed to extract data
from Twitter's REST and streaming APIs. It has three main goals:
\itemize{
\item Formulate and send requests to Twitter's REST and stream APIs.
\item Retrieve and iterate over returned data.
\item Wrangling data into tidy structures.
}

Get started by reading \code{vignette("rtweet")}.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://docs.ropensci.org/rtweet/}
  \item \url{https://github.com/ropensci/rtweet/}
  \item Report bugs at \url{https://github.com/ropensci/rtweet/issues}
}

}
\author{
\strong{Maintainer}: Lluís Revilla Sancho \email{lluis.revilla@gmail.com} (\href{https://orcid.org/0000-0001-9747-2570}{ORCID})

Authors:
\itemize{
  \item Michael W. Kearney \email{kearneymw@missouri.edu} (\href{https://orcid.org/0000-0002-0730-4694}{ORCID})
  \item Hadley Wickham (\href{https://orcid.org/0000-0003-4757-117X}{ORCID})
}

Other contributors:
\itemize{
  \item Andrew Heiss (\href{https://orcid.org/0000-0002-3948-3914}{ORCID}) [reviewer]
  \item Francois Briatte [reviewer]
  \item Jonathan Sidi \email{yonicd@gmail.com} (\href{https://orcid.org/0000-0002-4222-1819}{ORCID}) [contributor]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/user_muted.R
\name{user_muted}
\alias{user_muted}
\title{List muted users}
\usage{
user_muted(
  ids,
  n = 1000,
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  parse = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{ids}{A list id.}

\item{n}{Number of users to query.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{...}{Other parameters passed to the body of the request.}

\item{token}{These endpoints only accept a bearer token (can be created via
\code{\link[=rtweet_app]{rtweet_app()}}). In most cases you
are better of changing the default for all calls via \code{\link[=auth_as]{auth_as()}}.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{A logical value to provide more information about paginated queries.}
}
\value{
A data.frame with the user information of who is following the list:
id, name, and username.
Other information depends on the \code{expansions} and \code{fields} requested.
Accepted values are:
\itemize{
\item Expansions: \code{set_expansions(tweet = NULL, list = NULL)}.
\item Fields: \code{set_fields(media = NULL, poll = NULL, place = NULL, list = NULL)}.
}
}
\description{
Looks up the muted users.
}
\examples{
if (FALSE) {
  um <- user_muted(user_self()$id)
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/users/mutes/api-reference/get-users-muting}
}
\seealso{
\code{\link[=user_self]{user_self()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/post-message.R
\name{post_message}
\alias{post_message}
\title{Posts direct message from user's Twitter account}
\usage{
post_message(text, user, media = NULL, token = NULL)
}
\arguments{
\item{text}{Character, text of message.}

\item{user}{Character vector of screen names or user ids.
See \code{\link[=as_screenname]{as_screenname()}} for more details.}

\item{media}{File path to image or video media to be
included in tweet.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\description{
Posts direct message from user's Twitter account
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/direct-messages/sending-and-receiving/api-reference/new-event}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/graph-network.R
\name{network_data}
\alias{network_data}
\alias{network_graph}
\title{Network data}
\usage{
network_data(x, e = c("mention", "retweet", "reply", "quote"))

network_graph(x, e = c("mention", "retweet", "reply", "quote"))
}
\arguments{
\item{x}{Data frame returned by rtweet function}

\item{e}{Type of edge/link–i.e., "mention", "retweet", "quote", "reply".
This must be a character vector of length one or more. This value will be
split on punctuation and space (so you can include multiple types in the
same string separated by a comma or space). The values "all" and
"semantic" are assumed to mean all edge types, which is equivalent to the
default value of \code{c("mention", "retweet", "reply", "quote")}}
}
\value{
A from/to data edge data frame

An igraph object
}
\description{
\itemize{
\item \code{network_data()} returns a data frame that can easily be converted to
various network classes.
\item \code{network_graph()} returns a igraph object
}
}
\details{
Retrieve data to know which users are connected to which users.
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\seealso{
\code{\link[=network_graph]{network_graph()}} \code{\link{rtweet-deprecated}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tweet_threading.R
\name{tweet_threading}
\alias{tweet_threading}
\title{Collect statuses contained in a thread}
\usage{
tweet_threading(tw, traverse = c("backwards", "forwards"), verbose = FALSE)
}
\arguments{
\item{tw}{\code{\link[=lookup_tweets]{lookup_tweets()}} output containing
at least the last status in the thread or an id of a tweet.}

\item{traverse}{character, direction to traverse from origin status in \code{tw}.
It is not recommended to change the default if you don't know at which point of a thread you are starting.}

\item{verbose}{logical, output to console status of traverse.}
}
\value{
Tweets in a structure like \code{\link[=lookup_tweets]{lookup_tweets()}}.
}
\description{
Return all statuses that are part of a thread (Replies from a user to their
own tweets). By default the function traverses first backwards from the
origin status_id of the thread up to the root, then checks if there are any
child statuses that were posted after the origin status.
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\details{
The backwards method looks up the tweet which is replying to, so it works if
starting from the last tweet of the thread.

The forwards method looks for newer replies to the tweet provided. If the tweet doesn't have a reply it won't be able to find anything.
The forwards method is limited by the timeline API (See \code{\link[=get_timeline]{get_timeline()}}).
}
\seealso{
\code{\link{rtweet-deprecated}}, \code{\link[=lookup_tweets]{lookup_tweets()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/client.R
\name{client_as}
\alias{client_as}
\title{Set default client for the current session}
\usage{
client_as(client = NULL)
}
\arguments{
\item{client}{One of the following options:
\itemize{
\item \code{NULL}, the default, will look for rtweet's "default" authentication
which uses your personal default Twitter client. If it's not found, it will
call \code{\link[=client_setup_default]{client_setup_default()}} to set it up.
\item A string giving the name of a saved auth file made by \code{\link[=client_save]{client_save()}}.
\item A client object created by \code{\link[=rtweet_client]{rtweet_client()}}.
}}
}
\value{
Invisibly returns the previous authentication mechanism.
}
\description{
\code{client_as()} sets up the default client used by rtweet API calls with PKCE. See \code{\link[=rtweet_user]{rtweet_user()}} to learn more about the three
available authentication options.
}
\examples{
\dontrun{
# Use app auth for the remainder of this session:
my_app <- rtweet_app()
auth_as(my_app)

# Switch back to the default user based auth
client_as()
client_list()
}
}
\seealso{
Other client: 
\code{\link{client_get}()},
\code{\link{client_has_default}()},
\code{\link{client_save}()}
}
\concept{client}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/client.R
\name{client_clean}
\alias{client_clean}
\title{Clean clients}
\usage{
client_clean()
}
\value{
Either TRUE if folder could be deleted or FALSE.
}
\description{
Removes the rtweet clients directory.
}
\examples{
client_clean()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/clean_tweets.R
\name{clean_tweets}
\alias{clean_tweets}
\title{Clean text of tweets}
\usage{
clean_tweets(x, clean = c("users", "hashtags", "urls", "media"))
}
\arguments{
\item{x}{Tweets}

\item{clean}{Type of elements to be removed.}
}
\value{
A vector with the text without the entities selected
}
\description{
Removes from the text, users mentions, hashtags, urls and media.
Some urls or other text might remain if it is not recognized as an entity by
the API. \ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\seealso{
\code{\link{rtweet-deprecated}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/mentions.R
\name{get_mentions}
\alias{get_mentions}
\title{Get mentions for the authenticating user.}
\usage{
get_mentions(
  n = 200,
  since_id = NULL,
  max_id = NULL,
  parse = TRUE,
  retryonratelimit = NULL,
  verbose = TRUE,
  token = NULL,
  ...
)
}
\arguments{
\item{n}{Desired number of results to return. Results are downloaded
in pages when \code{n} is large; the default value will download a single
page. Set \code{n = Inf} to download as many results as possible.

The Twitter API rate limits the number of requests you can perform
in each 15 minute period. The easiest way to download more than that is
to use \code{retryonratelimit = TRUE}.

You are not guaranteed to get exactly \code{n} results back. You will get
fewer results when tweets have been deleted or if you hit a rate limit.
You will get more results if you ask for a number of tweets that's not
a multiple of page size, e.g. if you request \code{n = 150} and the page
size is 200, you'll get 200 results back.}

\item{since_id}{Supply a vector of ids or a data frame of previous results to
find tweets \strong{newer} than \code{since_id}.}

\item{max_id}{Supply a vector of ids or a data frame of previous results to
find tweets \strong{older} than \code{max_id}.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{retryonratelimit}{If \code{TRUE}, and a rate limit is exhausted, will wait
until it refreshes. Most Twitter rate limits refresh every 15 minutes.
If \code{FALSE}, and the rate limit is exceeded, the function will terminate
early with a warning; you'll still get back all results received up to
that point. The default value, \code{NULL}, consults the option
\code{rtweet.retryonratelimit} so that you can globally set it to \code{TRUE},
if desired.

If you expect a query to take hours or days to perform, you should not
rely solely on \code{retryonratelimit} because it does not handle other common
failure modes like temporarily losing your internet connection.}

\item{verbose}{Show progress bars and other messages indicating current
progress?}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{...}{Other arguments passed as parameters in composed API
query.}
}
\value{
Tibble of mentions data.
}
\description{
Returns data on up to 200 of the most recent mentions (Tweets
containing a users' screen_name) of the authenticating user.
The timeline returned is the equivalent of the one seen when you view
your mentions on twitter.com. \ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/timelines/overview}
}
\seealso{
\code{\link{rtweet-deprecated}}

Other tweets: 
\code{\link{get_favorites}()},
\code{\link{get_timeline}()},
\code{\link{lists_statuses}()},
\code{\link{lookup_tweets}()},
\code{\link{search_tweets}()}
}
\concept{tweets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/do_call_rbind.R
\name{do_call_rbind}
\alias{do_call_rbind}
\title{Binds list of data frames while preserving attribute (tweets or users) data.}
\usage{
do_call_rbind(x)
}
\arguments{
\item{x}{List of parsed tweets data or users data, each of which
presumably contains an attribute of the other (i.e., users data
contains tweets attribute; tweets data contains users attribute).}
}
\value{
A single merged (by row) data frame (tbl) of tweets or
users data that also contains as an attribute a merged (by row)
data frame (tbl) of its counterpart, making it accessible via the
\code{\link[=users_data]{users_data()}} or \code{\link[=tweets_data]{tweets_data()}} extractor
functions.
}
\description{
Row bind lists of tweets/users data whilst also preserving and binding
users/tweets attribute data. \ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\seealso{
\code{\link{rtweet-deprecated}}
}
\concept{parsing}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auth.R
\name{auth_get}
\alias{auth_get}
\title{Get the current authentication mechanism}
\usage{
auth_get()
}
\value{
The current token used.
}
\description{
If no authentication has been set up for this session, \code{auth_get()} will
call \code{\link[=auth_as]{auth_as()}} to set it up.
}
\examples{
\dontrun{
auth_get()
}
}
\seealso{
Other authentication: 
\code{\link{auth_as}()},
\code{\link{auth_save}()},
\code{\link{auth_setup_default}()},
\code{\link{rtweet_user}()}
}
\concept{authentication}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/user_by_username.R
\name{user_by_username}
\alias{user_by_username}
\title{Search users by username}
\usage{
user_by_username(
  username,
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  parse = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{username}{A user name string or up to 100.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{...}{Other arguments passed to the API.}

\item{token}{These endpoints only accept a bearer token (can be created via
\code{\link[=rtweet_app]{rtweet_app()}}). In most cases you
are better of changing the default for all calls via \code{\link[=auth_as]{auth_as()}}.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{A logical value to provide more information about paginated queries.}
}
\description{
Looks up users by their username.
}
\examples{
if (FALSE) {
  user_by_username("rOpenSci")
  user_by_username(c("Bioconductor", "R_Contributors"))
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/users/lookup/api-reference/get-users-by-username-username}
\url{https://developer.twitter.com/en/docs/twitter-api/users/lookup/api-reference/get-users-by}
}
\seealso{
\code{\link[=user_search]{user_search()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/user_timeline.R
\name{user_timeline}
\alias{user_timeline}
\title{User timeline}
\usage{
user_timeline(
  id,
  n = 100,
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  parse = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{id}{A tweet id string.}

\item{n}{Number of tweets to query.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{...}{Other arguments passed to the API.}

\item{token}{These endpoints only accept a bearer token (can be created via
\code{\link[=rtweet_app]{rtweet_app()}}). In most cases you
are better of changing the default for all calls via \code{\link[=auth_as]{auth_as()}}.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{A logical value to provide more information about paginated queries.}
}
\description{
Looks up the timeline of a user with up to 800 tweets in the last 7 days.
}
\examples{
if (FALSE) {
  ut <- user_timeline("1599030512919650304", verbose = TRUE)
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/tweets/timelines/api-reference/get-users-id-mentions}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/friends.R
\name{lookup_friendships}
\alias{lookup_friendships}
\title{Lookup friendship information between two specified users.}
\usage{
lookup_friendships(source, target, parse = TRUE, token = NULL)
}
\arguments{
\item{source}{Screen name or user id of source user.}

\item{target}{Screen name or user id of target user.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\description{
Gets information on friendship between two Twitter users.
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-friendships-show}
}
\seealso{
Other friends: 
\code{\link{my_friendships}()}
}
\concept{friends}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statuses.R
\name{tweet_delete}
\alias{tweet_delete}
\title{Delete tweet}
\usage{
tweet_delete(id, verbose = FALSE, token = NULL)
}
\arguments{
\item{id}{At least a tweet id.}

\item{verbose}{A logical value to provide more information about the
paginated queries (if any) and to store the data of each page.}

\item{token}{This endpoint accepts a OAuth2.0 authentication (can be
created via \code{\link[=rtweet_oauth2]{rtweet_oauth2()}}) or a bearer token (can be created via \code{\link[=rtweet_app]{rtweet_app()}}).}
}
\description{
Will delete a tweet
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/tweets/manage-tweets/api-reference/delete-tweets-id}
}
\seealso{
\code{\link[=tweet_post]{tweet_post()}}, \code{\link[=tweet_search_recent]{tweet_search_recent()}}, \code{\link[=user_timeline]{user_timeline()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/deprecated.R
\name{rtweet-deprecated}
\alias{rtweet-deprecated}
\title{Deprecated functions in rtweet}
\description{
These functions might not work due to the drop of API v1 in favor of API v2.
\itemize{
\item \code{clean_tweets()}: No replacement.
\item \code{collections()}: No replacement (It hasn't worked for a while).
\item \code{direct_messages()}: No replacement.
\item \code{do_call_rbind()}: No replacement (if any it will be a method).
\item \code{get_favorites()}: Use \code{tweet_liking_users()}.
\item \code{get_followers()}: Use \code{user_following()}.
\item \code{get_friends()}: Use \code{user_followers()}.
\item \code{network_data()} and \code{network_graph()}: No replacement.
\item \code{list_memberships()}: Use \code{list_users()}.
\item \code{get_mentions()}: Use \code{user_mentions()}
\item \code{user_block()}: No replacement.
\item \code{post_favorite()}: No replacement.
\item \code{post_list()}: \code{lists_subscribers()}, \code{list_subscriptions()}, \code{list_members()}, \code{lists_users()}
\item \code{post_tweet()}: Use \code{tweet_post()}.
\item \code{post_follow()}: No replacement.
\item \code{post_destroy()}: Use \code{tweet_delete()}.
\item \code{search_fullarchive()}: Use \code{tweet_search_all()}.
\item \code{search_30d()}: Use \code{tweet_search_recent()}.
\item \code{rate_limit()}: No replacement (already implemented inside the calls).
\item \code{save_as_csv()}: No replacement.
\item \code{search_tweets()}: Use \code{tweet_search_recent()}.
\item \code{search_tweets2()}: Use \code{tweet_search_recent()}.
\item \code{search_users()}: Use \code{user_search()}.
\item \code{lookup_tweets()}: Use \code{tweet_get()}, \code{tweet_retweeted_by()}.
\item \code{stream_tweets()}: Use \code{filtered_stream()}, \code{stream_add_rule()}, \code{stream_rm_rule()} and \code{sample_stream()}.
\item \code{get_timeline()}: Use \code{user_timeline()}.
\item \code{get_my_timeline()}: Use \code{user_timeline()}.
\item \code{get_token()}: Use \code{auth_get()}.
\item \code{get_tokens()}: Use \code{auth_get()}.
\item \code{get_trends()}: No replacement.
\item \code{trends_available()} and \code{trends_closest()}: No replacement.
\item \code{ts_data()} and \code{ts_plot()}: No replacement.
\item \code{tweet_shot()}: No replacement.
\item \code{tweet_threading()}: Use \code{tweet_get()} with conversation ID.
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lists_statuses.R
\name{lists_statuses}
\alias{lists_statuses}
\title{Get a timeline of tweets authored by members of a specified list.}
\usage{
lists_statuses(
  list_id = NULL,
  slug = NULL,
  owner_user = NULL,
  since_id = NULL,
  max_id = NULL,
  n = 200,
  include_rts = TRUE,
  parse = TRUE,
  retryonratelimit = NULL,
  verbose = TRUE,
  token = NULL
)
}
\arguments{
\item{list_id}{required The numerical id of the list.}

\item{slug}{required You can identify a list by its slug instead of
its numerical id. If you decide to do so, note that you'll also have
to specify the list owner using the owner_id or owner_screen_name
parameters.}

\item{owner_user}{optional The screen name or user ID of the user
who owns the list being requested by a slug.}

\item{since_id}{Supply a vector of ids or a data frame of previous results to
find tweets \strong{newer} than \code{since_id}.}

\item{max_id}{Supply a vector of ids or a data frame of previous results to
find tweets \strong{older} than \code{max_id}.}

\item{n}{Desired number of results to return. Results are downloaded
in pages when \code{n} is large; the default value will download a single
page. Set \code{n = Inf} to download as many results as possible.

The Twitter API rate limits the number of requests you can perform
in each 15 minute period. The easiest way to download more than that is
to use \code{retryonratelimit = TRUE}.

You are not guaranteed to get exactly \code{n} results back. You will get
fewer results when tweets have been deleted or if you hit a rate limit.
You will get more results if you ask for a number of tweets that's not
a multiple of page size, e.g. if you request \code{n = 150} and the page
size is 200, you'll get 200 results back.}

\item{include_rts}{optional When set to either true, t or 1,
the list timeline will contain native retweets (if they exist) in
addition to the standard stream of tweets. The output format of
retweeted tweets is identical to the representation you see in
home_timeline.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{retryonratelimit}{If \code{TRUE}, and a rate limit is exhausted, will wait
until it refreshes. Most Twitter rate limits refresh every 15 minutes.
If \code{FALSE}, and the rate limit is exceeded, the function will terminate
early with a warning; you'll still get back all results received up to
that point. The default value, \code{NULL}, consults the option
\code{rtweet.retryonratelimit} so that you can globally set it to \code{TRUE},
if desired.

If you expect a query to take hours or days to perform, you should not
rely solely on \code{retryonratelimit} because it does not handle other common
failure modes like temporarily losing your internet connection.}

\item{verbose}{Show progress bars and other messages indicating current
progress?}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\value{
data
}
\description{
Get a timeline of tweets authored by members of a specified list.
}
\seealso{
Other lists: 
\code{\link{lists_members}()},
\code{\link{lists_subscribers}()},
\code{\link{lists_subscriptions}()},
\code{\link{lists_users}()}

Other tweets: 
\code{\link{get_favorites}()},
\code{\link{get_mentions}()},
\code{\link{get_timeline}()},
\code{\link{lookup_tweets}()},
\code{\link{search_tweets}()}
}
\concept{lists}
\concept{tweets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auth.R
\name{auth_as}
\alias{auth_as}
\title{Set default authentication for the current session}
\usage{
auth_as(auth = NULL)
}
\arguments{
\item{auth}{One of the following options:
\itemize{
\item \code{NULL}, the default, will look for rtweet's "default" authentication
which uses your personal Twitter account. If it's not found, it will
call \code{\link[=auth_setup_default]{auth_setup_default()}} to set it up.
\item A string giving the name of a saved auth file made by \code{\link[=auth_save]{auth_save()}}.
\item An auth object created by \code{\link[=rtweet_app]{rtweet_app()}}, \code{\link[=rtweet_bot]{rtweet_bot()}}, or
\code{\link[=rtweet_user]{rtweet_user()}}.
}}
}
\value{
Invisibly returns the previous authentication mechanism.
}
\description{
\code{auth_as()} sets up the default authentication mechanism used by all
rtweet API calls. See \code{\link[=rtweet_user]{rtweet_user()}} to learn more about the three
available authentication options.
}
\examples{
\dontrun{
# Use app auth for the remainder of this session:
my_app <- rtweet_app()
auth_as(my_app)

# Switch back to the default user based auth
auth_as()

# Load auth saved by auth_save()
auth_as("my-saved-app")
}
}
\seealso{
\code{\link[=auth_sitrep]{auth_sitrep()}} to help finding and managing authentications.

Other authentication: 
\code{\link{auth_get}()},
\code{\link{auth_save}()},
\code{\link{auth_setup_default}()},
\code{\link{rtweet_user}()}
}
\concept{authentication}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/collections.R
\name{lookup_collections}
\alias{lookup_collections}
\alias{get_collections}
\title{Collections API}
\usage{
lookup_collections(id, n = 200, parse = TRUE, token = NULL, ...)

get_collections(
  user = NULL,
  status_id = NULL,
  n = 200,
  cursor = NULL,
  parse = TRUE,
  token = NULL
)
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}

\code{get_collections()} and \code{lookup_collections()} have been deprecated
since the underlying Twitter API has been deprecated.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/expansions.R
\name{Expansions}
\alias{Expansions}
\alias{set_expansions}
\alias{expansions}
\alias{tweet_expansions}
\alias{user_expansions}
\alias{list_expansions}
\title{Expansions}
\usage{
set_expansions(
  tweet = tweet_expansions(),
  user = user_expansions(),
  list = list_expansions()
)

tweet_expansions(attachments = TRUE, referenced_tweets = TRUE)

user_expansions()

list_expansions()
}
\arguments{
\item{tweet, user, list}{\code{\link[=tweet_expansions]{tweet_expansions()}}, \code{\link[=user_expansions]{user_expansions()}} and \code{\link[=tweet_expansions]{tweet_expansions()}}.}

\item{attachments}{Add attachments values? Default yes.}

\item{referenced_tweets}{Add referenced_tweets values? Default yes.}
}
\value{
A character with the characters of valid expansions.
}
\description{
Twitter parameters to add more fields on the returned values.
}
\details{
The \code{set_expansions} can be used to prepare the arguments for other rtweet functions.
}
\examples{
tweet_expansions()
user_expansions()
set_expansions()
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/expansions}
}
\seealso{
\link{Fields}, \code{\link[=set_fields]{set_fields()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{stopwordslangs}
\alias{stopwordslangs}
\title{Defunct: Twitter stop words in multiple languages data.}
\format{
A tibble with three variables and 24,000 observations
}
\description{
This data comes form a group of Twitter searches conducted at
several times during the calendar year of 2017. The data are
commonly observed words associated with 10 different languages,
including \code{c("ar", "en", "es", "fr", "in", "ja", "pt", "ru", "tr", "und")}. Variables include \code{"word"} (potential stop
words), \code{"lang"} (two or three word code), and \code{"p"}
(probability value associated with frequency position along a
normal distribution with higher values meaning the word occurs more
frequently and lower values meaning the words occur less
frequently).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ts_plot.R
\name{ts_data}
\alias{ts_data}
\title{Converts tweets data into time series-like data object.}
\usage{
ts_data(data, by = "days", trim = 0L, tz = "UTC")
}
\arguments{
\item{data}{Data frame or grouped data frame.}

\item{by}{Desired interval of time expressed as numeral plus one of
"secs", "mins", "hours", "days", "weeks", "months", or
"years". If a numeric is provided, the value is assumed to be in
seconds.}

\item{trim}{Number of observations to trim off the front and end of
each time series}

\item{tz}{Time zone to be used, defaults to "UTC" (Twitter default)}
}
\value{
Data frame with time, n, and grouping column if applicable.
}
\description{
Returns data containing the frequency of tweets over a specified
interval of time.
}
\examples{
if (auth_has_default()) {

## handles of women senators
orgs <- c("_R_Foundation", "ropensci")

## get timelines for each
orgs_tml <- get_timeline(orgs, n = 100)

## get single time series for tweets
ts_data(orgs_tml)

## using weekly intervals
ts_data(orgs_tml, "weeks")
}

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ts_plot.R
\name{ts_plot}
\alias{ts_plot}
\title{Plots tweets data as a time series-like data object.}
\usage{
ts_plot(data, by = "days", trim = 0L, tz = "UTC", ...)
}
\arguments{
\item{data}{Data frame or grouped data frame.}

\item{by}{Desired interval of time expressed as numeral plus one of
"secs", "mins", "hours", "days", "weeks", "months", or
"years". If a numeric is provided, the value is assumed to be in
seconds.}

\item{trim}{The number of observations to drop off the beginning
and end of the time series.}

\item{tz}{Time zone to be used, defaults to "UTC" (Twitter default)}

\item{...}{Other arguments passed to
\code{\link[ggplot2:geom_path]{ggplot2::geom_line()}}.}
}
\value{
If
\href{https://cran.r-project.org/package=ggplot2}{ggplot2} is
installed then a \code{\link[ggplot2:ggplot]{ggplot2::ggplot()}} plot object.
}
\description{
Creates a ggplot2 plot of the frequency of tweets over a specified
interval of time. \ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\seealso{
\code{\link{rtweet-deprecated}}
}
\concept{ts_data}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/friends.R
\name{get_friends}
\alias{get_friends}
\title{Get user IDs of accounts followed by target user(s).}
\usage{
get_friends(
  users,
  n = 5000,
  retryonratelimit = NULL,
  cursor = "-1",
  parse = TRUE,
  verbose = TRUE,
  token = NULL,
  page = lifecycle::deprecated()
)
}
\arguments{
\item{users}{Screen name or user ID of target user from which the
user IDs of friends (accounts followed BY target user) will be
retrieved.}

\item{n}{Desired number of results to return. Results are downloaded
in pages when \code{n} is large; the default value will download a single
page. Set \code{n = Inf} to download as many results as possible.

The Twitter API rate limits the number of requests you can perform
in each 15 minute period. The easiest way to download more than that is
to use \code{retryonratelimit = TRUE}.

You are not guaranteed to get exactly \code{n} results back. You will get
fewer results when tweets have been deleted or if you hit a rate limit.
You will get more results if you ask for a number of tweets that's not
a multiple of page size, e.g. if you request \code{n = 150} and the page
size is 200, you'll get 200 results back.}

\item{retryonratelimit}{If \code{TRUE}, and a rate limit is exhausted, will wait
until it refreshes. Most Twitter rate limits refresh every 15 minutes.
If \code{FALSE}, and the rate limit is exceeded, the function will terminate
early with a warning; you'll still get back all results received up to
that point. The default value, \code{NULL}, consults the option
\code{rtweet.retryonratelimit} so that you can globally set it to \code{TRUE},
if desired.

If you expect a query to take hours or days to perform, you should not
rely solely on \code{retryonratelimit} because it does not handle other common
failure modes like temporarily losing your internet connection.}

\item{cursor}{Which page of results to return. The default will return
the first page; you can supply the result from a previous call to
continue pagination from where it left off.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{Show progress bars and other messages indicating current
progress?}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{page}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}} Please use \code{cursor} instead.}
}
\value{
A tibble data frame with two columns, "from_id" for name or ID of target
user and "to_id" for accounts ID they follow.
}
\description{
Returns a list of user IDs for the accounts following BY one or
more specified users. \ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\details{
Generally, you should not need to set \code{n} to more than 5,000 since Twitter
limits the number of people that you can follow (i.e. to follow more than
5,000 people at least 5,000 people need to follow you).
}
\note{
If a user is protected the API will omit all requests so you'll need
to find which user is protected. rtweet will warn you and the output will be \code{NA}.
}
\examples{
if (FALSE) {
  get_friends("ropensci")
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-friends-ids}
}
\seealso{
\code{\link{rtweet-deprecated}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stream.R
\name{parse_stream}
\alias{parse_stream}
\title{Parser of stream}
\usage{
parse_stream(path, ...)
}
\arguments{
\item{path}{Character, name of JSON file with data collected by
\code{\link[=stream_tweets]{stream_tweets()}}.}

\item{...}{Unused, keeping it for back compatibility.}
}
\description{
Converts Twitter stream data (JSON file) into parsed data frame.
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\examples{
\dontrun{
stream_tweets(timeout = 1, file_name = "stream.json", parse = FALSE)
parse_stream("stream.json")
}
}
\seealso{
\code{\link[=stream_tweets]{stream_tweets()}}, \code{\link{rtweet-deprecated}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tokens.R
\name{create_token}
\alias{create_token}
\title{Create custom Twitter OAuth token}
\usage{
create_token(
  app = "mytwitterapp",
  consumer_key = NULL,
  consumer_secret = NULL,
  access_token = NULL,
  access_secret = NULL,
  set_renv = TRUE
)
}
\arguments{
\item{app}{Name of user created Twitter application}

\item{consumer_key, consumer_secret}{App API key and secret.}

\item{access_token, access_secret}{Access token and secret.}

\item{set_renv}{Should the token be cached?}
}
\value{
Twitter OAuth token(s) (Token1.0).
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
By default, \code{create_token()} does three things: it creates an authentication
"token", sets it as the default token for the current session, and save it
to disk to make it the default for future sessions.

These three components have now been split up into three separate pieces:
use \code{\link[=rtweet_user]{rtweet_user()}}/\code{\link[=rtweet_app]{rtweet_app()}}/\code{\link[=rtweet_bot]{rtweet_bot()}} to create the token,
\code{\link[=auth_as]{auth_as()}} to make it the default for this session, and \code{\link[=auth_save]{auth_save()}} to
use it in future sessions. See \code{vignette("auth", package = "rtweet")} for full details.
}
\seealso{
Other tokens: 
\code{\link{get_token}()},
\code{\link{rate_limit}()}
}
\concept{tokens}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/post_destroy.R
\name{post_destroy}
\alias{post_destroy}
\title{Delete status of user's Twitter account \ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}}
\usage{
post_destroy(destroy_id, token = NULL)
}
\arguments{
\item{destroy_id}{To delete a status, supply the single status ID here. If a
character string is supplied, overriding the default (NULL), then a destroy
request is made (and the status text and media attachments) are irrelevant.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\description{
Deletes a status of user's profile.
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/post-statuses-destroy-id}
}
\seealso{
\code{\link[=tweet_delete]{tweet_delete()}} \code{\link{rtweet-deprecated}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stream.R
\name{stream_tweets}
\alias{stream_tweets}
\title{Collect a live stream of Twitter data}
\usage{
stream_tweets(
  q = "",
  timeout = 30,
  parse = TRUE,
  token = NULL,
  file_name = NULL,
  verbose = TRUE,
  append = TRUE,
  ...
)
}
\arguments{
\item{q}{Query used to select and customize streaming collection
method.  There are four possible methods:
\enumerate{
\item The default, \code{q = ""}, returns a small random sample of all
publicly available Twitter statuses.
\item To filter by keyword, provide a comma separated character string with
the desired phrase(s) and keyword(s).
\item Track users by providing a comma separated list of user IDs or
screen names.
\item Use four latitude/longitude bounding box points to stream by geo
location. This must be provided via a vector of length 4, e.g.,
\code{c(-125, 26, -65, 49)}.
}}

\item{timeout}{Integer specifying number of seconds to stream tweets for.
Stream indefinitely with \code{timeout = Inf}.

The stream can be interrupted at any time, and \code{file_name} will still be
valid file.}

\item{parse}{Use \code{FALSE} to opt-out of parsing the tweets.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{file_name}{Character with name of file. If not specified,
will write to a temporary file \code{stream_tweets*.json}.}

\item{verbose}{If \code{TRUE}, display a progress bar.}

\item{append}{If \code{TRUE}, will append to the end of \code{file_name}; if
\code{FALSE}, will overwrite.}

\item{...}{Other arguments passed in to query parameters.}
}
\value{
A tibble with one row per tweet
}
\description{
Streams public statuses to a file via one of the following four methods:
\enumerate{
\item Sampling a small random sample of all publicly available tweets
\item Filtering via a search-like query (up to 400 keywords)
\item Tracking via vector of user ids (up to 5000 user_ids)
\item Location via geo coordinates (1-360 degree location boxes)
}

Learn more in \code{vignette("stream", package = "rtweet")}
}
\details{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
They were removed from the website.

The webpages describing how it used to work were removed.
}
\seealso{
\code{\link[=filtered_stream]{filtered_stream()}}, \code{\link{rtweet-deprecated}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/premium.R
\name{search_fullarchive}
\alias{search_fullarchive}
\alias{search_30day}
\title{Premium Twitter searches}
\usage{
search_fullarchive(
  q,
  n = 100,
  fromDate = NULL,
  toDate = NULL,
  continue = NULL,
  env_name = NULL,
  premium = FALSE,
  safedir = NULL,
  parse = TRUE,
  token = NULL
)

search_30day(
  q,
  n = 100,
  fromDate = NULL,
  toDate = NULL,
  env_name = NULL,
  continue = NULL,
  premium = FALSE,
  safedir = NULL,
  parse = TRUE,
  token = NULL
)
}
\arguments{
\item{q}{Search query on which to match/filter tweets. See details for
information about available search operators.}

\item{n}{Desired number of results to return. Results are downloaded
in pages when \code{n} is large; the default value will download a single
page. Set \code{n = Inf} to download as many results as possible.

The Twitter API rate limits the number of requests you can perform
in each 15 minute period. The easiest way to download more than that is
to use \code{retryonratelimit = TRUE}.

You are not guaranteed to get exactly \code{n} results back. You will get
fewer results when tweets have been deleted or if you hit a rate limit.
You will get more results if you ask for a number of tweets that's not
a multiple of page size, e.g. if you request \code{n = 150} and the page
size is 200, you'll get 200 results back.}

\item{fromDate}{Oldest date-time (YYYYMMDDHHMM) from which tweets should be
searched for.}

\item{toDate}{Newest date-time (YYYYMMDDHHMM) from which tweets should be
searched for.}

\item{continue}{A character string with the next results of a query. You
must make the exact same query as the original, including \code{q}, \code{toDate},
and \code{fromDate}.}

\item{env_name}{Name/label of developer environment to use for the search.}

\item{premium}{A logical value if the environment is paid (TRUE) or
sandboxed, the default (FALSE). It limits the number of results retrieved so the number
of API queries needed to retrieve \code{n} results.}

\item{safedir}{Name of directory to which each response object should be
saved. If the directory doesn't exist, it will be created. If NULL (the
default) then a dir will be created in the current working directory. To
override/deactivate safedir set this to FALSE.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\value{
A tibble data frame of Twitter data.
}
\description{
Search 30day or fullarchive premium products. There is a limit of 5000 tweets
and 25000 for the fullarchive and 30day endpoints respectively. In addition,
there are some limits in the number of requests that are possible on a
certain amount of time, this have already been taken into account.
See the info provided by Twitter and the "Developer Account" section.
}
\details{
Note: The \code{env_name} must match the ones you set up for the token you are using.
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\section{Developer Account}{

Users must have an approved developer account and an active/labeled
environment to access Twitter's premium APIs. For more information, to check
your current Subscriptions and Dev Environments, or to apply for a developer
account visit \url{https://developer.twitter.com}.
}

\section{Search operators}{

\emph{Note: Bolded operators ending with a colon should be immediately
followed by a word or quoted phrase (if appropriate)–e.g.,} \code{lang:en}
}

\section{Keyword}{

\itemize{
\item \strong{""}           ~~ match exact phrase
\item \strong{#}               ~~ hashtag
\item \strong{@}               ~~ at mentions)
\item \strong{url:}            ~~ found in URL
\item \strong{lang:}           ~~ language of tweet
}
}

\section{Accounts of interest}{

\itemize{
\item \strong{from:}           ~~ authored by
\item \strong{to:}             ~~ sent to
\item \strong{retweets_of:}    ~~ retweet author
}
}

\section{Tweet attributes}{

\itemize{
\item \strong{is:retweet}      ~~ only retweets
\item \strong{has:mentions}    ~~ uses mention(s)
\item \strong{has:hashtags}    ~~ uses hashtags(s)
\item \strong{has:media}       ~~ includes media(s)
\item \strong{has:videos}      ~~ includes video(s)
\item \strong{has:images}      ~~ includes image(s)
\item \strong{has:links}       ~~ includes URL(s)
\item \strong{is:verified}     ~~ from verified accounts
}
}

\section{Geospatial}{

\itemize{
\item \strong{bounding_box:[west_long south_lat east_long north_lat]} ~~ lat/long coordinates box
\item \strong{point_radius:[lon lat radius]} ~~ center of search radius
\item \strong{has:geo}           ~~ uses geotagging
\item \strong{place:}            ~~ by place
\item \strong{place_country:}    ~~ by country
\item \strong{has:profile_geo}   ~~ geo associated with profile
\item \strong{profile_country:}  ~~ country associated with profile
\item \strong{profile_region:}   ~~ region associated with profile
\item \strong{profile_locality:} ~~ locality associated with profile
}
}

\seealso{
\code{\link[=tweet_search_recent]{tweet_search_recent()}}, \code{\link[=tweet_search_all]{tweet_search_all()}}, \code{\link{rtweet-deprecated}}
}
\concept{premium endpoints}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/users.R
\name{lookup_users}
\alias{lookup_users}
\title{Get Twitter users data for given users (user IDs or screen names).}
\usage{
lookup_users(
  users,
  parse = TRUE,
  token = NULL,
  retryonratelimit = NULL,
  verbose = TRUE
)
}
\arguments{
\item{users}{User id or screen name of target user.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{retryonratelimit}{If \code{TRUE}, and a rate limit is exhausted, will wait
until it refreshes. Most Twitter rate limits refresh every 15 minutes.
If \code{FALSE}, and the rate limit is exceeded, the function will terminate
early with a warning; you'll still get back all results received up to
that point. The default value, \code{NULL}, consults the option
\code{rtweet.retryonratelimit} so that you can globally set it to \code{TRUE},
if desired.

If you expect a query to take hours or days to perform, you should not
rely solely on \code{retryonratelimit} because it does not handle other common
failure modes like temporarily losing your internet connection.}

\item{verbose}{Show progress bars and other messages indicating current
progress?}
}
\value{
A tibble of users data.
}
\description{
Get Twitter users data for given users (user IDs or screen names).
}
\examples{

if (FALSE) {
    users <- c("twitter", "rladiesglobal", "_R_Foundation")
    users <- lookup_users(users)
}

}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-users-lookup}
}
\seealso{
Other users: 
\code{\link{as_screenname}()},
\code{\link{lists_subscribers}()},
\code{\link{search_users}()}
}
\concept{users}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{langs}
\alias{langs}
\title{Defunct: Language codes recognized by Twitter data.}
\format{
A tibble with five variables and 486 observations.
}
\description{
This data comes from the Library of Congress,
\url{https://www.loc.gov/standards/iso639-2/ISO-639-2_utf-8.txt}. The data are
descriptions and codes associated with internationally recognized languages.
Variables include translations for each language represented as
bibliographic, terminological, alpha, English, and French.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ts_plot.R
\name{round_time}
\alias{round_time}
\title{A generic function for rounding date and time values}
\usage{
round_time(x, n, tz)
}
\arguments{
\item{x}{A vector of class POSIX or Date.}

\item{n}{Unit to round to. Defaults to mins. Numeric values treated
as seconds. Otherwise this should be one of "mins", "hours", "days",
"weeks", "months", "years" (plural optional).}

\item{tz}{Time zone to be used, defaults to "UTC" (Twitter default)}
}
\value{
If POSIXct then POSIX. If date then Date.
}
\description{
A generic function for rounding date and time values
}
\examples{

## class posixct
round_time(Sys.time(), "12 hours")

## class date
unique(round_time(seq(Sys.Date(), Sys.Date() + 100, "1 day"), "weeks"))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/post-list.R
\name{post_list}
\alias{post_list}
\title{Manage Twitter lists}
\usage{
post_list(
  users = NULL,
  name = NULL,
  description = NULL,
  private = FALSE,
  destroy = FALSE,
  list_id = NULL,
  slug = NULL,
  token = NULL
)
}
\arguments{
\item{users}{Character vectors of users to be added to list.}

\item{name}{Name of new list to create.}

\item{description}{Optional, description of list (single character string).}

\item{private}{Logical indicating whether created list should be private.
Defaults to false, meaning the list would be public. Not applicable if list
already exists.}

\item{destroy}{Logical indicating whether to delete a list. Either \code{list_id} or
\code{slug} must be provided if \code{destroy = TRUE}.}

\item{list_id}{Optional, numeric ID of list.}

\item{slug}{Optional, list slug.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\value{
Response object from HTTP request.
}
\description{
Create, add users, and destroy Twitter lists. \ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
Create: \url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-create}
Destroy: \url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-destroy}
Add users: \url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-members-create},
\url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-members-create_all}
Remove users: \url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-members-destroy},
\url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/post-lists-members-destroy_all}
}
\seealso{
\code{\link{rtweet-deprecated}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/post-favorite.R
\name{post_favorite}
\alias{post_favorite}
\alias{post_favourite}
\alias{favorite_tweet}
\title{Favorites target status id.}
\usage{
post_favorite(
  status_id,
  destroy = FALSE,
  include_entities = FALSE,
  token = NULL
)
}
\arguments{
\item{status_id}{Status id of target tweet.}

\item{destroy}{Logical indicating whether to post (add) or
remove (delete) target tweet as favorite.}

\item{include_entities}{Logical indicating whether to
include entities object in return.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
Create: \url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/post-favorites-create}
Destroy: \url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/post-favorites-destroy}
}
\seealso{
\code{\link{rtweet-deprecated}}

Other post: 
\code{\link{post_follow}()},
\code{\link{post_friendship}()},
\code{\link{post_tweet}()}
}
\concept{post}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rules.R
\name{rules}
\alias{rules}
\title{Extract the streaming rules}
\usage{
rules(x, ...)
}
\arguments{
\item{x}{An object returned by \verb{stream_*_rule}}

\item{...}{Other arguments currently ignored.}
}
\description{
Provides the information about the rules
}
\seealso{
\code{stream_add_rule()} and \code{stream_rm_rule()}.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/scopes.R
\name{set_scopes}
\alias{set_scopes}
\title{Scopes of the OAuth2 token}
\usage{
set_scopes(read = TRUE, write = TRUE, tweet_moderate = TRUE, regenerate = TRUE)
}
\arguments{
\item{read}{Allow to read.}

\item{write}{Allow to write/manage?}

\item{tweet_moderate}{Allow to hide or show replies to your Tweets.}

\item{regenerate}{Allow to use the token for more than 2 hours.}
}
\value{
A character with all the possible scopes or those allowed.
}
\description{
Permissions given to a token of a Twitter account.
By default it allows everything.
}
\examples{
set_scopes()
}
\references{
\url{https://developer.twitter.com/en/docs/authentication/oauth-2-0/authorization-code}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tweet_counts.R
\name{tweet_counts_recent}
\alias{tweet_counts_recent}
\alias{tweet_counts_all}
\title{Count tweets}
\usage{
tweet_counts_recent(query, ..., token = NULL, parse = TRUE, verbose = FALSE)

tweet_counts_all(query, ..., token = NULL, parse = TRUE, verbose = FALSE)
}
\arguments{
\item{query}{One query for matching Tweets.}

\item{...}{Other arguments passed to the API.}

\item{token}{These endpoints only accept a bearer token (can be created via
\code{\link[=rtweet_app]{rtweet_app()}}). In most cases you
are better of changing the default for all calls via \code{\link[=auth_as]{auth_as()}}.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{A logical value to provide more information about the
paginated queries (if any) and to store the data of each page.}
}
\value{
The number of tweets for a given granularity
}
\description{
Count tweets
}
\examples{
if (FALSE) {
  tcr <- tweet_counts_recent(query = "#rtweet", parse = FALSE)
  tca <- tweet_counts_all(query = "#rtweet", parse = FALSE)
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/tweets/counts/api-reference/get-tweets-counts-all}

\url{https://developer.twitter.com/en/docs/twitter-api/tweets/counts/api-reference/get-tweets-counts-recent}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/stream.R
\name{stream_tweets2}
\alias{stream_tweets2}
\title{A more robust version of stream_tweets}
\usage{
stream_tweets2(..., dir = NULL, append = FALSE)
}
\arguments{
\item{dir}{Name of directory in which json files should be written.
The default, NULL, will create a timestamped "stream" folder in the
current working directory. If a dir name is provided that does not
already exist, one will be created.}

\item{append}{Logical indicating whether to append or overwrite
file_name if the file already exists. Defaults to FALSE, meaning
this function will overwrite the preexisting file_name (in other
words, it will delete any old file with the same name as
file_name) meaning the data will be added as new lines to file if
pre-existing.}
}
\value{
Returns data as expected using original search_tweets
function.
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
Please use \code{\link[=stream_tweets]{stream_tweets()}} instead.
}
\seealso{
\code{\link{rtweet-deprecated}}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/client.R
\name{client_has_default}
\alias{client_has_default}
\alias{client_setup_default}
\title{Set up default client}
\usage{
client_has_default()

client_setup_default()
}
\value{
\code{client_setup_default()}: Invisibly returns the previous authentication mechanism.
\code{client_has_default()}: A logical value \code{TRUE} if there is a default authentication.
}
\description{
You'll need to run this function once per computer so that rtweet can use
your client.
}
\details{
It will use the current default account for rtweet and save them as "rtweet".
If a default is found it will use it instead.
}
\examples{
\dontrun{
if (!client_has_default()) {
   client_setup_default()
}
}
}
\seealso{
Other client: 
\code{\link{client_as}()},
\code{\link{client_get}()},
\code{\link{client_save}()}
}
\concept{client}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tweet_search.R
\name{tweet_search_all}
\alias{tweet_search_all}
\title{Search in the Twitter archive}
\usage{
tweet_search_all(
  query,
  n = 500,
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  parse = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{query}{One query for matching Tweets.}

\item{n}{Number of tweets to query.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{...}{Other arguments passed to the API.}

\item{token}{These endpoints only accept a bearer token (can be created via
\code{\link[=rtweet_app]{rtweet_app()}}). In most cases you
are better of changing the default for all calls via \code{\link[=auth_as]{auth_as()}}.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{A logical value to provide more information about the
paginated queries (if any) and to store the data of each page.}
}
\description{
Search in the Twitter archive
}
\note{
OAuth2.0 requires tweet.read and users.read permissions.
}
\examples{
if (FALSE) {
  sa <- tweet_search_all("#rtweet", parse = FALSE)
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/tweets/search/api-reference/get-tweets-search-all}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statuses.R
\name{tweet_post}
\alias{tweet_post}
\title{Post a tweet}
\usage{
tweet_post(text, ..., token = NULL)
}
\arguments{
\item{text}{Text of the tweet.}

\item{...}{Other accepted arguments.}

\item{token}{This endpoint accepts a OAuth2.0 authentication (can be
created via \code{\link[=rtweet_oauth2]{rtweet_oauth2()}}) or a bearer token (can be created via \code{\link[=rtweet_app]{rtweet_app()}}).}
}
\description{
This function uses the API v2 to post tweets.
}
\examples{
if (FALSE) {
 # It requires the Oauth2.0 Authentication
  tp_id <- tweet_post("Posting from #rtweet with the basic plan")
  tweet_post()
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/tweets/manage-tweets/api-reference/post-tweets}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auth_clean.R
\name{auth_clean}
\alias{auth_clean}
\title{Remove tokens}
\usage{
auth_clean(old = TRUE, new = FALSE)
}
\arguments{
\item{old}{A logical value if you want to remove old tokens.}

\item{new}{A logical value if you want to remove new tokens.}
}
\value{
An invisible logical value showing the success of the operation.
If no tokens need to be deleted it will return FALSE too.
\code{NULL} if there is nothing to do.
}
\description{
If there is a file with saved tokens it will delete it.
}
\details{
This functions helps to comply with CRAN policy to remove files created by
the package.
}
\examples{
auth_clean(TRUE, TRUE)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{emojis}
\alias{emojis}
\title{Defunct: Emojis codes and descriptions data.}
\format{
A tibble with two variables and 2,623 observations.
}
\description{
This data comes from "Unicode.org":
\url{https://unicode.org/emoji/charts/full-emoji-list.html}.
The data are codes and descriptions of Emojis.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/bearer_token.R
\name{invalidate_bearer}
\alias{invalidate_bearer}
\title{Invalidate bearer token}
\usage{
invalidate_bearer(api_key, api_secret, client = NULL, token = NULL)
}
\arguments{
\item{api_key, api_secret}{API key and secret. Deprecated in favor of \verb{client_*} arguments.}

\item{client}{Which client app will be used, see \code{\link[=rtweet_client]{rtweet_client()}} for details.}

\item{token}{Expert use only. Use this to invalidate a specific bearer token
created with \code{\link[=rtweet_app]{rtweet_app()}}. If \code{NULL} the default authentication mechanism is invalidated.}
}
\description{
Invalidate the bearer token automatically if you know the API key and API secret.
}
\note{
Not tested!
}
\references{
\url{https://developer.twitter.com/en/docs/authentication/api-reference/invalidate_bearer_token}
\url{https://developer.twitter.com/en/docs/authentication/api-reference/invalidate_access_token}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tweet_embed.R
\name{tweet_embed}
\alias{tweet_embed}
\title{Create a Tweet Embed}
\usage{
tweet_embed(screen_name, status_id, ...)
}
\arguments{
\item{screen_name}{character, screen name of the user}

\item{status_id}{character, status id}

\item{...}{parameters to pass to the GET call. See
\url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/get-statuses-oembed}
for details.}
}
\value{
character
}
\description{
Twitter API GET call to retieve the tweet in embedded form.
}
\examples{
name   <- 'kearneymw'
status <- '1087047171306856451'

tweet_embed(screen_name = name, status_id = status)

tweet_embed(
 screen_name = name,
 status_id = status,
 hide_thread = TRUE, 
 hide_media = FALSE, 
 align = 'center'
)

}
\seealso{
\code{\link[httr:GET]{httr::GET()}},\code{\link[httr:content]{httr::content()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statuses.R
\name{tweet_get}
\alias{tweet_get}
\title{Get tweet information}
\usage{
tweet_get(
  id,
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  parse = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{id}{At least a tweet id.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{...}{Other arguments passed to the API.}

\item{token}{This endpoint accepts a OAuth2.0 authentication (can be
created via \code{\link[=rtweet_oauth2]{rtweet_oauth2()}}) or a bearer token (can be created via \code{\link[=rtweet_app]{rtweet_app()}}).}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{A logical value to provide more information about the
paginated queries (if any) and to store the data of each page.}
}
\description{
Look up tweets up to 100 at the same time.
}
\examples{
if (FALSE){
 tweet_get("567053242429734913", parse = FALSE)
 tweet_get(c("567053242429734913", "567053242429734913"), parse = FALSE)
 tweet_get(c("567053242429734913", "567053242429734913"), parse = TRUE)
}
}
\references{
One tweet: \url{https://developer.twitter.com/en/docs/twitter-api/tweets/lookup/api-reference/get-tweets-id}

Multiple tweets: \url{https://developer.twitter.com/en/docs/twitter-api/tweets/lookup/api-reference/get-tweets}
}
\seealso{
\code{\link[=lookup_tweets]{lookup_tweets()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lists_users.R
\name{lists_users}
\alias{lists_users}
\title{Get all lists a specified user subscribes to, including their own.}
\usage{
lists_users(user = NULL, reverse = FALSE, token = NULL, parse = TRUE)
}
\arguments{
\item{user}{Character vector of screen names or user ids.
See \code{\link[=as_screenname]{as_screenname()}} for more details.}

\item{reverse}{optional Set this to true if you would like owned lists
to be returned first. See description above for information on
how this parameter works.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}
}
\value{
data
}
\description{
Get all lists a specified user subscribes to, including their own.
}
\seealso{
Other lists: 
\code{\link{lists_members}()},
\code{\link{lists_statuses}()},
\code{\link{lists_subscribers}()},
\code{\link{lists_subscriptions}()}
}
\concept{lists}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/post-user.R
\name{post_friendship}
\alias{post_friendship}
\alias{friendship_update}
\title{Updates friendship notifications and retweet abilities.}
\usage{
post_friendship(user, device = FALSE, retweets = FALSE, token = NULL)
}
\arguments{
\item{user}{Character vector of screen names or user ids.
See \code{\link[=as_screenname]{as_screenname()}} for more details.}

\item{device}{Logical indicating whether to enable or disable
device notifications from target user behaviors. Defaults
to false.}

\item{retweets}{Logical indicating whether to enable or disable
retweets from target user behaviors. Defaults to false.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\description{
Updates friendship notifications and retweet abilities.
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/post-friendships-update}
}
\seealso{
Other post: 
\code{\link{post_favorite}()},
\code{\link{post_follow}()},
\code{\link{post_tweet}()}
}
\concept{post}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/client.R
\name{client_get}
\alias{client_get}
\title{Get the current client}
\usage{
client_get()
}
\value{
The current client used.
}
\description{
If no client has been set up for this session, \code{client_get()} will
call \code{\link[=client_as]{client_as()}} to set it up.
}
\examples{
\dontrun{
client_get()
}
}
\seealso{
Other client: 
\code{\link{client_as}()},
\code{\link{client_has_default}()},
\code{\link{client_save}()}
}
\concept{client}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/trends.R
\name{get_trends}
\alias{get_trends}
\title{Get Twitter trends data.}
\usage{
get_trends(
  woeid = 1,
  lat = NULL,
  lng = NULL,
  exclude_hashtags = FALSE,
  token = NULL,
  parse = TRUE
)
}
\arguments{
\item{woeid}{Numeric, WOEID (Yahoo! Where On Earth ID) or character
string of desired town or country. Users may also supply latitude
and longitude coordinates to fetch the closest available trends
data given the provided location. Latitude/longitude coordinates
should be provided as WOEID value consisting of 2 numeric values
or via one latitude value and one longitude value (to the
appropriately named parameters).  To browse all available trend
places, see \code{\link[=trends_available]{trends_available()}}}

\item{lat}{Optional alternative to WOEID. Numeric, latitude in
degrees.  If two coordinates are provided for WOEID, this
function will coerce the first value to latitude.}

\item{lng}{Optional alternative to WOEID. Numeric, longitude in
degrees.  If two coordinates are provided for WOEID, this
function will coerce the second value to longitude.}

\item{exclude_hashtags}{Logical, indicating whether or not to
exclude hashtags. Defaults to FALSE--meaning, hashtags are
included in returned trends.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}
}
\value{
Tibble data frame of trends data for a given geographical area.
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\seealso{
\code{\link{rtweet-deprecated}}

Other trends: 
\code{\link{trends_available}()}
}
\concept{trends}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/client.R
\name{rtweet_client}
\alias{rtweet_client}
\title{Client}
\usage{
rtweet_client(client_id, client_secret, app, scopes = NULL)
}
\arguments{
\item{client_id, client_secret}{Application OAuth client ID and client Secret.
These are generally not required for \code{rtweet_user()} since the defaults will use
the built-in rtweet app.}

\item{app}{Name of the client, it helps if you make it match with the name of your app.
On the Twitter app the Callback URI must be \verb{http://127.0.0.1:1410/}
(the trailing / must be included).}

\item{scopes}{Default scopes allowed for users using this client.
Leave \code{NULL} to allow everything or choose yours with \code{set_scopes()}.}
}
\description{
Set up your client mechanism for the Twitter API.
}
\examples{
\donttest{
if (interactive()) {
  rtweet_client()
}
}
}
\seealso{
scopes
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plain_tweets.R
\name{plain_tweets}
\alias{plain_tweets}
\title{Clean up character vector (tweets) to more of a plain text.}
\usage{
plain_tweets(x)
}
\arguments{
\item{x}{The desired character vector or data frame/list with named column/element
"text" to be cleaned and processed.}
}
\value{
Data reformatted with ascii encoding and normal ampersands and
without URL links, line breaks, fancy spaces/tabs, fancy apostrophes,
}
\description{
Removes links, linebreaks, fancy spaces and apostrophes and convert everything to ASCII text.
Deprecated to be defunct for next release as there are better text processing tools.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api_v2_responses.R
\name{retrieve_errors}
\alias{retrieve_errors}
\title{Expose errors of the response}
\usage{
retrieve_errors(expr = NULL)
}
\arguments{
\item{expr}{An expression that might cause an error.
If \code{NULL} it looks for the last error.}
}
\description{
Expose errors of the response
}
\examples{
if (FALSE){
  new_rule <- stream_add_rule(list(value = "#rstats", tag = "rstats1"))
  stream_add_rule(list(value = "#rstats", tag = "rstats2")) # ERROR
  # See the full information provided by the API:
  retrieve_errors(stream_add_rule(list(value = "#rstats", tag = "rstats2")))
  retrieve_errors()
}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/statuses.R
\name{lookup_tweets}
\alias{lookup_tweets}
\alias{lookup_statuses}
\title{Get tweets data for given statuses (status IDs).}
\usage{
lookup_tweets(
  statuses,
  parse = TRUE,
  token = NULL,
  retryonratelimit = NULL,
  verbose = TRUE
)
}
\arguments{
\item{statuses}{User id or screen name of target user.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{retryonratelimit}{If \code{TRUE}, and a rate limit is exhausted, will wait
until it refreshes. Most Twitter rate limits refresh every 15 minutes.
If \code{FALSE}, and the rate limit is exceeded, the function will terminate
early with a warning; you'll still get back all results received up to
that point. The default value, \code{NULL}, consults the option
\code{rtweet.retryonratelimit} so that you can globally set it to \code{TRUE},
if desired.

If you expect a query to take hours or days to perform, you should not
rely solely on \code{retryonratelimit} because it does not handle other common
failure modes like temporarily losing your internet connection.}

\item{verbose}{Show progress bars and other messages indicating current
progress?}
}
\value{
A tibble of tweets data.
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/get-statuses-lookup}
}
\seealso{
\code{\link[=tweet_search_recent]{tweet_search_recent()}}, \code{\link{rtweet-deprecated}}

Other tweets: 
\code{\link{get_favorites}()},
\code{\link{get_mentions}()},
\code{\link{get_timeline}()},
\code{\link{lists_statuses}()},
\code{\link{search_tweets}()}
}
\concept{tweets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/ids.R
\name{ids}
\alias{ids}
\title{Extract the ids}
\usage{
ids(x, ...)
}
\arguments{
\item{x}{An object of the rtweet package.}

\item{...}{Other arguments currently unused.}
}
\description{
Extract the ids of the rtweet data if present.
Depending on the object type it returns either users ids,  tweet ids or rules ids.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auth.R
\name{auth_setup_default}
\alias{auth_setup_default}
\alias{auth_has_default}
\title{Set up default authentication}
\usage{
auth_setup_default()

auth_has_default()
}
\value{
\code{auth_setup_default()}: Invisibly returns the previous authentication mechanism.
\code{auth_has_default()}: A logical value \code{TRUE} if there is a default authentication.
}
\description{
You'll need to run this function once per computer so that rtweet can use
your personal Twitter account. See \code{\link[=rtweet_app]{rtweet_app()}}/\link{rtweet_bot} and
\code{\link[=auth_save]{auth_save()}} for other authentication options.
}
\details{
It will use the current logged in account on the default browser to detect
the credentials needed for rtweet and save them as "default".
If a default is found it will use it instead.
}
\examples{
\dontrun{
if (!auth_has_default() && interactive()) {
   auth_setup_default()
}
}
}
\seealso{
Other authentication: 
\code{\link{auth_as}()},
\code{\link{auth_get}()},
\code{\link{auth_save}()},
\code{\link{rtweet_user}()}
}
\concept{authentication}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/list_tweets.R
\name{list_tweets}
\alias{list_tweets}
\title{Lists tweets of a specified list}
\usage{
list_tweets(
  ids,
  n = 100,
  expansions = NULL,
  fields = NULL,
  ...,
  token = NULL,
  parse = TRUE,
  verbose = FALSE
)
}
\arguments{
\item{ids}{A list id.}

\item{n}{Number of users to query.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{...}{Other parameters passed to the body of the request.}

\item{token}{These endpoints only accept a bearer token (can be created via
\code{\link[=rtweet_app]{rtweet_app()}}). In most cases you
are better of changing the default for all calls via \code{\link[=auth_as]{auth_as()}}.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{A logical value to provide more information about paginated queries.}
}
\value{
A data.frame with the user information of who is following the list:
edit_history_tweet_ids, id and text.
Other information depends on the \code{expansions} and \code{fields} requested.
Accepted values are:
\itemize{
\item Expansions: \code{set_expansions(list = NULL)}.
\item Fields: \code{set_fields(list = NULL)}.
}
}
\description{
Looks up the followers of a list.
}
\examples{
if (FALSE) {
  lt <- list_tweets("1150793074420998146")
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/lists/list-tweets/api-reference/get-lists-id-tweets}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auth_sitrep.R
\name{auth_sitrep}
\alias{auth_sitrep}
\title{Twitter Tokens sitrep}
\usage{
auth_sitrep()
}
\value{
Invisibly, TRUE if some problems were found and FALSE otherwise
}
\description{
Get a situation report of your current tokens; useful for upgrading from
rtweet 0.7.0 to 1.0.0 and diagnosing problems with tokens.
}
\details{
Prints rtweet tokens on the old folder (rtweet < 0.7.0) and on the
new (rtweet > 1.0.0) default location.
For each folder it reports apps and then users and bots authentications.
For users authentications it reports the user_id, so that you can check who is that user.

Users should follow its advise, if there is no advise but there are still
some problems authenticating regenerate the authentications.
}
\note{
It is safe to use in public, as instead of the tokens or keys it reports a letter.
}
\examples{
auth_sitrep()
}
\seealso{
\code{\link[=auth_as]{auth_as()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/followers.R
\name{get_followers}
\alias{get_followers}
\title{Get user IDs for accounts following target user.}
\usage{
get_followers(
  user,
  n = 5000,
  cursor = "-1",
  retryonratelimit = NULL,
  parse = TRUE,
  verbose = TRUE,
  token = NULL,
  page = lifecycle::deprecated()
)
}
\arguments{
\item{user}{Character vector of screen names or user ids.
See \code{\link[=as_screenname]{as_screenname()}} for more details.}

\item{n}{Desired number of results to return. Results are downloaded
in pages when \code{n} is large; the default value will download a single
page. Set \code{n = Inf} to download as many results as possible.

The Twitter API rate limits the number of requests you can perform
in each 15 minute period. The easiest way to download more than that is
to use \code{retryonratelimit = TRUE}.

You are not guaranteed to get exactly \code{n} results back. You will get
fewer results when tweets have been deleted or if you hit a rate limit.
You will get more results if you ask for a number of tweets that's not
a multiple of page size, e.g. if you request \code{n = 150} and the page
size is 200, you'll get 200 results back.}

\item{cursor}{Which page of results to return. The default will return
the first page; you can supply the result from a previous call to
continue pagination from where it left off.}

\item{retryonratelimit}{If \code{TRUE}, and a rate limit is exhausted, will wait
until it refreshes. Most Twitter rate limits refresh every 15 minutes.
If \code{FALSE}, and the rate limit is exceeded, the function will terminate
early with a warning; you'll still get back all results received up to
that point. The default value, \code{NULL}, consults the option
\code{rtweet.retryonratelimit} so that you can globally set it to \code{TRUE},
if desired.

If you expect a query to take hours or days to perform, you should not
rely solely on \code{retryonratelimit} because it does not handle other common
failure modes like temporarily losing your internet connection.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{verbose}{Show progress bars and other messages indicating current
progress?}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{page}{\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}} Please use \code{cursor} instead.}
}
\value{
A tibble data frame with one column named "from_id" with the
followers and another one "to_id" with the user used as input.
}
\description{
Returns a list of user IDs for the accounts following specified
user.
}
\examples{
if (auth_has_default()) {
  users <- get_followers("_R_Foundation")
  users

  # use `cursor` to find the next "page" of results
  more_users <- get_followers("_R_Foundation", cursor = users)

}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-followers-ids}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/retweets.R
\name{get_retweets}
\alias{get_retweets}
\alias{get_retweeters}
\title{Get the most recent retweets/retweeters}
\usage{
get_retweets(status_id, n = 100, parse = TRUE, token = NULL, ...)

get_retweeters(status_id, n = 100, parse = TRUE, token = NULL)
}
\arguments{
\item{status_id}{Tweet/status id.}

\item{n}{Number of results to retrieve. Must be <= 100.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{...}{Other arguments used as parameters in the query sent to
Twitter's rest API, for example, \code{trim_user = TRUE}.}
}
\value{
Tweets data of the most recent retweets/retweeters of a given status.
}
\description{
\code{get_retweets()} returns the 100 most recent retweets of a tweet;
\code{get_retweeters()} returns the 100 most recent users who retweeted them.
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/get-statuses-retweets-id}

\url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/get-statuses-retweeters-ids}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/post-user.R
\name{post_follow}
\alias{post_follow}
\alias{follow_user}
\alias{post_unfollow_user}
\alias{unfollow_user}
\alias{post_mute}
\alias{mute_user}
\title{Follows target Twitter user.}
\usage{
post_follow(
  user,
  destroy = FALSE,
  mute = FALSE,
  notify = FALSE,
  retweets = TRUE,
  token = NULL
)

post_unfollow_user(user, token = NULL)

post_mute(user, token = NULL)
}
\arguments{
\item{user}{Character vector of screen names or user ids.
See \code{\link[=as_screenname]{as_screenname()}} for more details.}

\item{destroy}{Logical indicating whether to post (add) or
remove (delete) target tweet as favorite.}

\item{mute}{Logical indicating whether to mute the intended
friend (you must already be following this account prior
to muting them)}

\item{notify}{Logical indicating whether to enable notifications
for target user. Defaults to false.}

\item{retweets}{Logical indicating whether to enable retweets
for target user. Defaults to true.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
Update: \url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/post-friendships-update}
Create: \url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/post-friendships-create}
Destroy: \url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/post-friendships-destroy}
Mute: \url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/mute-block-report-users/api-reference/post-mutes-users-create}
}
\seealso{
\code{\link{rtweet-deprecated}}

Other post: 
\code{\link{post_favorite}()},
\code{\link{post_friendship}()},
\code{\link{post_tweet}()}
}
\concept{post}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/entities.R
\name{entity}
\alias{entity}
\title{Extract methods}
\usage{
entity(x, entity, ...)
}
\arguments{
\item{x}{A tweets object of the rtweet package.}

\item{entity}{A entity to extract data from.}

\item{...}{Other possible arguments currently ignored.}
}
\value{
Some information about those entities and the tweet id it comes from.
for users mentions the ids of the mentioned users are "user_id", "user_id_str"
(not "id_str")
}
\description{
Extract entities of the tweets linked to a tweet id.
}
\details{
The position of where does this occur is not provided.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/next_cursor.R
\name{previous_cursor}
\alias{previous_cursor}
\title{Previous cursor}
\usage{
previous_cursor(x)
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
Reverse pagination is no longer supported.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/search_users.R
\name{search_users}
\alias{search_users}
\title{Search for users}
\usage{
search_users(q, n = 100, parse = TRUE, token = NULL, verbose = TRUE)
}
\arguments{
\item{q}{As string providing the search query. Try searching by interest,
full name, company name, or location. Exact match searches are not
supported.}

\item{n}{Desired number of results to return. Results are downloaded
in pages when \code{n} is large; the default value will download a single
page. Set \code{n = Inf} to download as many results as possible.

The Twitter API rate limits the number of requests you can perform
in each 15 minute period. The easiest way to download more than that is
to use \code{retryonratelimit = TRUE}.

You are not guaranteed to get exactly \code{n} results back. You will get
fewer results when tweets have been deleted or if you hit a rate limit.
You will get more results if you ask for a number of tweets that's not
a multiple of page size, e.g. if you request \code{n = 150} and the page
size is 200, you'll get 200 results back.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{verbose}{Show progress bars and other messages indicating current
progress?}
}
\value{
Data frame with one row for each matching user.
}
\description{
Search for Twitter users. The Twitter API limits the results to at most
1,000 users.  \ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-users-search}
}
\seealso{
\code{\link[=user_search]{user_search()}}, \code{\link{rtweet-deprecated}}

Other users: 
\code{\link{as_screenname}()},
\code{\link{lists_subscribers}()},
\code{\link{lookup_users}()}
}
\concept{users}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/direct_messages.R
\name{direct_messages_received}
\alias{direct_messages_received}
\alias{direct_messages_sent}
\title{(DEPRECATED) Get the most recent direct messages sent to the authenticating user.}
\usage{
direct_messages_received(
  since_id = NULL,
  max_id = NULL,
  n = 200,
  parse = TRUE,
  token = NULL
)

direct_messages_sent(
  since_id = NULL,
  max_id = NULL,
  n = 200,
  parse = TRUE,
  token = NULL
)
}
\value{
Return object converted to nested list. If status code of
response object is not 200, the response object is returned
directly.
}
\description{
Retrieves up to 200 of the most recently received direct messages
by the authenticating (home) user. This function requires access
token with read, write, and direct messages access.
}
\details{
Includes detailed information about the sender and
recipient user. You can request up to 200 direct messages per
call, and only the most recent 200 direct messages will be available using
this endpoint.
}
\examples{

\dontrun{

## get my direct messages
dms <- direct_messages_received()
## get direct messages I've sent
sdms <- direct_messages_sent()
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/next_cursor.R
\name{next_cursor}
\alias{next_cursor}
\alias{since_id}
\title{Extract cursor (for cursor based pagination)}
\usage{
next_cursor(x)

since_id(x)
}
\description{
This internal helper extracts the cursor from the object passed to the
\code{cursor} argument of the functions that use \code{\link[=TWIT_paginate_cursor]{TWIT_paginate_cursor()}}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/post-tweet.R
\name{post_tweet}
\alias{post_tweet}
\alias{post_status}
\title{Posts status update to user's Twitter account}
\usage{
post_tweet(
  status = "my first rtweet #rstats",
  media = NULL,
  token = NULL,
  in_reply_to_status_id = NULL,
  destroy_id = NULL,
  retweet_id = NULL,
  auto_populate_reply_metadata = FALSE,
  media_alt_text = NULL,
  lat = NULL,
  long = NULL,
  display_coordinates = FALSE
)
}
\arguments{
\item{status}{Character, tweet status. Must be 280 characters or less.}

\item{media}{Length 1 character vector with a file path to video media \strong{OR}
up-to length 4 character vector with file paths to static images to be included in tweet.
\strong{The caller is responsible for managing this.}}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{in_reply_to_status_id}{Status ID of tweet to which you'd like to reply.
Note: in line with the Twitter API, this parameter is ignored unless the
author of the tweet this parameter references is mentioned within the
status text.}

\item{destroy_id}{To delete a status, supply the single status ID here. If a
character string is supplied, overriding the default (NULL), then a destroy
request is made (and the status text and media attachments) are irrelevant.}

\item{retweet_id}{To retweet a status, supply the single status ID here. If a
character string is supplied, overriding the default (NULL), then a retweet
request is made (and the status text and media attachments) are irrelevant.}

\item{auto_populate_reply_metadata}{If set to TRUE and used with
in_reply_to_status_id, leading @mentions will be looked up from the
original Tweet, and added to the new Tweet from there. Defaults to FALSE.}

\item{media_alt_text}{attach additional \href{https://en.wikipedia.org/wiki/Alt_attribute}{alt text}
metadata to the \code{media} you are uploading. Should be same length as
\code{media} (i.e. as many alt text entries as there are \code{media} entries). See
\href{https://developer.twitter.com/en/docs/twitter-api/v1/media/upload-media/api-reference/post-media-metadata-create}{the official API documentation}
for more information.}

\item{lat}{A numeric value representing the latitude of the location the
tweet refers to. Range should be between -90 and 90 (north). Note that you
should enable the "Precise location" option in your account via \emph{Settings
and privacy > Privacy and Safety > Location}. See
\href{https://help.twitter.com/en/safety-and-security/x-location-services-for-mobile}{the official Help Center section}.}

\item{long}{A numeric value representing the longitude of the location the
tweet refers to. Range should be between -180 and 180 (west). See
\code{lat} parameter.}

\item{display_coordinates}{Put a pin on the exact coordinates a tweet has
been sent from. Value should be TRUE or FALSE. This parameter would apply
only if you have provided a valid \code{lat/long} pair of valid values.}
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
Tweet: \url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/post-statuses-update}
Retweet: \url{https://developer.twitter.com/en/docs/twitter-api/v1/tweets/post-and-engage/api-reference/post-statuses-retweet-id}
Media: \url{https://developer.twitter.com/en/docs/twitter-api/v1/media/upload-media/api-reference/post-media-metadata-create}
Alt-text: \url{https://developer.twitter.com/en/docs/twitter-api/v1/media/upload-media/api-reference/post-media-metadata-create}
}
\seealso{
\code{\link[=tweet_post]{tweet_post()}}, \code{\link{rtweet-deprecated}}

Other post: 
\code{\link{post_favorite}()},
\code{\link{post_follow}()},
\code{\link{post_friendship}()}
}
\concept{post}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/next_cursor.R
\name{max_id}
\alias{max_id}
\title{Extract min/max id (for id based pagination)}
\usage{
max_id(x)
}
\arguments{
\item{x}{Either a data frame of tweets or a character vector of status ids.}
}
\description{
These internal helpers extract the ids passed on to the \code{max_id}
and \code{since_id} arguments to functions that use \code{\link[=TWIT_paginate_max_id]{TWIT_paginate_max_id()}}.
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/save_as_csv.R
\name{flatten}
\alias{flatten}
\alias{unflatten}
\title{flatten/unflatten data frame}
\usage{
flatten(x)

unflatten(x)
}
\arguments{
\item{x}{Data frame with list columns or converted-to-character (flattened)
columns.}
}
\value{
If flattened, then data frame where non-recursive list
columns---that is, list columns that contain only atomic, or non-list,
elements---have been converted to character vectors. If unflattened,
this function splits on spaces columns originally returned as lists
by functions in rtweet package. See details for more information.
}
\description{
Converts list columns that containing all atomic elements into
character vectors and vice versa (for appropriate named variables
according to the rtweet package)
}
\details{
If recursive list columns are contained within the data frame,
relevant columns will still be converted to atomic types but output
will also be accompanied with a warning message.

\code{flatten} flattens list columns by pasting them into a single string for
each observations. For example, a tweet that mentions four other users,
for the mentions_user_id variable, it will include the four user IDs
separated by a space.

`unflatten`` splits on spaces to convert into list columns any
columns with the following names: hashtags, symbols, urls_url,
urls_t.co, urls_expanded_url, media_url, media_t.co,
media_expanded_url, media_type, ext_media_url, ext_media_t.co,
ext_media_expanded_url, mentions_user_id, mentions_screen_name,
geo_coords, coords_coords, bbox_coords, mentions_screen_name
}
\seealso{
Other datafiles: 
\code{\link{read_twitter_csv}()},
\code{\link{write_as_csv}()}

Other datafiles: 
\code{\link{read_twitter_csv}()},
\code{\link{write_as_csv}()}
}
\concept{datafiles}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/extractors.R
\name{users_data}
\alias{users_data}
\alias{tweets_data}
\title{Get tweets from users, or users from tweets}
\usage{
users_data(tweets)

tweets_data(users)
}
\arguments{
\item{tweets}{A data frame of tweets.}

\item{users}{A data frame of users.}
}
\value{
\code{user_data()} returns a data frame of users; \code{tweets_data()}
returns a data frame of tweets.
}
\description{
Twitter API endpoints that return tweets also return data about the users who
tweeted, and most endpoints that return users also return their last tweet.
Showing these additional columns would clutter the default display, so
rtweet instead stores in special attributes and allows you to show them
with the \code{user_data()} and \code{tweets_data()} helpers.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lat_lng.R
\name{lat_lng}
\alias{lat_lng}
\title{Adds single-point latitude and longitude variables to tweets data.}
\usage{
lat_lng(
  x,
  coords = c("coords_coords", "bbox_coords", "geo_coords"),
  prefs = "bbox_coords"
)
}
\arguments{
\item{x}{Parsed Twitter data as returned by various rtweet
functions. This should be a data frame with variables such as
"bbox_coords", "coords_coords", and "geo_coords" (among
other non-geolocation Twitter variables).}

\item{coords}{Names of variables containing latitude and longitude
coordinates.  Priority is given to bounding box coordinates (each
obs consists of eight entries) followed by the supplied order of
variable names. Defaults to "bbox_coords",
"coords_coords", and "geo_coords") (which are the default column
names of data returned by most status-oriented rtweet functions).}

\item{prefs}{Preference of coordinates to use as default, must be in \code{coords}.}
}
\value{
Returns updated data object with full information latitude
and longitude vars.
}
\description{
Appends parsed Twitter data with latitude and longitude variables
using all available geolocation information.
}
\details{
On occasion values may appear to be outliers given a
previously used query filter (e.g., when searching for tweets
sent from the continental US).  This is typically because those
tweets returned a large bounding box that overlapped with the
area of interest. This function converts boxes into their
geographical midpoints, which works well in the vast majority of
cases, but sometimes includes an otherwise puzzling result.
}
\seealso{
Other geo: 
\code{\link{lookup_coords}()}
}
\concept{geo}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/friends.R
\name{my_friendships}
\alias{my_friendships}
\title{Lookup friendship information between users.}
\usage{
my_friendships(user, parse = FALSE, token = NULL)
}
\arguments{
\item{user}{Character vector of screen names or user ids.
See \code{\link[=as_screenname]{as_screenname()}} for more details.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}
}
\description{
Gets information on friendship between authenticated user and up
to 100 other users.
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/follow-search-get-users/api-reference/get-friendships-lookup}
}
\seealso{
Other friends: 
\code{\link{lookup_friendships}()}
}
\concept{friends}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/compliance.R
\name{job_compliance}
\alias{job_compliance}
\title{Job compliance}
\usage{
job_compliance(ids, name, type, resumable = TRUE, token = NULL)
}
\arguments{
\item{ids}{Ids of tweets or users to check.}

\item{name}{Name of the job.}

\item{type}{Type of ids: either 'tweets' or 'users'.}

\item{resumable}{A logical value if the job is resumable.}

\item{token}{Bearer token used.}
}
\description{
Job compliance
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/compliance/batch-compliance/api-reference}
Submit job: \url{https://developer.twitter.com/en/docs/twitter-api/compliance/batch-compliance/api-reference/post-compliance-jobs}
Job status: \url{https://developer.twitter.com/en/docs/twitter-api/compliance/batch-compliance/api-reference/get-compliance-jobs-id}
Jobs list: \url{https://developer.twitter.com/en/docs/twitter-api/compliance/batch-compliance/api-reference/get-compliance-jobs}
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/user_bookmarks.R
\name{user_bookmarks}
\alias{user_bookmarks}
\title{Retrieve user bookmarks}
\usage{
user_bookmarks(
  id,
  n = 100,
  ...,
  expansions = NULL,
  fields = NULL,
  parse = TRUE,
  token = NULL,
  verbose = FALSE
)
}
\arguments{
\item{id}{Twitter user id: character string identifying your account.}

\item{n}{Number of tweets to retrieve.}

\item{...}{Other arguments passed down to the API.}

\item{expansions}{Set \code{NULL} to not use any expansion, set \code{NA} to get all
expansions, or provide a vector with the expansions you want (create it with
\code{\link[=set_expansions]{set_expansions()}}).}

\item{fields}{Set \code{NULL} to not use any field, get all allowed fields with \code{NA},
provide a list with the fields you want (create it with \code{\link[=set_fields]{set_fields()}}).}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{token}{This endpoint only accept a OAuth2.0 authentication (can be
created via \code{\link[=rtweet_oauth2]{rtweet_oauth2()}}).}

\item{verbose}{A logical value}
}
\value{
A data.frame with the user information of who is following the list:
edit_history_tweet_ids, id and text.
Other information depends on the \code{expansions} and \code{fields} requested.
Accepted values are:
\itemize{
\item Expansions: \code{set_expansions(list = NULL)}.
\item Fields: \code{set_fields(list = NULL)}.
}
}
\description{
Collects the 800 most recent bookmarked tweets of a user.
}
\note{
This endpoint requires a OAuth2.0 authentication, with tweet.read, users.read and bookmark.read permissions.
}
\examples{
if (FALSE) {
   # Requires token_oa2
   ub <- user_bookmarks(user_self()$id, parse = FALSE, n = Inf, token = token_oa2)
}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/tweets/bookmarks/api-reference/get-users-id-bookmarks}
}
\seealso{
\code{\link[=rtweet_oauth2]{rtweet_oauth2()}}, \code{\link[=user_self]{user_self()}}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/fields.R
\docType{data}
\name{Fields}
\alias{Fields}
\alias{fields}
\alias{media_fields}
\alias{place_fields}
\alias{poll_fields}
\alias{list_fields}
\alias{tweet_fields}
\alias{user_fields}
\alias{metrics_fields}
\title{Fields}
\format{
An object of class \code{character} of length 13.

An object of class \code{character} of length 8.

An object of class \code{character} of length 5.

An object of class \code{character} of length 6.

An object of class \code{character} of length 18.

An object of class \code{character} of length 15.

An object of class \code{character} of length 4.
}
\usage{
media_fields

place_fields

poll_fields

list_fields

tweet_fields

user_fields

metrics_fields
}
\description{
Arguments of expansion that select which values are returned.
Fields are possible for:
\itemize{
\item \href{https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/tweet}{Tweets}
\item \href{https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/user}{Users}
\item \href{https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/media}{Media}
\item \href{https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/poll}{Polls}
\item \href{https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/place}{Places}
\item \href{https://developer.twitter.com/en/docs/twitter-api/data-dictionary/object-model/lists}{Lists}
}
}
\examples{
media_fields
place_fields
poll_fields
tweet_fields
user_fields
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/fields}
}
\seealso{
\link{Expansions}, \code{\link[=set_fields]{set_fields()}}
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/links.R
\name{links}
\alias{links}
\title{Create the links}
\usage{
links(x, ...)
}
\arguments{
\item{x}{An object of the rtweet package.}

\item{...}{Other arguments currently unused.}
}
\description{
create the links from the rtweet data present.
Depending on the object type it returns either users links,  tweet links or rules links.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/user_id.R
\name{as_screenname}
\alias{as_screenname}
\alias{as_userid}
\title{Mark a user id as a screen name}
\usage{
as_screenname(x)
}
\arguments{
\item{x}{A character vector of Twitter screen names.}
}
\description{
There are two ways to identify a Twitter user: a screen name (e.g.
"justinbieber") or a user identifier (e.g. "27260086"). User identifiers
look like regular numbers, but are actually 64-bit integers which can't be
stored in R's numeric vectors. For this reason, rtweet always returns ids as
strings.

Unfortunately this introduces an ambiguity, because user names can
also consist solely of numbers (e.g. "123456") so it's not obvious whether
a string consisting only of numbers is a screen name or a user id. By
default, rtweet will assume its a user id, so if you have a screen name
that consists only of numbers, you'll need to use \code{as_screenname()} to
tell rtweet that it's actually a screen name.

Note that in general, you are best off using user ids; screen names are
not static and may change over longer periods of time.
}
\seealso{
Other users: 
\code{\link{lists_subscribers}()},
\code{\link{lookup_users}()},
\code{\link{search_users}()}
}
\concept{users}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/client.R
\name{client_save}
\alias{client_save}
\alias{client_list}
\title{Save an authentication mechanism for use in a future session}
\usage{
client_save(client)

client_list()
}
\arguments{
\item{client}{A client \code{\link[=rtweet_client]{rtweet_client()}}.}
}
\value{
Invisible the path where the client is saved.
}
\description{
Use \code{client_save()} with \code{\link[=client_as]{client_as()}} to avoid repeatedly entering app
credentials, making it easier to share auth between projects.
Use \code{client_list()} to list all saved credentials.
}
\details{
The tokens are saved on the clients folder in \code{tools::R_user_dir("rtweet", "config")}.
}
\examples{
\dontrun{
# save app client for use in other sessions
client <- rtweet_client()
client_save(client)

# later, in a different session...
client_as("my-app")
# Show all authentications stored
client_list()
}
}
\seealso{
\code{\link[=auth_sitrep]{auth_sitrep()}} to help finding and managing authentications.

Other client: 
\code{\link{client_as}()},
\code{\link{client_get}()},
\code{\link{client_has_default}()}
}
\concept{client}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auth.R
\name{rtweet_user}
\alias{rtweet_user}
\alias{rtweet_bot}
\alias{rtweet_app}
\alias{rtweet_bearer}
\alias{rtweet_oauth2}
\title{Authentication options}
\usage{
rtweet_user(
  client_id = NULL,
  client_secret = NULL,
  api_key = client_id,
  api_secret = client_secret
)

rtweet_bot(api_key, api_secret, access_token, access_secret, app = "rtweet")

rtweet_app(bearer_token)

rtweet_bearer(client = NULL, scopes = NULL)

rtweet_oauth2(client = NULL, scopes = NULL)
}
\arguments{
\item{client_id, client_secret}{Application OAuth client ID and client Secret.
These are generally not required for \code{rtweet_user()} since the defaults will use
the built-in rtweet app.}

\item{api_key, api_secret}{API key and secret. Deprecated in favor of \verb{client_*} arguments.}

\item{access_token, access_secret}{Access token and secret.}

\item{app}{Name of the application you are building.}

\item{bearer_token}{App bearer token.}

\item{client}{Which client app will be used, see \code{\link[=rtweet_client]{rtweet_client()}} for details.}

\item{scopes}{The permissions of the app, see \code{\link[=set_scopes]{set_scopes()}} for details.
By default it uses the client's scopes. Provided here in case you want to modify them.}
}
\value{
If the validation is successful the OAuth token.
For \code{rtweet_app()} a \code{rtweet_bearer}.
}
\description{
Authenticate methods to use the Twitter API.
See the instructions in \code{vignette("auth", package = "rtweet")}.
}
\details{
There are four ways that you can authenticate with the Twitter API:
\itemize{
\item \code{rtweet_user()} interactively authenticates an existing Twitter user.
This form is most appropriate if you want rtweet to control your
Twitter account.
\item \code{rtweet_app()} authenticates as a Twitter application. An application can't
perform actions (i.e. it can't tweet) but otherwise has generally higher
rate limits (i.e. you can do more searches). See details
at \url{https://developer.twitter.com/en/docs/twitter-api/v1/rate-limits}.
This form is most appropriate if you are collecting data.
\item \code{rtweet_bot()} authenticates as bot that takes actions on behalf of an app.
This form is most appropriate if you want to create a Twitter account that
is run by a computer, rather than a human.
\item \code{rtweet_oauth2()} authenticates as a user using a client.
This authentication is required in some endpoints.
}

To use \code{rtweet_app()}, \code{rtweet_bot()}  or \code{rtweet_oauth2()} you will need to
create your own Twitter app following the instructions in
\code{vignette("auth", package = "rtweet")}.
\code{rtweet_user()} \emph{can be} used with your own app, but generally there is
no need to because it uses the Twitter app provided by rtweet.

Use \code{\link[=auth_as]{auth_as()}} to set the default auth mechanism for the current session,
and \code{\link[=auth_save]{auth_save()}} to save an auth mechanism for use in future sessions.
}
\section{Security}{
All of the arguments to these functions are roughly equivalent to
passwords so should generally not be typed into the console (where they
the will be recorded in \code{.Rhistory}) or recorded in a script (which is
easy to accidentally share). Instead, call these functions without arguments
since the default behaviour is to use ask_pass that if possible uses
\code{\link[askpass:askpass]{askpass::askpass()}} to interactively safely prompt you for the values.
}

\examples{
\dontrun{
rtweet_app()
}
}
\references{
\url{https://developer.twitter.com/en/docs/authentication/oauth-2-0/authorization-code}
}
\seealso{
\code{\link[=rtweet_client]{rtweet_client()}}

Other authentication: 
\code{\link{auth_as}()},
\code{\link{auth_get}()},
\code{\link{auth_save}()},
\code{\link{auth_setup_default}()}
}
\concept{authentication}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/rate_limit.R
\name{rate_limit}
\alias{rate_limit}
\alias{rate_limit_reset}
\alias{rate_limit_wait}
\title{Rate limit helpers}
\usage{
rate_limit(resource_match = NULL, token = NULL)

rate_limit_reset(endpoint, token = NULL)

rate_limit_wait(endpoint, token = NULL)
}
\arguments{
\item{resource_match}{An optional regular expression used to filter the
resources listed in returned rate limit data.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{endpoint}{Name of Twitter endpoint like \code{"lookup/users"},
\code{"/media/upload"}, or \code{"/feedback/show/:id"}.}
}
\description{
\itemize{
\item \code{rate_limit()} returns a tibble of info about all rate limits
\item \code{rate_limit_reset()} returns the next reset for a endpoint
\item \code{rate_limit_wait()} waits for the next reset for an endpoint
}

You should not need to use these function in the usual operation of rtweet
because all paginated functions will wait on your behalf if you set
\code{retryonratelimit = TRUE}.
}
\details{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/developer-utilities/rate-limit-status}
}
\seealso{
\code{\link{rtweet-deprecated}}

Other tokens: 
\code{\link{create_token}()},
\code{\link{get_token}()}
}
\concept{tokens}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/trends.R
\name{trends_available}
\alias{trends_available}
\title{Available Twitter trends along with associated WOEID.}
\usage{
trends_available(token = NULL, parse = TRUE)
}
\arguments{
\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}
}
\value{
Data frame with WOEID column. WOEID is a Yahoo! Where On
Earth ID.
}
\description{
\ifelse{html}{\href{https://lifecycle.r-lib.org/articles/stages.html#deprecated}{\figure{lifecycle-deprecated.svg}{options: alt='[Deprecated]'}}}{\strong{[Deprecated]}}
}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/trends/locations-with-trending-topics/api-reference/get-trends-available}
}
\seealso{
\code{\link{rtweet-deprecated}}

Other trends: 
\code{\link{get_trends}()}
}
\concept{trends}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tweets_and_users.R
\name{tweets_with_users}
\alias{tweets_with_users}
\alias{users_with_tweets}
\title{Parsing data into tweets/users data tibbles}
\usage{
tweets_with_users(x)

users_with_tweets(x)
}
\arguments{
\item{x}{A list of responses, with one element for each page.}
}
\value{
A tweets/users tibble with users/tweets attribute.
}
\description{
For internal use only
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/lists_members.R
\name{lists_members}
\alias{lists_members}
\title{Get Twitter list members (users on a given list).}
\usage{
lists_members(
  list_id = NULL,
  slug = NULL,
  owner_user = NULL,
  n = 5000,
  cursor = "-1",
  token = NULL,
  retryonratelimit = NULL,
  verbose = TRUE,
  parse = TRUE,
  ...
)
}
\arguments{
\item{list_id}{required The numerical id of the list.}

\item{slug}{required You can identify a list by its slug instead of
its numerical id. If you decide to do so, note that you'll also
have to specify the list owner using the owner_id or
owner_user parameters.}

\item{owner_user}{optional The screen name or user ID of the user}

\item{n}{Desired number of results to return. Results are downloaded
in pages when \code{n} is large; the default value will download a single
page. Set \code{n = Inf} to download as many results as possible.

The Twitter API rate limits the number of requests you can perform
in each 15 minute period. The easiest way to download more than that is
to use \code{retryonratelimit = TRUE}.

You are not guaranteed to get exactly \code{n} results back. You will get
fewer results when tweets have been deleted or if you hit a rate limit.
You will get more results if you ask for a number of tweets that's not
a multiple of page size, e.g. if you request \code{n = 150} and the page
size is 200, you'll get 200 results back.}

\item{cursor}{Which page of results to return. The default will return
the first page; you can supply the result from a previous call to
continue pagination from where it left off.}

\item{token}{Use this to override authentication for
a single API call. In many cases you are better off changing the
default for all calls. See \code{\link[=auth_as]{auth_as()}} for details.}

\item{retryonratelimit}{If \code{TRUE}, and a rate limit is exhausted, will wait
until it refreshes. Most Twitter rate limits refresh every 15 minutes.
If \code{FALSE}, and the rate limit is exceeded, the function will terminate
early with a warning; you'll still get back all results received up to
that point. The default value, \code{NULL}, consults the option
\code{rtweet.retryonratelimit} so that you can globally set it to \code{TRUE},
if desired.

If you expect a query to take hours or days to perform, you should not
rely solely on \code{retryonratelimit} because it does not handle other common
failure modes like temporarily losing your internet connection.}

\item{verbose}{Show progress bars and other messages indicating current
progress?}

\item{parse}{If \code{TRUE}, the default, returns a tidy data frame. Use \code{FALSE}
to return the "raw" list corresponding to the JSON returned from the
Twitter API.}

\item{...}{Other arguments used as parameters in query composition.}
}
\description{
Get Twitter list members (users on a given list).
}
\examples{
if (auth_has_default()) {

## get list members for a list of rstats experts using list_id
(rstats <- lists_members("1260528710559694850"))

## get list members for an rstats list using list topic slug
## list owner's screen name
rstats <- lists_members(slug = "r-people", owner_user = "Lluis_Revilla")
rstats

}

}
\references{
\url{https://developer.twitter.com/en/docs/twitter-api/v1/accounts-and-users/create-manage-lists/api-reference/get-lists-members}
}
\seealso{
Other lists: 
\code{\link{lists_statuses}()},
\code{\link{lists_subscribers}()},
\code{\link{lists_subscriptions}()},
\code{\link{lists_users}()}
}
\concept{lists}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/auth.R
\name{auth_save}
\alias{auth_save}
\alias{auth_list}
\title{Save an authentication mechanism for use in a future session}
\usage{
auth_save(auth, name)

auth_list()
}
\arguments{
\item{auth}{One of \code{\link[=rtweet_app]{rtweet_app()}}, \code{\link[=rtweet_bot]{rtweet_bot()}}, or \code{\link[=rtweet_user]{rtweet_user()}}.}

\item{name}{Name of the file to use.}
}
\value{
Invisible the path where the authentication is saved.
}
\description{
Use \code{auth_save()} with \code{\link[=auth_as]{auth_as()}} to avoid repeatedly entering app
credentials, making it easier to share auth between projects.
Use \code{auth_list()} to list all saved credentials.
}
\details{
The tokens are saved on \code{tools::R_user_dir("rtweet", "config")}.
}
\examples{
\dontrun{
# save app auth for use in other sessions
auth <- rtweet_app()
auth_save(auth, "my-app")

# later, in a different session...
auth_as("my-app")
# Show all authentications stored
auth_list()
}
}
\seealso{
\code{\link[=auth_sitrep]{auth_sitrep()}} to help finding and managing authentications.

Other authentication: 
\code{\link{auth_as}()},
\code{\link{auth_get}()},
\code{\link{auth_setup_default}()},
\code{\link{rtweet_user}()}
}
\concept{authentication}
